package app

// Code generated by go generate; DO NOT EDIT.

import (
	"fmt"
	"strings"
)

// HTMLA is the interface that describes a <a> HTML element.
type HTMLA interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLA

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLA

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLA

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLA

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLA

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLA

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLA

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLA

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLA

	// Download specifies that the target will be downloaded when a user clicks on the hyperlink.
	Download(v string) HTMLA

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLA

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLA

	// Href specifies the URL of the page the link goes to.
	Href(v string) HTMLA

	// HrefLang specifies the language of the linked document.
	HrefLang(v string) HTMLA

	// ID specifies a unique id for an element.
	ID(v string) HTMLA

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLA

	// Media specifies what media/device the linked document is optimized for.
	Media(v string) HTMLA

	// Ping specifies a list of URLs to be notified if the user follows the hyperlink.
	Ping(v string) HTMLA

	// Rel specifies the relationship between the current document and the linked document.
	Rel(v string) HTMLA

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLA

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLA

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLA

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLA

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLA

	// Target specifies the target for where to open the linked document or where to submit the form.
	Target(v string) HTMLA

	// Title specifies extra information about an element.
	Title(v string) HTMLA

	// Type specifies the type of element.
	Type(v string) HTMLA

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLA

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLA

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLA

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLA

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLA

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLA

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLA

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLA

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLA

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLA

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLA

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLA

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLA

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLA

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLA

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLA

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLA

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLA

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLA

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLA

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLA

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLA

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLA

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLA

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLA

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLA

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLA

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLA

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLA

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLA

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLA

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLA
}

// A returns an HTML element that defines a hyperlink.
func A() HTMLA {
	e := &htmlA{
		elem: elem{
			tag:         "a",
			selfClosing: false,
		},
	}

	return e
}

type htmlA struct {
	elem
}

func (e *htmlA) Body(elems ...UI) HTMLA {
	e.setBody(elems...)
	return e
}

func (e *htmlA) Text(v interface{}) HTMLA {
	return e.Body(Text(v))
}

func (e *htmlA) AccessKey(v string) HTMLA {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlA) Aria(k string, v interface{}) HTMLA {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlA) Attr(n string, v interface{}) HTMLA {
	e.setAttr(n, v)
	return e
}

func (e *htmlA) Class(v ...string) HTMLA {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlA) ContentEditable(v bool) HTMLA {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlA) DataSet(k string, v interface{}) HTMLA {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlA) Dir(v string) HTMLA {
	e.setAttr("dir", v)
	return e
}

func (e *htmlA) Download(v string) HTMLA {
	e.setAttr("download", v)
	return e
}

func (e *htmlA) Draggable(v bool) HTMLA {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlA) Hidden(v bool) HTMLA {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlA) Href(v string) HTMLA {
	e.setAttr("href", v)
	return e
}

func (e *htmlA) HrefLang(v string) HTMLA {
	e.setAttr("hreflang", v)
	return e
}

func (e *htmlA) ID(v string) HTMLA {
	e.setAttr("id", v)
	return e
}

func (e *htmlA) Lang(v string) HTMLA {
	e.setAttr("lang", v)
	return e
}

func (e *htmlA) Media(v string) HTMLA {
	e.setAttr("media", v)
	return e
}

func (e *htmlA) Ping(v string) HTMLA {
	e.setAttr("ping", v)
	return e
}

func (e *htmlA) Rel(v string) HTMLA {
	e.setAttr("rel", v)
	return e
}

func (e *htmlA) Role(v string) HTMLA {
	e.setAttr("role", v)
	return e
}

func (e *htmlA) Spellcheck(v bool) HTMLA {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlA) Style(k, v string) HTMLA {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlA) Styles(s map[string]string) HTMLA {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlA) TabIndex(v int) HTMLA {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlA) Target(v string) HTMLA {
	e.setAttr("target", v)
	return e
}

func (e *htmlA) Title(v string) HTMLA {
	e.setAttr("title", v)
	return e
}

func (e *htmlA) Type(v string) HTMLA {
	e.setAttr("type", v)
	return e
}

func (e *htmlA) OnBlur(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlA) OnChange(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlA) OnClick(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlA) OnContextMenu(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlA) OnCopy(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlA) OnCut(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlA) OnDblClick(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlA) OnDrag(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlA) OnDragEnd(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlA) OnDragEnter(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlA) OnDragLeave(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlA) OnDragOver(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlA) OnDragStart(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlA) OnDrop(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlA) OnFocus(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlA) OnInput(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlA) OnInvalid(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlA) OnKeyDown(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlA) OnKeyPress(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlA) OnKeyup(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlA) OnMouseDown(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlA) OnMouseMove(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlA) OnMouseOut(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlA) OnMouseOver(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlA) OnMouseUp(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlA) OnPaste(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlA) OnReset(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlA) OnScroll(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlA) OnSearch(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlA) OnSelect(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlA) OnSubmit(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlA) OnWheel(h EventHandler, scope ...interface{}) HTMLA {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLAbbr is the interface that describes a <abbr> HTML element.
type HTMLAbbr interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLAbbr

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLAbbr

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLAbbr

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLAbbr

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLAbbr

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLAbbr

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLAbbr

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLAbbr

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLAbbr

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLAbbr

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLAbbr

	// ID specifies a unique id for an element.
	ID(v string) HTMLAbbr

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLAbbr

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLAbbr

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLAbbr

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLAbbr

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLAbbr

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLAbbr

	// Title specifies extra information about an element.
	Title(v string) HTMLAbbr

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLAbbr

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLAbbr
}

// Abbr returns an HTML element that defines an abbreviation or an acronym.
func Abbr() HTMLAbbr {
	e := &htmlAbbr{
		elem: elem{
			tag:         "abbr",
			selfClosing: false,
		},
	}

	return e
}

type htmlAbbr struct {
	elem
}

func (e *htmlAbbr) Body(elems ...UI) HTMLAbbr {
	e.setBody(elems...)
	return e
}

func (e *htmlAbbr) Text(v interface{}) HTMLAbbr {
	return e.Body(Text(v))
}

func (e *htmlAbbr) AccessKey(v string) HTMLAbbr {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlAbbr) Aria(k string, v interface{}) HTMLAbbr {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAbbr) Attr(n string, v interface{}) HTMLAbbr {
	e.setAttr(n, v)
	return e
}

func (e *htmlAbbr) Class(v ...string) HTMLAbbr {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlAbbr) ContentEditable(v bool) HTMLAbbr {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlAbbr) DataSet(k string, v interface{}) HTMLAbbr {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAbbr) Dir(v string) HTMLAbbr {
	e.setAttr("dir", v)
	return e
}

func (e *htmlAbbr) Draggable(v bool) HTMLAbbr {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlAbbr) Hidden(v bool) HTMLAbbr {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlAbbr) ID(v string) HTMLAbbr {
	e.setAttr("id", v)
	return e
}

func (e *htmlAbbr) Lang(v string) HTMLAbbr {
	e.setAttr("lang", v)
	return e
}

func (e *htmlAbbr) Role(v string) HTMLAbbr {
	e.setAttr("role", v)
	return e
}

func (e *htmlAbbr) Spellcheck(v bool) HTMLAbbr {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlAbbr) Style(k, v string) HTMLAbbr {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlAbbr) Styles(s map[string]string) HTMLAbbr {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlAbbr) TabIndex(v int) HTMLAbbr {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlAbbr) Title(v string) HTMLAbbr {
	e.setAttr("title", v)
	return e
}

func (e *htmlAbbr) OnBlur(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlAbbr) OnChange(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlAbbr) OnClick(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlAbbr) OnContextMenu(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlAbbr) OnCopy(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlAbbr) OnCut(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlAbbr) OnDblClick(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlAbbr) OnDrag(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlAbbr) OnDragEnd(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlAbbr) OnDragEnter(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlAbbr) OnDragLeave(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlAbbr) OnDragOver(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlAbbr) OnDragStart(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlAbbr) OnDrop(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlAbbr) OnFocus(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlAbbr) OnInput(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlAbbr) OnInvalid(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlAbbr) OnKeyDown(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlAbbr) OnKeyPress(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlAbbr) OnKeyup(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlAbbr) OnMouseDown(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlAbbr) OnMouseMove(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlAbbr) OnMouseOut(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlAbbr) OnMouseOver(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlAbbr) OnMouseUp(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlAbbr) OnPaste(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlAbbr) OnReset(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlAbbr) OnScroll(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlAbbr) OnSearch(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlAbbr) OnSelect(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlAbbr) OnSubmit(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlAbbr) OnWheel(h EventHandler, scope ...interface{}) HTMLAbbr {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLAddress is the interface that describes a <address> HTML element.
type HTMLAddress interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLAddress

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLAddress

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLAddress

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLAddress

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLAddress

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLAddress

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLAddress

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLAddress

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLAddress

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLAddress

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLAddress

	// ID specifies a unique id for an element.
	ID(v string) HTMLAddress

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLAddress

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLAddress

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLAddress

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLAddress

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLAddress

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLAddress

	// Title specifies extra information about an element.
	Title(v string) HTMLAddress

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLAddress

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLAddress

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLAddress

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLAddress

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLAddress

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLAddress

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLAddress

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLAddress

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLAddress

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLAddress

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLAddress

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLAddress

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLAddress

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLAddress

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLAddress

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLAddress

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLAddress

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLAddress

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLAddress

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLAddress

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLAddress

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLAddress

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLAddress

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLAddress

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLAddress
}

// Address returns an HTML element that defines contact information for the author/owner of a document.
func Address() HTMLAddress {
	e := &htmlAddress{
		elem: elem{
			tag:         "address",
			selfClosing: false,
		},
	}

	return e
}

type htmlAddress struct {
	elem
}

func (e *htmlAddress) Body(elems ...UI) HTMLAddress {
	e.setBody(elems...)
	return e
}

func (e *htmlAddress) Text(v interface{}) HTMLAddress {
	return e.Body(Text(v))
}

func (e *htmlAddress) AccessKey(v string) HTMLAddress {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlAddress) Aria(k string, v interface{}) HTMLAddress {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAddress) Attr(n string, v interface{}) HTMLAddress {
	e.setAttr(n, v)
	return e
}

func (e *htmlAddress) Class(v ...string) HTMLAddress {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlAddress) ContentEditable(v bool) HTMLAddress {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlAddress) DataSet(k string, v interface{}) HTMLAddress {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAddress) Dir(v string) HTMLAddress {
	e.setAttr("dir", v)
	return e
}

func (e *htmlAddress) Draggable(v bool) HTMLAddress {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlAddress) Hidden(v bool) HTMLAddress {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlAddress) ID(v string) HTMLAddress {
	e.setAttr("id", v)
	return e
}

func (e *htmlAddress) Lang(v string) HTMLAddress {
	e.setAttr("lang", v)
	return e
}

func (e *htmlAddress) Role(v string) HTMLAddress {
	e.setAttr("role", v)
	return e
}

func (e *htmlAddress) Spellcheck(v bool) HTMLAddress {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlAddress) Style(k, v string) HTMLAddress {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlAddress) Styles(s map[string]string) HTMLAddress {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlAddress) TabIndex(v int) HTMLAddress {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlAddress) Title(v string) HTMLAddress {
	e.setAttr("title", v)
	return e
}

func (e *htmlAddress) OnBlur(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlAddress) OnChange(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlAddress) OnClick(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlAddress) OnContextMenu(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlAddress) OnCopy(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlAddress) OnCut(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlAddress) OnDblClick(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlAddress) OnDrag(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlAddress) OnDragEnd(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlAddress) OnDragEnter(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlAddress) OnDragLeave(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlAddress) OnDragOver(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlAddress) OnDragStart(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlAddress) OnDrop(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlAddress) OnFocus(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlAddress) OnInput(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlAddress) OnInvalid(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlAddress) OnKeyDown(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlAddress) OnKeyPress(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlAddress) OnKeyup(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlAddress) OnMouseDown(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlAddress) OnMouseMove(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlAddress) OnMouseOut(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlAddress) OnMouseOver(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlAddress) OnMouseUp(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlAddress) OnPaste(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlAddress) OnReset(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlAddress) OnScroll(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlAddress) OnSearch(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlAddress) OnSelect(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlAddress) OnSubmit(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlAddress) OnWheel(h EventHandler, scope ...interface{}) HTMLAddress {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLArea is the interface that describes a <area> HTML element.
type HTMLArea interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLArea

	// Alt specifies an alternate text when the original element fails to display.
	Alt(v string) HTMLArea

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLArea

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLArea

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLArea

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLArea

	// Coords specifies the coordinates of the area.
	Coords(v string) HTMLArea

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLArea

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLArea

	// Download specifies that the target will be downloaded when a user clicks on the hyperlink.
	Download(v string) HTMLArea

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLArea

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLArea

	// Href specifies the URL of the page the link goes to.
	Href(v string) HTMLArea

	// HrefLang specifies the language of the linked document.
	HrefLang(v string) HTMLArea

	// ID specifies a unique id for an element.
	ID(v string) HTMLArea

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLArea

	// Media specifies what media/device the linked document is optimized for.
	Media(v string) HTMLArea

	// Rel specifies the relationship between the current document and the linked document.
	Rel(v string) HTMLArea

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLArea

	// Shape specifies the shape of the area.
	Shape(v string) HTMLArea

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLArea

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLArea

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLArea

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLArea

	// Target specifies the target for where to open the linked document or where to submit the form.
	Target(v string) HTMLArea

	// Title specifies extra information about an element.
	Title(v string) HTMLArea

	// Type specifies the type of element.
	Type(v string) HTMLArea

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLArea

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLArea

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLArea

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLArea

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLArea

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLArea

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLArea

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLArea

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLArea

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLArea

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLArea

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLArea

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLArea

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLArea

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLArea

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLArea

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLArea

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLArea

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLArea

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLArea

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLArea

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLArea

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLArea

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLArea

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLArea

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLArea

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLArea

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLArea

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLArea

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLArea

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLArea

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLArea
}

// Area returns an HTML element that defines an area inside an image-map.
func Area() HTMLArea {
	e := &htmlArea{
		elem: elem{
			tag:         "area",
			selfClosing: true,
		},
	}

	return e
}

type htmlArea struct {
	elem
}

func (e *htmlArea) AccessKey(v string) HTMLArea {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlArea) Alt(v string) HTMLArea {
	e.setAttr("alt", v)
	return e
}

func (e *htmlArea) Aria(k string, v interface{}) HTMLArea {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlArea) Attr(n string, v interface{}) HTMLArea {
	e.setAttr(n, v)
	return e
}

func (e *htmlArea) Class(v ...string) HTMLArea {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlArea) ContentEditable(v bool) HTMLArea {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlArea) Coords(v string) HTMLArea {
	e.setAttr("coords", v)
	return e
}

func (e *htmlArea) DataSet(k string, v interface{}) HTMLArea {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlArea) Dir(v string) HTMLArea {
	e.setAttr("dir", v)
	return e
}

func (e *htmlArea) Download(v string) HTMLArea {
	e.setAttr("download", v)
	return e
}

func (e *htmlArea) Draggable(v bool) HTMLArea {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlArea) Hidden(v bool) HTMLArea {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlArea) Href(v string) HTMLArea {
	e.setAttr("href", v)
	return e
}

func (e *htmlArea) HrefLang(v string) HTMLArea {
	e.setAttr("hreflang", v)
	return e
}

func (e *htmlArea) ID(v string) HTMLArea {
	e.setAttr("id", v)
	return e
}

func (e *htmlArea) Lang(v string) HTMLArea {
	e.setAttr("lang", v)
	return e
}

func (e *htmlArea) Media(v string) HTMLArea {
	e.setAttr("media", v)
	return e
}

func (e *htmlArea) Rel(v string) HTMLArea {
	e.setAttr("rel", v)
	return e
}

func (e *htmlArea) Role(v string) HTMLArea {
	e.setAttr("role", v)
	return e
}

func (e *htmlArea) Shape(v string) HTMLArea {
	e.setAttr("shape", v)
	return e
}

func (e *htmlArea) Spellcheck(v bool) HTMLArea {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlArea) Style(k, v string) HTMLArea {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlArea) Styles(s map[string]string) HTMLArea {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlArea) TabIndex(v int) HTMLArea {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlArea) Target(v string) HTMLArea {
	e.setAttr("target", v)
	return e
}

func (e *htmlArea) Title(v string) HTMLArea {
	e.setAttr("title", v)
	return e
}

func (e *htmlArea) Type(v string) HTMLArea {
	e.setAttr("type", v)
	return e
}

func (e *htmlArea) OnBlur(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlArea) OnChange(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlArea) OnClick(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlArea) OnContextMenu(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlArea) OnCopy(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlArea) OnCut(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlArea) OnDblClick(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlArea) OnDrag(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlArea) OnDragEnd(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlArea) OnDragEnter(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlArea) OnDragLeave(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlArea) OnDragOver(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlArea) OnDragStart(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlArea) OnDrop(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlArea) OnFocus(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlArea) OnInput(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlArea) OnInvalid(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlArea) OnKeyDown(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlArea) OnKeyPress(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlArea) OnKeyup(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlArea) OnMouseDown(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlArea) OnMouseMove(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlArea) OnMouseOut(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlArea) OnMouseOver(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlArea) OnMouseUp(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlArea) OnPaste(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlArea) OnReset(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlArea) OnScroll(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlArea) OnSearch(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlArea) OnSelect(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlArea) OnSubmit(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlArea) OnWheel(h EventHandler, scope ...interface{}) HTMLArea {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLArticle is the interface that describes a <article> HTML element.
type HTMLArticle interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLArticle

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLArticle

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLArticle

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLArticle

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLArticle

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLArticle

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLArticle

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLArticle

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLArticle

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLArticle

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLArticle

	// ID specifies a unique id for an element.
	ID(v string) HTMLArticle

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLArticle

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLArticle

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLArticle

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLArticle

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLArticle

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLArticle

	// Title specifies extra information about an element.
	Title(v string) HTMLArticle

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLArticle

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLArticle

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLArticle

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLArticle

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLArticle

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLArticle

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLArticle

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLArticle

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLArticle

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLArticle

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLArticle

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLArticle

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLArticle

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLArticle

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLArticle

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLArticle

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLArticle

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLArticle

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLArticle

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLArticle

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLArticle

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLArticle

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLArticle

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLArticle

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLArticle
}

// Article returns an HTML element that defines an article.
func Article() HTMLArticle {
	e := &htmlArticle{
		elem: elem{
			tag:         "article",
			selfClosing: false,
		},
	}

	return e
}

type htmlArticle struct {
	elem
}

func (e *htmlArticle) Body(elems ...UI) HTMLArticle {
	e.setBody(elems...)
	return e
}

func (e *htmlArticle) Text(v interface{}) HTMLArticle {
	return e.Body(Text(v))
}

func (e *htmlArticle) AccessKey(v string) HTMLArticle {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlArticle) Aria(k string, v interface{}) HTMLArticle {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlArticle) Attr(n string, v interface{}) HTMLArticle {
	e.setAttr(n, v)
	return e
}

func (e *htmlArticle) Class(v ...string) HTMLArticle {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlArticle) ContentEditable(v bool) HTMLArticle {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlArticle) DataSet(k string, v interface{}) HTMLArticle {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlArticle) Dir(v string) HTMLArticle {
	e.setAttr("dir", v)
	return e
}

func (e *htmlArticle) Draggable(v bool) HTMLArticle {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlArticle) Hidden(v bool) HTMLArticle {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlArticle) ID(v string) HTMLArticle {
	e.setAttr("id", v)
	return e
}

func (e *htmlArticle) Lang(v string) HTMLArticle {
	e.setAttr("lang", v)
	return e
}

func (e *htmlArticle) Role(v string) HTMLArticle {
	e.setAttr("role", v)
	return e
}

func (e *htmlArticle) Spellcheck(v bool) HTMLArticle {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlArticle) Style(k, v string) HTMLArticle {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlArticle) Styles(s map[string]string) HTMLArticle {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlArticle) TabIndex(v int) HTMLArticle {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlArticle) Title(v string) HTMLArticle {
	e.setAttr("title", v)
	return e
}

func (e *htmlArticle) OnBlur(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlArticle) OnChange(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlArticle) OnClick(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlArticle) OnContextMenu(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlArticle) OnCopy(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlArticle) OnCut(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlArticle) OnDblClick(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlArticle) OnDrag(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlArticle) OnDragEnd(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlArticle) OnDragEnter(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlArticle) OnDragLeave(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlArticle) OnDragOver(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlArticle) OnDragStart(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlArticle) OnDrop(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlArticle) OnFocus(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlArticle) OnInput(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlArticle) OnInvalid(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlArticle) OnKeyDown(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlArticle) OnKeyPress(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlArticle) OnKeyup(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlArticle) OnMouseDown(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlArticle) OnMouseMove(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlArticle) OnMouseOut(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlArticle) OnMouseOver(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlArticle) OnMouseUp(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlArticle) OnPaste(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlArticle) OnReset(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlArticle) OnScroll(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlArticle) OnSearch(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlArticle) OnSelect(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlArticle) OnSubmit(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlArticle) OnWheel(h EventHandler, scope ...interface{}) HTMLArticle {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLAside is the interface that describes a <aside> HTML element.
type HTMLAside interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLAside

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLAside

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLAside

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLAside

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLAside

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLAside

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLAside

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLAside

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLAside

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLAside

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLAside

	// ID specifies a unique id for an element.
	ID(v string) HTMLAside

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLAside

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLAside

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLAside

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLAside

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLAside

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLAside

	// Title specifies extra information about an element.
	Title(v string) HTMLAside

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLAside

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLAside

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLAside

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLAside

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLAside

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLAside

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLAside

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLAside

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLAside

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLAside

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLAside

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLAside

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLAside

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLAside

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLAside

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLAside

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLAside

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLAside

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLAside

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLAside

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLAside

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLAside

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLAside

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLAside

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLAside

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLAside

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLAside

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLAside

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLAside

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLAside

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLAside

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLAside
}

// Aside returns an HTML element that defines content aside from the page content.
func Aside() HTMLAside {
	e := &htmlAside{
		elem: elem{
			tag:         "aside",
			selfClosing: false,
		},
	}

	return e
}

type htmlAside struct {
	elem
}

func (e *htmlAside) Body(elems ...UI) HTMLAside {
	e.setBody(elems...)
	return e
}

func (e *htmlAside) Text(v interface{}) HTMLAside {
	return e.Body(Text(v))
}

func (e *htmlAside) AccessKey(v string) HTMLAside {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlAside) Aria(k string, v interface{}) HTMLAside {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAside) Attr(n string, v interface{}) HTMLAside {
	e.setAttr(n, v)
	return e
}

func (e *htmlAside) Class(v ...string) HTMLAside {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlAside) ContentEditable(v bool) HTMLAside {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlAside) DataSet(k string, v interface{}) HTMLAside {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAside) Dir(v string) HTMLAside {
	e.setAttr("dir", v)
	return e
}

func (e *htmlAside) Draggable(v bool) HTMLAside {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlAside) Hidden(v bool) HTMLAside {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlAside) ID(v string) HTMLAside {
	e.setAttr("id", v)
	return e
}

func (e *htmlAside) Lang(v string) HTMLAside {
	e.setAttr("lang", v)
	return e
}

func (e *htmlAside) Role(v string) HTMLAside {
	e.setAttr("role", v)
	return e
}

func (e *htmlAside) Spellcheck(v bool) HTMLAside {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlAside) Style(k, v string) HTMLAside {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlAside) Styles(s map[string]string) HTMLAside {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlAside) TabIndex(v int) HTMLAside {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlAside) Title(v string) HTMLAside {
	e.setAttr("title", v)
	return e
}

func (e *htmlAside) OnBlur(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlAside) OnChange(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlAside) OnClick(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlAside) OnContextMenu(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlAside) OnCopy(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlAside) OnCut(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlAside) OnDblClick(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlAside) OnDrag(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlAside) OnDragEnd(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlAside) OnDragEnter(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlAside) OnDragLeave(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlAside) OnDragOver(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlAside) OnDragStart(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlAside) OnDrop(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlAside) OnFocus(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlAside) OnInput(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlAside) OnInvalid(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlAside) OnKeyDown(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlAside) OnKeyPress(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlAside) OnKeyup(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlAside) OnMouseDown(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlAside) OnMouseMove(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlAside) OnMouseOut(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlAside) OnMouseOver(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlAside) OnMouseUp(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlAside) OnPaste(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlAside) OnReset(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlAside) OnScroll(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlAside) OnSearch(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlAside) OnSelect(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlAside) OnSubmit(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlAside) OnWheel(h EventHandler, scope ...interface{}) HTMLAside {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLAudio is the interface that describes a <audio> HTML element.
type HTMLAudio interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLAudio

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLAudio

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLAudio

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLAudio

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLAudio

	// AutoPlay specifies that the audio/video will start playing as soon as it is ready.
	AutoPlay(v bool) HTMLAudio

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLAudio

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLAudio

	// Controls specifies that audio/video controls should be displayed (such as a play/pause button etc).
	Controls(v bool) HTMLAudio

	// CrossOrigin sets the mode of the request to an HTTP CORS Request.
	CrossOrigin(v string) HTMLAudio

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLAudio

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLAudio

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLAudio

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLAudio

	// ID specifies a unique id for an element.
	ID(v string) HTMLAudio

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLAudio

	// Loop specifies that the audio/video will start over again, every time it is finished.
	Loop(v bool) HTMLAudio

	// Muted specifies that the audio output of the video should be muted.
	Muted(v bool) HTMLAudio

	// Preload specifies if and how the author thinks the audio/video should be loaded when the page loads.
	Preload(v string) HTMLAudio

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLAudio

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLAudio

	// Src specifies the URL of the media file.
	Src(v string) HTMLAudio

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLAudio

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLAudio

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLAudio

	// Title specifies extra information about an element.
	Title(v string) HTMLAudio

	// OnAbort calls the given handler on abort.
	OnAbort(h EventHandler, scope ...interface{}) HTMLAudio

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLAudio

	// OnCanPlay calls the given handler when a file is ready to start playing (when it has buffered enough to begin).
	OnCanPlay(h EventHandler, scope ...interface{}) HTMLAudio

	// OnCanPlayThrough calls the given handler when a file can be played all the way to the end without pausing for buffering.
	OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLAudio

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLAudio

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLAudio

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLAudio

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLAudio

	// OnCueChange calls the given handler when the cue changes in a track element.
	OnCueChange(h EventHandler, scope ...interface{}) HTMLAudio

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLAudio

	// OnDurationChange calls the given handler when the length of the media changes.
	OnDurationChange(h EventHandler, scope ...interface{}) HTMLAudio

	// OnEmptied calls the given handler when something bad happens and the file is suddenly unavailable (like unexpectedly disconnects).
	OnEmptied(h EventHandler, scope ...interface{}) HTMLAudio

	// OnEnded calls the given handler when the media has reach the end.
	OnEnded(h EventHandler, scope ...interface{}) HTMLAudio

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLAudio

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLAudio

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLAudio

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLAudio

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLAudio

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLAudio

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLAudio

	// OnLoadStart calls the given handler just as the file begins to load before anything is actually loaded.
	OnLoadStart(h EventHandler, scope ...interface{}) HTMLAudio

	// OnLoadedData calls the given handler when media data is loaded.
	OnLoadedData(h EventHandler, scope ...interface{}) HTMLAudio

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLAudio

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLAudio

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLAudio

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLAudio

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLAudio

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLAudio

	// OnPause calls the given handler when the media is paused either by the user or programmatically.
	OnPause(h EventHandler, scope ...interface{}) HTMLAudio

	// OnPlay calls the given handler when the media is ready to start playing.
	OnPlay(h EventHandler, scope ...interface{}) HTMLAudio

	// OnPlaying calls the given handler when the media actually has started playing.
	OnPlaying(h EventHandler, scope ...interface{}) HTMLAudio

	// OnProgress calls the given handler when the browser is in the process of getting the media data.
	OnProgress(h EventHandler, scope ...interface{}) HTMLAudio

	// OnRateChange calls the given handler each time the playback rate changes (like when a user switches to a slow motion or fast forward mode).
	OnRateChange(h EventHandler, scope ...interface{}) HTMLAudio

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLAudio

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSeeked calls the given handler when the seeking attribute is set to false indicating that seeking has ended.
	OnSeeked(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSeeking calls the given handler when the seeking attribute is set to true indicating that seeking is active.
	OnSeeking(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLAudio

	// OnStalled calls the given handler when the browser is unable to fetch the media data for whatever reason.
	OnStalled(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLAudio

	// OnSuspend calls the given handler when fetching the media data is stopped before it is completely loaded for whatever reason.
	OnSuspend(h EventHandler, scope ...interface{}) HTMLAudio

	// OnTimeUpdate calls the given handler when the playing position has changed (like when the user fast forwards to a different point in the media).
	OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLAudio

	// OnVolumeChange calls the given handler each time the volume is changed which (includes setting the volume to "mute").
	OnVolumeChange(h EventHandler, scope ...interface{}) HTMLAudio

	// OnWaiting calls the given handler when the media has paused but is expected to resume (like when the media pauses to buffer more data).
	OnWaiting(h EventHandler, scope ...interface{}) HTMLAudio

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLAudio

	// OnloadedMetaData calls the given handler when meta data (like dimensions and duration) are loaded.
	OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLAudio
}

// Audio returns an HTML element that defines sound content.
func Audio() HTMLAudio {
	e := &htmlAudio{
		elem: elem{
			tag:         "audio",
			selfClosing: false,
		},
	}

	return e
}

type htmlAudio struct {
	elem
}

func (e *htmlAudio) Body(elems ...UI) HTMLAudio {
	e.setBody(elems...)
	return e
}

func (e *htmlAudio) Text(v interface{}) HTMLAudio {
	return e.Body(Text(v))
}

func (e *htmlAudio) AccessKey(v string) HTMLAudio {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlAudio) Aria(k string, v interface{}) HTMLAudio {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAudio) Attr(n string, v interface{}) HTMLAudio {
	e.setAttr(n, v)
	return e
}

func (e *htmlAudio) AutoPlay(v bool) HTMLAudio {
	e.setAttr("autoplay", v)
	return e
}

func (e *htmlAudio) Class(v ...string) HTMLAudio {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlAudio) ContentEditable(v bool) HTMLAudio {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlAudio) Controls(v bool) HTMLAudio {
	e.setAttr("controls", v)
	return e
}

func (e *htmlAudio) CrossOrigin(v string) HTMLAudio {
	e.setAttr("crossorigin", v)
	return e
}

func (e *htmlAudio) DataSet(k string, v interface{}) HTMLAudio {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlAudio) Dir(v string) HTMLAudio {
	e.setAttr("dir", v)
	return e
}

func (e *htmlAudio) Draggable(v bool) HTMLAudio {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlAudio) Hidden(v bool) HTMLAudio {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlAudio) ID(v string) HTMLAudio {
	e.setAttr("id", v)
	return e
}

func (e *htmlAudio) Lang(v string) HTMLAudio {
	e.setAttr("lang", v)
	return e
}

func (e *htmlAudio) Loop(v bool) HTMLAudio {
	e.setAttr("loop", v)
	return e
}

func (e *htmlAudio) Muted(v bool) HTMLAudio {
	e.setAttr("muted", v)
	return e
}

func (e *htmlAudio) Preload(v string) HTMLAudio {
	e.setAttr("preload", v)
	return e
}

func (e *htmlAudio) Role(v string) HTMLAudio {
	e.setAttr("role", v)
	return e
}

func (e *htmlAudio) Spellcheck(v bool) HTMLAudio {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlAudio) Src(v string) HTMLAudio {
	e.setAttr("src", v)
	return e
}

func (e *htmlAudio) Style(k, v string) HTMLAudio {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlAudio) Styles(s map[string]string) HTMLAudio {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlAudio) TabIndex(v int) HTMLAudio {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlAudio) Title(v string) HTMLAudio {
	e.setAttr("title", v)
	return e
}

func (e *htmlAudio) OnAbort(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("abort", h, scope...)
	return e
}

func (e *htmlAudio) OnBlur(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlAudio) OnCanPlay(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("canplay", h, scope...)
	return e
}

func (e *htmlAudio) OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("canplaythrough", h, scope...)
	return e
}

func (e *htmlAudio) OnChange(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlAudio) OnClick(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlAudio) OnContextMenu(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlAudio) OnCopy(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlAudio) OnCueChange(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("cuechange", h, scope...)
	return e
}

func (e *htmlAudio) OnCut(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlAudio) OnDblClick(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlAudio) OnDrag(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlAudio) OnDragEnd(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlAudio) OnDragEnter(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlAudio) OnDragLeave(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlAudio) OnDragOver(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlAudio) OnDragStart(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlAudio) OnDrop(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlAudio) OnDurationChange(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("durationchange", h, scope...)
	return e
}

func (e *htmlAudio) OnEmptied(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("emptied", h, scope...)
	return e
}

func (e *htmlAudio) OnEnded(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("ended", h, scope...)
	return e
}

func (e *htmlAudio) OnError(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlAudio) OnFocus(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlAudio) OnInput(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlAudio) OnInvalid(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlAudio) OnKeyDown(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlAudio) OnKeyPress(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlAudio) OnKeyup(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlAudio) OnLoadStart(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("loadstart", h, scope...)
	return e
}

func (e *htmlAudio) OnLoadedData(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("loadeddata", h, scope...)
	return e
}

func (e *htmlAudio) OnMouseDown(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlAudio) OnMouseMove(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlAudio) OnMouseOut(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlAudio) OnMouseOver(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlAudio) OnMouseUp(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlAudio) OnPaste(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlAudio) OnPause(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("pause", h, scope...)
	return e
}

func (e *htmlAudio) OnPlay(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("play", h, scope...)
	return e
}

func (e *htmlAudio) OnPlaying(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("playing", h, scope...)
	return e
}

func (e *htmlAudio) OnProgress(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("progress", h, scope...)
	return e
}

func (e *htmlAudio) OnRateChange(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("ratechange", h, scope...)
	return e
}

func (e *htmlAudio) OnReset(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlAudio) OnScroll(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlAudio) OnSearch(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlAudio) OnSeeked(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("seeked", h, scope...)
	return e
}

func (e *htmlAudio) OnSeeking(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("seeking", h, scope...)
	return e
}

func (e *htmlAudio) OnSelect(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlAudio) OnStalled(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("stalled", h, scope...)
	return e
}

func (e *htmlAudio) OnSubmit(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlAudio) OnSuspend(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("suspend", h, scope...)
	return e
}

func (e *htmlAudio) OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("timeupdate", h, scope...)
	return e
}

func (e *htmlAudio) OnVolumeChange(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("volumechange", h, scope...)
	return e
}

func (e *htmlAudio) OnWaiting(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("waiting", h, scope...)
	return e
}

func (e *htmlAudio) OnWheel(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("wheel", h, scope...)
	return e
}

func (e *htmlAudio) OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLAudio {
	e.setEventHandler("loadedmetadata", h, scope...)
	return e
}

// HTMLB is the interface that describes a <b> HTML element.
type HTMLB interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLB

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLB

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLB

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLB

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLB

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLB

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLB

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLB

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLB

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLB

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLB

	// ID specifies a unique id for an element.
	ID(v string) HTMLB

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLB

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLB

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLB

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLB

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLB

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLB

	// Title specifies extra information about an element.
	Title(v string) HTMLB

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLB

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLB

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLB

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLB

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLB

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLB

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLB

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLB

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLB

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLB

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLB

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLB

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLB

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLB

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLB

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLB

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLB

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLB

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLB

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLB

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLB

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLB

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLB

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLB

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLB

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLB

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLB

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLB

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLB

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLB

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLB

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLB
}

// B returns an HTML element that defines bold text.
func B() HTMLB {
	e := &htmlB{
		elem: elem{
			tag:         "b",
			selfClosing: false,
		},
	}

	return e
}

type htmlB struct {
	elem
}

func (e *htmlB) Body(elems ...UI) HTMLB {
	e.setBody(elems...)
	return e
}

func (e *htmlB) Text(v interface{}) HTMLB {
	return e.Body(Text(v))
}

func (e *htmlB) AccessKey(v string) HTMLB {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlB) Aria(k string, v interface{}) HTMLB {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlB) Attr(n string, v interface{}) HTMLB {
	e.setAttr(n, v)
	return e
}

func (e *htmlB) Class(v ...string) HTMLB {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlB) ContentEditable(v bool) HTMLB {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlB) DataSet(k string, v interface{}) HTMLB {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlB) Dir(v string) HTMLB {
	e.setAttr("dir", v)
	return e
}

func (e *htmlB) Draggable(v bool) HTMLB {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlB) Hidden(v bool) HTMLB {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlB) ID(v string) HTMLB {
	e.setAttr("id", v)
	return e
}

func (e *htmlB) Lang(v string) HTMLB {
	e.setAttr("lang", v)
	return e
}

func (e *htmlB) Role(v string) HTMLB {
	e.setAttr("role", v)
	return e
}

func (e *htmlB) Spellcheck(v bool) HTMLB {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlB) Style(k, v string) HTMLB {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlB) Styles(s map[string]string) HTMLB {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlB) TabIndex(v int) HTMLB {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlB) Title(v string) HTMLB {
	e.setAttr("title", v)
	return e
}

func (e *htmlB) OnBlur(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlB) OnChange(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlB) OnClick(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlB) OnContextMenu(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlB) OnCopy(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlB) OnCut(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlB) OnDblClick(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlB) OnDrag(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlB) OnDragEnd(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlB) OnDragEnter(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlB) OnDragLeave(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlB) OnDragOver(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlB) OnDragStart(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlB) OnDrop(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlB) OnFocus(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlB) OnInput(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlB) OnInvalid(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlB) OnKeyDown(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlB) OnKeyPress(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlB) OnKeyup(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlB) OnMouseDown(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlB) OnMouseMove(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlB) OnMouseOut(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlB) OnMouseOver(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlB) OnMouseUp(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlB) OnPaste(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlB) OnReset(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlB) OnScroll(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlB) OnSearch(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlB) OnSelect(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlB) OnSubmit(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlB) OnWheel(h EventHandler, scope ...interface{}) HTMLB {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBase is the interface that describes a <base> HTML element.
type HTMLBase interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBase

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBase

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBase

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBase

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBase

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBase

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBase

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBase

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBase

	// Href specifies the URL of the page the link goes to.
	Href(v string) HTMLBase

	// ID specifies a unique id for an element.
	ID(v string) HTMLBase

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBase

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBase

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBase

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBase

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBase

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBase

	// Target specifies the target for where to open the linked document or where to submit the form.
	Target(v string) HTMLBase

	// Title specifies extra information about an element.
	Title(v string) HTMLBase

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBase

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBase

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBase

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBase

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBase

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBase

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBase

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBase

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBase

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBase

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBase

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBase

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBase

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBase

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBase

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBase

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBase

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBase

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBase

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBase

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBase

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBase

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBase

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBase

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBase

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBase

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBase

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBase

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBase

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBase

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBase

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBase
}

// Base returns an HTML element that specifies the base URL/target for all relative URLs in a document.
func Base() HTMLBase {
	e := &htmlBase{
		elem: elem{
			tag:         "base",
			selfClosing: true,
		},
	}

	return e
}

type htmlBase struct {
	elem
}

func (e *htmlBase) AccessKey(v string) HTMLBase {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBase) Aria(k string, v interface{}) HTMLBase {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBase) Attr(n string, v interface{}) HTMLBase {
	e.setAttr(n, v)
	return e
}

func (e *htmlBase) Class(v ...string) HTMLBase {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBase) ContentEditable(v bool) HTMLBase {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBase) DataSet(k string, v interface{}) HTMLBase {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBase) Dir(v string) HTMLBase {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBase) Draggable(v bool) HTMLBase {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBase) Hidden(v bool) HTMLBase {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBase) Href(v string) HTMLBase {
	e.setAttr("href", v)
	return e
}

func (e *htmlBase) ID(v string) HTMLBase {
	e.setAttr("id", v)
	return e
}

func (e *htmlBase) Lang(v string) HTMLBase {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBase) Role(v string) HTMLBase {
	e.setAttr("role", v)
	return e
}

func (e *htmlBase) Spellcheck(v bool) HTMLBase {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBase) Style(k, v string) HTMLBase {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBase) Styles(s map[string]string) HTMLBase {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBase) TabIndex(v int) HTMLBase {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBase) Target(v string) HTMLBase {
	e.setAttr("target", v)
	return e
}

func (e *htmlBase) Title(v string) HTMLBase {
	e.setAttr("title", v)
	return e
}

func (e *htmlBase) OnBlur(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBase) OnChange(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBase) OnClick(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBase) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBase) OnCopy(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBase) OnCut(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBase) OnDblClick(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBase) OnDrag(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBase) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBase) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBase) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBase) OnDragOver(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBase) OnDragStart(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBase) OnDrop(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBase) OnFocus(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBase) OnInput(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBase) OnInvalid(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBase) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBase) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBase) OnKeyup(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBase) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBase) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBase) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBase) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBase) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBase) OnPaste(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBase) OnReset(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBase) OnScroll(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBase) OnSearch(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBase) OnSelect(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBase) OnSubmit(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBase) OnWheel(h EventHandler, scope ...interface{}) HTMLBase {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBdi is the interface that describes a <bdi> HTML element.
type HTMLBdi interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLBdi

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLBdi

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBdi

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBdi

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBdi

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBdi

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBdi

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBdi

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBdi

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBdi

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBdi

	// ID specifies a unique id for an element.
	ID(v string) HTMLBdi

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBdi

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBdi

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBdi

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBdi

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBdi

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBdi

	// Title specifies extra information about an element.
	Title(v string) HTMLBdi

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBdi

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBdi

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBdi

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBdi

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBdi

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBdi

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBdi

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBdi

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBdi

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBdi

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBdi

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBdi

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBdi

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBdi

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBdi

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBdi

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBdi

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBdi

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBdi

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBdi

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBdi

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBdi

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBdi

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBdi

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBdi
}

// Bdi returns an HTML element that isolates a part of text that might be formatted in a different direction from other text outside it.
func Bdi() HTMLBdi {
	e := &htmlBdi{
		elem: elem{
			tag:         "bdi",
			selfClosing: false,
		},
	}

	return e
}

type htmlBdi struct {
	elem
}

func (e *htmlBdi) Body(elems ...UI) HTMLBdi {
	e.setBody(elems...)
	return e
}

func (e *htmlBdi) Text(v interface{}) HTMLBdi {
	return e.Body(Text(v))
}

func (e *htmlBdi) AccessKey(v string) HTMLBdi {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBdi) Aria(k string, v interface{}) HTMLBdi {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBdi) Attr(n string, v interface{}) HTMLBdi {
	e.setAttr(n, v)
	return e
}

func (e *htmlBdi) Class(v ...string) HTMLBdi {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBdi) ContentEditable(v bool) HTMLBdi {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBdi) DataSet(k string, v interface{}) HTMLBdi {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBdi) Dir(v string) HTMLBdi {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBdi) Draggable(v bool) HTMLBdi {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBdi) Hidden(v bool) HTMLBdi {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBdi) ID(v string) HTMLBdi {
	e.setAttr("id", v)
	return e
}

func (e *htmlBdi) Lang(v string) HTMLBdi {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBdi) Role(v string) HTMLBdi {
	e.setAttr("role", v)
	return e
}

func (e *htmlBdi) Spellcheck(v bool) HTMLBdi {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBdi) Style(k, v string) HTMLBdi {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBdi) Styles(s map[string]string) HTMLBdi {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBdi) TabIndex(v int) HTMLBdi {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBdi) Title(v string) HTMLBdi {
	e.setAttr("title", v)
	return e
}

func (e *htmlBdi) OnBlur(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBdi) OnChange(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBdi) OnClick(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBdi) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBdi) OnCopy(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBdi) OnCut(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBdi) OnDblClick(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBdi) OnDrag(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBdi) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBdi) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBdi) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBdi) OnDragOver(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBdi) OnDragStart(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBdi) OnDrop(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBdi) OnFocus(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBdi) OnInput(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBdi) OnInvalid(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBdi) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBdi) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBdi) OnKeyup(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBdi) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBdi) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBdi) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBdi) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBdi) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBdi) OnPaste(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBdi) OnReset(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBdi) OnScroll(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBdi) OnSearch(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBdi) OnSelect(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBdi) OnSubmit(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBdi) OnWheel(h EventHandler, scope ...interface{}) HTMLBdi {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBdo is the interface that describes a <bdo> HTML element.
type HTMLBdo interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLBdo

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLBdo

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBdo

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBdo

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBdo

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBdo

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBdo

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBdo

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBdo

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBdo

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBdo

	// ID specifies a unique id for an element.
	ID(v string) HTMLBdo

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBdo

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBdo

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBdo

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBdo

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBdo

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBdo

	// Title specifies extra information about an element.
	Title(v string) HTMLBdo

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBdo

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBdo

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBdo

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBdo

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBdo

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBdo

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBdo

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBdo

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBdo

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBdo

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBdo

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBdo

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBdo

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBdo

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBdo

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBdo

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBdo

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBdo

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBdo

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBdo

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBdo

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBdo

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBdo

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBdo

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBdo
}

// Bdo returns an HTML element that overrides the current text direction.
func Bdo() HTMLBdo {
	e := &htmlBdo{
		elem: elem{
			tag:         "bdo",
			selfClosing: false,
		},
	}

	return e
}

type htmlBdo struct {
	elem
}

func (e *htmlBdo) Body(elems ...UI) HTMLBdo {
	e.setBody(elems...)
	return e
}

func (e *htmlBdo) Text(v interface{}) HTMLBdo {
	return e.Body(Text(v))
}

func (e *htmlBdo) AccessKey(v string) HTMLBdo {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBdo) Aria(k string, v interface{}) HTMLBdo {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBdo) Attr(n string, v interface{}) HTMLBdo {
	e.setAttr(n, v)
	return e
}

func (e *htmlBdo) Class(v ...string) HTMLBdo {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBdo) ContentEditable(v bool) HTMLBdo {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBdo) DataSet(k string, v interface{}) HTMLBdo {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBdo) Dir(v string) HTMLBdo {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBdo) Draggable(v bool) HTMLBdo {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBdo) Hidden(v bool) HTMLBdo {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBdo) ID(v string) HTMLBdo {
	e.setAttr("id", v)
	return e
}

func (e *htmlBdo) Lang(v string) HTMLBdo {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBdo) Role(v string) HTMLBdo {
	e.setAttr("role", v)
	return e
}

func (e *htmlBdo) Spellcheck(v bool) HTMLBdo {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBdo) Style(k, v string) HTMLBdo {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBdo) Styles(s map[string]string) HTMLBdo {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBdo) TabIndex(v int) HTMLBdo {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBdo) Title(v string) HTMLBdo {
	e.setAttr("title", v)
	return e
}

func (e *htmlBdo) OnBlur(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBdo) OnChange(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBdo) OnClick(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBdo) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBdo) OnCopy(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBdo) OnCut(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBdo) OnDblClick(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBdo) OnDrag(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBdo) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBdo) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBdo) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBdo) OnDragOver(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBdo) OnDragStart(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBdo) OnDrop(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBdo) OnFocus(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBdo) OnInput(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBdo) OnInvalid(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBdo) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBdo) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBdo) OnKeyup(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBdo) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBdo) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBdo) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBdo) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBdo) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBdo) OnPaste(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBdo) OnReset(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBdo) OnScroll(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBdo) OnSearch(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBdo) OnSelect(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBdo) OnSubmit(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBdo) OnWheel(h EventHandler, scope ...interface{}) HTMLBdo {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBlockquote is the interface that describes a <blockquote> HTML element.
type HTMLBlockquote interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLBlockquote

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLBlockquote

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBlockquote

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBlockquote

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBlockquote

	// Cite specifies a URL which explains the quote/deleted/inserted text.
	Cite(v string) HTMLBlockquote

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBlockquote

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBlockquote

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBlockquote

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBlockquote

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBlockquote

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBlockquote

	// ID specifies a unique id for an element.
	ID(v string) HTMLBlockquote

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBlockquote

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBlockquote

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBlockquote

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBlockquote

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBlockquote

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBlockquote

	// Title specifies extra information about an element.
	Title(v string) HTMLBlockquote

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBlockquote

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBlockquote
}

// Blockquote returns an HTML element that defines a section that is quoted from another source.
func Blockquote() HTMLBlockquote {
	e := &htmlBlockquote{
		elem: elem{
			tag:         "blockquote",
			selfClosing: false,
		},
	}

	return e
}

type htmlBlockquote struct {
	elem
}

func (e *htmlBlockquote) Body(elems ...UI) HTMLBlockquote {
	e.setBody(elems...)
	return e
}

func (e *htmlBlockquote) Text(v interface{}) HTMLBlockquote {
	return e.Body(Text(v))
}

func (e *htmlBlockquote) AccessKey(v string) HTMLBlockquote {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBlockquote) Aria(k string, v interface{}) HTMLBlockquote {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBlockquote) Attr(n string, v interface{}) HTMLBlockquote {
	e.setAttr(n, v)
	return e
}

func (e *htmlBlockquote) Cite(v string) HTMLBlockquote {
	e.setAttr("cite", v)
	return e
}

func (e *htmlBlockquote) Class(v ...string) HTMLBlockquote {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBlockquote) ContentEditable(v bool) HTMLBlockquote {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBlockquote) DataSet(k string, v interface{}) HTMLBlockquote {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBlockquote) Dir(v string) HTMLBlockquote {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBlockquote) Draggable(v bool) HTMLBlockquote {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBlockquote) Hidden(v bool) HTMLBlockquote {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBlockquote) ID(v string) HTMLBlockquote {
	e.setAttr("id", v)
	return e
}

func (e *htmlBlockquote) Lang(v string) HTMLBlockquote {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBlockquote) Role(v string) HTMLBlockquote {
	e.setAttr("role", v)
	return e
}

func (e *htmlBlockquote) Spellcheck(v bool) HTMLBlockquote {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBlockquote) Style(k, v string) HTMLBlockquote {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBlockquote) Styles(s map[string]string) HTMLBlockquote {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBlockquote) TabIndex(v int) HTMLBlockquote {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBlockquote) Title(v string) HTMLBlockquote {
	e.setAttr("title", v)
	return e
}

func (e *htmlBlockquote) OnBlur(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBlockquote) OnChange(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBlockquote) OnClick(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBlockquote) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBlockquote) OnCopy(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBlockquote) OnCut(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDblClick(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDrag(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDragOver(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDragStart(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBlockquote) OnDrop(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBlockquote) OnFocus(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBlockquote) OnInput(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBlockquote) OnInvalid(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBlockquote) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBlockquote) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBlockquote) OnKeyup(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBlockquote) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBlockquote) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBlockquote) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBlockquote) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBlockquote) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBlockquote) OnPaste(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBlockquote) OnReset(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBlockquote) OnScroll(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBlockquote) OnSearch(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBlockquote) OnSelect(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBlockquote) OnSubmit(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBlockquote) OnWheel(h EventHandler, scope ...interface{}) HTMLBlockquote {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBody is the interface that describes a <body> HTML element.
type HTMLBody interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLBody

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLBody

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBody

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBody

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBody

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBody

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBody

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBody

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBody

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBody

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBody

	// ID specifies a unique id for an element.
	ID(v string) HTMLBody

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBody

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBody

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBody

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBody

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBody

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBody

	// Title specifies extra information about an element.
	Title(v string) HTMLBody

	// OnAfterPrint runs the given handler after the document is printed.
	OnAfterPrint(h EventHandler, scope ...interface{}) HTMLBody

	// OnBeforePrint calls the given handler before the document is printed.
	OnBeforePrint(h EventHandler, scope ...interface{}) HTMLBody

	// OnBeforeUnload calls the given handler when the document is about to be unloaded.
	OnBeforeUnload(h EventHandler, scope ...interface{}) HTMLBody

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBody

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBody

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBody

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBody

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBody

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBody

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBody

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBody

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBody

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBody

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBody

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBody

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBody

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBody

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLBody

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBody

	// OnHashChange calls the given handler when there has been changes to the anchor part of the a URL.
	OnHashChange(h EventHandler, scope ...interface{}) HTMLBody

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBody

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBody

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBody

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBody

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBody

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLBody

	// OnMessage calls then given handler when a message is triggered.
	OnMessage(h EventHandler, scope ...interface{}) HTMLBody

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBody

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBody

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBody

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBody

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBody

	// OnOffline calls the given handler when the browser starts to work offline.
	OnOffline(h EventHandler, scope ...interface{}) HTMLBody

	// OnOnline calls the given handler when the browser starts to work online.
	OnOnline(h EventHandler, scope ...interface{}) HTMLBody

	// OnPageHide calls the given handler when a user navigates away from a page.
	OnPageHide(h EventHandler, scope ...interface{}) HTMLBody

	// OnPageShow calls the given handler when a user navigates to a page.
	OnPageShow(h EventHandler, scope ...interface{}) HTMLBody

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBody

	// OnPopState calls the given handler when the window's history changes.
	OnPopState(h EventHandler, scope ...interface{}) HTMLBody

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBody

	// OnResize calls the given handler when the browser window is resized.
	OnResize(h EventHandler, scope ...interface{}) HTMLBody

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBody

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBody

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBody

	// OnStorage calls the given handler when a Web Storage area is updated.
	OnStorage(h EventHandler, scope ...interface{}) HTMLBody

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBody

	// OnUnload calls the given handler once a page has unloaded (or the browser window has been closed).
	OnUnload(h EventHandler, scope ...interface{}) HTMLBody

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBody
}

// Body returns an HTML element that defines the document's body.
func Body() HTMLBody {
	e := &htmlBody{
		elem: elem{
			tag:         "body",
			selfClosing: false,
		},
	}

	return e
}

type htmlBody struct {
	elem
}

func (e *htmlBody) Body(elems ...UI) HTMLBody {
	e.setBody(elems...)
	return e
}

func (e *htmlBody) Text(v interface{}) HTMLBody {
	return e.Body(Text(v))
}

func (e *htmlBody) AccessKey(v string) HTMLBody {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBody) Aria(k string, v interface{}) HTMLBody {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBody) Attr(n string, v interface{}) HTMLBody {
	e.setAttr(n, v)
	return e
}

func (e *htmlBody) Class(v ...string) HTMLBody {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBody) ContentEditable(v bool) HTMLBody {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBody) DataSet(k string, v interface{}) HTMLBody {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBody) Dir(v string) HTMLBody {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBody) Draggable(v bool) HTMLBody {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBody) Hidden(v bool) HTMLBody {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBody) ID(v string) HTMLBody {
	e.setAttr("id", v)
	return e
}

func (e *htmlBody) Lang(v string) HTMLBody {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBody) Role(v string) HTMLBody {
	e.setAttr("role", v)
	return e
}

func (e *htmlBody) Spellcheck(v bool) HTMLBody {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBody) Style(k, v string) HTMLBody {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBody) Styles(s map[string]string) HTMLBody {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBody) TabIndex(v int) HTMLBody {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBody) Title(v string) HTMLBody {
	e.setAttr("title", v)
	return e
}

func (e *htmlBody) OnAfterPrint(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("afterprint", h, scope...)
	return e
}

func (e *htmlBody) OnBeforePrint(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("beforeprint", h, scope...)
	return e
}

func (e *htmlBody) OnBeforeUnload(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("beforeunload", h, scope...)
	return e
}

func (e *htmlBody) OnBlur(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBody) OnChange(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBody) OnClick(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBody) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBody) OnCopy(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBody) OnCut(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBody) OnDblClick(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBody) OnDrag(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBody) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBody) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBody) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBody) OnDragOver(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBody) OnDragStart(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBody) OnDrop(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBody) OnError(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlBody) OnFocus(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBody) OnHashChange(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("hashchange", h, scope...)
	return e
}

func (e *htmlBody) OnInput(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBody) OnInvalid(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBody) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBody) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBody) OnKeyup(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBody) OnLoad(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlBody) OnMessage(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("message", h, scope...)
	return e
}

func (e *htmlBody) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBody) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBody) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBody) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBody) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBody) OnOffline(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("offline", h, scope...)
	return e
}

func (e *htmlBody) OnOnline(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("online", h, scope...)
	return e
}

func (e *htmlBody) OnPageHide(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("pagehide", h, scope...)
	return e
}

func (e *htmlBody) OnPageShow(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("pageshow", h, scope...)
	return e
}

func (e *htmlBody) OnPaste(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBody) OnPopState(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("popstate", h, scope...)
	return e
}

func (e *htmlBody) OnReset(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBody) OnResize(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("resize", h, scope...)
	return e
}

func (e *htmlBody) OnScroll(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBody) OnSearch(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBody) OnSelect(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBody) OnStorage(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("storage", h, scope...)
	return e
}

func (e *htmlBody) OnSubmit(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBody) OnUnload(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("unload", h, scope...)
	return e
}

func (e *htmlBody) OnWheel(h EventHandler, scope ...interface{}) HTMLBody {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLBr is the interface that describes a <br> HTML element.
type HTMLBr interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLBr

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLBr

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLBr

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLBr

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLBr

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLBr

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLBr

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLBr

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLBr

	// ID specifies a unique id for an element.
	ID(v string) HTMLBr

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLBr

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLBr

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLBr

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLBr

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLBr

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLBr

	// Title specifies extra information about an element.
	Title(v string) HTMLBr

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLBr

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLBr

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLBr

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLBr

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLBr

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLBr

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLBr

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLBr

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLBr

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLBr

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLBr

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLBr

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLBr

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLBr

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLBr

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLBr

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLBr

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLBr

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLBr

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLBr

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLBr

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLBr

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLBr

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLBr

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLBr

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLBr

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLBr

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLBr

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLBr

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLBr

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLBr

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLBr
}

// Br returns an HTML element that defines a single line break.
func Br() HTMLBr {
	e := &htmlBr{
		elem: elem{
			tag:         "br",
			selfClosing: true,
		},
	}

	return e
}

type htmlBr struct {
	elem
}

func (e *htmlBr) AccessKey(v string) HTMLBr {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlBr) Aria(k string, v interface{}) HTMLBr {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBr) Attr(n string, v interface{}) HTMLBr {
	e.setAttr(n, v)
	return e
}

func (e *htmlBr) Class(v ...string) HTMLBr {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlBr) ContentEditable(v bool) HTMLBr {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlBr) DataSet(k string, v interface{}) HTMLBr {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlBr) Dir(v string) HTMLBr {
	e.setAttr("dir", v)
	return e
}

func (e *htmlBr) Draggable(v bool) HTMLBr {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlBr) Hidden(v bool) HTMLBr {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlBr) ID(v string) HTMLBr {
	e.setAttr("id", v)
	return e
}

func (e *htmlBr) Lang(v string) HTMLBr {
	e.setAttr("lang", v)
	return e
}

func (e *htmlBr) Role(v string) HTMLBr {
	e.setAttr("role", v)
	return e
}

func (e *htmlBr) Spellcheck(v bool) HTMLBr {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlBr) Style(k, v string) HTMLBr {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlBr) Styles(s map[string]string) HTMLBr {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlBr) TabIndex(v int) HTMLBr {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlBr) Title(v string) HTMLBr {
	e.setAttr("title", v)
	return e
}

func (e *htmlBr) OnBlur(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlBr) OnChange(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlBr) OnClick(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlBr) OnContextMenu(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlBr) OnCopy(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlBr) OnCut(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlBr) OnDblClick(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlBr) OnDrag(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlBr) OnDragEnd(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlBr) OnDragEnter(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlBr) OnDragLeave(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlBr) OnDragOver(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlBr) OnDragStart(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlBr) OnDrop(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlBr) OnFocus(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlBr) OnInput(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlBr) OnInvalid(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlBr) OnKeyDown(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlBr) OnKeyPress(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlBr) OnKeyup(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlBr) OnMouseDown(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlBr) OnMouseMove(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlBr) OnMouseOut(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlBr) OnMouseOver(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlBr) OnMouseUp(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlBr) OnPaste(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlBr) OnReset(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlBr) OnScroll(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlBr) OnSearch(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlBr) OnSelect(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlBr) OnSubmit(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlBr) OnWheel(h EventHandler, scope ...interface{}) HTMLBr {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLButton is the interface that describes a <button> HTML element.
type HTMLButton interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLButton

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLButton

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLButton

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLButton

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLButton

	// AutoFocus specifies that the element should automatically get focus when the page loads.
	AutoFocus(v bool) HTMLButton

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLButton

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLButton

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLButton

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLButton

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLButton

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLButton

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLButton

	// FormAction specifies where to send the form-data when a form is submitted. Only for submit type.
	FormAction(v string) HTMLButton

	// FormEncType specifies how form-data should be encoded before sending it to a server. Only for submit type.
	FormEncType(v string) HTMLButton

	// FormMethod specifies how to send the form-data (which HTTP method to use). Only for submit type.
	FormMethod(v string) HTMLButton

	// FormNoValidate specifies that the form-data should not be validated on submission. Only for submit type.
	FormNoValidate(v bool) HTMLButton

	// FormTarget specifies where to display the response after submitting the form. Only for submit type.
	FormTarget(v string) HTMLButton

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLButton

	// ID specifies a unique id for an element.
	ID(v string) HTMLButton

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLButton

	// Name specifies the name of the element.
	Name(v string) HTMLButton

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLButton

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLButton

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLButton

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLButton

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLButton

	// Title specifies extra information about an element.
	Title(v string) HTMLButton

	// Type specifies the type of element.
	Type(v string) HTMLButton

	// Value specifies the value of the element.
	Value(v interface{}) HTMLButton

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLButton

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLButton

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLButton

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLButton

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLButton

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLButton

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLButton

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLButton

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLButton

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLButton

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLButton

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLButton

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLButton

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLButton

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLButton

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLButton

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLButton

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLButton

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLButton

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLButton

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLButton

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLButton

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLButton

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLButton

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLButton

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLButton

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLButton

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLButton

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLButton

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLButton

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLButton

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLButton
}

// Button returns an HTML element that defines a clickable button.
func Button() HTMLButton {
	e := &htmlButton{
		elem: elem{
			tag:         "button",
			selfClosing: false,
		},
	}

	return e
}

type htmlButton struct {
	elem
}

func (e *htmlButton) Body(elems ...UI) HTMLButton {
	e.setBody(elems...)
	return e
}

func (e *htmlButton) Text(v interface{}) HTMLButton {
	return e.Body(Text(v))
}

func (e *htmlButton) AccessKey(v string) HTMLButton {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlButton) Aria(k string, v interface{}) HTMLButton {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlButton) Attr(n string, v interface{}) HTMLButton {
	e.setAttr(n, v)
	return e
}

func (e *htmlButton) AutoFocus(v bool) HTMLButton {
	e.setAttr("autofocus", v)
	return e
}

func (e *htmlButton) Class(v ...string) HTMLButton {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlButton) ContentEditable(v bool) HTMLButton {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlButton) DataSet(k string, v interface{}) HTMLButton {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlButton) Dir(v string) HTMLButton {
	e.setAttr("dir", v)
	return e
}

func (e *htmlButton) Disabled(v bool) HTMLButton {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlButton) Draggable(v bool) HTMLButton {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlButton) Form(v string) HTMLButton {
	e.setAttr("form", v)
	return e
}

func (e *htmlButton) FormAction(v string) HTMLButton {
	e.setAttr("formaction", v)
	return e
}

func (e *htmlButton) FormEncType(v string) HTMLButton {
	e.setAttr("formenctype", v)
	return e
}

func (e *htmlButton) FormMethod(v string) HTMLButton {
	e.setAttr("formmethod", v)
	return e
}

func (e *htmlButton) FormNoValidate(v bool) HTMLButton {
	e.setAttr("formnovalidate", v)
	return e
}

func (e *htmlButton) FormTarget(v string) HTMLButton {
	e.setAttr("formtarget", v)
	return e
}

func (e *htmlButton) Hidden(v bool) HTMLButton {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlButton) ID(v string) HTMLButton {
	e.setAttr("id", v)
	return e
}

func (e *htmlButton) Lang(v string) HTMLButton {
	e.setAttr("lang", v)
	return e
}

func (e *htmlButton) Name(v string) HTMLButton {
	e.setAttr("name", v)
	return e
}

func (e *htmlButton) Role(v string) HTMLButton {
	e.setAttr("role", v)
	return e
}

func (e *htmlButton) Spellcheck(v bool) HTMLButton {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlButton) Style(k, v string) HTMLButton {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlButton) Styles(s map[string]string) HTMLButton {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlButton) TabIndex(v int) HTMLButton {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlButton) Title(v string) HTMLButton {
	e.setAttr("title", v)
	return e
}

func (e *htmlButton) Type(v string) HTMLButton {
	e.setAttr("type", v)
	return e
}

func (e *htmlButton) Value(v interface{}) HTMLButton {
	e.setAttr("value", v)
	return e
}

func (e *htmlButton) OnBlur(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlButton) OnChange(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlButton) OnClick(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlButton) OnContextMenu(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlButton) OnCopy(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlButton) OnCut(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlButton) OnDblClick(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlButton) OnDrag(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlButton) OnDragEnd(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlButton) OnDragEnter(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlButton) OnDragLeave(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlButton) OnDragOver(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlButton) OnDragStart(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlButton) OnDrop(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlButton) OnFocus(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlButton) OnInput(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlButton) OnInvalid(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlButton) OnKeyDown(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlButton) OnKeyPress(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlButton) OnKeyup(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlButton) OnMouseDown(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlButton) OnMouseMove(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlButton) OnMouseOut(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlButton) OnMouseOver(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlButton) OnMouseUp(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlButton) OnPaste(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlButton) OnReset(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlButton) OnScroll(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlButton) OnSearch(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlButton) OnSelect(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlButton) OnSubmit(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlButton) OnWheel(h EventHandler, scope ...interface{}) HTMLButton {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLCanvas is the interface that describes a <canvas> HTML element.
type HTMLCanvas interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLCanvas

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLCanvas

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLCanvas

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLCanvas

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLCanvas

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLCanvas

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLCanvas

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLCanvas

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLCanvas

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLCanvas

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLCanvas

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLCanvas

	// ID specifies a unique id for an element.
	ID(v string) HTMLCanvas

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLCanvas

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLCanvas

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLCanvas

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLCanvas

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLCanvas

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLCanvas

	// Title specifies extra information about an element.
	Title(v string) HTMLCanvas

	// Width specifies the width of the element.
	Width(v int) HTMLCanvas

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLCanvas

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLCanvas
}

// Canvas returns an HTML element that is used to draw graphics on the fly.
func Canvas() HTMLCanvas {
	e := &htmlCanvas{
		elem: elem{
			tag:         "canvas",
			selfClosing: false,
		},
	}

	return e
}

type htmlCanvas struct {
	elem
}

func (e *htmlCanvas) Body(elems ...UI) HTMLCanvas {
	e.setBody(elems...)
	return e
}

func (e *htmlCanvas) Text(v interface{}) HTMLCanvas {
	return e.Body(Text(v))
}

func (e *htmlCanvas) AccessKey(v string) HTMLCanvas {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlCanvas) Aria(k string, v interface{}) HTMLCanvas {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCanvas) Attr(n string, v interface{}) HTMLCanvas {
	e.setAttr(n, v)
	return e
}

func (e *htmlCanvas) Class(v ...string) HTMLCanvas {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlCanvas) ContentEditable(v bool) HTMLCanvas {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlCanvas) DataSet(k string, v interface{}) HTMLCanvas {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCanvas) Dir(v string) HTMLCanvas {
	e.setAttr("dir", v)
	return e
}

func (e *htmlCanvas) Draggable(v bool) HTMLCanvas {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlCanvas) Height(v int) HTMLCanvas {
	e.setAttr("height", v)
	return e
}

func (e *htmlCanvas) Hidden(v bool) HTMLCanvas {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlCanvas) ID(v string) HTMLCanvas {
	e.setAttr("id", v)
	return e
}

func (e *htmlCanvas) Lang(v string) HTMLCanvas {
	e.setAttr("lang", v)
	return e
}

func (e *htmlCanvas) Role(v string) HTMLCanvas {
	e.setAttr("role", v)
	return e
}

func (e *htmlCanvas) Spellcheck(v bool) HTMLCanvas {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlCanvas) Style(k, v string) HTMLCanvas {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlCanvas) Styles(s map[string]string) HTMLCanvas {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlCanvas) TabIndex(v int) HTMLCanvas {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlCanvas) Title(v string) HTMLCanvas {
	e.setAttr("title", v)
	return e
}

func (e *htmlCanvas) Width(v int) HTMLCanvas {
	e.setAttr("width", v)
	return e
}

func (e *htmlCanvas) OnBlur(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlCanvas) OnChange(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlCanvas) OnClick(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlCanvas) OnContextMenu(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlCanvas) OnCopy(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlCanvas) OnCut(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlCanvas) OnDblClick(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlCanvas) OnDrag(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlCanvas) OnDragEnd(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlCanvas) OnDragEnter(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlCanvas) OnDragLeave(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlCanvas) OnDragOver(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlCanvas) OnDragStart(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlCanvas) OnDrop(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlCanvas) OnFocus(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlCanvas) OnInput(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlCanvas) OnInvalid(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlCanvas) OnKeyDown(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlCanvas) OnKeyPress(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlCanvas) OnKeyup(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlCanvas) OnMouseDown(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlCanvas) OnMouseMove(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlCanvas) OnMouseOut(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlCanvas) OnMouseOver(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlCanvas) OnMouseUp(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlCanvas) OnPaste(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlCanvas) OnReset(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlCanvas) OnScroll(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlCanvas) OnSearch(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlCanvas) OnSelect(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlCanvas) OnSubmit(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlCanvas) OnWheel(h EventHandler, scope ...interface{}) HTMLCanvas {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLCaption is the interface that describes a <caption> HTML element.
type HTMLCaption interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLCaption

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLCaption

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLCaption

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLCaption

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLCaption

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLCaption

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLCaption

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLCaption

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLCaption

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLCaption

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLCaption

	// ID specifies a unique id for an element.
	ID(v string) HTMLCaption

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLCaption

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLCaption

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLCaption

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLCaption

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLCaption

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLCaption

	// Title specifies extra information about an element.
	Title(v string) HTMLCaption

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLCaption

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLCaption

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLCaption

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLCaption

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLCaption

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLCaption

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLCaption

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLCaption

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLCaption

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLCaption

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLCaption

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLCaption

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLCaption

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLCaption

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLCaption

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLCaption

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLCaption

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLCaption

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLCaption

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLCaption

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLCaption

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLCaption

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLCaption

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLCaption

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLCaption
}

// Caption returns an HTML element that defines a table caption.
func Caption() HTMLCaption {
	e := &htmlCaption{
		elem: elem{
			tag:         "caption",
			selfClosing: false,
		},
	}

	return e
}

type htmlCaption struct {
	elem
}

func (e *htmlCaption) Body(elems ...UI) HTMLCaption {
	e.setBody(elems...)
	return e
}

func (e *htmlCaption) Text(v interface{}) HTMLCaption {
	return e.Body(Text(v))
}

func (e *htmlCaption) AccessKey(v string) HTMLCaption {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlCaption) Aria(k string, v interface{}) HTMLCaption {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCaption) Attr(n string, v interface{}) HTMLCaption {
	e.setAttr(n, v)
	return e
}

func (e *htmlCaption) Class(v ...string) HTMLCaption {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlCaption) ContentEditable(v bool) HTMLCaption {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlCaption) DataSet(k string, v interface{}) HTMLCaption {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCaption) Dir(v string) HTMLCaption {
	e.setAttr("dir", v)
	return e
}

func (e *htmlCaption) Draggable(v bool) HTMLCaption {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlCaption) Hidden(v bool) HTMLCaption {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlCaption) ID(v string) HTMLCaption {
	e.setAttr("id", v)
	return e
}

func (e *htmlCaption) Lang(v string) HTMLCaption {
	e.setAttr("lang", v)
	return e
}

func (e *htmlCaption) Role(v string) HTMLCaption {
	e.setAttr("role", v)
	return e
}

func (e *htmlCaption) Spellcheck(v bool) HTMLCaption {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlCaption) Style(k, v string) HTMLCaption {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlCaption) Styles(s map[string]string) HTMLCaption {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlCaption) TabIndex(v int) HTMLCaption {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlCaption) Title(v string) HTMLCaption {
	e.setAttr("title", v)
	return e
}

func (e *htmlCaption) OnBlur(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlCaption) OnChange(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlCaption) OnClick(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlCaption) OnContextMenu(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlCaption) OnCopy(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlCaption) OnCut(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlCaption) OnDblClick(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlCaption) OnDrag(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlCaption) OnDragEnd(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlCaption) OnDragEnter(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlCaption) OnDragLeave(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlCaption) OnDragOver(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlCaption) OnDragStart(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlCaption) OnDrop(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlCaption) OnFocus(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlCaption) OnInput(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlCaption) OnInvalid(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlCaption) OnKeyDown(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlCaption) OnKeyPress(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlCaption) OnKeyup(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlCaption) OnMouseDown(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlCaption) OnMouseMove(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlCaption) OnMouseOut(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlCaption) OnMouseOver(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlCaption) OnMouseUp(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlCaption) OnPaste(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlCaption) OnReset(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlCaption) OnScroll(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlCaption) OnSearch(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlCaption) OnSelect(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlCaption) OnSubmit(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlCaption) OnWheel(h EventHandler, scope ...interface{}) HTMLCaption {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLCite is the interface that describes a <cite> HTML element.
type HTMLCite interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLCite

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLCite

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLCite

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLCite

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLCite

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLCite

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLCite

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLCite

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLCite

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLCite

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLCite

	// ID specifies a unique id for an element.
	ID(v string) HTMLCite

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLCite

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLCite

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLCite

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLCite

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLCite

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLCite

	// Title specifies extra information about an element.
	Title(v string) HTMLCite

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLCite

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLCite

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLCite

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLCite

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLCite

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLCite

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLCite

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLCite

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLCite

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLCite

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLCite

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLCite

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLCite

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLCite

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLCite

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLCite

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLCite

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLCite

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLCite

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLCite

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLCite

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLCite

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLCite

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLCite

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLCite

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLCite

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLCite

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLCite

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLCite

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLCite

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLCite

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLCite
}

// Cite returns an HTML element that defines the title of a work.
func Cite() HTMLCite {
	e := &htmlCite{
		elem: elem{
			tag:         "cite",
			selfClosing: false,
		},
	}

	return e
}

type htmlCite struct {
	elem
}

func (e *htmlCite) Body(elems ...UI) HTMLCite {
	e.setBody(elems...)
	return e
}

func (e *htmlCite) Text(v interface{}) HTMLCite {
	return e.Body(Text(v))
}

func (e *htmlCite) AccessKey(v string) HTMLCite {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlCite) Aria(k string, v interface{}) HTMLCite {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCite) Attr(n string, v interface{}) HTMLCite {
	e.setAttr(n, v)
	return e
}

func (e *htmlCite) Class(v ...string) HTMLCite {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlCite) ContentEditable(v bool) HTMLCite {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlCite) DataSet(k string, v interface{}) HTMLCite {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCite) Dir(v string) HTMLCite {
	e.setAttr("dir", v)
	return e
}

func (e *htmlCite) Draggable(v bool) HTMLCite {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlCite) Hidden(v bool) HTMLCite {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlCite) ID(v string) HTMLCite {
	e.setAttr("id", v)
	return e
}

func (e *htmlCite) Lang(v string) HTMLCite {
	e.setAttr("lang", v)
	return e
}

func (e *htmlCite) Role(v string) HTMLCite {
	e.setAttr("role", v)
	return e
}

func (e *htmlCite) Spellcheck(v bool) HTMLCite {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlCite) Style(k, v string) HTMLCite {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlCite) Styles(s map[string]string) HTMLCite {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlCite) TabIndex(v int) HTMLCite {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlCite) Title(v string) HTMLCite {
	e.setAttr("title", v)
	return e
}

func (e *htmlCite) OnBlur(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlCite) OnChange(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlCite) OnClick(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlCite) OnContextMenu(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlCite) OnCopy(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlCite) OnCut(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlCite) OnDblClick(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlCite) OnDrag(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlCite) OnDragEnd(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlCite) OnDragEnter(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlCite) OnDragLeave(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlCite) OnDragOver(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlCite) OnDragStart(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlCite) OnDrop(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlCite) OnFocus(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlCite) OnInput(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlCite) OnInvalid(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlCite) OnKeyDown(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlCite) OnKeyPress(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlCite) OnKeyup(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlCite) OnMouseDown(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlCite) OnMouseMove(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlCite) OnMouseOut(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlCite) OnMouseOver(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlCite) OnMouseUp(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlCite) OnPaste(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlCite) OnReset(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlCite) OnScroll(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlCite) OnSearch(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlCite) OnSelect(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlCite) OnSubmit(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlCite) OnWheel(h EventHandler, scope ...interface{}) HTMLCite {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLCode is the interface that describes a <code> HTML element.
type HTMLCode interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLCode

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLCode

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLCode

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLCode

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLCode

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLCode

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLCode

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLCode

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLCode

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLCode

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLCode

	// ID specifies a unique id for an element.
	ID(v string) HTMLCode

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLCode

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLCode

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLCode

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLCode

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLCode

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLCode

	// Title specifies extra information about an element.
	Title(v string) HTMLCode

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLCode

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLCode

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLCode

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLCode

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLCode

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLCode

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLCode

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLCode

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLCode

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLCode

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLCode

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLCode

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLCode

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLCode

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLCode

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLCode

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLCode

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLCode

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLCode

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLCode

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLCode

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLCode

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLCode

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLCode

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLCode

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLCode

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLCode

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLCode

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLCode

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLCode

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLCode

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLCode
}

// Code returns an HTML element that defines a piece of computer code.
func Code() HTMLCode {
	e := &htmlCode{
		elem: elem{
			tag:         "code",
			selfClosing: false,
		},
	}

	return e
}

type htmlCode struct {
	elem
}

func (e *htmlCode) Body(elems ...UI) HTMLCode {
	e.setBody(elems...)
	return e
}

func (e *htmlCode) Text(v interface{}) HTMLCode {
	return e.Body(Text(v))
}

func (e *htmlCode) AccessKey(v string) HTMLCode {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlCode) Aria(k string, v interface{}) HTMLCode {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCode) Attr(n string, v interface{}) HTMLCode {
	e.setAttr(n, v)
	return e
}

func (e *htmlCode) Class(v ...string) HTMLCode {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlCode) ContentEditable(v bool) HTMLCode {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlCode) DataSet(k string, v interface{}) HTMLCode {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCode) Dir(v string) HTMLCode {
	e.setAttr("dir", v)
	return e
}

func (e *htmlCode) Draggable(v bool) HTMLCode {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlCode) Hidden(v bool) HTMLCode {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlCode) ID(v string) HTMLCode {
	e.setAttr("id", v)
	return e
}

func (e *htmlCode) Lang(v string) HTMLCode {
	e.setAttr("lang", v)
	return e
}

func (e *htmlCode) Role(v string) HTMLCode {
	e.setAttr("role", v)
	return e
}

func (e *htmlCode) Spellcheck(v bool) HTMLCode {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlCode) Style(k, v string) HTMLCode {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlCode) Styles(s map[string]string) HTMLCode {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlCode) TabIndex(v int) HTMLCode {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlCode) Title(v string) HTMLCode {
	e.setAttr("title", v)
	return e
}

func (e *htmlCode) OnBlur(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlCode) OnChange(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlCode) OnClick(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlCode) OnContextMenu(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlCode) OnCopy(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlCode) OnCut(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlCode) OnDblClick(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlCode) OnDrag(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlCode) OnDragEnd(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlCode) OnDragEnter(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlCode) OnDragLeave(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlCode) OnDragOver(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlCode) OnDragStart(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlCode) OnDrop(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlCode) OnFocus(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlCode) OnInput(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlCode) OnInvalid(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlCode) OnKeyDown(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlCode) OnKeyPress(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlCode) OnKeyup(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlCode) OnMouseDown(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlCode) OnMouseMove(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlCode) OnMouseOut(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlCode) OnMouseOver(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlCode) OnMouseUp(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlCode) OnPaste(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlCode) OnReset(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlCode) OnScroll(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlCode) OnSearch(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlCode) OnSelect(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlCode) OnSubmit(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlCode) OnWheel(h EventHandler, scope ...interface{}) HTMLCode {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLCol is the interface that describes a <col> HTML element.
type HTMLCol interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLCol

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLCol

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLCol

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLCol

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLCol

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLCol

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLCol

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLCol

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLCol

	// ID specifies a unique id for an element.
	ID(v string) HTMLCol

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLCol

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLCol

	// Span specifies the number of columns to span.
	Span(v int) HTMLCol

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLCol

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLCol

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLCol

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLCol

	// Title specifies extra information about an element.
	Title(v string) HTMLCol

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLCol

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLCol

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLCol

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLCol

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLCol

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLCol

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLCol

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLCol

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLCol

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLCol

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLCol

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLCol

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLCol

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLCol

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLCol

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLCol

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLCol

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLCol

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLCol

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLCol

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLCol

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLCol

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLCol

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLCol

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLCol

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLCol

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLCol

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLCol

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLCol

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLCol

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLCol

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLCol
}

// Col returns an HTML element that specifies column properties for each column within a colgroup element.
func Col() HTMLCol {
	e := &htmlCol{
		elem: elem{
			tag:         "col",
			selfClosing: true,
		},
	}

	return e
}

type htmlCol struct {
	elem
}

func (e *htmlCol) AccessKey(v string) HTMLCol {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlCol) Aria(k string, v interface{}) HTMLCol {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCol) Attr(n string, v interface{}) HTMLCol {
	e.setAttr(n, v)
	return e
}

func (e *htmlCol) Class(v ...string) HTMLCol {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlCol) ContentEditable(v bool) HTMLCol {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlCol) DataSet(k string, v interface{}) HTMLCol {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlCol) Dir(v string) HTMLCol {
	e.setAttr("dir", v)
	return e
}

func (e *htmlCol) Draggable(v bool) HTMLCol {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlCol) Hidden(v bool) HTMLCol {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlCol) ID(v string) HTMLCol {
	e.setAttr("id", v)
	return e
}

func (e *htmlCol) Lang(v string) HTMLCol {
	e.setAttr("lang", v)
	return e
}

func (e *htmlCol) Role(v string) HTMLCol {
	e.setAttr("role", v)
	return e
}

func (e *htmlCol) Span(v int) HTMLCol {
	e.setAttr("span", v)
	return e
}

func (e *htmlCol) Spellcheck(v bool) HTMLCol {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlCol) Style(k, v string) HTMLCol {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlCol) Styles(s map[string]string) HTMLCol {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlCol) TabIndex(v int) HTMLCol {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlCol) Title(v string) HTMLCol {
	e.setAttr("title", v)
	return e
}

func (e *htmlCol) OnBlur(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlCol) OnChange(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlCol) OnClick(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlCol) OnContextMenu(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlCol) OnCopy(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlCol) OnCut(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlCol) OnDblClick(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlCol) OnDrag(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlCol) OnDragEnd(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlCol) OnDragEnter(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlCol) OnDragLeave(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlCol) OnDragOver(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlCol) OnDragStart(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlCol) OnDrop(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlCol) OnFocus(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlCol) OnInput(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlCol) OnInvalid(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlCol) OnKeyDown(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlCol) OnKeyPress(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlCol) OnKeyup(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlCol) OnMouseDown(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlCol) OnMouseMove(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlCol) OnMouseOut(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlCol) OnMouseOver(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlCol) OnMouseUp(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlCol) OnPaste(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlCol) OnReset(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlCol) OnScroll(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlCol) OnSearch(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlCol) OnSelect(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlCol) OnSubmit(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlCol) OnWheel(h EventHandler, scope ...interface{}) HTMLCol {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLColGroup is the interface that describes a <colgroup> HTML element.
type HTMLColGroup interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLColGroup

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLColGroup

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLColGroup

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLColGroup

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLColGroup

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLColGroup

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLColGroup

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLColGroup

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLColGroup

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLColGroup

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLColGroup

	// ID specifies a unique id for an element.
	ID(v string) HTMLColGroup

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLColGroup

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLColGroup

	// Span specifies the number of columns to span.
	Span(v int) HTMLColGroup

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLColGroup

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLColGroup

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLColGroup

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLColGroup

	// Title specifies extra information about an element.
	Title(v string) HTMLColGroup

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLColGroup

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLColGroup
}

// ColGroup returns an HTML element that specifies a group of one or more columns in a table for formatting.
func ColGroup() HTMLColGroup {
	e := &htmlColGroup{
		elem: elem{
			tag:         "colgroup",
			selfClosing: false,
		},
	}

	return e
}

type htmlColGroup struct {
	elem
}

func (e *htmlColGroup) Body(elems ...UI) HTMLColGroup {
	e.setBody(elems...)
	return e
}

func (e *htmlColGroup) Text(v interface{}) HTMLColGroup {
	return e.Body(Text(v))
}

func (e *htmlColGroup) AccessKey(v string) HTMLColGroup {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlColGroup) Aria(k string, v interface{}) HTMLColGroup {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlColGroup) Attr(n string, v interface{}) HTMLColGroup {
	e.setAttr(n, v)
	return e
}

func (e *htmlColGroup) Class(v ...string) HTMLColGroup {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlColGroup) ContentEditable(v bool) HTMLColGroup {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlColGroup) DataSet(k string, v interface{}) HTMLColGroup {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlColGroup) Dir(v string) HTMLColGroup {
	e.setAttr("dir", v)
	return e
}

func (e *htmlColGroup) Draggable(v bool) HTMLColGroup {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlColGroup) Hidden(v bool) HTMLColGroup {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlColGroup) ID(v string) HTMLColGroup {
	e.setAttr("id", v)
	return e
}

func (e *htmlColGroup) Lang(v string) HTMLColGroup {
	e.setAttr("lang", v)
	return e
}

func (e *htmlColGroup) Role(v string) HTMLColGroup {
	e.setAttr("role", v)
	return e
}

func (e *htmlColGroup) Span(v int) HTMLColGroup {
	e.setAttr("span", v)
	return e
}

func (e *htmlColGroup) Spellcheck(v bool) HTMLColGroup {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlColGroup) Style(k, v string) HTMLColGroup {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlColGroup) Styles(s map[string]string) HTMLColGroup {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlColGroup) TabIndex(v int) HTMLColGroup {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlColGroup) Title(v string) HTMLColGroup {
	e.setAttr("title", v)
	return e
}

func (e *htmlColGroup) OnBlur(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlColGroup) OnChange(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlColGroup) OnClick(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlColGroup) OnContextMenu(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlColGroup) OnCopy(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlColGroup) OnCut(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlColGroup) OnDblClick(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlColGroup) OnDrag(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlColGroup) OnDragEnd(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlColGroup) OnDragEnter(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlColGroup) OnDragLeave(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlColGroup) OnDragOver(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlColGroup) OnDragStart(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlColGroup) OnDrop(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlColGroup) OnFocus(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlColGroup) OnInput(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlColGroup) OnInvalid(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlColGroup) OnKeyDown(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlColGroup) OnKeyPress(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlColGroup) OnKeyup(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlColGroup) OnMouseDown(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlColGroup) OnMouseMove(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlColGroup) OnMouseOut(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlColGroup) OnMouseOver(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlColGroup) OnMouseUp(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlColGroup) OnPaste(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlColGroup) OnReset(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlColGroup) OnScroll(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlColGroup) OnSearch(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlColGroup) OnSelect(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlColGroup) OnSubmit(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlColGroup) OnWheel(h EventHandler, scope ...interface{}) HTMLColGroup {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLData is the interface that describes a <data> HTML element.
type HTMLData interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLData

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLData

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLData

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLData

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLData

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLData

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLData

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLData

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLData

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLData

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLData

	// ID specifies a unique id for an element.
	ID(v string) HTMLData

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLData

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLData

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLData

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLData

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLData

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLData

	// Title specifies extra information about an element.
	Title(v string) HTMLData

	// Value specifies the value of the element.
	Value(v interface{}) HTMLData
}

// Data returns an HTML element that links the given content with a machine-readable translation.
func Data() HTMLData {
	e := &htmlData{
		elem: elem{
			tag:         "data",
			selfClosing: false,
		},
	}

	return e
}

type htmlData struct {
	elem
}

func (e *htmlData) Body(elems ...UI) HTMLData {
	e.setBody(elems...)
	return e
}

func (e *htmlData) Text(v interface{}) HTMLData {
	return e.Body(Text(v))
}

func (e *htmlData) AccessKey(v string) HTMLData {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlData) Aria(k string, v interface{}) HTMLData {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlData) Attr(n string, v interface{}) HTMLData {
	e.setAttr(n, v)
	return e
}

func (e *htmlData) Class(v ...string) HTMLData {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlData) ContentEditable(v bool) HTMLData {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlData) DataSet(k string, v interface{}) HTMLData {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlData) Dir(v string) HTMLData {
	e.setAttr("dir", v)
	return e
}

func (e *htmlData) Draggable(v bool) HTMLData {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlData) Hidden(v bool) HTMLData {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlData) ID(v string) HTMLData {
	e.setAttr("id", v)
	return e
}

func (e *htmlData) Lang(v string) HTMLData {
	e.setAttr("lang", v)
	return e
}

func (e *htmlData) Role(v string) HTMLData {
	e.setAttr("role", v)
	return e
}

func (e *htmlData) Spellcheck(v bool) HTMLData {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlData) Style(k, v string) HTMLData {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlData) Styles(s map[string]string) HTMLData {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlData) TabIndex(v int) HTMLData {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlData) Title(v string) HTMLData {
	e.setAttr("title", v)
	return e
}

func (e *htmlData) Value(v interface{}) HTMLData {
	e.setAttr("value", v)
	return e
}

// HTMLDataList is the interface that describes a <datalist> HTML element.
type HTMLDataList interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDataList

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDataList

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDataList

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDataList

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDataList

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDataList

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDataList

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDataList

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDataList

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDataList

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDataList

	// ID specifies a unique id for an element.
	ID(v string) HTMLDataList

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDataList

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDataList

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDataList

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDataList

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDataList

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDataList

	// Title specifies extra information about an element.
	Title(v string) HTMLDataList

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDataList

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDataList

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDataList

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDataList

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDataList

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDataList

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDataList

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDataList

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDataList

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDataList

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDataList

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDataList

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDataList

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDataList

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDataList

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDataList

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDataList

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDataList

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDataList

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDataList

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDataList

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDataList

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDataList

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDataList

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDataList
}

// DataList returns an HTML element that specifies a list of pre-defined options for input controls.
func DataList() HTMLDataList {
	e := &htmlDataList{
		elem: elem{
			tag:         "datalist",
			selfClosing: false,
		},
	}

	return e
}

type htmlDataList struct {
	elem
}

func (e *htmlDataList) Body(elems ...UI) HTMLDataList {
	e.setBody(elems...)
	return e
}

func (e *htmlDataList) Text(v interface{}) HTMLDataList {
	return e.Body(Text(v))
}

func (e *htmlDataList) AccessKey(v string) HTMLDataList {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDataList) Aria(k string, v interface{}) HTMLDataList {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDataList) Attr(n string, v interface{}) HTMLDataList {
	e.setAttr(n, v)
	return e
}

func (e *htmlDataList) Class(v ...string) HTMLDataList {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDataList) ContentEditable(v bool) HTMLDataList {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDataList) DataSet(k string, v interface{}) HTMLDataList {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDataList) Dir(v string) HTMLDataList {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDataList) Draggable(v bool) HTMLDataList {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDataList) Hidden(v bool) HTMLDataList {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDataList) ID(v string) HTMLDataList {
	e.setAttr("id", v)
	return e
}

func (e *htmlDataList) Lang(v string) HTMLDataList {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDataList) Role(v string) HTMLDataList {
	e.setAttr("role", v)
	return e
}

func (e *htmlDataList) Spellcheck(v bool) HTMLDataList {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDataList) Style(k, v string) HTMLDataList {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDataList) Styles(s map[string]string) HTMLDataList {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDataList) TabIndex(v int) HTMLDataList {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDataList) Title(v string) HTMLDataList {
	e.setAttr("title", v)
	return e
}

func (e *htmlDataList) OnBlur(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDataList) OnChange(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDataList) OnClick(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDataList) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDataList) OnCopy(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDataList) OnCut(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDataList) OnDblClick(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDataList) OnDrag(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDataList) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDataList) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDataList) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDataList) OnDragOver(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDataList) OnDragStart(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDataList) OnDrop(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDataList) OnFocus(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDataList) OnInput(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDataList) OnInvalid(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDataList) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDataList) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDataList) OnKeyup(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDataList) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDataList) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDataList) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDataList) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDataList) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDataList) OnPaste(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDataList) OnReset(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDataList) OnScroll(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDataList) OnSearch(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDataList) OnSelect(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDataList) OnSubmit(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDataList) OnWheel(h EventHandler, scope ...interface{}) HTMLDataList {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDd is the interface that describes a <dd> HTML element.
type HTMLDd interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDd

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDd

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDd

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDd

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDd

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDd

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDd

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDd

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDd

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDd

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDd

	// ID specifies a unique id for an element.
	ID(v string) HTMLDd

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDd

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDd

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDd

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDd

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDd

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDd

	// Title specifies extra information about an element.
	Title(v string) HTMLDd

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDd

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDd

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDd

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDd

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDd

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDd

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDd

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDd

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDd

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDd

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDd

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDd

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDd

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDd

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDd

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDd

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDd

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDd

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDd

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDd

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDd

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDd

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDd

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDd

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDd

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDd

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDd

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDd

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDd

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDd

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDd

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDd
}

// Dd returns an HTML element that defines a description/value of a term in a description list.
func Dd() HTMLDd {
	e := &htmlDd{
		elem: elem{
			tag:         "dd",
			selfClosing: false,
		},
	}

	return e
}

type htmlDd struct {
	elem
}

func (e *htmlDd) Body(elems ...UI) HTMLDd {
	e.setBody(elems...)
	return e
}

func (e *htmlDd) Text(v interface{}) HTMLDd {
	return e.Body(Text(v))
}

func (e *htmlDd) AccessKey(v string) HTMLDd {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDd) Aria(k string, v interface{}) HTMLDd {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDd) Attr(n string, v interface{}) HTMLDd {
	e.setAttr(n, v)
	return e
}

func (e *htmlDd) Class(v ...string) HTMLDd {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDd) ContentEditable(v bool) HTMLDd {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDd) DataSet(k string, v interface{}) HTMLDd {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDd) Dir(v string) HTMLDd {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDd) Draggable(v bool) HTMLDd {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDd) Hidden(v bool) HTMLDd {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDd) ID(v string) HTMLDd {
	e.setAttr("id", v)
	return e
}

func (e *htmlDd) Lang(v string) HTMLDd {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDd) Role(v string) HTMLDd {
	e.setAttr("role", v)
	return e
}

func (e *htmlDd) Spellcheck(v bool) HTMLDd {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDd) Style(k, v string) HTMLDd {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDd) Styles(s map[string]string) HTMLDd {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDd) TabIndex(v int) HTMLDd {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDd) Title(v string) HTMLDd {
	e.setAttr("title", v)
	return e
}

func (e *htmlDd) OnBlur(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDd) OnChange(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDd) OnClick(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDd) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDd) OnCopy(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDd) OnCut(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDd) OnDblClick(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDd) OnDrag(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDd) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDd) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDd) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDd) OnDragOver(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDd) OnDragStart(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDd) OnDrop(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDd) OnFocus(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDd) OnInput(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDd) OnInvalid(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDd) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDd) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDd) OnKeyup(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDd) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDd) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDd) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDd) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDd) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDd) OnPaste(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDd) OnReset(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDd) OnScroll(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDd) OnSearch(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDd) OnSelect(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDd) OnSubmit(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDd) OnWheel(h EventHandler, scope ...interface{}) HTMLDd {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDel is the interface that describes a <del> HTML element.
type HTMLDel interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDel

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDel

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDel

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDel

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDel

	// Cite specifies a URL which explains the quote/deleted/inserted text.
	Cite(v string) HTMLDel

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDel

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDel

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDel

	// DateTime specifies the date and time.
	DateTime(v string) HTMLDel

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDel

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDel

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDel

	// ID specifies a unique id for an element.
	ID(v string) HTMLDel

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDel

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDel

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDel

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDel

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDel

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDel

	// Title specifies extra information about an element.
	Title(v string) HTMLDel

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDel

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDel

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDel

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDel

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDel

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDel

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDel

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDel

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDel

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDel

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDel

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDel

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDel

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDel

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDel

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDel

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDel

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDel

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDel

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDel

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDel

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDel

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDel

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDel

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDel

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDel

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDel

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDel

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDel

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDel

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDel

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDel
}

// Del returns an HTML element that defines text that has been deleted from a document.
func Del() HTMLDel {
	e := &htmlDel{
		elem: elem{
			tag:         "del",
			selfClosing: false,
		},
	}

	return e
}

type htmlDel struct {
	elem
}

func (e *htmlDel) Body(elems ...UI) HTMLDel {
	e.setBody(elems...)
	return e
}

func (e *htmlDel) Text(v interface{}) HTMLDel {
	return e.Body(Text(v))
}

func (e *htmlDel) AccessKey(v string) HTMLDel {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDel) Aria(k string, v interface{}) HTMLDel {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDel) Attr(n string, v interface{}) HTMLDel {
	e.setAttr(n, v)
	return e
}

func (e *htmlDel) Cite(v string) HTMLDel {
	e.setAttr("cite", v)
	return e
}

func (e *htmlDel) Class(v ...string) HTMLDel {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDel) ContentEditable(v bool) HTMLDel {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDel) DataSet(k string, v interface{}) HTMLDel {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDel) DateTime(v string) HTMLDel {
	e.setAttr("datetime", v)
	return e
}

func (e *htmlDel) Dir(v string) HTMLDel {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDel) Draggable(v bool) HTMLDel {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDel) Hidden(v bool) HTMLDel {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDel) ID(v string) HTMLDel {
	e.setAttr("id", v)
	return e
}

func (e *htmlDel) Lang(v string) HTMLDel {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDel) Role(v string) HTMLDel {
	e.setAttr("role", v)
	return e
}

func (e *htmlDel) Spellcheck(v bool) HTMLDel {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDel) Style(k, v string) HTMLDel {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDel) Styles(s map[string]string) HTMLDel {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDel) TabIndex(v int) HTMLDel {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDel) Title(v string) HTMLDel {
	e.setAttr("title", v)
	return e
}

func (e *htmlDel) OnBlur(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDel) OnChange(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDel) OnClick(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDel) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDel) OnCopy(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDel) OnCut(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDel) OnDblClick(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDel) OnDrag(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDel) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDel) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDel) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDel) OnDragOver(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDel) OnDragStart(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDel) OnDrop(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDel) OnFocus(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDel) OnInput(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDel) OnInvalid(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDel) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDel) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDel) OnKeyup(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDel) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDel) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDel) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDel) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDel) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDel) OnPaste(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDel) OnReset(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDel) OnScroll(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDel) OnSearch(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDel) OnSelect(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDel) OnSubmit(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDel) OnWheel(h EventHandler, scope ...interface{}) HTMLDel {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDetails is the interface that describes a <details> HTML element.
type HTMLDetails interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDetails

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDetails

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDetails

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDetails

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDetails

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDetails

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDetails

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDetails

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDetails

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDetails

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDetails

	// ID specifies a unique id for an element.
	ID(v string) HTMLDetails

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDetails

	// Open specifies that the details should be visible (open) to the user.
	Open(v bool) HTMLDetails

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDetails

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDetails

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDetails

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDetails

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDetails

	// Title specifies extra information about an element.
	Title(v string) HTMLDetails

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDetails

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDetails

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDetails

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDetails

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDetails

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDetails

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDetails

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDetails

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDetails

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDetails

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDetails

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDetails

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDetails

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDetails

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDetails

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDetails

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDetails

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDetails

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDetails

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDetails

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDetails

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDetails

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDetails

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDetails

	// OnToggle calls the given handler when the user opens or closes the details element.
	OnToggle(h EventHandler, scope ...interface{}) HTMLDetails

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDetails
}

// Details returns an HTML element that defines additional details that the user can view or hide.
func Details() HTMLDetails {
	e := &htmlDetails{
		elem: elem{
			tag:         "details",
			selfClosing: false,
		},
	}

	return e
}

type htmlDetails struct {
	elem
}

func (e *htmlDetails) Body(elems ...UI) HTMLDetails {
	e.setBody(elems...)
	return e
}

func (e *htmlDetails) Text(v interface{}) HTMLDetails {
	return e.Body(Text(v))
}

func (e *htmlDetails) AccessKey(v string) HTMLDetails {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDetails) Aria(k string, v interface{}) HTMLDetails {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDetails) Attr(n string, v interface{}) HTMLDetails {
	e.setAttr(n, v)
	return e
}

func (e *htmlDetails) Class(v ...string) HTMLDetails {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDetails) ContentEditable(v bool) HTMLDetails {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDetails) DataSet(k string, v interface{}) HTMLDetails {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDetails) Dir(v string) HTMLDetails {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDetails) Draggable(v bool) HTMLDetails {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDetails) Hidden(v bool) HTMLDetails {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDetails) ID(v string) HTMLDetails {
	e.setAttr("id", v)
	return e
}

func (e *htmlDetails) Lang(v string) HTMLDetails {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDetails) Open(v bool) HTMLDetails {
	e.setAttr("open", v)
	return e
}

func (e *htmlDetails) Role(v string) HTMLDetails {
	e.setAttr("role", v)
	return e
}

func (e *htmlDetails) Spellcheck(v bool) HTMLDetails {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDetails) Style(k, v string) HTMLDetails {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDetails) Styles(s map[string]string) HTMLDetails {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDetails) TabIndex(v int) HTMLDetails {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDetails) Title(v string) HTMLDetails {
	e.setAttr("title", v)
	return e
}

func (e *htmlDetails) OnBlur(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDetails) OnChange(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDetails) OnClick(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDetails) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDetails) OnCopy(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDetails) OnCut(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDetails) OnDblClick(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDetails) OnDrag(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDetails) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDetails) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDetails) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDetails) OnDragOver(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDetails) OnDragStart(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDetails) OnDrop(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDetails) OnFocus(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDetails) OnInput(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDetails) OnInvalid(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDetails) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDetails) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDetails) OnKeyup(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDetails) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDetails) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDetails) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDetails) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDetails) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDetails) OnPaste(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDetails) OnReset(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDetails) OnScroll(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDetails) OnSearch(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDetails) OnSelect(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDetails) OnSubmit(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDetails) OnToggle(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("toggle", h, scope...)
	return e
}

func (e *htmlDetails) OnWheel(h EventHandler, scope ...interface{}) HTMLDetails {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDfn is the interface that describes a <dfn> HTML element.
type HTMLDfn interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDfn

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDfn

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDfn

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDfn

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDfn

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDfn

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDfn

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDfn

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDfn

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDfn

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDfn

	// ID specifies a unique id for an element.
	ID(v string) HTMLDfn

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDfn

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDfn

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDfn

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDfn

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDfn

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDfn

	// Title specifies extra information about an element.
	Title(v string) HTMLDfn

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDfn

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDfn

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDfn

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDfn

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDfn

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDfn

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDfn

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDfn

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDfn

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDfn

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDfn

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDfn

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDfn

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDfn

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDfn

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDfn

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDfn

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDfn

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDfn

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDfn

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDfn

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDfn

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDfn

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDfn

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDfn
}

// Dfn returns an HTML element that represents the defining instance of a term.
func Dfn() HTMLDfn {
	e := &htmlDfn{
		elem: elem{
			tag:         "dfn",
			selfClosing: false,
		},
	}

	return e
}

type htmlDfn struct {
	elem
}

func (e *htmlDfn) Body(elems ...UI) HTMLDfn {
	e.setBody(elems...)
	return e
}

func (e *htmlDfn) Text(v interface{}) HTMLDfn {
	return e.Body(Text(v))
}

func (e *htmlDfn) AccessKey(v string) HTMLDfn {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDfn) Aria(k string, v interface{}) HTMLDfn {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDfn) Attr(n string, v interface{}) HTMLDfn {
	e.setAttr(n, v)
	return e
}

func (e *htmlDfn) Class(v ...string) HTMLDfn {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDfn) ContentEditable(v bool) HTMLDfn {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDfn) DataSet(k string, v interface{}) HTMLDfn {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDfn) Dir(v string) HTMLDfn {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDfn) Draggable(v bool) HTMLDfn {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDfn) Hidden(v bool) HTMLDfn {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDfn) ID(v string) HTMLDfn {
	e.setAttr("id", v)
	return e
}

func (e *htmlDfn) Lang(v string) HTMLDfn {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDfn) Role(v string) HTMLDfn {
	e.setAttr("role", v)
	return e
}

func (e *htmlDfn) Spellcheck(v bool) HTMLDfn {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDfn) Style(k, v string) HTMLDfn {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDfn) Styles(s map[string]string) HTMLDfn {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDfn) TabIndex(v int) HTMLDfn {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDfn) Title(v string) HTMLDfn {
	e.setAttr("title", v)
	return e
}

func (e *htmlDfn) OnBlur(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDfn) OnChange(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDfn) OnClick(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDfn) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDfn) OnCopy(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDfn) OnCut(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDfn) OnDblClick(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDfn) OnDrag(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDfn) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDfn) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDfn) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDfn) OnDragOver(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDfn) OnDragStart(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDfn) OnDrop(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDfn) OnFocus(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDfn) OnInput(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDfn) OnInvalid(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDfn) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDfn) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDfn) OnKeyup(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDfn) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDfn) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDfn) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDfn) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDfn) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDfn) OnPaste(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDfn) OnReset(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDfn) OnScroll(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDfn) OnSearch(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDfn) OnSelect(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDfn) OnSubmit(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDfn) OnWheel(h EventHandler, scope ...interface{}) HTMLDfn {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDialog is the interface that describes a <dialog> HTML element.
type HTMLDialog interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDialog

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDialog

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDialog

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDialog

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDialog

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDialog

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDialog

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDialog

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDialog

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDialog

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDialog

	// ID specifies a unique id for an element.
	ID(v string) HTMLDialog

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDialog

	// Open specifies that the details should be visible (open) to the user.
	Open(v bool) HTMLDialog

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDialog

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDialog

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDialog

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDialog

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDialog

	// Title specifies extra information about an element.
	Title(v string) HTMLDialog

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDialog

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDialog

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDialog

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDialog

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDialog

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDialog

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDialog

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDialog

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDialog

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDialog

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDialog

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDialog

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDialog

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDialog

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDialog

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDialog

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDialog

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDialog

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDialog

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDialog

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDialog

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDialog

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDialog

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDialog

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDialog
}

// Dialog returns an HTML element that defines a dialog box or window.
func Dialog() HTMLDialog {
	e := &htmlDialog{
		elem: elem{
			tag:         "dialog",
			selfClosing: false,
		},
	}

	return e
}

type htmlDialog struct {
	elem
}

func (e *htmlDialog) Body(elems ...UI) HTMLDialog {
	e.setBody(elems...)
	return e
}

func (e *htmlDialog) Text(v interface{}) HTMLDialog {
	return e.Body(Text(v))
}

func (e *htmlDialog) AccessKey(v string) HTMLDialog {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDialog) Aria(k string, v interface{}) HTMLDialog {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDialog) Attr(n string, v interface{}) HTMLDialog {
	e.setAttr(n, v)
	return e
}

func (e *htmlDialog) Class(v ...string) HTMLDialog {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDialog) ContentEditable(v bool) HTMLDialog {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDialog) DataSet(k string, v interface{}) HTMLDialog {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDialog) Dir(v string) HTMLDialog {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDialog) Draggable(v bool) HTMLDialog {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDialog) Hidden(v bool) HTMLDialog {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDialog) ID(v string) HTMLDialog {
	e.setAttr("id", v)
	return e
}

func (e *htmlDialog) Lang(v string) HTMLDialog {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDialog) Open(v bool) HTMLDialog {
	e.setAttr("open", v)
	return e
}

func (e *htmlDialog) Role(v string) HTMLDialog {
	e.setAttr("role", v)
	return e
}

func (e *htmlDialog) Spellcheck(v bool) HTMLDialog {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDialog) Style(k, v string) HTMLDialog {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDialog) Styles(s map[string]string) HTMLDialog {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDialog) TabIndex(v int) HTMLDialog {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDialog) Title(v string) HTMLDialog {
	e.setAttr("title", v)
	return e
}

func (e *htmlDialog) OnBlur(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDialog) OnChange(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDialog) OnClick(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDialog) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDialog) OnCopy(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDialog) OnCut(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDialog) OnDblClick(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDialog) OnDrag(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDialog) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDialog) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDialog) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDialog) OnDragOver(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDialog) OnDragStart(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDialog) OnDrop(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDialog) OnFocus(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDialog) OnInput(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDialog) OnInvalid(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDialog) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDialog) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDialog) OnKeyup(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDialog) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDialog) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDialog) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDialog) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDialog) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDialog) OnPaste(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDialog) OnReset(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDialog) OnScroll(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDialog) OnSearch(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDialog) OnSelect(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDialog) OnSubmit(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDialog) OnWheel(h EventHandler, scope ...interface{}) HTMLDialog {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDiv is the interface that describes a <div> HTML element.
type HTMLDiv interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDiv

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDiv

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDiv

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDiv

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDiv

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDiv

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDiv

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDiv

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDiv

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDiv

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDiv

	// ID specifies a unique id for an element.
	ID(v string) HTMLDiv

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDiv

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDiv

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDiv

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDiv

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDiv

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDiv

	// Title specifies extra information about an element.
	Title(v string) HTMLDiv

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDiv

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDiv

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDiv

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDiv

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDiv

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDiv

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDiv

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDiv

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDiv

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDiv

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDiv

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDiv

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDiv

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDiv

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDiv

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDiv

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDiv

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDiv

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDiv

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDiv

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDiv

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDiv

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDiv

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDiv

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDiv
}

// Div returns an HTML element that defines a section in a document.
func Div() HTMLDiv {
	e := &htmlDiv{
		elem: elem{
			tag:         "div",
			selfClosing: false,
		},
	}

	return e
}

type htmlDiv struct {
	elem
}

func (e *htmlDiv) Body(elems ...UI) HTMLDiv {
	e.setBody(elems...)
	return e
}

func (e *htmlDiv) Text(v interface{}) HTMLDiv {
	return e.Body(Text(v))
}

func (e *htmlDiv) AccessKey(v string) HTMLDiv {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDiv) Aria(k string, v interface{}) HTMLDiv {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDiv) Attr(n string, v interface{}) HTMLDiv {
	e.setAttr(n, v)
	return e
}

func (e *htmlDiv) Class(v ...string) HTMLDiv {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDiv) ContentEditable(v bool) HTMLDiv {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDiv) DataSet(k string, v interface{}) HTMLDiv {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDiv) Dir(v string) HTMLDiv {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDiv) Draggable(v bool) HTMLDiv {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDiv) Hidden(v bool) HTMLDiv {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDiv) ID(v string) HTMLDiv {
	e.setAttr("id", v)
	return e
}

func (e *htmlDiv) Lang(v string) HTMLDiv {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDiv) Role(v string) HTMLDiv {
	e.setAttr("role", v)
	return e
}

func (e *htmlDiv) Spellcheck(v bool) HTMLDiv {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDiv) Style(k, v string) HTMLDiv {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDiv) Styles(s map[string]string) HTMLDiv {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDiv) TabIndex(v int) HTMLDiv {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDiv) Title(v string) HTMLDiv {
	e.setAttr("title", v)
	return e
}

func (e *htmlDiv) OnBlur(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDiv) OnChange(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDiv) OnClick(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDiv) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDiv) OnCopy(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDiv) OnCut(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDiv) OnDblClick(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDiv) OnDrag(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDiv) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDiv) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDiv) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDiv) OnDragOver(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDiv) OnDragStart(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDiv) OnDrop(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDiv) OnFocus(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDiv) OnInput(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDiv) OnInvalid(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDiv) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDiv) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDiv) OnKeyup(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDiv) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDiv) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDiv) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDiv) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDiv) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDiv) OnPaste(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDiv) OnReset(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDiv) OnScroll(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDiv) OnSearch(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDiv) OnSelect(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDiv) OnSubmit(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDiv) OnWheel(h EventHandler, scope ...interface{}) HTMLDiv {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDl is the interface that describes a <dl> HTML element.
type HTMLDl interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDl

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDl

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDl

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDl

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDl

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDl

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDl

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDl

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDl

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDl

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDl

	// ID specifies a unique id for an element.
	ID(v string) HTMLDl

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDl

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDl

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDl

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDl

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDl

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDl

	// Title specifies extra information about an element.
	Title(v string) HTMLDl

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDl

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDl

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDl

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDl

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDl

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDl

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDl

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDl

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDl

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDl

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDl

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDl

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDl

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDl

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDl

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDl

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDl

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDl

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDl

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDl

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDl

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDl

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDl

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDl

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDl

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDl

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDl

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDl

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDl

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDl

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDl

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDl
}

// Dl returns an HTML element that defines a description list.
func Dl() HTMLDl {
	e := &htmlDl{
		elem: elem{
			tag:         "dl",
			selfClosing: false,
		},
	}

	return e
}

type htmlDl struct {
	elem
}

func (e *htmlDl) Body(elems ...UI) HTMLDl {
	e.setBody(elems...)
	return e
}

func (e *htmlDl) Text(v interface{}) HTMLDl {
	return e.Body(Text(v))
}

func (e *htmlDl) AccessKey(v string) HTMLDl {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDl) Aria(k string, v interface{}) HTMLDl {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDl) Attr(n string, v interface{}) HTMLDl {
	e.setAttr(n, v)
	return e
}

func (e *htmlDl) Class(v ...string) HTMLDl {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDl) ContentEditable(v bool) HTMLDl {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDl) DataSet(k string, v interface{}) HTMLDl {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDl) Dir(v string) HTMLDl {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDl) Draggable(v bool) HTMLDl {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDl) Hidden(v bool) HTMLDl {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDl) ID(v string) HTMLDl {
	e.setAttr("id", v)
	return e
}

func (e *htmlDl) Lang(v string) HTMLDl {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDl) Role(v string) HTMLDl {
	e.setAttr("role", v)
	return e
}

func (e *htmlDl) Spellcheck(v bool) HTMLDl {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDl) Style(k, v string) HTMLDl {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDl) Styles(s map[string]string) HTMLDl {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDl) TabIndex(v int) HTMLDl {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDl) Title(v string) HTMLDl {
	e.setAttr("title", v)
	return e
}

func (e *htmlDl) OnBlur(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDl) OnChange(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDl) OnClick(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDl) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDl) OnCopy(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDl) OnCut(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDl) OnDblClick(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDl) OnDrag(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDl) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDl) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDl) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDl) OnDragOver(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDl) OnDragStart(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDl) OnDrop(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDl) OnFocus(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDl) OnInput(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDl) OnInvalid(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDl) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDl) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDl) OnKeyup(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDl) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDl) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDl) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDl) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDl) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDl) OnPaste(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDl) OnReset(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDl) OnScroll(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDl) OnSearch(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDl) OnSelect(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDl) OnSubmit(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDl) OnWheel(h EventHandler, scope ...interface{}) HTMLDl {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLDt is the interface that describes a <dt> HTML element.
type HTMLDt interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLDt

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLDt

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLDt

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLDt

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLDt

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLDt

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLDt

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLDt

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLDt

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLDt

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLDt

	// ID specifies a unique id for an element.
	ID(v string) HTMLDt

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLDt

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLDt

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLDt

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLDt

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLDt

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLDt

	// Title specifies extra information about an element.
	Title(v string) HTMLDt

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLDt

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLDt

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLDt

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLDt

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLDt

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLDt

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLDt

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLDt

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLDt

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLDt

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLDt

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLDt

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLDt

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLDt

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLDt

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLDt

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLDt

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLDt

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLDt

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLDt

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLDt

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLDt

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLDt

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLDt

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLDt

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLDt

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLDt

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLDt

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLDt

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLDt

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLDt

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLDt
}

// Dt returns an HTML element that defines a term/name in a description list.
func Dt() HTMLDt {
	e := &htmlDt{
		elem: elem{
			tag:         "dt",
			selfClosing: false,
		},
	}

	return e
}

type htmlDt struct {
	elem
}

func (e *htmlDt) Body(elems ...UI) HTMLDt {
	e.setBody(elems...)
	return e
}

func (e *htmlDt) Text(v interface{}) HTMLDt {
	return e.Body(Text(v))
}

func (e *htmlDt) AccessKey(v string) HTMLDt {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlDt) Aria(k string, v interface{}) HTMLDt {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDt) Attr(n string, v interface{}) HTMLDt {
	e.setAttr(n, v)
	return e
}

func (e *htmlDt) Class(v ...string) HTMLDt {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlDt) ContentEditable(v bool) HTMLDt {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlDt) DataSet(k string, v interface{}) HTMLDt {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlDt) Dir(v string) HTMLDt {
	e.setAttr("dir", v)
	return e
}

func (e *htmlDt) Draggable(v bool) HTMLDt {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlDt) Hidden(v bool) HTMLDt {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlDt) ID(v string) HTMLDt {
	e.setAttr("id", v)
	return e
}

func (e *htmlDt) Lang(v string) HTMLDt {
	e.setAttr("lang", v)
	return e
}

func (e *htmlDt) Role(v string) HTMLDt {
	e.setAttr("role", v)
	return e
}

func (e *htmlDt) Spellcheck(v bool) HTMLDt {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlDt) Style(k, v string) HTMLDt {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlDt) Styles(s map[string]string) HTMLDt {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlDt) TabIndex(v int) HTMLDt {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlDt) Title(v string) HTMLDt {
	e.setAttr("title", v)
	return e
}

func (e *htmlDt) OnBlur(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlDt) OnChange(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlDt) OnClick(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlDt) OnContextMenu(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlDt) OnCopy(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlDt) OnCut(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlDt) OnDblClick(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlDt) OnDrag(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlDt) OnDragEnd(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlDt) OnDragEnter(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlDt) OnDragLeave(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlDt) OnDragOver(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlDt) OnDragStart(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlDt) OnDrop(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlDt) OnFocus(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlDt) OnInput(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlDt) OnInvalid(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlDt) OnKeyDown(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlDt) OnKeyPress(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlDt) OnKeyup(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlDt) OnMouseDown(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlDt) OnMouseMove(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlDt) OnMouseOut(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlDt) OnMouseOver(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlDt) OnMouseUp(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlDt) OnPaste(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlDt) OnReset(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlDt) OnScroll(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlDt) OnSearch(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlDt) OnSelect(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlDt) OnSubmit(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlDt) OnWheel(h EventHandler, scope ...interface{}) HTMLDt {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLEm is the interface that describes a <em> HTML element.
type HTMLEm interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLEm

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLEm

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLEm

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLEm

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLEm

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLEm

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLEm

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLEm

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLEm

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLEm

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLEm

	// ID specifies a unique id for an element.
	ID(v string) HTMLEm

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLEm

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLEm

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLEm

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLEm

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLEm

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLEm

	// Title specifies extra information about an element.
	Title(v string) HTMLEm

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLEm

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLEm

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLEm

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLEm

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLEm

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLEm

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLEm

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLEm

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLEm

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLEm

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLEm

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLEm

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLEm

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLEm

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLEm

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLEm

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLEm

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLEm

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLEm

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLEm

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLEm

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLEm

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLEm

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLEm

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLEm

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLEm

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLEm

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLEm

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLEm

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLEm

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLEm

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLEm
}

// Em returns an HTML element that defines emphasized text.
func Em() HTMLEm {
	e := &htmlEm{
		elem: elem{
			tag:         "em",
			selfClosing: false,
		},
	}

	return e
}

type htmlEm struct {
	elem
}

func (e *htmlEm) Body(elems ...UI) HTMLEm {
	e.setBody(elems...)
	return e
}

func (e *htmlEm) Text(v interface{}) HTMLEm {
	return e.Body(Text(v))
}

func (e *htmlEm) AccessKey(v string) HTMLEm {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlEm) Aria(k string, v interface{}) HTMLEm {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlEm) Attr(n string, v interface{}) HTMLEm {
	e.setAttr(n, v)
	return e
}

func (e *htmlEm) Class(v ...string) HTMLEm {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlEm) ContentEditable(v bool) HTMLEm {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlEm) DataSet(k string, v interface{}) HTMLEm {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlEm) Dir(v string) HTMLEm {
	e.setAttr("dir", v)
	return e
}

func (e *htmlEm) Draggable(v bool) HTMLEm {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlEm) Hidden(v bool) HTMLEm {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlEm) ID(v string) HTMLEm {
	e.setAttr("id", v)
	return e
}

func (e *htmlEm) Lang(v string) HTMLEm {
	e.setAttr("lang", v)
	return e
}

func (e *htmlEm) Role(v string) HTMLEm {
	e.setAttr("role", v)
	return e
}

func (e *htmlEm) Spellcheck(v bool) HTMLEm {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlEm) Style(k, v string) HTMLEm {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlEm) Styles(s map[string]string) HTMLEm {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlEm) TabIndex(v int) HTMLEm {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlEm) Title(v string) HTMLEm {
	e.setAttr("title", v)
	return e
}

func (e *htmlEm) OnBlur(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlEm) OnChange(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlEm) OnClick(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlEm) OnContextMenu(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlEm) OnCopy(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlEm) OnCut(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlEm) OnDblClick(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlEm) OnDrag(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlEm) OnDragEnd(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlEm) OnDragEnter(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlEm) OnDragLeave(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlEm) OnDragOver(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlEm) OnDragStart(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlEm) OnDrop(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlEm) OnFocus(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlEm) OnInput(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlEm) OnInvalid(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlEm) OnKeyDown(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlEm) OnKeyPress(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlEm) OnKeyup(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlEm) OnMouseDown(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlEm) OnMouseMove(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlEm) OnMouseOut(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlEm) OnMouseOver(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlEm) OnMouseUp(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlEm) OnPaste(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlEm) OnReset(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlEm) OnScroll(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlEm) OnSearch(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlEm) OnSelect(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlEm) OnSubmit(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlEm) OnWheel(h EventHandler, scope ...interface{}) HTMLEm {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLEmbed is the interface that describes a <embed> HTML element.
type HTMLEmbed interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLEmbed

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLEmbed

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLEmbed

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLEmbed

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLEmbed

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLEmbed

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLEmbed

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLEmbed

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLEmbed

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLEmbed

	// ID specifies a unique id for an element.
	ID(v string) HTMLEmbed

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLEmbed

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLEmbed

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLEmbed

	// Src specifies the URL of the media file.
	Src(v string) HTMLEmbed

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLEmbed

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLEmbed

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLEmbed

	// Title specifies extra information about an element.
	Title(v string) HTMLEmbed

	// Type specifies the type of element.
	Type(v string) HTMLEmbed

	// Width specifies the width of the element.
	Width(v int) HTMLEmbed

	// OnAbort calls the given handler on abort.
	OnAbort(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnCanPlay calls the given handler when a file is ready to start playing (when it has buffered enough to begin).
	OnCanPlay(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnCanPlayThrough calls the given handler when a file can be played all the way to the end without pausing for buffering.
	OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnCueChange calls the given handler when the cue changes in a track element.
	OnCueChange(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnDurationChange calls the given handler when the length of the media changes.
	OnDurationChange(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnEmptied calls the given handler when something bad happens and the file is suddenly unavailable (like unexpectedly disconnects).
	OnEmptied(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnEnded calls the given handler when the media has reach the end.
	OnEnded(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnLoadStart calls the given handler just as the file begins to load before anything is actually loaded.
	OnLoadStart(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnLoadedData calls the given handler when media data is loaded.
	OnLoadedData(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnPause calls the given handler when the media is paused either by the user or programmatically.
	OnPause(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnPlay calls the given handler when the media is ready to start playing.
	OnPlay(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnPlaying calls the given handler when the media actually has started playing.
	OnPlaying(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnProgress calls the given handler when the browser is in the process of getting the media data.
	OnProgress(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnRateChange calls the given handler each time the playback rate changes (like when a user switches to a slow motion or fast forward mode).
	OnRateChange(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSeeked calls the given handler when the seeking attribute is set to false indicating that seeking has ended.
	OnSeeked(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSeeking calls the given handler when the seeking attribute is set to true indicating that seeking is active.
	OnSeeking(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnStalled calls the given handler when the browser is unable to fetch the media data for whatever reason.
	OnStalled(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnSuspend calls the given handler when fetching the media data is stopped before it is completely loaded for whatever reason.
	OnSuspend(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnTimeUpdate calls the given handler when the playing position has changed (like when the user fast forwards to a different point in the media).
	OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnVolumeChange calls the given handler each time the volume is changed which (includes setting the volume to "mute").
	OnVolumeChange(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnWaiting calls the given handler when the media has paused but is expected to resume (like when the media pauses to buffer more data).
	OnWaiting(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLEmbed

	// OnloadedMetaData calls the given handler when meta data (like dimensions and duration) are loaded.
	OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLEmbed
}

// Embed returns an HTML element that defines a container for an external (non-HTML) application.
func Embed() HTMLEmbed {
	e := &htmlEmbed{
		elem: elem{
			tag:         "embed",
			selfClosing: true,
		},
	}

	return e
}

type htmlEmbed struct {
	elem
}

func (e *htmlEmbed) AccessKey(v string) HTMLEmbed {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlEmbed) Aria(k string, v interface{}) HTMLEmbed {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlEmbed) Attr(n string, v interface{}) HTMLEmbed {
	e.setAttr(n, v)
	return e
}

func (e *htmlEmbed) Class(v ...string) HTMLEmbed {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlEmbed) ContentEditable(v bool) HTMLEmbed {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlEmbed) DataSet(k string, v interface{}) HTMLEmbed {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlEmbed) Dir(v string) HTMLEmbed {
	e.setAttr("dir", v)
	return e
}

func (e *htmlEmbed) Draggable(v bool) HTMLEmbed {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlEmbed) Height(v int) HTMLEmbed {
	e.setAttr("height", v)
	return e
}

func (e *htmlEmbed) Hidden(v bool) HTMLEmbed {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlEmbed) ID(v string) HTMLEmbed {
	e.setAttr("id", v)
	return e
}

func (e *htmlEmbed) Lang(v string) HTMLEmbed {
	e.setAttr("lang", v)
	return e
}

func (e *htmlEmbed) Role(v string) HTMLEmbed {
	e.setAttr("role", v)
	return e
}

func (e *htmlEmbed) Spellcheck(v bool) HTMLEmbed {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlEmbed) Src(v string) HTMLEmbed {
	e.setAttr("src", v)
	return e
}

func (e *htmlEmbed) Style(k, v string) HTMLEmbed {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlEmbed) Styles(s map[string]string) HTMLEmbed {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlEmbed) TabIndex(v int) HTMLEmbed {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlEmbed) Title(v string) HTMLEmbed {
	e.setAttr("title", v)
	return e
}

func (e *htmlEmbed) Type(v string) HTMLEmbed {
	e.setAttr("type", v)
	return e
}

func (e *htmlEmbed) Width(v int) HTMLEmbed {
	e.setAttr("width", v)
	return e
}

func (e *htmlEmbed) OnAbort(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("abort", h, scope...)
	return e
}

func (e *htmlEmbed) OnBlur(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlEmbed) OnCanPlay(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("canplay", h, scope...)
	return e
}

func (e *htmlEmbed) OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("canplaythrough", h, scope...)
	return e
}

func (e *htmlEmbed) OnChange(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlEmbed) OnClick(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlEmbed) OnContextMenu(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlEmbed) OnCopy(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlEmbed) OnCueChange(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("cuechange", h, scope...)
	return e
}

func (e *htmlEmbed) OnCut(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlEmbed) OnDblClick(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlEmbed) OnDrag(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlEmbed) OnDragEnd(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlEmbed) OnDragEnter(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlEmbed) OnDragLeave(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlEmbed) OnDragOver(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlEmbed) OnDragStart(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlEmbed) OnDrop(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlEmbed) OnDurationChange(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("durationchange", h, scope...)
	return e
}

func (e *htmlEmbed) OnEmptied(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("emptied", h, scope...)
	return e
}

func (e *htmlEmbed) OnEnded(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("ended", h, scope...)
	return e
}

func (e *htmlEmbed) OnError(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlEmbed) OnFocus(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlEmbed) OnInput(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlEmbed) OnInvalid(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlEmbed) OnKeyDown(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlEmbed) OnKeyPress(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlEmbed) OnKeyup(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlEmbed) OnLoadStart(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("loadstart", h, scope...)
	return e
}

func (e *htmlEmbed) OnLoadedData(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("loadeddata", h, scope...)
	return e
}

func (e *htmlEmbed) OnMouseDown(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlEmbed) OnMouseMove(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlEmbed) OnMouseOut(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlEmbed) OnMouseOver(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlEmbed) OnMouseUp(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlEmbed) OnPaste(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlEmbed) OnPause(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("pause", h, scope...)
	return e
}

func (e *htmlEmbed) OnPlay(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("play", h, scope...)
	return e
}

func (e *htmlEmbed) OnPlaying(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("playing", h, scope...)
	return e
}

func (e *htmlEmbed) OnProgress(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("progress", h, scope...)
	return e
}

func (e *htmlEmbed) OnRateChange(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("ratechange", h, scope...)
	return e
}

func (e *htmlEmbed) OnReset(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlEmbed) OnScroll(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlEmbed) OnSearch(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlEmbed) OnSeeked(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("seeked", h, scope...)
	return e
}

func (e *htmlEmbed) OnSeeking(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("seeking", h, scope...)
	return e
}

func (e *htmlEmbed) OnSelect(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlEmbed) OnStalled(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("stalled", h, scope...)
	return e
}

func (e *htmlEmbed) OnSubmit(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlEmbed) OnSuspend(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("suspend", h, scope...)
	return e
}

func (e *htmlEmbed) OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("timeupdate", h, scope...)
	return e
}

func (e *htmlEmbed) OnVolumeChange(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("volumechange", h, scope...)
	return e
}

func (e *htmlEmbed) OnWaiting(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("waiting", h, scope...)
	return e
}

func (e *htmlEmbed) OnWheel(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("wheel", h, scope...)
	return e
}

func (e *htmlEmbed) OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLEmbed {
	e.setEventHandler("loadedmetadata", h, scope...)
	return e
}

// HTMLFieldSet is the interface that describes a <fieldset> HTML element.
type HTMLFieldSet interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLFieldSet

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLFieldSet

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLFieldSet

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLFieldSet

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLFieldSet

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLFieldSet

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLFieldSet

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLFieldSet

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLFieldSet

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLFieldSet

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLFieldSet

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLFieldSet

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLFieldSet

	// ID specifies a unique id for an element.
	ID(v string) HTMLFieldSet

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLFieldSet

	// Name specifies the name of the element.
	Name(v string) HTMLFieldSet

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLFieldSet

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLFieldSet

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLFieldSet

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLFieldSet

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLFieldSet

	// Title specifies extra information about an element.
	Title(v string) HTMLFieldSet

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLFieldSet

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLFieldSet
}

// FieldSet returns an HTML element that groups related elements in a form.
func FieldSet() HTMLFieldSet {
	e := &htmlFieldSet{
		elem: elem{
			tag:         "fieldset",
			selfClosing: false,
		},
	}

	return e
}

type htmlFieldSet struct {
	elem
}

func (e *htmlFieldSet) Body(elems ...UI) HTMLFieldSet {
	e.setBody(elems...)
	return e
}

func (e *htmlFieldSet) Text(v interface{}) HTMLFieldSet {
	return e.Body(Text(v))
}

func (e *htmlFieldSet) AccessKey(v string) HTMLFieldSet {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlFieldSet) Aria(k string, v interface{}) HTMLFieldSet {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFieldSet) Attr(n string, v interface{}) HTMLFieldSet {
	e.setAttr(n, v)
	return e
}

func (e *htmlFieldSet) Class(v ...string) HTMLFieldSet {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlFieldSet) ContentEditable(v bool) HTMLFieldSet {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlFieldSet) DataSet(k string, v interface{}) HTMLFieldSet {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFieldSet) Dir(v string) HTMLFieldSet {
	e.setAttr("dir", v)
	return e
}

func (e *htmlFieldSet) Disabled(v bool) HTMLFieldSet {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlFieldSet) Draggable(v bool) HTMLFieldSet {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlFieldSet) Form(v string) HTMLFieldSet {
	e.setAttr("form", v)
	return e
}

func (e *htmlFieldSet) Hidden(v bool) HTMLFieldSet {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlFieldSet) ID(v string) HTMLFieldSet {
	e.setAttr("id", v)
	return e
}

func (e *htmlFieldSet) Lang(v string) HTMLFieldSet {
	e.setAttr("lang", v)
	return e
}

func (e *htmlFieldSet) Name(v string) HTMLFieldSet {
	e.setAttr("name", v)
	return e
}

func (e *htmlFieldSet) Role(v string) HTMLFieldSet {
	e.setAttr("role", v)
	return e
}

func (e *htmlFieldSet) Spellcheck(v bool) HTMLFieldSet {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlFieldSet) Style(k, v string) HTMLFieldSet {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlFieldSet) Styles(s map[string]string) HTMLFieldSet {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlFieldSet) TabIndex(v int) HTMLFieldSet {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlFieldSet) Title(v string) HTMLFieldSet {
	e.setAttr("title", v)
	return e
}

func (e *htmlFieldSet) OnBlur(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlFieldSet) OnChange(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlFieldSet) OnClick(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlFieldSet) OnContextMenu(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlFieldSet) OnCopy(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlFieldSet) OnCut(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDblClick(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDrag(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDragEnd(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDragEnter(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDragLeave(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDragOver(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDragStart(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlFieldSet) OnDrop(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlFieldSet) OnFocus(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlFieldSet) OnInput(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlFieldSet) OnInvalid(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlFieldSet) OnKeyDown(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlFieldSet) OnKeyPress(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlFieldSet) OnKeyup(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlFieldSet) OnMouseDown(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlFieldSet) OnMouseMove(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlFieldSet) OnMouseOut(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlFieldSet) OnMouseOver(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlFieldSet) OnMouseUp(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlFieldSet) OnPaste(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlFieldSet) OnReset(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlFieldSet) OnScroll(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlFieldSet) OnSearch(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlFieldSet) OnSelect(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlFieldSet) OnSubmit(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlFieldSet) OnWheel(h EventHandler, scope ...interface{}) HTMLFieldSet {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLFigCaption is the interface that describes a <figcaption> HTML element.
type HTMLFigCaption interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLFigCaption

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLFigCaption

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLFigCaption

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLFigCaption

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLFigCaption

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLFigCaption

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLFigCaption

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLFigCaption

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLFigCaption

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLFigCaption

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLFigCaption

	// ID specifies a unique id for an element.
	ID(v string) HTMLFigCaption

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLFigCaption

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLFigCaption

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLFigCaption

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLFigCaption

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLFigCaption

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLFigCaption

	// Title specifies extra information about an element.
	Title(v string) HTMLFigCaption

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLFigCaption

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLFigCaption
}

// FigCaption returns an HTML element that defines a caption for a figure element.
func FigCaption() HTMLFigCaption {
	e := &htmlFigCaption{
		elem: elem{
			tag:         "figcaption",
			selfClosing: false,
		},
	}

	return e
}

type htmlFigCaption struct {
	elem
}

func (e *htmlFigCaption) Body(elems ...UI) HTMLFigCaption {
	e.setBody(elems...)
	return e
}

func (e *htmlFigCaption) Text(v interface{}) HTMLFigCaption {
	return e.Body(Text(v))
}

func (e *htmlFigCaption) AccessKey(v string) HTMLFigCaption {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlFigCaption) Aria(k string, v interface{}) HTMLFigCaption {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFigCaption) Attr(n string, v interface{}) HTMLFigCaption {
	e.setAttr(n, v)
	return e
}

func (e *htmlFigCaption) Class(v ...string) HTMLFigCaption {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlFigCaption) ContentEditable(v bool) HTMLFigCaption {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlFigCaption) DataSet(k string, v interface{}) HTMLFigCaption {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFigCaption) Dir(v string) HTMLFigCaption {
	e.setAttr("dir", v)
	return e
}

func (e *htmlFigCaption) Draggable(v bool) HTMLFigCaption {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlFigCaption) Hidden(v bool) HTMLFigCaption {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlFigCaption) ID(v string) HTMLFigCaption {
	e.setAttr("id", v)
	return e
}

func (e *htmlFigCaption) Lang(v string) HTMLFigCaption {
	e.setAttr("lang", v)
	return e
}

func (e *htmlFigCaption) Role(v string) HTMLFigCaption {
	e.setAttr("role", v)
	return e
}

func (e *htmlFigCaption) Spellcheck(v bool) HTMLFigCaption {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlFigCaption) Style(k, v string) HTMLFigCaption {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlFigCaption) Styles(s map[string]string) HTMLFigCaption {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlFigCaption) TabIndex(v int) HTMLFigCaption {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlFigCaption) Title(v string) HTMLFigCaption {
	e.setAttr("title", v)
	return e
}

func (e *htmlFigCaption) OnBlur(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlFigCaption) OnChange(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlFigCaption) OnClick(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlFigCaption) OnContextMenu(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlFigCaption) OnCopy(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlFigCaption) OnCut(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDblClick(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDrag(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDragEnd(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDragEnter(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDragLeave(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDragOver(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDragStart(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlFigCaption) OnDrop(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlFigCaption) OnFocus(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlFigCaption) OnInput(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlFigCaption) OnInvalid(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlFigCaption) OnKeyDown(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlFigCaption) OnKeyPress(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlFigCaption) OnKeyup(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlFigCaption) OnMouseDown(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlFigCaption) OnMouseMove(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlFigCaption) OnMouseOut(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlFigCaption) OnMouseOver(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlFigCaption) OnMouseUp(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlFigCaption) OnPaste(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlFigCaption) OnReset(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlFigCaption) OnScroll(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlFigCaption) OnSearch(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlFigCaption) OnSelect(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlFigCaption) OnSubmit(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlFigCaption) OnWheel(h EventHandler, scope ...interface{}) HTMLFigCaption {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLFigure is the interface that describes a <figure> HTML element.
type HTMLFigure interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLFigure

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLFigure

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLFigure

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLFigure

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLFigure

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLFigure

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLFigure

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLFigure

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLFigure

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLFigure

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLFigure

	// ID specifies a unique id for an element.
	ID(v string) HTMLFigure

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLFigure

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLFigure

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLFigure

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLFigure

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLFigure

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLFigure

	// Title specifies extra information about an element.
	Title(v string) HTMLFigure

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLFigure

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLFigure

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLFigure

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLFigure

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLFigure

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLFigure

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLFigure

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLFigure

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLFigure

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLFigure

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLFigure

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLFigure

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLFigure

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLFigure

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLFigure

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLFigure

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLFigure

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLFigure

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLFigure

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLFigure

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLFigure

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLFigure

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLFigure

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLFigure

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLFigure
}

// Figure returns an HTML element that specifies self-contained content.
func Figure() HTMLFigure {
	e := &htmlFigure{
		elem: elem{
			tag:         "figure",
			selfClosing: false,
		},
	}

	return e
}

type htmlFigure struct {
	elem
}

func (e *htmlFigure) Body(elems ...UI) HTMLFigure {
	e.setBody(elems...)
	return e
}

func (e *htmlFigure) Text(v interface{}) HTMLFigure {
	return e.Body(Text(v))
}

func (e *htmlFigure) AccessKey(v string) HTMLFigure {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlFigure) Aria(k string, v interface{}) HTMLFigure {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFigure) Attr(n string, v interface{}) HTMLFigure {
	e.setAttr(n, v)
	return e
}

func (e *htmlFigure) Class(v ...string) HTMLFigure {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlFigure) ContentEditable(v bool) HTMLFigure {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlFigure) DataSet(k string, v interface{}) HTMLFigure {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFigure) Dir(v string) HTMLFigure {
	e.setAttr("dir", v)
	return e
}

func (e *htmlFigure) Draggable(v bool) HTMLFigure {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlFigure) Hidden(v bool) HTMLFigure {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlFigure) ID(v string) HTMLFigure {
	e.setAttr("id", v)
	return e
}

func (e *htmlFigure) Lang(v string) HTMLFigure {
	e.setAttr("lang", v)
	return e
}

func (e *htmlFigure) Role(v string) HTMLFigure {
	e.setAttr("role", v)
	return e
}

func (e *htmlFigure) Spellcheck(v bool) HTMLFigure {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlFigure) Style(k, v string) HTMLFigure {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlFigure) Styles(s map[string]string) HTMLFigure {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlFigure) TabIndex(v int) HTMLFigure {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlFigure) Title(v string) HTMLFigure {
	e.setAttr("title", v)
	return e
}

func (e *htmlFigure) OnBlur(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlFigure) OnChange(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlFigure) OnClick(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlFigure) OnContextMenu(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlFigure) OnCopy(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlFigure) OnCut(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlFigure) OnDblClick(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlFigure) OnDrag(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlFigure) OnDragEnd(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlFigure) OnDragEnter(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlFigure) OnDragLeave(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlFigure) OnDragOver(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlFigure) OnDragStart(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlFigure) OnDrop(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlFigure) OnFocus(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlFigure) OnInput(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlFigure) OnInvalid(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlFigure) OnKeyDown(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlFigure) OnKeyPress(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlFigure) OnKeyup(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlFigure) OnMouseDown(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlFigure) OnMouseMove(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlFigure) OnMouseOut(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlFigure) OnMouseOver(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlFigure) OnMouseUp(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlFigure) OnPaste(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlFigure) OnReset(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlFigure) OnScroll(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlFigure) OnSearch(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlFigure) OnSelect(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlFigure) OnSubmit(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlFigure) OnWheel(h EventHandler, scope ...interface{}) HTMLFigure {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLFooter is the interface that describes a <footer> HTML element.
type HTMLFooter interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLFooter

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLFooter

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLFooter

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLFooter

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLFooter

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLFooter

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLFooter

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLFooter

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLFooter

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLFooter

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLFooter

	// ID specifies a unique id for an element.
	ID(v string) HTMLFooter

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLFooter

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLFooter

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLFooter

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLFooter

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLFooter

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLFooter

	// Title specifies extra information about an element.
	Title(v string) HTMLFooter

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLFooter

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLFooter

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLFooter

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLFooter

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLFooter

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLFooter

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLFooter

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLFooter

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLFooter

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLFooter

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLFooter

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLFooter

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLFooter

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLFooter

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLFooter

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLFooter

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLFooter

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLFooter

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLFooter

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLFooter

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLFooter

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLFooter

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLFooter

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLFooter

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLFooter
}

// Footer returns an HTML element that defines a footer for a document or section.
func Footer() HTMLFooter {
	e := &htmlFooter{
		elem: elem{
			tag:         "footer",
			selfClosing: false,
		},
	}

	return e
}

type htmlFooter struct {
	elem
}

func (e *htmlFooter) Body(elems ...UI) HTMLFooter {
	e.setBody(elems...)
	return e
}

func (e *htmlFooter) Text(v interface{}) HTMLFooter {
	return e.Body(Text(v))
}

func (e *htmlFooter) AccessKey(v string) HTMLFooter {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlFooter) Aria(k string, v interface{}) HTMLFooter {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFooter) Attr(n string, v interface{}) HTMLFooter {
	e.setAttr(n, v)
	return e
}

func (e *htmlFooter) Class(v ...string) HTMLFooter {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlFooter) ContentEditable(v bool) HTMLFooter {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlFooter) DataSet(k string, v interface{}) HTMLFooter {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlFooter) Dir(v string) HTMLFooter {
	e.setAttr("dir", v)
	return e
}

func (e *htmlFooter) Draggable(v bool) HTMLFooter {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlFooter) Hidden(v bool) HTMLFooter {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlFooter) ID(v string) HTMLFooter {
	e.setAttr("id", v)
	return e
}

func (e *htmlFooter) Lang(v string) HTMLFooter {
	e.setAttr("lang", v)
	return e
}

func (e *htmlFooter) Role(v string) HTMLFooter {
	e.setAttr("role", v)
	return e
}

func (e *htmlFooter) Spellcheck(v bool) HTMLFooter {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlFooter) Style(k, v string) HTMLFooter {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlFooter) Styles(s map[string]string) HTMLFooter {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlFooter) TabIndex(v int) HTMLFooter {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlFooter) Title(v string) HTMLFooter {
	e.setAttr("title", v)
	return e
}

func (e *htmlFooter) OnBlur(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlFooter) OnChange(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlFooter) OnClick(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlFooter) OnContextMenu(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlFooter) OnCopy(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlFooter) OnCut(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlFooter) OnDblClick(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlFooter) OnDrag(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlFooter) OnDragEnd(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlFooter) OnDragEnter(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlFooter) OnDragLeave(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlFooter) OnDragOver(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlFooter) OnDragStart(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlFooter) OnDrop(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlFooter) OnFocus(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlFooter) OnInput(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlFooter) OnInvalid(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlFooter) OnKeyDown(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlFooter) OnKeyPress(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlFooter) OnKeyup(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlFooter) OnMouseDown(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlFooter) OnMouseMove(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlFooter) OnMouseOut(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlFooter) OnMouseOver(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlFooter) OnMouseUp(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlFooter) OnPaste(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlFooter) OnReset(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlFooter) OnScroll(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlFooter) OnSearch(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlFooter) OnSelect(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlFooter) OnSubmit(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlFooter) OnWheel(h EventHandler, scope ...interface{}) HTMLFooter {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLForm is the interface that describes a <form> HTML element.
type HTMLForm interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLForm

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLForm

	// AcceptCharset specifies the character encodings that are to be used for the form submission.
	AcceptCharset(v string) HTMLForm

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLForm

	// Action specifies where to send the form-data when a form is submitted.
	Action(v string) HTMLForm

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLForm

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLForm

	// AutoComplete specifies whether the element should have autocomplete enabled.
	AutoComplete(v bool) HTMLForm

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLForm

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLForm

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLForm

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLForm

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLForm

	// EncType specifies how the form-data should be encoded when submitting it to the server (only for post method).
	EncType(v string) HTMLForm

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLForm

	// ID specifies a unique id for an element.
	ID(v string) HTMLForm

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLForm

	// Method specifies the HTTP method to use when sending form-data.
	Method(v string) HTMLForm

	// Name specifies the name of the element.
	Name(v string) HTMLForm

	// NoValidate specifies that the form should not be validated when submitted.
	NoValidate(v bool) HTMLForm

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLForm

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLForm

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLForm

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLForm

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLForm

	// Target specifies the target for where to open the linked document or where to submit the form.
	Target(v string) HTMLForm

	// Title specifies extra information about an element.
	Title(v string) HTMLForm

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLForm

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLForm

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLForm

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLForm

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLForm

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLForm

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLForm

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLForm

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLForm

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLForm

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLForm

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLForm

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLForm

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLForm

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLForm

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLForm

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLForm

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLForm

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLForm

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLForm

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLForm

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLForm

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLForm

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLForm

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLForm

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLForm

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLForm

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLForm

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLForm

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLForm

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLForm

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLForm
}

// Form returns an HTML element that defines an HTML form for user input.
func Form() HTMLForm {
	e := &htmlForm{
		elem: elem{
			tag:         "form",
			selfClosing: false,
		},
	}

	return e
}

type htmlForm struct {
	elem
}

func (e *htmlForm) Body(elems ...UI) HTMLForm {
	e.setBody(elems...)
	return e
}

func (e *htmlForm) Text(v interface{}) HTMLForm {
	return e.Body(Text(v))
}

func (e *htmlForm) AcceptCharset(v string) HTMLForm {
	e.setAttr("acceptcharset", v)
	return e
}

func (e *htmlForm) AccessKey(v string) HTMLForm {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlForm) Action(v string) HTMLForm {
	e.setAttr("action", v)
	return e
}

func (e *htmlForm) Aria(k string, v interface{}) HTMLForm {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlForm) Attr(n string, v interface{}) HTMLForm {
	e.setAttr(n, v)
	return e
}

func (e *htmlForm) AutoComplete(v bool) HTMLForm {
	s := "off"
	if v {
		s = "on"
	}

	e.setAttr("autocomplete", s)
	return e
}

func (e *htmlForm) Class(v ...string) HTMLForm {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlForm) ContentEditable(v bool) HTMLForm {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlForm) DataSet(k string, v interface{}) HTMLForm {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlForm) Dir(v string) HTMLForm {
	e.setAttr("dir", v)
	return e
}

func (e *htmlForm) Draggable(v bool) HTMLForm {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlForm) EncType(v string) HTMLForm {
	e.setAttr("enctype", v)
	return e
}

func (e *htmlForm) Hidden(v bool) HTMLForm {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlForm) ID(v string) HTMLForm {
	e.setAttr("id", v)
	return e
}

func (e *htmlForm) Lang(v string) HTMLForm {
	e.setAttr("lang", v)
	return e
}

func (e *htmlForm) Method(v string) HTMLForm {
	e.setAttr("method", v)
	return e
}

func (e *htmlForm) Name(v string) HTMLForm {
	e.setAttr("name", v)
	return e
}

func (e *htmlForm) NoValidate(v bool) HTMLForm {
	e.setAttr("novalidate", v)
	return e
}

func (e *htmlForm) Role(v string) HTMLForm {
	e.setAttr("role", v)
	return e
}

func (e *htmlForm) Spellcheck(v bool) HTMLForm {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlForm) Style(k, v string) HTMLForm {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlForm) Styles(s map[string]string) HTMLForm {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlForm) TabIndex(v int) HTMLForm {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlForm) Target(v string) HTMLForm {
	e.setAttr("target", v)
	return e
}

func (e *htmlForm) Title(v string) HTMLForm {
	e.setAttr("title", v)
	return e
}

func (e *htmlForm) OnBlur(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlForm) OnChange(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlForm) OnClick(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlForm) OnContextMenu(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlForm) OnCopy(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlForm) OnCut(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlForm) OnDblClick(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlForm) OnDrag(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlForm) OnDragEnd(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlForm) OnDragEnter(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlForm) OnDragLeave(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlForm) OnDragOver(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlForm) OnDragStart(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlForm) OnDrop(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlForm) OnFocus(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlForm) OnInput(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlForm) OnInvalid(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlForm) OnKeyDown(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlForm) OnKeyPress(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlForm) OnKeyup(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlForm) OnMouseDown(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlForm) OnMouseMove(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlForm) OnMouseOut(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlForm) OnMouseOver(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlForm) OnMouseUp(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlForm) OnPaste(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlForm) OnReset(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlForm) OnScroll(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlForm) OnSearch(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlForm) OnSelect(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlForm) OnSubmit(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlForm) OnWheel(h EventHandler, scope ...interface{}) HTMLForm {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH1 is the interface that describes a <h1> HTML element.
type HTMLH1 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH1

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH1

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH1

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH1

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH1

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH1

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH1

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH1

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH1

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH1

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH1

	// ID specifies a unique id for an element.
	ID(v string) HTMLH1

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH1

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH1

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH1

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH1

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH1

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH1

	// Title specifies extra information about an element.
	Title(v string) HTMLH1

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH1

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH1

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH1

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH1

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH1

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH1

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH1

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH1

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH1

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH1

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH1

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH1

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH1

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH1

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH1

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH1

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH1

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH1

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH1

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH1

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH1

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH1

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH1

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH1

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH1

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH1

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH1

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH1

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH1

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH1

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH1

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH1
}

// H1 returns an HTML element that defines HTML heading.
func H1() HTMLH1 {
	e := &htmlH1{
		elem: elem{
			tag:         "h1",
			selfClosing: false,
		},
	}

	return e
}

type htmlH1 struct {
	elem
}

func (e *htmlH1) Body(elems ...UI) HTMLH1 {
	e.setBody(elems...)
	return e
}

func (e *htmlH1) Text(v interface{}) HTMLH1 {
	return e.Body(Text(v))
}

func (e *htmlH1) AccessKey(v string) HTMLH1 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH1) Aria(k string, v interface{}) HTMLH1 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH1) Attr(n string, v interface{}) HTMLH1 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH1) Class(v ...string) HTMLH1 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH1) ContentEditable(v bool) HTMLH1 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH1) DataSet(k string, v interface{}) HTMLH1 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH1) Dir(v string) HTMLH1 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH1) Draggable(v bool) HTMLH1 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH1) Hidden(v bool) HTMLH1 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH1) ID(v string) HTMLH1 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH1) Lang(v string) HTMLH1 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH1) Role(v string) HTMLH1 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH1) Spellcheck(v bool) HTMLH1 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH1) Style(k, v string) HTMLH1 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH1) Styles(s map[string]string) HTMLH1 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH1) TabIndex(v int) HTMLH1 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH1) Title(v string) HTMLH1 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH1) OnBlur(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH1) OnChange(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH1) OnClick(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH1) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH1) OnCopy(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH1) OnCut(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH1) OnDblClick(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH1) OnDrag(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH1) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH1) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH1) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH1) OnDragOver(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH1) OnDragStart(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH1) OnDrop(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH1) OnFocus(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH1) OnInput(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH1) OnInvalid(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH1) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH1) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH1) OnKeyup(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH1) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH1) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH1) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH1) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH1) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH1) OnPaste(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH1) OnReset(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH1) OnScroll(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH1) OnSearch(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH1) OnSelect(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH1) OnSubmit(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH1) OnWheel(h EventHandler, scope ...interface{}) HTMLH1 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH2 is the interface that describes a <h2> HTML element.
type HTMLH2 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH2

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH2

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH2

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH2

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH2

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH2

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH2

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH2

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH2

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH2

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH2

	// ID specifies a unique id for an element.
	ID(v string) HTMLH2

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH2

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH2

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH2

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH2

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH2

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH2

	// Title specifies extra information about an element.
	Title(v string) HTMLH2

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH2

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH2

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH2

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH2

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH2

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH2

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH2

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH2

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH2

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH2

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH2

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH2

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH2

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH2

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH2

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH2

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH2

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH2

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH2

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH2

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH2

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH2

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH2

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH2

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH2

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH2

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH2

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH2

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH2

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH2

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH2

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH2
}

// H2 returns an HTML element that defines HTML heading.
func H2() HTMLH2 {
	e := &htmlH2{
		elem: elem{
			tag:         "h2",
			selfClosing: false,
		},
	}

	return e
}

type htmlH2 struct {
	elem
}

func (e *htmlH2) Body(elems ...UI) HTMLH2 {
	e.setBody(elems...)
	return e
}

func (e *htmlH2) Text(v interface{}) HTMLH2 {
	return e.Body(Text(v))
}

func (e *htmlH2) AccessKey(v string) HTMLH2 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH2) Aria(k string, v interface{}) HTMLH2 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH2) Attr(n string, v interface{}) HTMLH2 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH2) Class(v ...string) HTMLH2 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH2) ContentEditable(v bool) HTMLH2 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH2) DataSet(k string, v interface{}) HTMLH2 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH2) Dir(v string) HTMLH2 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH2) Draggable(v bool) HTMLH2 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH2) Hidden(v bool) HTMLH2 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH2) ID(v string) HTMLH2 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH2) Lang(v string) HTMLH2 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH2) Role(v string) HTMLH2 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH2) Spellcheck(v bool) HTMLH2 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH2) Style(k, v string) HTMLH2 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH2) Styles(s map[string]string) HTMLH2 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH2) TabIndex(v int) HTMLH2 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH2) Title(v string) HTMLH2 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH2) OnBlur(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH2) OnChange(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH2) OnClick(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH2) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH2) OnCopy(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH2) OnCut(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH2) OnDblClick(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH2) OnDrag(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH2) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH2) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH2) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH2) OnDragOver(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH2) OnDragStart(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH2) OnDrop(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH2) OnFocus(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH2) OnInput(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH2) OnInvalid(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH2) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH2) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH2) OnKeyup(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH2) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH2) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH2) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH2) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH2) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH2) OnPaste(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH2) OnReset(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH2) OnScroll(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH2) OnSearch(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH2) OnSelect(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH2) OnSubmit(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH2) OnWheel(h EventHandler, scope ...interface{}) HTMLH2 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH3 is the interface that describes a <h3> HTML element.
type HTMLH3 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH3

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH3

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH3

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH3

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH3

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH3

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH3

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH3

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH3

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH3

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH3

	// ID specifies a unique id for an element.
	ID(v string) HTMLH3

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH3

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH3

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH3

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH3

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH3

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH3

	// Title specifies extra information about an element.
	Title(v string) HTMLH3

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH3

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH3

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH3

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH3

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH3

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH3

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH3

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH3

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH3

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH3

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH3

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH3

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH3

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH3

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH3

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH3

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH3

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH3

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH3

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH3

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH3

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH3

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH3

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH3

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH3

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH3

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH3

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH3

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH3

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH3

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH3

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH3
}

// H3 returns an HTML element that defines HTML heading.
func H3() HTMLH3 {
	e := &htmlH3{
		elem: elem{
			tag:         "h3",
			selfClosing: false,
		},
	}

	return e
}

type htmlH3 struct {
	elem
}

func (e *htmlH3) Body(elems ...UI) HTMLH3 {
	e.setBody(elems...)
	return e
}

func (e *htmlH3) Text(v interface{}) HTMLH3 {
	return e.Body(Text(v))
}

func (e *htmlH3) AccessKey(v string) HTMLH3 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH3) Aria(k string, v interface{}) HTMLH3 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH3) Attr(n string, v interface{}) HTMLH3 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH3) Class(v ...string) HTMLH3 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH3) ContentEditable(v bool) HTMLH3 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH3) DataSet(k string, v interface{}) HTMLH3 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH3) Dir(v string) HTMLH3 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH3) Draggable(v bool) HTMLH3 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH3) Hidden(v bool) HTMLH3 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH3) ID(v string) HTMLH3 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH3) Lang(v string) HTMLH3 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH3) Role(v string) HTMLH3 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH3) Spellcheck(v bool) HTMLH3 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH3) Style(k, v string) HTMLH3 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH3) Styles(s map[string]string) HTMLH3 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH3) TabIndex(v int) HTMLH3 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH3) Title(v string) HTMLH3 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH3) OnBlur(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH3) OnChange(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH3) OnClick(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH3) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH3) OnCopy(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH3) OnCut(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH3) OnDblClick(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH3) OnDrag(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH3) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH3) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH3) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH3) OnDragOver(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH3) OnDragStart(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH3) OnDrop(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH3) OnFocus(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH3) OnInput(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH3) OnInvalid(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH3) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH3) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH3) OnKeyup(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH3) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH3) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH3) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH3) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH3) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH3) OnPaste(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH3) OnReset(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH3) OnScroll(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH3) OnSearch(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH3) OnSelect(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH3) OnSubmit(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH3) OnWheel(h EventHandler, scope ...interface{}) HTMLH3 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH4 is the interface that describes a <h4> HTML element.
type HTMLH4 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH4

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH4

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH4

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH4

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH4

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH4

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH4

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH4

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH4

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH4

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH4

	// ID specifies a unique id for an element.
	ID(v string) HTMLH4

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH4

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH4

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH4

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH4

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH4

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH4

	// Title specifies extra information about an element.
	Title(v string) HTMLH4

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH4

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH4

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH4

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH4

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH4

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH4

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH4

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH4

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH4

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH4

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH4

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH4

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH4

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH4

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH4

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH4

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH4

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH4

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH4

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH4

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH4

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH4

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH4

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH4

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH4

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH4

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH4

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH4

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH4

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH4

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH4

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH4
}

// H4 returns an HTML element that defines HTML heading.
func H4() HTMLH4 {
	e := &htmlH4{
		elem: elem{
			tag:         "h4",
			selfClosing: false,
		},
	}

	return e
}

type htmlH4 struct {
	elem
}

func (e *htmlH4) Body(elems ...UI) HTMLH4 {
	e.setBody(elems...)
	return e
}

func (e *htmlH4) Text(v interface{}) HTMLH4 {
	return e.Body(Text(v))
}

func (e *htmlH4) AccessKey(v string) HTMLH4 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH4) Aria(k string, v interface{}) HTMLH4 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH4) Attr(n string, v interface{}) HTMLH4 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH4) Class(v ...string) HTMLH4 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH4) ContentEditable(v bool) HTMLH4 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH4) DataSet(k string, v interface{}) HTMLH4 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH4) Dir(v string) HTMLH4 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH4) Draggable(v bool) HTMLH4 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH4) Hidden(v bool) HTMLH4 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH4) ID(v string) HTMLH4 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH4) Lang(v string) HTMLH4 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH4) Role(v string) HTMLH4 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH4) Spellcheck(v bool) HTMLH4 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH4) Style(k, v string) HTMLH4 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH4) Styles(s map[string]string) HTMLH4 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH4) TabIndex(v int) HTMLH4 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH4) Title(v string) HTMLH4 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH4) OnBlur(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH4) OnChange(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH4) OnClick(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH4) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH4) OnCopy(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH4) OnCut(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH4) OnDblClick(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH4) OnDrag(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH4) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH4) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH4) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH4) OnDragOver(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH4) OnDragStart(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH4) OnDrop(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH4) OnFocus(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH4) OnInput(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH4) OnInvalid(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH4) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH4) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH4) OnKeyup(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH4) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH4) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH4) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH4) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH4) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH4) OnPaste(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH4) OnReset(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH4) OnScroll(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH4) OnSearch(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH4) OnSelect(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH4) OnSubmit(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH4) OnWheel(h EventHandler, scope ...interface{}) HTMLH4 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH5 is the interface that describes a <h5> HTML element.
type HTMLH5 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH5

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH5

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH5

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH5

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH5

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH5

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH5

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH5

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH5

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH5

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH5

	// ID specifies a unique id for an element.
	ID(v string) HTMLH5

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH5

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH5

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH5

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH5

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH5

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH5

	// Title specifies extra information about an element.
	Title(v string) HTMLH5

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH5

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH5

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH5

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH5

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH5

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH5

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH5

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH5

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH5

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH5

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH5

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH5

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH5

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH5

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH5

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH5

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH5

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH5

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH5

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH5

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH5

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH5

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH5

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH5

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH5

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH5

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH5

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH5

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH5

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH5

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH5

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH5
}

// H5 returns an HTML element that defines HTML heading.
func H5() HTMLH5 {
	e := &htmlH5{
		elem: elem{
			tag:         "h5",
			selfClosing: false,
		},
	}

	return e
}

type htmlH5 struct {
	elem
}

func (e *htmlH5) Body(elems ...UI) HTMLH5 {
	e.setBody(elems...)
	return e
}

func (e *htmlH5) Text(v interface{}) HTMLH5 {
	return e.Body(Text(v))
}

func (e *htmlH5) AccessKey(v string) HTMLH5 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH5) Aria(k string, v interface{}) HTMLH5 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH5) Attr(n string, v interface{}) HTMLH5 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH5) Class(v ...string) HTMLH5 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH5) ContentEditable(v bool) HTMLH5 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH5) DataSet(k string, v interface{}) HTMLH5 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH5) Dir(v string) HTMLH5 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH5) Draggable(v bool) HTMLH5 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH5) Hidden(v bool) HTMLH5 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH5) ID(v string) HTMLH5 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH5) Lang(v string) HTMLH5 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH5) Role(v string) HTMLH5 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH5) Spellcheck(v bool) HTMLH5 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH5) Style(k, v string) HTMLH5 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH5) Styles(s map[string]string) HTMLH5 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH5) TabIndex(v int) HTMLH5 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH5) Title(v string) HTMLH5 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH5) OnBlur(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH5) OnChange(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH5) OnClick(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH5) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH5) OnCopy(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH5) OnCut(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH5) OnDblClick(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH5) OnDrag(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH5) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH5) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH5) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH5) OnDragOver(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH5) OnDragStart(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH5) OnDrop(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH5) OnFocus(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH5) OnInput(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH5) OnInvalid(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH5) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH5) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH5) OnKeyup(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH5) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH5) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH5) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH5) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH5) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH5) OnPaste(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH5) OnReset(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH5) OnScroll(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH5) OnSearch(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH5) OnSelect(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH5) OnSubmit(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH5) OnWheel(h EventHandler, scope ...interface{}) HTMLH5 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLH6 is the interface that describes a <h6> HTML element.
type HTMLH6 interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLH6

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLH6

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLH6

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLH6

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLH6

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLH6

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLH6

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLH6

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLH6

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLH6

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLH6

	// ID specifies a unique id for an element.
	ID(v string) HTMLH6

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLH6

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLH6

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLH6

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLH6

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLH6

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLH6

	// Title specifies extra information about an element.
	Title(v string) HTMLH6

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLH6

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLH6

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLH6

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLH6

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLH6

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLH6

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLH6

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLH6

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLH6

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLH6

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLH6

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLH6

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLH6

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLH6

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLH6

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLH6

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLH6

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLH6

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLH6

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLH6

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLH6

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLH6

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLH6

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLH6

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLH6

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLH6

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLH6

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLH6

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLH6

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLH6

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLH6

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLH6
}

// H6 returns an HTML element that defines HTML heading.
func H6() HTMLH6 {
	e := &htmlH6{
		elem: elem{
			tag:         "h6",
			selfClosing: false,
		},
	}

	return e
}

type htmlH6 struct {
	elem
}

func (e *htmlH6) Body(elems ...UI) HTMLH6 {
	e.setBody(elems...)
	return e
}

func (e *htmlH6) Text(v interface{}) HTMLH6 {
	return e.Body(Text(v))
}

func (e *htmlH6) AccessKey(v string) HTMLH6 {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlH6) Aria(k string, v interface{}) HTMLH6 {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH6) Attr(n string, v interface{}) HTMLH6 {
	e.setAttr(n, v)
	return e
}

func (e *htmlH6) Class(v ...string) HTMLH6 {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlH6) ContentEditable(v bool) HTMLH6 {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlH6) DataSet(k string, v interface{}) HTMLH6 {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlH6) Dir(v string) HTMLH6 {
	e.setAttr("dir", v)
	return e
}

func (e *htmlH6) Draggable(v bool) HTMLH6 {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlH6) Hidden(v bool) HTMLH6 {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlH6) ID(v string) HTMLH6 {
	e.setAttr("id", v)
	return e
}

func (e *htmlH6) Lang(v string) HTMLH6 {
	e.setAttr("lang", v)
	return e
}

func (e *htmlH6) Role(v string) HTMLH6 {
	e.setAttr("role", v)
	return e
}

func (e *htmlH6) Spellcheck(v bool) HTMLH6 {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlH6) Style(k, v string) HTMLH6 {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlH6) Styles(s map[string]string) HTMLH6 {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlH6) TabIndex(v int) HTMLH6 {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlH6) Title(v string) HTMLH6 {
	e.setAttr("title", v)
	return e
}

func (e *htmlH6) OnBlur(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlH6) OnChange(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlH6) OnClick(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlH6) OnContextMenu(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlH6) OnCopy(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlH6) OnCut(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlH6) OnDblClick(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlH6) OnDrag(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlH6) OnDragEnd(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlH6) OnDragEnter(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlH6) OnDragLeave(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlH6) OnDragOver(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlH6) OnDragStart(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlH6) OnDrop(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlH6) OnFocus(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlH6) OnInput(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlH6) OnInvalid(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlH6) OnKeyDown(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlH6) OnKeyPress(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlH6) OnKeyup(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlH6) OnMouseDown(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlH6) OnMouseMove(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlH6) OnMouseOut(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlH6) OnMouseOver(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlH6) OnMouseUp(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlH6) OnPaste(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlH6) OnReset(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlH6) OnScroll(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlH6) OnSearch(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlH6) OnSelect(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlH6) OnSubmit(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlH6) OnWheel(h EventHandler, scope ...interface{}) HTMLH6 {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLHead is the interface that describes a <head> HTML element.
type HTMLHead interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLHead

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLHead

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLHead

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLHead

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLHead

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLHead

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLHead

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLHead

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLHead

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLHead

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLHead

	// ID specifies a unique id for an element.
	ID(v string) HTMLHead

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLHead

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLHead

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLHead

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLHead

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLHead

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLHead

	// Title specifies extra information about an element.
	Title(v string) HTMLHead
}

// Head returns an HTML element that defines information about the document.
func Head() HTMLHead {
	e := &htmlHead{
		elem: elem{
			tag:         "head",
			selfClosing: false,
		},
	}

	return e
}

type htmlHead struct {
	elem
}

func (e *htmlHead) Body(elems ...UI) HTMLHead {
	e.setBody(elems...)
	return e
}

func (e *htmlHead) Text(v interface{}) HTMLHead {
	return e.Body(Text(v))
}

func (e *htmlHead) AccessKey(v string) HTMLHead {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlHead) Aria(k string, v interface{}) HTMLHead {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHead) Attr(n string, v interface{}) HTMLHead {
	e.setAttr(n, v)
	return e
}

func (e *htmlHead) Class(v ...string) HTMLHead {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlHead) ContentEditable(v bool) HTMLHead {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlHead) DataSet(k string, v interface{}) HTMLHead {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHead) Dir(v string) HTMLHead {
	e.setAttr("dir", v)
	return e
}

func (e *htmlHead) Draggable(v bool) HTMLHead {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlHead) Hidden(v bool) HTMLHead {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlHead) ID(v string) HTMLHead {
	e.setAttr("id", v)
	return e
}

func (e *htmlHead) Lang(v string) HTMLHead {
	e.setAttr("lang", v)
	return e
}

func (e *htmlHead) Role(v string) HTMLHead {
	e.setAttr("role", v)
	return e
}

func (e *htmlHead) Spellcheck(v bool) HTMLHead {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlHead) Style(k, v string) HTMLHead {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlHead) Styles(s map[string]string) HTMLHead {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlHead) TabIndex(v int) HTMLHead {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlHead) Title(v string) HTMLHead {
	e.setAttr("title", v)
	return e
}

// HTMLHeader is the interface that describes a <header> HTML element.
type HTMLHeader interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLHeader

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLHeader

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLHeader

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLHeader

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLHeader

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLHeader

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLHeader

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLHeader

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLHeader

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLHeader

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLHeader

	// ID specifies a unique id for an element.
	ID(v string) HTMLHeader

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLHeader

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLHeader

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLHeader

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLHeader

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLHeader

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLHeader

	// Title specifies extra information about an element.
	Title(v string) HTMLHeader

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLHeader

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLHeader

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLHeader

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLHeader

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLHeader

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLHeader

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLHeader

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLHeader

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLHeader

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLHeader

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLHeader

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLHeader

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLHeader

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLHeader

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLHeader

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLHeader

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLHeader

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLHeader

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLHeader

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLHeader

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLHeader

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLHeader

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLHeader

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLHeader

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLHeader
}

// Header returns an HTML element that defines a header for a document or section.
func Header() HTMLHeader {
	e := &htmlHeader{
		elem: elem{
			tag:         "header",
			selfClosing: false,
		},
	}

	return e
}

type htmlHeader struct {
	elem
}

func (e *htmlHeader) Body(elems ...UI) HTMLHeader {
	e.setBody(elems...)
	return e
}

func (e *htmlHeader) Text(v interface{}) HTMLHeader {
	return e.Body(Text(v))
}

func (e *htmlHeader) AccessKey(v string) HTMLHeader {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlHeader) Aria(k string, v interface{}) HTMLHeader {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHeader) Attr(n string, v interface{}) HTMLHeader {
	e.setAttr(n, v)
	return e
}

func (e *htmlHeader) Class(v ...string) HTMLHeader {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlHeader) ContentEditable(v bool) HTMLHeader {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlHeader) DataSet(k string, v interface{}) HTMLHeader {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHeader) Dir(v string) HTMLHeader {
	e.setAttr("dir", v)
	return e
}

func (e *htmlHeader) Draggable(v bool) HTMLHeader {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlHeader) Hidden(v bool) HTMLHeader {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlHeader) ID(v string) HTMLHeader {
	e.setAttr("id", v)
	return e
}

func (e *htmlHeader) Lang(v string) HTMLHeader {
	e.setAttr("lang", v)
	return e
}

func (e *htmlHeader) Role(v string) HTMLHeader {
	e.setAttr("role", v)
	return e
}

func (e *htmlHeader) Spellcheck(v bool) HTMLHeader {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlHeader) Style(k, v string) HTMLHeader {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlHeader) Styles(s map[string]string) HTMLHeader {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlHeader) TabIndex(v int) HTMLHeader {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlHeader) Title(v string) HTMLHeader {
	e.setAttr("title", v)
	return e
}

func (e *htmlHeader) OnBlur(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlHeader) OnChange(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlHeader) OnClick(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlHeader) OnContextMenu(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlHeader) OnCopy(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlHeader) OnCut(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlHeader) OnDblClick(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlHeader) OnDrag(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlHeader) OnDragEnd(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlHeader) OnDragEnter(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlHeader) OnDragLeave(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlHeader) OnDragOver(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlHeader) OnDragStart(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlHeader) OnDrop(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlHeader) OnFocus(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlHeader) OnInput(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlHeader) OnInvalid(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlHeader) OnKeyDown(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlHeader) OnKeyPress(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlHeader) OnKeyup(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlHeader) OnMouseDown(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlHeader) OnMouseMove(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlHeader) OnMouseOut(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlHeader) OnMouseOver(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlHeader) OnMouseUp(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlHeader) OnPaste(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlHeader) OnReset(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlHeader) OnScroll(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlHeader) OnSearch(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlHeader) OnSelect(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlHeader) OnSubmit(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlHeader) OnWheel(h EventHandler, scope ...interface{}) HTMLHeader {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLHr is the interface that describes a <hr> HTML element.
type HTMLHr interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLHr

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLHr

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLHr

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLHr

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLHr

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLHr

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLHr

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLHr

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLHr

	// ID specifies a unique id for an element.
	ID(v string) HTMLHr

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLHr

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLHr

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLHr

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLHr

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLHr

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLHr

	// Title specifies extra information about an element.
	Title(v string) HTMLHr

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLHr

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLHr

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLHr

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLHr

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLHr

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLHr

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLHr

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLHr

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLHr

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLHr

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLHr

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLHr

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLHr

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLHr

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLHr

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLHr

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLHr

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLHr

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLHr

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLHr

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLHr

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLHr

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLHr

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLHr

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLHr

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLHr

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLHr

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLHr

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLHr

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLHr

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLHr

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLHr
}

// Hr returns an HTML element that defines a thematic change in the content.
func Hr() HTMLHr {
	e := &htmlHr{
		elem: elem{
			tag:         "hr",
			selfClosing: true,
		},
	}

	return e
}

type htmlHr struct {
	elem
}

func (e *htmlHr) AccessKey(v string) HTMLHr {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlHr) Aria(k string, v interface{}) HTMLHr {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHr) Attr(n string, v interface{}) HTMLHr {
	e.setAttr(n, v)
	return e
}

func (e *htmlHr) Class(v ...string) HTMLHr {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlHr) ContentEditable(v bool) HTMLHr {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlHr) DataSet(k string, v interface{}) HTMLHr {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHr) Dir(v string) HTMLHr {
	e.setAttr("dir", v)
	return e
}

func (e *htmlHr) Draggable(v bool) HTMLHr {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlHr) Hidden(v bool) HTMLHr {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlHr) ID(v string) HTMLHr {
	e.setAttr("id", v)
	return e
}

func (e *htmlHr) Lang(v string) HTMLHr {
	e.setAttr("lang", v)
	return e
}

func (e *htmlHr) Role(v string) HTMLHr {
	e.setAttr("role", v)
	return e
}

func (e *htmlHr) Spellcheck(v bool) HTMLHr {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlHr) Style(k, v string) HTMLHr {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlHr) Styles(s map[string]string) HTMLHr {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlHr) TabIndex(v int) HTMLHr {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlHr) Title(v string) HTMLHr {
	e.setAttr("title", v)
	return e
}

func (e *htmlHr) OnBlur(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlHr) OnChange(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlHr) OnClick(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlHr) OnContextMenu(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlHr) OnCopy(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlHr) OnCut(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlHr) OnDblClick(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlHr) OnDrag(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlHr) OnDragEnd(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlHr) OnDragEnter(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlHr) OnDragLeave(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlHr) OnDragOver(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlHr) OnDragStart(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlHr) OnDrop(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlHr) OnFocus(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlHr) OnInput(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlHr) OnInvalid(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlHr) OnKeyDown(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlHr) OnKeyPress(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlHr) OnKeyup(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlHr) OnMouseDown(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlHr) OnMouseMove(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlHr) OnMouseOut(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlHr) OnMouseOver(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlHr) OnMouseUp(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlHr) OnPaste(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlHr) OnReset(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlHr) OnScroll(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlHr) OnSearch(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlHr) OnSelect(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlHr) OnSubmit(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlHr) OnWheel(h EventHandler, scope ...interface{}) HTMLHr {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLHtml is the interface that describes a <html> HTML element.
type HTMLHtml interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLHtml

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLHtml

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLHtml

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLHtml

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLHtml

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLHtml

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLHtml

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLHtml

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLHtml

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLHtml

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLHtml

	// ID specifies a unique id for an element.
	ID(v string) HTMLHtml

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLHtml

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLHtml

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLHtml

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLHtml

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLHtml

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLHtml

	// Title specifies extra information about an element.
	Title(v string) HTMLHtml
}

// Html returns an HTML element that defines the root of an HTML document.
func Html() HTMLHtml {
	e := &htmlHtml{
		elem: elem{
			tag:         "html",
			selfClosing: false,
		},
	}

	return e
}

type htmlHtml struct {
	elem
}

func (e *htmlHtml) Body(elems ...UI) HTMLHtml {
	e.setBody(elems...)
	return e
}

func (e *htmlHtml) Text(v interface{}) HTMLHtml {
	return e.Body(Text(v))
}

func (e *htmlHtml) AccessKey(v string) HTMLHtml {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlHtml) Aria(k string, v interface{}) HTMLHtml {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHtml) Attr(n string, v interface{}) HTMLHtml {
	e.setAttr(n, v)
	return e
}

func (e *htmlHtml) Class(v ...string) HTMLHtml {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlHtml) ContentEditable(v bool) HTMLHtml {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlHtml) DataSet(k string, v interface{}) HTMLHtml {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlHtml) Dir(v string) HTMLHtml {
	e.setAttr("dir", v)
	return e
}

func (e *htmlHtml) Draggable(v bool) HTMLHtml {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlHtml) Hidden(v bool) HTMLHtml {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlHtml) ID(v string) HTMLHtml {
	e.setAttr("id", v)
	return e
}

func (e *htmlHtml) Lang(v string) HTMLHtml {
	e.setAttr("lang", v)
	return e
}

func (e *htmlHtml) Role(v string) HTMLHtml {
	e.setAttr("role", v)
	return e
}

func (e *htmlHtml) Spellcheck(v bool) HTMLHtml {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlHtml) Style(k, v string) HTMLHtml {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlHtml) Styles(s map[string]string) HTMLHtml {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlHtml) TabIndex(v int) HTMLHtml {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlHtml) Title(v string) HTMLHtml {
	e.setAttr("title", v)
	return e
}

// HTMLI is the interface that describes a <i> HTML element.
type HTMLI interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLI

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLI

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLI

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLI

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLI

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLI

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLI

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLI

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLI

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLI

	// ID specifies a unique id for an element.
	ID(v string) HTMLI

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLI

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLI

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLI

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLI

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLI

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLI

	// Title specifies extra information about an element.
	Title(v string) HTMLI

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLI

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLI

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLI

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLI

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLI

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLI

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLI

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLI

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLI

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLI

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLI

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLI

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLI

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLI

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLI

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLI

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLI

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLI

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLI

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLI

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLI

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLI

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLI

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLI

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLI

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLI

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLI

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLI

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLI

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLI

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLI

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLI
}

// I returns an HTML element that defines a part of text in an alternate voice or mood.
func I() HTMLI {
	e := &htmlI{
		elem: elem{
			tag:         "i",
			selfClosing: false,
		},
	}

	return e
}

type htmlI struct {
	elem
}

func (e *htmlI) Body(elems ...UI) HTMLI {
	e.setBody(elems...)
	return e
}

func (e *htmlI) Text(v interface{}) HTMLI {
	return e.Body(Text(v))
}

func (e *htmlI) AccessKey(v string) HTMLI {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlI) Aria(k string, v interface{}) HTMLI {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlI) Attr(n string, v interface{}) HTMLI {
	e.setAttr(n, v)
	return e
}

func (e *htmlI) Class(v ...string) HTMLI {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlI) ContentEditable(v bool) HTMLI {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlI) DataSet(k string, v interface{}) HTMLI {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlI) Dir(v string) HTMLI {
	e.setAttr("dir", v)
	return e
}

func (e *htmlI) Draggable(v bool) HTMLI {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlI) Hidden(v bool) HTMLI {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlI) ID(v string) HTMLI {
	e.setAttr("id", v)
	return e
}

func (e *htmlI) Lang(v string) HTMLI {
	e.setAttr("lang", v)
	return e
}

func (e *htmlI) Role(v string) HTMLI {
	e.setAttr("role", v)
	return e
}

func (e *htmlI) Spellcheck(v bool) HTMLI {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlI) Style(k, v string) HTMLI {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlI) Styles(s map[string]string) HTMLI {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlI) TabIndex(v int) HTMLI {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlI) Title(v string) HTMLI {
	e.setAttr("title", v)
	return e
}

func (e *htmlI) OnBlur(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlI) OnChange(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlI) OnClick(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlI) OnContextMenu(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlI) OnCopy(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlI) OnCut(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlI) OnDblClick(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlI) OnDrag(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlI) OnDragEnd(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlI) OnDragEnter(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlI) OnDragLeave(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlI) OnDragOver(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlI) OnDragStart(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlI) OnDrop(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlI) OnFocus(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlI) OnInput(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlI) OnInvalid(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlI) OnKeyDown(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlI) OnKeyPress(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlI) OnKeyup(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlI) OnMouseDown(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlI) OnMouseMove(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlI) OnMouseOut(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlI) OnMouseOver(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlI) OnMouseUp(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlI) OnPaste(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlI) OnReset(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlI) OnScroll(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlI) OnSearch(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlI) OnSelect(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlI) OnSubmit(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlI) OnWheel(h EventHandler, scope ...interface{}) HTMLI {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLIFrame is the interface that describes a <iframe> HTML element.
type HTMLIFrame interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLIFrame

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLIFrame

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLIFrame

	// Allow specifies a feature policy. Can be called multiple times to set multiple policies.
	Allow(v string) HTMLIFrame

	// AllowFullscreen reports whether an iframe can activate fullscreen mode.
	AllowFullscreen(v bool) HTMLIFrame

	// AllowPaymentRequest reports whether an iframe should be allowed to invoke the Payment Request API
	AllowPaymentRequest(v bool) HTMLIFrame

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLIFrame

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLIFrame

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLIFrame

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLIFrame

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLIFrame

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLIFrame

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLIFrame

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLIFrame

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLIFrame

	// ID specifies a unique id for an element.
	ID(v string) HTMLIFrame

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLIFrame

	// Name specifies the name of the element.
	Name(v string) HTMLIFrame

	// ReferrerPolicy specifies how much/which referrer information that will be sent when processing the iframe attributes
	ReferrerPolicy(v string) HTMLIFrame

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLIFrame

	// Sandbox enables an extra set of restrictions for the content in an iframe.
	Sandbox(v interface{}) HTMLIFrame

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLIFrame

	// Src specifies the URL of the media file.
	Src(v string) HTMLIFrame

	// SrcDoc specifies the HTML content of the page to show in the iframe.
	SrcDoc(v string) HTMLIFrame

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLIFrame

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLIFrame

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLIFrame

	// Title specifies extra information about an element.
	Title(v string) HTMLIFrame

	// Width specifies the width of the element.
	Width(v int) HTMLIFrame

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLIFrame

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLIFrame
}

// IFrame returns an HTML element that defines an inline frame.
func IFrame() HTMLIFrame {
	e := &htmlIFrame{
		elem: elem{
			tag:         "iframe",
			selfClosing: false,
		},
	}

	return e
}

type htmlIFrame struct {
	elem
}

func (e *htmlIFrame) Body(elems ...UI) HTMLIFrame {
	e.setBody(elems...)
	return e
}

func (e *htmlIFrame) Text(v interface{}) HTMLIFrame {
	return e.Body(Text(v))
}

func (e *htmlIFrame) AccessKey(v string) HTMLIFrame {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlIFrame) Allow(v string) HTMLIFrame {
	e.setAttr("allow", v)
	return e
}

func (e *htmlIFrame) AllowFullscreen(v bool) HTMLIFrame {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("allowfullscreen", s)
	return e
}

func (e *htmlIFrame) AllowPaymentRequest(v bool) HTMLIFrame {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("allowpaymentrequest", s)
	return e
}

func (e *htmlIFrame) Aria(k string, v interface{}) HTMLIFrame {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlIFrame) Attr(n string, v interface{}) HTMLIFrame {
	e.setAttr(n, v)
	return e
}

func (e *htmlIFrame) Class(v ...string) HTMLIFrame {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlIFrame) ContentEditable(v bool) HTMLIFrame {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlIFrame) DataSet(k string, v interface{}) HTMLIFrame {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlIFrame) Dir(v string) HTMLIFrame {
	e.setAttr("dir", v)
	return e
}

func (e *htmlIFrame) Draggable(v bool) HTMLIFrame {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlIFrame) Height(v int) HTMLIFrame {
	e.setAttr("height", v)
	return e
}

func (e *htmlIFrame) Hidden(v bool) HTMLIFrame {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlIFrame) ID(v string) HTMLIFrame {
	e.setAttr("id", v)
	return e
}

func (e *htmlIFrame) Lang(v string) HTMLIFrame {
	e.setAttr("lang", v)
	return e
}

func (e *htmlIFrame) Name(v string) HTMLIFrame {
	e.setAttr("name", v)
	return e
}

func (e *htmlIFrame) ReferrerPolicy(v string) HTMLIFrame {
	e.setAttr("referrerpolicy", v)
	return e
}

func (e *htmlIFrame) Role(v string) HTMLIFrame {
	e.setAttr("role", v)
	return e
}

func (e *htmlIFrame) Sandbox(v interface{}) HTMLIFrame {
	e.setAttr("sandbox", v)
	return e
}

func (e *htmlIFrame) Spellcheck(v bool) HTMLIFrame {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlIFrame) Src(v string) HTMLIFrame {
	e.setAttr("src", v)
	return e
}

func (e *htmlIFrame) SrcDoc(v string) HTMLIFrame {
	e.setAttr("srcdoc", v)
	return e
}

func (e *htmlIFrame) Style(k, v string) HTMLIFrame {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlIFrame) Styles(s map[string]string) HTMLIFrame {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlIFrame) TabIndex(v int) HTMLIFrame {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlIFrame) Title(v string) HTMLIFrame {
	e.setAttr("title", v)
	return e
}

func (e *htmlIFrame) Width(v int) HTMLIFrame {
	e.setAttr("width", v)
	return e
}

func (e *htmlIFrame) OnBlur(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlIFrame) OnChange(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlIFrame) OnClick(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlIFrame) OnContextMenu(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlIFrame) OnCopy(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlIFrame) OnCut(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlIFrame) OnDblClick(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlIFrame) OnDrag(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlIFrame) OnDragEnd(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlIFrame) OnDragEnter(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlIFrame) OnDragLeave(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlIFrame) OnDragOver(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlIFrame) OnDragStart(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlIFrame) OnDrop(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlIFrame) OnFocus(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlIFrame) OnInput(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlIFrame) OnInvalid(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlIFrame) OnKeyDown(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlIFrame) OnKeyPress(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlIFrame) OnKeyup(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlIFrame) OnLoad(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlIFrame) OnMouseDown(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlIFrame) OnMouseMove(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlIFrame) OnMouseOut(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlIFrame) OnMouseOver(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlIFrame) OnMouseUp(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlIFrame) OnPaste(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlIFrame) OnReset(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlIFrame) OnScroll(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlIFrame) OnSearch(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlIFrame) OnSelect(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlIFrame) OnSubmit(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlIFrame) OnWheel(h EventHandler, scope ...interface{}) HTMLIFrame {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLImg is the interface that describes a <img> HTML element.
type HTMLImg interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLImg

	// Alt specifies an alternate text when the original element fails to display.
	Alt(v string) HTMLImg

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLImg

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLImg

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLImg

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLImg

	// CrossOrigin sets the mode of the request to an HTTP CORS Request.
	CrossOrigin(v string) HTMLImg

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLImg

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLImg

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLImg

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLImg

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLImg

	// ID specifies a unique id for an element.
	ID(v string) HTMLImg

	// IsMap specifies an image as a server-side image-map.
	IsMap(v bool) HTMLImg

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLImg

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLImg

	// Sizes specifies the size of the linked resource.
	Sizes(v string) HTMLImg

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLImg

	// Src specifies the URL of the media file.
	Src(v string) HTMLImg

	// SrcSet specifies the URL of the image to use in different situations.
	SrcSet(v string) HTMLImg

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLImg

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLImg

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLImg

	// Title specifies extra information about an element.
	Title(v string) HTMLImg

	// UseMap specifies an image as a client-side image-map.
	UseMap(v string) HTMLImg

	// Width specifies the width of the element.
	Width(v int) HTMLImg

	// OnAbort calls the given handler on abort.
	OnAbort(h EventHandler, scope ...interface{}) HTMLImg

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLImg

	// OnCanPlay calls the given handler when a file is ready to start playing (when it has buffered enough to begin).
	OnCanPlay(h EventHandler, scope ...interface{}) HTMLImg

	// OnCanPlayThrough calls the given handler when a file can be played all the way to the end without pausing for buffering.
	OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLImg

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLImg

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLImg

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLImg

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLImg

	// OnCueChange calls the given handler when the cue changes in a track element.
	OnCueChange(h EventHandler, scope ...interface{}) HTMLImg

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLImg

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLImg

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLImg

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLImg

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLImg

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLImg

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLImg

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLImg

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLImg

	// OnDurationChange calls the given handler when the length of the media changes.
	OnDurationChange(h EventHandler, scope ...interface{}) HTMLImg

	// OnEmptied calls the given handler when something bad happens and the file is suddenly unavailable (like unexpectedly disconnects).
	OnEmptied(h EventHandler, scope ...interface{}) HTMLImg

	// OnEnded calls the given handler when the media has reach the end.
	OnEnded(h EventHandler, scope ...interface{}) HTMLImg

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLImg

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLImg

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLImg

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLImg

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLImg

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLImg

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLImg

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLImg

	// OnLoadStart calls the given handler just as the file begins to load before anything is actually loaded.
	OnLoadStart(h EventHandler, scope ...interface{}) HTMLImg

	// OnLoadedData calls the given handler when media data is loaded.
	OnLoadedData(h EventHandler, scope ...interface{}) HTMLImg

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLImg

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLImg

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLImg

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLImg

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLImg

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLImg

	// OnPause calls the given handler when the media is paused either by the user or programmatically.
	OnPause(h EventHandler, scope ...interface{}) HTMLImg

	// OnPlay calls the given handler when the media is ready to start playing.
	OnPlay(h EventHandler, scope ...interface{}) HTMLImg

	// OnPlaying calls the given handler when the media actually has started playing.
	OnPlaying(h EventHandler, scope ...interface{}) HTMLImg

	// OnProgress calls the given handler when the browser is in the process of getting the media data.
	OnProgress(h EventHandler, scope ...interface{}) HTMLImg

	// OnRateChange calls the given handler each time the playback rate changes (like when a user switches to a slow motion or fast forward mode).
	OnRateChange(h EventHandler, scope ...interface{}) HTMLImg

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLImg

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLImg

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLImg

	// OnSeeked calls the given handler when the seeking attribute is set to false indicating that seeking has ended.
	OnSeeked(h EventHandler, scope ...interface{}) HTMLImg

	// OnSeeking calls the given handler when the seeking attribute is set to true indicating that seeking is active.
	OnSeeking(h EventHandler, scope ...interface{}) HTMLImg

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLImg

	// OnStalled calls the given handler when the browser is unable to fetch the media data for whatever reason.
	OnStalled(h EventHandler, scope ...interface{}) HTMLImg

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLImg

	// OnSuspend calls the given handler when fetching the media data is stopped before it is completely loaded for whatever reason.
	OnSuspend(h EventHandler, scope ...interface{}) HTMLImg

	// OnTimeUpdate calls the given handler when the playing position has changed (like when the user fast forwards to a different point in the media).
	OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLImg

	// OnVolumeChange calls the given handler each time the volume is changed which (includes setting the volume to "mute").
	OnVolumeChange(h EventHandler, scope ...interface{}) HTMLImg

	// OnWaiting calls the given handler when the media has paused but is expected to resume (like when the media pauses to buffer more data).
	OnWaiting(h EventHandler, scope ...interface{}) HTMLImg

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLImg

	// OnloadedMetaData calls the given handler when meta data (like dimensions and duration) are loaded.
	OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLImg
}

// Img returns an HTML element that defines an image.
func Img() HTMLImg {
	e := &htmlImg{
		elem: elem{
			tag:         "img",
			selfClosing: true,
		},
	}

	return e
}

type htmlImg struct {
	elem
}

func (e *htmlImg) AccessKey(v string) HTMLImg {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlImg) Alt(v string) HTMLImg {
	e.setAttr("alt", v)
	return e
}

func (e *htmlImg) Aria(k string, v interface{}) HTMLImg {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlImg) Attr(n string, v interface{}) HTMLImg {
	e.setAttr(n, v)
	return e
}

func (e *htmlImg) Class(v ...string) HTMLImg {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlImg) ContentEditable(v bool) HTMLImg {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlImg) CrossOrigin(v string) HTMLImg {
	e.setAttr("crossorigin", v)
	return e
}

func (e *htmlImg) DataSet(k string, v interface{}) HTMLImg {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlImg) Dir(v string) HTMLImg {
	e.setAttr("dir", v)
	return e
}

func (e *htmlImg) Draggable(v bool) HTMLImg {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlImg) Height(v int) HTMLImg {
	e.setAttr("height", v)
	return e
}

func (e *htmlImg) Hidden(v bool) HTMLImg {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlImg) ID(v string) HTMLImg {
	e.setAttr("id", v)
	return e
}

func (e *htmlImg) IsMap(v bool) HTMLImg {
	e.setAttr("ismap", v)
	return e
}

func (e *htmlImg) Lang(v string) HTMLImg {
	e.setAttr("lang", v)
	return e
}

func (e *htmlImg) Role(v string) HTMLImg {
	e.setAttr("role", v)
	return e
}

func (e *htmlImg) Sizes(v string) HTMLImg {
	e.setAttr("sizes", v)
	return e
}

func (e *htmlImg) Spellcheck(v bool) HTMLImg {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlImg) Src(v string) HTMLImg {
	e.setAttr("src", v)
	return e
}

func (e *htmlImg) SrcSet(v string) HTMLImg {
	e.setAttr("srcset", v)
	return e
}

func (e *htmlImg) Style(k, v string) HTMLImg {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlImg) Styles(s map[string]string) HTMLImg {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlImg) TabIndex(v int) HTMLImg {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlImg) Title(v string) HTMLImg {
	e.setAttr("title", v)
	return e
}

func (e *htmlImg) UseMap(v string) HTMLImg {
	e.setAttr("usemap", v)
	return e
}

func (e *htmlImg) Width(v int) HTMLImg {
	e.setAttr("width", v)
	return e
}

func (e *htmlImg) OnAbort(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("abort", h, scope...)
	return e
}

func (e *htmlImg) OnBlur(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlImg) OnCanPlay(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("canplay", h, scope...)
	return e
}

func (e *htmlImg) OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("canplaythrough", h, scope...)
	return e
}

func (e *htmlImg) OnChange(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlImg) OnClick(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlImg) OnContextMenu(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlImg) OnCopy(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlImg) OnCueChange(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("cuechange", h, scope...)
	return e
}

func (e *htmlImg) OnCut(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlImg) OnDblClick(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlImg) OnDrag(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlImg) OnDragEnd(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlImg) OnDragEnter(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlImg) OnDragLeave(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlImg) OnDragOver(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlImg) OnDragStart(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlImg) OnDrop(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlImg) OnDurationChange(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("durationchange", h, scope...)
	return e
}

func (e *htmlImg) OnEmptied(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("emptied", h, scope...)
	return e
}

func (e *htmlImg) OnEnded(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("ended", h, scope...)
	return e
}

func (e *htmlImg) OnError(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlImg) OnFocus(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlImg) OnInput(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlImg) OnInvalid(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlImg) OnKeyDown(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlImg) OnKeyPress(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlImg) OnKeyup(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlImg) OnLoad(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlImg) OnLoadStart(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("loadstart", h, scope...)
	return e
}

func (e *htmlImg) OnLoadedData(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("loadeddata", h, scope...)
	return e
}

func (e *htmlImg) OnMouseDown(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlImg) OnMouseMove(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlImg) OnMouseOut(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlImg) OnMouseOver(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlImg) OnMouseUp(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlImg) OnPaste(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlImg) OnPause(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("pause", h, scope...)
	return e
}

func (e *htmlImg) OnPlay(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("play", h, scope...)
	return e
}

func (e *htmlImg) OnPlaying(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("playing", h, scope...)
	return e
}

func (e *htmlImg) OnProgress(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("progress", h, scope...)
	return e
}

func (e *htmlImg) OnRateChange(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("ratechange", h, scope...)
	return e
}

func (e *htmlImg) OnReset(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlImg) OnScroll(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlImg) OnSearch(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlImg) OnSeeked(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("seeked", h, scope...)
	return e
}

func (e *htmlImg) OnSeeking(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("seeking", h, scope...)
	return e
}

func (e *htmlImg) OnSelect(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlImg) OnStalled(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("stalled", h, scope...)
	return e
}

func (e *htmlImg) OnSubmit(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlImg) OnSuspend(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("suspend", h, scope...)
	return e
}

func (e *htmlImg) OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("timeupdate", h, scope...)
	return e
}

func (e *htmlImg) OnVolumeChange(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("volumechange", h, scope...)
	return e
}

func (e *htmlImg) OnWaiting(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("waiting", h, scope...)
	return e
}

func (e *htmlImg) OnWheel(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("wheel", h, scope...)
	return e
}

func (e *htmlImg) OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLImg {
	e.setEventHandler("loadedmetadata", h, scope...)
	return e
}

// HTMLInput is the interface that describes a <input> HTML element.
type HTMLInput interface {
	UI

	// Accept specifies the types of files that the server accepts (only for file type).
	Accept(v string) HTMLInput

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLInput

	// Alt specifies an alternate text when the original element fails to display.
	Alt(v string) HTMLInput

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLInput

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLInput

	// AutoComplete specifies whether the element should have autocomplete enabled.
	AutoComplete(v bool) HTMLInput

	// AutoFocus specifies that the element should automatically get focus when the page loads.
	AutoFocus(v bool) HTMLInput

	// Capture specifies the capture input method in file upload controls
	Capture(v string) HTMLInput

	// Checked specifies that an input element should be pre-selected when the page loads (for checkbox or radio types).
	Checked(v bool) HTMLInput

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLInput

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLInput

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLInput

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLInput

	// DirName specifies that the text direction will be submitted.
	DirName(v string) HTMLInput

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLInput

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLInput

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLInput

	// FormAction specifies where to send the form-data when a form is submitted. Only for submit type.
	FormAction(v string) HTMLInput

	// FormEncType specifies how form-data should be encoded before sending it to a server. Only for submit type.
	FormEncType(v string) HTMLInput

	// FormMethod specifies how to send the form-data (which HTTP method to use). Only for submit type.
	FormMethod(v string) HTMLInput

	// FormNoValidate specifies that the form-data should not be validated on submission. Only for submit type.
	FormNoValidate(v bool) HTMLInput

	// FormTarget specifies where to display the response after submitting the form. Only for submit type.
	FormTarget(v string) HTMLInput

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLInput

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLInput

	// ID specifies a unique id for an element.
	ID(v string) HTMLInput

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLInput

	// List refers to a datalist element that contains pre-defined options for an input element.
	List(v string) HTMLInput

	// Max Specifies the maximum value.
	Max(v interface{}) HTMLInput

	// MaxLength specifies the maximum number of characters allowed in an element.
	MaxLength(v int) HTMLInput

	// Min specifies a minimum value.
	Min(v interface{}) HTMLInput

	// Multiple specifies that a user can enter more than one value.
	Multiple(v bool) HTMLInput

	// Name specifies the name of the element.
	Name(v string) HTMLInput

	// Pattern specifies a regular expression that an input element's value is checked against.
	Pattern(v string) HTMLInput

	// Placeholder specifies a short hint that describes the expected value of the element.
	Placeholder(v string) HTMLInput

	// ReadOnly specifies that the element is read-only.
	ReadOnly(v bool) HTMLInput

	// Required specifies that the element must be filled out before submitting the form.
	Required(v bool) HTMLInput

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLInput

	// Size specifies the width.
	Size(v int) HTMLInput

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLInput

	// Src specifies the URL of the media file.
	Src(v string) HTMLInput

	// Step specifies the legal number intervals for an input field.
	Step(v float64) HTMLInput

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLInput

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLInput

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLInput

	// Title specifies extra information about an element.
	Title(v string) HTMLInput

	// Type specifies the type of element.
	Type(v string) HTMLInput

	// Value specifies the value of the element.
	Value(v interface{}) HTMLInput

	// Width specifies the width of the element.
	Width(v int) HTMLInput

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLInput

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLInput

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLInput

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLInput

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLInput

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLInput

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLInput

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLInput

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLInput

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLInput

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLInput

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLInput

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLInput

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLInput

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLInput

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLInput

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLInput

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLInput

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLInput

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLInput

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLInput

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLInput

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLInput

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLInput

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLInput

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLInput

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLInput

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLInput

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLInput

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLInput

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLInput

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLInput

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLInput
}

// Input returns an HTML element that defines an input control.
func Input() HTMLInput {
	e := &htmlInput{
		elem: elem{
			tag:         "input",
			selfClosing: true,
		},
	}

	return e
}

type htmlInput struct {
	elem
}

func (e *htmlInput) Accept(v string) HTMLInput {
	e.setAttr("accept", v)
	return e
}

func (e *htmlInput) AccessKey(v string) HTMLInput {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlInput) Alt(v string) HTMLInput {
	e.setAttr("alt", v)
	return e
}

func (e *htmlInput) Aria(k string, v interface{}) HTMLInput {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlInput) Attr(n string, v interface{}) HTMLInput {
	e.setAttr(n, v)
	return e
}

func (e *htmlInput) AutoComplete(v bool) HTMLInput {
	s := "off"
	if v {
		s = "on"
	}

	e.setAttr("autocomplete", s)
	return e
}

func (e *htmlInput) AutoFocus(v bool) HTMLInput {
	e.setAttr("autofocus", v)
	return e
}

func (e *htmlInput) Capture(v string) HTMLInput {
	e.setAttr("capture", v)
	return e
}

func (e *htmlInput) Checked(v bool) HTMLInput {
	e.setAttr("checked", v)
	return e
}

func (e *htmlInput) Class(v ...string) HTMLInput {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlInput) ContentEditable(v bool) HTMLInput {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlInput) DataSet(k string, v interface{}) HTMLInput {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlInput) Dir(v string) HTMLInput {
	e.setAttr("dir", v)
	return e
}

func (e *htmlInput) DirName(v string) HTMLInput {
	e.setAttr("dirname", v)
	return e
}

func (e *htmlInput) Disabled(v bool) HTMLInput {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlInput) Draggable(v bool) HTMLInput {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlInput) Form(v string) HTMLInput {
	e.setAttr("form", v)
	return e
}

func (e *htmlInput) FormAction(v string) HTMLInput {
	e.setAttr("formaction", v)
	return e
}

func (e *htmlInput) FormEncType(v string) HTMLInput {
	e.setAttr("formenctype", v)
	return e
}

func (e *htmlInput) FormMethod(v string) HTMLInput {
	e.setAttr("formmethod", v)
	return e
}

func (e *htmlInput) FormNoValidate(v bool) HTMLInput {
	e.setAttr("formnovalidate", v)
	return e
}

func (e *htmlInput) FormTarget(v string) HTMLInput {
	e.setAttr("formtarget", v)
	return e
}

func (e *htmlInput) Height(v int) HTMLInput {
	e.setAttr("height", v)
	return e
}

func (e *htmlInput) Hidden(v bool) HTMLInput {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlInput) ID(v string) HTMLInput {
	e.setAttr("id", v)
	return e
}

func (e *htmlInput) Lang(v string) HTMLInput {
	e.setAttr("lang", v)
	return e
}

func (e *htmlInput) List(v string) HTMLInput {
	e.setAttr("list", v)
	return e
}

func (e *htmlInput) Max(v interface{}) HTMLInput {
	e.setAttr("max", v)
	return e
}

func (e *htmlInput) MaxLength(v int) HTMLInput {
	e.setAttr("maxlength", v)
	return e
}

func (e *htmlInput) Min(v interface{}) HTMLInput {
	e.setAttr("min", v)
	return e
}

func (e *htmlInput) Multiple(v bool) HTMLInput {
	e.setAttr("multiple", v)
	return e
}

func (e *htmlInput) Name(v string) HTMLInput {
	e.setAttr("name", v)
	return e
}

func (e *htmlInput) Pattern(v string) HTMLInput {
	e.setAttr("pattern", v)
	return e
}

func (e *htmlInput) Placeholder(v string) HTMLInput {
	e.setAttr("placeholder", v)
	return e
}

func (e *htmlInput) ReadOnly(v bool) HTMLInput {
	e.setAttr("readonly", v)
	return e
}

func (e *htmlInput) Required(v bool) HTMLInput {
	e.setAttr("required", v)
	return e
}

func (e *htmlInput) Role(v string) HTMLInput {
	e.setAttr("role", v)
	return e
}

func (e *htmlInput) Size(v int) HTMLInput {
	e.setAttr("size", v)
	return e
}

func (e *htmlInput) Spellcheck(v bool) HTMLInput {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlInput) Src(v string) HTMLInput {
	e.setAttr("src", v)
	return e
}

func (e *htmlInput) Step(v float64) HTMLInput {
	e.setAttr("step", v)
	return e
}

func (e *htmlInput) Style(k, v string) HTMLInput {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlInput) Styles(s map[string]string) HTMLInput {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlInput) TabIndex(v int) HTMLInput {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlInput) Title(v string) HTMLInput {
	e.setAttr("title", v)
	return e
}

func (e *htmlInput) Type(v string) HTMLInput {
	e.setAttr("type", v)
	return e
}

func (e *htmlInput) Value(v interface{}) HTMLInput {
	e.setAttr("value", v)
	return e
}

func (e *htmlInput) Width(v int) HTMLInput {
	e.setAttr("width", v)
	return e
}

func (e *htmlInput) OnBlur(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlInput) OnChange(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlInput) OnClick(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlInput) OnContextMenu(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlInput) OnCopy(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlInput) OnCut(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlInput) OnDblClick(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlInput) OnDrag(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlInput) OnDragEnd(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlInput) OnDragEnter(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlInput) OnDragLeave(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlInput) OnDragOver(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlInput) OnDragStart(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlInput) OnDrop(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlInput) OnFocus(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlInput) OnInput(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlInput) OnInvalid(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlInput) OnKeyDown(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlInput) OnKeyPress(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlInput) OnKeyup(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlInput) OnLoad(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlInput) OnMouseDown(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlInput) OnMouseMove(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlInput) OnMouseOut(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlInput) OnMouseOver(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlInput) OnMouseUp(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlInput) OnPaste(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlInput) OnReset(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlInput) OnScroll(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlInput) OnSearch(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlInput) OnSelect(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlInput) OnSubmit(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlInput) OnWheel(h EventHandler, scope ...interface{}) HTMLInput {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLIns is the interface that describes a <ins> HTML element.
type HTMLIns interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLIns

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLIns

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLIns

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLIns

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLIns

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLIns

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLIns

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLIns

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLIns

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLIns

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLIns

	// ID specifies a unique id for an element.
	ID(v string) HTMLIns

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLIns

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLIns

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLIns

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLIns

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLIns

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLIns

	// Title specifies extra information about an element.
	Title(v string) HTMLIns

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLIns

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLIns

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLIns

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLIns

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLIns

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLIns

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLIns

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLIns

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLIns

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLIns

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLIns

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLIns

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLIns

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLIns

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLIns

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLIns

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLIns

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLIns

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLIns

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLIns

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLIns

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLIns

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLIns

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLIns

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLIns

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLIns

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLIns

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLIns

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLIns

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLIns

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLIns

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLIns
}

// Ins returns an HTML element that defines a text that has been inserted into a document.
func Ins() HTMLIns {
	e := &htmlIns{
		elem: elem{
			tag:         "ins",
			selfClosing: false,
		},
	}

	return e
}

type htmlIns struct {
	elem
}

func (e *htmlIns) Body(elems ...UI) HTMLIns {
	e.setBody(elems...)
	return e
}

func (e *htmlIns) Text(v interface{}) HTMLIns {
	return e.Body(Text(v))
}

func (e *htmlIns) AccessKey(v string) HTMLIns {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlIns) Aria(k string, v interface{}) HTMLIns {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlIns) Attr(n string, v interface{}) HTMLIns {
	e.setAttr(n, v)
	return e
}

func (e *htmlIns) Class(v ...string) HTMLIns {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlIns) ContentEditable(v bool) HTMLIns {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlIns) DataSet(k string, v interface{}) HTMLIns {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlIns) Dir(v string) HTMLIns {
	e.setAttr("dir", v)
	return e
}

func (e *htmlIns) Draggable(v bool) HTMLIns {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlIns) Hidden(v bool) HTMLIns {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlIns) ID(v string) HTMLIns {
	e.setAttr("id", v)
	return e
}

func (e *htmlIns) Lang(v string) HTMLIns {
	e.setAttr("lang", v)
	return e
}

func (e *htmlIns) Role(v string) HTMLIns {
	e.setAttr("role", v)
	return e
}

func (e *htmlIns) Spellcheck(v bool) HTMLIns {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlIns) Style(k, v string) HTMLIns {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlIns) Styles(s map[string]string) HTMLIns {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlIns) TabIndex(v int) HTMLIns {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlIns) Title(v string) HTMLIns {
	e.setAttr("title", v)
	return e
}

func (e *htmlIns) OnBlur(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlIns) OnChange(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlIns) OnClick(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlIns) OnContextMenu(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlIns) OnCopy(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlIns) OnCut(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlIns) OnDblClick(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlIns) OnDrag(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlIns) OnDragEnd(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlIns) OnDragEnter(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlIns) OnDragLeave(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlIns) OnDragOver(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlIns) OnDragStart(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlIns) OnDrop(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlIns) OnFocus(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlIns) OnInput(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlIns) OnInvalid(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlIns) OnKeyDown(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlIns) OnKeyPress(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlIns) OnKeyup(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlIns) OnMouseDown(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlIns) OnMouseMove(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlIns) OnMouseOut(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlIns) OnMouseOver(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlIns) OnMouseUp(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlIns) OnPaste(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlIns) OnReset(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlIns) OnScroll(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlIns) OnSearch(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlIns) OnSelect(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlIns) OnSubmit(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlIns) OnWheel(h EventHandler, scope ...interface{}) HTMLIns {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLKbd is the interface that describes a <kbd> HTML element.
type HTMLKbd interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLKbd

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLKbd

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLKbd

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLKbd

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLKbd

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLKbd

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLKbd

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLKbd

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLKbd

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLKbd

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLKbd

	// ID specifies a unique id for an element.
	ID(v string) HTMLKbd

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLKbd

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLKbd

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLKbd

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLKbd

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLKbd

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLKbd

	// Title specifies extra information about an element.
	Title(v string) HTMLKbd

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLKbd

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLKbd

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLKbd

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLKbd

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLKbd

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLKbd

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLKbd

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLKbd

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLKbd

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLKbd

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLKbd

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLKbd

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLKbd

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLKbd

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLKbd

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLKbd

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLKbd

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLKbd

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLKbd

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLKbd

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLKbd

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLKbd

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLKbd

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLKbd

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLKbd
}

// Kbd returns an HTML element that defines keyboard input.
func Kbd() HTMLKbd {
	e := &htmlKbd{
		elem: elem{
			tag:         "kbd",
			selfClosing: false,
		},
	}

	return e
}

type htmlKbd struct {
	elem
}

func (e *htmlKbd) Body(elems ...UI) HTMLKbd {
	e.setBody(elems...)
	return e
}

func (e *htmlKbd) Text(v interface{}) HTMLKbd {
	return e.Body(Text(v))
}

func (e *htmlKbd) AccessKey(v string) HTMLKbd {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlKbd) Aria(k string, v interface{}) HTMLKbd {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlKbd) Attr(n string, v interface{}) HTMLKbd {
	e.setAttr(n, v)
	return e
}

func (e *htmlKbd) Class(v ...string) HTMLKbd {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlKbd) ContentEditable(v bool) HTMLKbd {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlKbd) DataSet(k string, v interface{}) HTMLKbd {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlKbd) Dir(v string) HTMLKbd {
	e.setAttr("dir", v)
	return e
}

func (e *htmlKbd) Draggable(v bool) HTMLKbd {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlKbd) Hidden(v bool) HTMLKbd {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlKbd) ID(v string) HTMLKbd {
	e.setAttr("id", v)
	return e
}

func (e *htmlKbd) Lang(v string) HTMLKbd {
	e.setAttr("lang", v)
	return e
}

func (e *htmlKbd) Role(v string) HTMLKbd {
	e.setAttr("role", v)
	return e
}

func (e *htmlKbd) Spellcheck(v bool) HTMLKbd {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlKbd) Style(k, v string) HTMLKbd {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlKbd) Styles(s map[string]string) HTMLKbd {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlKbd) TabIndex(v int) HTMLKbd {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlKbd) Title(v string) HTMLKbd {
	e.setAttr("title", v)
	return e
}

func (e *htmlKbd) OnBlur(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlKbd) OnChange(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlKbd) OnClick(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlKbd) OnContextMenu(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlKbd) OnCopy(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlKbd) OnCut(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlKbd) OnDblClick(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlKbd) OnDrag(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlKbd) OnDragEnd(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlKbd) OnDragEnter(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlKbd) OnDragLeave(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlKbd) OnDragOver(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlKbd) OnDragStart(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlKbd) OnDrop(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlKbd) OnFocus(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlKbd) OnInput(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlKbd) OnInvalid(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlKbd) OnKeyDown(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlKbd) OnKeyPress(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlKbd) OnKeyup(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlKbd) OnMouseDown(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlKbd) OnMouseMove(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlKbd) OnMouseOut(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlKbd) OnMouseOver(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlKbd) OnMouseUp(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlKbd) OnPaste(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlKbd) OnReset(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlKbd) OnScroll(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlKbd) OnSearch(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlKbd) OnSelect(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlKbd) OnSubmit(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlKbd) OnWheel(h EventHandler, scope ...interface{}) HTMLKbd {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLLabel is the interface that describes a <label> HTML element.
type HTMLLabel interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLLabel

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLLabel

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLLabel

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLLabel

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLLabel

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLLabel

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLLabel

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLLabel

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLLabel

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLLabel

	// For specifies which form element(s) a label/calculation is bound to.
	For(v string) HTMLLabel

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLLabel

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLLabel

	// ID specifies a unique id for an element.
	ID(v string) HTMLLabel

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLLabel

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLLabel

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLLabel

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLLabel

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLLabel

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLLabel

	// Title specifies extra information about an element.
	Title(v string) HTMLLabel

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLLabel

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLLabel

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLLabel

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLLabel

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLLabel

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLLabel

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLLabel

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLLabel

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLLabel

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLLabel

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLLabel

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLLabel

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLLabel

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLLabel

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLLabel

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLLabel

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLLabel

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLLabel

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLLabel

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLLabel

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLLabel

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLLabel

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLLabel

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLLabel

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLLabel
}

// Label returns an HTML element that defines a label for an input element.
func Label() HTMLLabel {
	e := &htmlLabel{
		elem: elem{
			tag:         "label",
			selfClosing: false,
		},
	}

	return e
}

type htmlLabel struct {
	elem
}

func (e *htmlLabel) Body(elems ...UI) HTMLLabel {
	e.setBody(elems...)
	return e
}

func (e *htmlLabel) Text(v interface{}) HTMLLabel {
	return e.Body(Text(v))
}

func (e *htmlLabel) AccessKey(v string) HTMLLabel {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlLabel) Aria(k string, v interface{}) HTMLLabel {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLabel) Attr(n string, v interface{}) HTMLLabel {
	e.setAttr(n, v)
	return e
}

func (e *htmlLabel) Class(v ...string) HTMLLabel {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlLabel) ContentEditable(v bool) HTMLLabel {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlLabel) DataSet(k string, v interface{}) HTMLLabel {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLabel) Dir(v string) HTMLLabel {
	e.setAttr("dir", v)
	return e
}

func (e *htmlLabel) Draggable(v bool) HTMLLabel {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlLabel) For(v string) HTMLLabel {
	e.setAttr("for", v)
	return e
}

func (e *htmlLabel) Form(v string) HTMLLabel {
	e.setAttr("form", v)
	return e
}

func (e *htmlLabel) Hidden(v bool) HTMLLabel {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlLabel) ID(v string) HTMLLabel {
	e.setAttr("id", v)
	return e
}

func (e *htmlLabel) Lang(v string) HTMLLabel {
	e.setAttr("lang", v)
	return e
}

func (e *htmlLabel) Role(v string) HTMLLabel {
	e.setAttr("role", v)
	return e
}

func (e *htmlLabel) Spellcheck(v bool) HTMLLabel {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlLabel) Style(k, v string) HTMLLabel {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlLabel) Styles(s map[string]string) HTMLLabel {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlLabel) TabIndex(v int) HTMLLabel {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlLabel) Title(v string) HTMLLabel {
	e.setAttr("title", v)
	return e
}

func (e *htmlLabel) OnBlur(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlLabel) OnChange(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlLabel) OnClick(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlLabel) OnContextMenu(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlLabel) OnCopy(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlLabel) OnCut(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlLabel) OnDblClick(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlLabel) OnDrag(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlLabel) OnDragEnd(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlLabel) OnDragEnter(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlLabel) OnDragLeave(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlLabel) OnDragOver(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlLabel) OnDragStart(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlLabel) OnDrop(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlLabel) OnFocus(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlLabel) OnInput(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlLabel) OnInvalid(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlLabel) OnKeyDown(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlLabel) OnKeyPress(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlLabel) OnKeyup(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlLabel) OnMouseDown(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlLabel) OnMouseMove(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlLabel) OnMouseOut(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlLabel) OnMouseOver(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlLabel) OnMouseUp(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlLabel) OnPaste(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlLabel) OnReset(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlLabel) OnScroll(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlLabel) OnSearch(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlLabel) OnSelect(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlLabel) OnSubmit(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlLabel) OnWheel(h EventHandler, scope ...interface{}) HTMLLabel {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLLegend is the interface that describes a <legend> HTML element.
type HTMLLegend interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLLegend

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLLegend

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLLegend

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLLegend

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLLegend

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLLegend

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLLegend

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLLegend

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLLegend

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLLegend

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLLegend

	// ID specifies a unique id for an element.
	ID(v string) HTMLLegend

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLLegend

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLLegend

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLLegend

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLLegend

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLLegend

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLLegend

	// Title specifies extra information about an element.
	Title(v string) HTMLLegend

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLLegend

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLLegend

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLLegend

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLLegend

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLLegend

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLLegend

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLLegend

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLLegend

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLLegend

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLLegend

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLLegend

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLLegend

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLLegend

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLLegend

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLLegend

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLLegend

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLLegend

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLLegend

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLLegend

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLLegend

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLLegend

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLLegend

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLLegend

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLLegend

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLLegend
}

// Legend returns an HTML element that defines a caption for a fieldset element.
func Legend() HTMLLegend {
	e := &htmlLegend{
		elem: elem{
			tag:         "legend",
			selfClosing: false,
		},
	}

	return e
}

type htmlLegend struct {
	elem
}

func (e *htmlLegend) Body(elems ...UI) HTMLLegend {
	e.setBody(elems...)
	return e
}

func (e *htmlLegend) Text(v interface{}) HTMLLegend {
	return e.Body(Text(v))
}

func (e *htmlLegend) AccessKey(v string) HTMLLegend {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlLegend) Aria(k string, v interface{}) HTMLLegend {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLegend) Attr(n string, v interface{}) HTMLLegend {
	e.setAttr(n, v)
	return e
}

func (e *htmlLegend) Class(v ...string) HTMLLegend {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlLegend) ContentEditable(v bool) HTMLLegend {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlLegend) DataSet(k string, v interface{}) HTMLLegend {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLegend) Dir(v string) HTMLLegend {
	e.setAttr("dir", v)
	return e
}

func (e *htmlLegend) Draggable(v bool) HTMLLegend {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlLegend) Hidden(v bool) HTMLLegend {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlLegend) ID(v string) HTMLLegend {
	e.setAttr("id", v)
	return e
}

func (e *htmlLegend) Lang(v string) HTMLLegend {
	e.setAttr("lang", v)
	return e
}

func (e *htmlLegend) Role(v string) HTMLLegend {
	e.setAttr("role", v)
	return e
}

func (e *htmlLegend) Spellcheck(v bool) HTMLLegend {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlLegend) Style(k, v string) HTMLLegend {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlLegend) Styles(s map[string]string) HTMLLegend {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlLegend) TabIndex(v int) HTMLLegend {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlLegend) Title(v string) HTMLLegend {
	e.setAttr("title", v)
	return e
}

func (e *htmlLegend) OnBlur(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlLegend) OnChange(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlLegend) OnClick(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlLegend) OnContextMenu(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlLegend) OnCopy(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlLegend) OnCut(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlLegend) OnDblClick(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlLegend) OnDrag(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlLegend) OnDragEnd(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlLegend) OnDragEnter(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlLegend) OnDragLeave(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlLegend) OnDragOver(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlLegend) OnDragStart(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlLegend) OnDrop(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlLegend) OnFocus(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlLegend) OnInput(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlLegend) OnInvalid(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlLegend) OnKeyDown(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlLegend) OnKeyPress(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlLegend) OnKeyup(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlLegend) OnMouseDown(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlLegend) OnMouseMove(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlLegend) OnMouseOut(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlLegend) OnMouseOver(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlLegend) OnMouseUp(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlLegend) OnPaste(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlLegend) OnReset(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlLegend) OnScroll(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlLegend) OnSearch(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlLegend) OnSelect(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlLegend) OnSubmit(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlLegend) OnWheel(h EventHandler, scope ...interface{}) HTMLLegend {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLLi is the interface that describes a <li> HTML element.
type HTMLLi interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLLi

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLLi

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLLi

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLLi

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLLi

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLLi

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLLi

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLLi

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLLi

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLLi

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLLi

	// ID specifies a unique id for an element.
	ID(v string) HTMLLi

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLLi

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLLi

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLLi

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLLi

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLLi

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLLi

	// Title specifies extra information about an element.
	Title(v string) HTMLLi

	// Value specifies the value of the element.
	Value(v interface{}) HTMLLi

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLLi

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLLi

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLLi

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLLi

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLLi

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLLi

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLLi

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLLi

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLLi

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLLi

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLLi

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLLi

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLLi

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLLi

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLLi

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLLi

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLLi

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLLi

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLLi

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLLi

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLLi

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLLi

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLLi

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLLi

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLLi

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLLi

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLLi

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLLi

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLLi

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLLi

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLLi

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLLi
}

// Li returns an HTML element that defines a list item.
func Li() HTMLLi {
	e := &htmlLi{
		elem: elem{
			tag:         "li",
			selfClosing: false,
		},
	}

	return e
}

type htmlLi struct {
	elem
}

func (e *htmlLi) Body(elems ...UI) HTMLLi {
	e.setBody(elems...)
	return e
}

func (e *htmlLi) Text(v interface{}) HTMLLi {
	return e.Body(Text(v))
}

func (e *htmlLi) AccessKey(v string) HTMLLi {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlLi) Aria(k string, v interface{}) HTMLLi {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLi) Attr(n string, v interface{}) HTMLLi {
	e.setAttr(n, v)
	return e
}

func (e *htmlLi) Class(v ...string) HTMLLi {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlLi) ContentEditable(v bool) HTMLLi {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlLi) DataSet(k string, v interface{}) HTMLLi {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLi) Dir(v string) HTMLLi {
	e.setAttr("dir", v)
	return e
}

func (e *htmlLi) Draggable(v bool) HTMLLi {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlLi) Hidden(v bool) HTMLLi {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlLi) ID(v string) HTMLLi {
	e.setAttr("id", v)
	return e
}

func (e *htmlLi) Lang(v string) HTMLLi {
	e.setAttr("lang", v)
	return e
}

func (e *htmlLi) Role(v string) HTMLLi {
	e.setAttr("role", v)
	return e
}

func (e *htmlLi) Spellcheck(v bool) HTMLLi {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlLi) Style(k, v string) HTMLLi {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlLi) Styles(s map[string]string) HTMLLi {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlLi) TabIndex(v int) HTMLLi {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlLi) Title(v string) HTMLLi {
	e.setAttr("title", v)
	return e
}

func (e *htmlLi) Value(v interface{}) HTMLLi {
	e.setAttr("value", v)
	return e
}

func (e *htmlLi) OnBlur(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlLi) OnChange(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlLi) OnClick(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlLi) OnContextMenu(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlLi) OnCopy(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlLi) OnCut(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlLi) OnDblClick(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlLi) OnDrag(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlLi) OnDragEnd(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlLi) OnDragEnter(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlLi) OnDragLeave(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlLi) OnDragOver(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlLi) OnDragStart(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlLi) OnDrop(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlLi) OnFocus(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlLi) OnInput(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlLi) OnInvalid(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlLi) OnKeyDown(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlLi) OnKeyPress(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlLi) OnKeyup(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlLi) OnMouseDown(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlLi) OnMouseMove(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlLi) OnMouseOut(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlLi) OnMouseOver(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlLi) OnMouseUp(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlLi) OnPaste(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlLi) OnReset(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlLi) OnScroll(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlLi) OnSearch(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlLi) OnSelect(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlLi) OnSubmit(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlLi) OnWheel(h EventHandler, scope ...interface{}) HTMLLi {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLLink is the interface that describes a <link> HTML element.
type HTMLLink interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLLink

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLLink

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLLink

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLLink

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLLink

	// CrossOrigin sets the mode of the request to an HTTP CORS Request.
	CrossOrigin(v string) HTMLLink

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLLink

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLLink

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLLink

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLLink

	// Href specifies the URL of the page the link goes to.
	Href(v string) HTMLLink

	// HrefLang specifies the language of the linked document.
	HrefLang(v string) HTMLLink

	// ID specifies a unique id for an element.
	ID(v string) HTMLLink

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLLink

	// Media specifies what media/device the linked document is optimized for.
	Media(v string) HTMLLink

	// Rel specifies the relationship between the current document and the linked document.
	Rel(v string) HTMLLink

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLLink

	// Sizes specifies the size of the linked resource.
	Sizes(v string) HTMLLink

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLLink

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLLink

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLLink

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLLink

	// Title specifies extra information about an element.
	Title(v string) HTMLLink

	// Type specifies the type of element.
	Type(v string) HTMLLink

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLLink

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLLink

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLLink

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLLink

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLLink

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLLink

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLLink

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLLink

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLLink

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLLink

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLLink

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLLink

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLLink

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLLink

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLLink

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLLink

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLLink

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLLink

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLLink

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLLink

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLLink

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLLink

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLLink

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLLink

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLLink

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLLink

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLLink

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLLink

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLLink

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLLink

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLLink

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLLink

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLLink
}

// Link returns an HTML element that defines the relationship between a document and an external resource (most used to link to style sheets).
func Link() HTMLLink {
	e := &htmlLink{
		elem: elem{
			tag:         "link",
			selfClosing: true,
		},
	}

	return e
}

type htmlLink struct {
	elem
}

func (e *htmlLink) AccessKey(v string) HTMLLink {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlLink) Aria(k string, v interface{}) HTMLLink {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLink) Attr(n string, v interface{}) HTMLLink {
	e.setAttr(n, v)
	return e
}

func (e *htmlLink) Class(v ...string) HTMLLink {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlLink) ContentEditable(v bool) HTMLLink {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlLink) CrossOrigin(v string) HTMLLink {
	e.setAttr("crossorigin", v)
	return e
}

func (e *htmlLink) DataSet(k string, v interface{}) HTMLLink {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlLink) Dir(v string) HTMLLink {
	e.setAttr("dir", v)
	return e
}

func (e *htmlLink) Draggable(v bool) HTMLLink {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlLink) Hidden(v bool) HTMLLink {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlLink) Href(v string) HTMLLink {
	e.setAttr("href", v)
	return e
}

func (e *htmlLink) HrefLang(v string) HTMLLink {
	e.setAttr("hreflang", v)
	return e
}

func (e *htmlLink) ID(v string) HTMLLink {
	e.setAttr("id", v)
	return e
}

func (e *htmlLink) Lang(v string) HTMLLink {
	e.setAttr("lang", v)
	return e
}

func (e *htmlLink) Media(v string) HTMLLink {
	e.setAttr("media", v)
	return e
}

func (e *htmlLink) Rel(v string) HTMLLink {
	e.setAttr("rel", v)
	return e
}

func (e *htmlLink) Role(v string) HTMLLink {
	e.setAttr("role", v)
	return e
}

func (e *htmlLink) Sizes(v string) HTMLLink {
	e.setAttr("sizes", v)
	return e
}

func (e *htmlLink) Spellcheck(v bool) HTMLLink {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlLink) Style(k, v string) HTMLLink {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlLink) Styles(s map[string]string) HTMLLink {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlLink) TabIndex(v int) HTMLLink {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlLink) Title(v string) HTMLLink {
	e.setAttr("title", v)
	return e
}

func (e *htmlLink) Type(v string) HTMLLink {
	e.setAttr("type", v)
	return e
}

func (e *htmlLink) OnBlur(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlLink) OnChange(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlLink) OnClick(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlLink) OnContextMenu(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlLink) OnCopy(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlLink) OnCut(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlLink) OnDblClick(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlLink) OnDrag(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlLink) OnDragEnd(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlLink) OnDragEnter(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlLink) OnDragLeave(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlLink) OnDragOver(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlLink) OnDragStart(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlLink) OnDrop(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlLink) OnFocus(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlLink) OnInput(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlLink) OnInvalid(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlLink) OnKeyDown(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlLink) OnKeyPress(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlLink) OnKeyup(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlLink) OnLoad(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlLink) OnMouseDown(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlLink) OnMouseMove(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlLink) OnMouseOut(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlLink) OnMouseOver(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlLink) OnMouseUp(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlLink) OnPaste(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlLink) OnReset(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlLink) OnScroll(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlLink) OnSearch(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlLink) OnSelect(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlLink) OnSubmit(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlLink) OnWheel(h EventHandler, scope ...interface{}) HTMLLink {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLMain is the interface that describes a <main> HTML element.
type HTMLMain interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLMain

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLMain

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLMain

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLMain

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLMain

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLMain

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLMain

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLMain

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLMain

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLMain

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLMain

	// ID specifies a unique id for an element.
	ID(v string) HTMLMain

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLMain

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLMain

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLMain

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLMain

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLMain

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLMain

	// Title specifies extra information about an element.
	Title(v string) HTMLMain

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLMain

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLMain

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLMain

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLMain

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLMain

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLMain

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLMain

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLMain

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLMain

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLMain

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLMain

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLMain

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLMain

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLMain

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLMain

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLMain

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLMain

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLMain

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLMain

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLMain

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLMain

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLMain

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLMain

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLMain

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLMain

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLMain

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLMain

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLMain

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLMain

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLMain

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLMain

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLMain
}

// Main returns an HTML element that specifies the main content of a document.
func Main() HTMLMain {
	e := &htmlMain{
		elem: elem{
			tag:         "main",
			selfClosing: false,
		},
	}

	return e
}

type htmlMain struct {
	elem
}

func (e *htmlMain) Body(elems ...UI) HTMLMain {
	e.setBody(elems...)
	return e
}

func (e *htmlMain) Text(v interface{}) HTMLMain {
	return e.Body(Text(v))
}

func (e *htmlMain) AccessKey(v string) HTMLMain {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlMain) Aria(k string, v interface{}) HTMLMain {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMain) Attr(n string, v interface{}) HTMLMain {
	e.setAttr(n, v)
	return e
}

func (e *htmlMain) Class(v ...string) HTMLMain {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlMain) ContentEditable(v bool) HTMLMain {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlMain) DataSet(k string, v interface{}) HTMLMain {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMain) Dir(v string) HTMLMain {
	e.setAttr("dir", v)
	return e
}

func (e *htmlMain) Draggable(v bool) HTMLMain {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlMain) Hidden(v bool) HTMLMain {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlMain) ID(v string) HTMLMain {
	e.setAttr("id", v)
	return e
}

func (e *htmlMain) Lang(v string) HTMLMain {
	e.setAttr("lang", v)
	return e
}

func (e *htmlMain) Role(v string) HTMLMain {
	e.setAttr("role", v)
	return e
}

func (e *htmlMain) Spellcheck(v bool) HTMLMain {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlMain) Style(k, v string) HTMLMain {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlMain) Styles(s map[string]string) HTMLMain {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlMain) TabIndex(v int) HTMLMain {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlMain) Title(v string) HTMLMain {
	e.setAttr("title", v)
	return e
}

func (e *htmlMain) OnBlur(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlMain) OnChange(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlMain) OnClick(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlMain) OnContextMenu(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlMain) OnCopy(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlMain) OnCut(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlMain) OnDblClick(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlMain) OnDrag(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlMain) OnDragEnd(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlMain) OnDragEnter(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlMain) OnDragLeave(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlMain) OnDragOver(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlMain) OnDragStart(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlMain) OnDrop(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlMain) OnFocus(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlMain) OnInput(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlMain) OnInvalid(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlMain) OnKeyDown(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlMain) OnKeyPress(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlMain) OnKeyup(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlMain) OnMouseDown(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlMain) OnMouseMove(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlMain) OnMouseOut(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlMain) OnMouseOver(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlMain) OnMouseUp(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlMain) OnPaste(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlMain) OnReset(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlMain) OnScroll(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlMain) OnSearch(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlMain) OnSelect(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlMain) OnSubmit(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlMain) OnWheel(h EventHandler, scope ...interface{}) HTMLMain {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLMap is the interface that describes a <map> HTML element.
type HTMLMap interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLMap

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLMap

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLMap

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLMap

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLMap

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLMap

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLMap

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLMap

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLMap

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLMap

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLMap

	// ID specifies a unique id for an element.
	ID(v string) HTMLMap

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLMap

	// Name specifies the name of the element.
	Name(v string) HTMLMap

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLMap

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLMap

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLMap

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLMap

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLMap

	// Title specifies extra information about an element.
	Title(v string) HTMLMap

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLMap

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLMap

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLMap

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLMap

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLMap

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLMap

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLMap

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLMap

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLMap

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLMap

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLMap

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLMap

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLMap

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLMap

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLMap

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLMap

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLMap

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLMap

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLMap

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLMap

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLMap

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLMap

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLMap

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLMap

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLMap

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLMap

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLMap

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLMap

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLMap

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLMap

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLMap

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLMap
}

// Map returns an HTML element that defines a client-side image-map.
func Map() HTMLMap {
	e := &htmlMap{
		elem: elem{
			tag:         "map",
			selfClosing: false,
		},
	}

	return e
}

type htmlMap struct {
	elem
}

func (e *htmlMap) Body(elems ...UI) HTMLMap {
	e.setBody(elems...)
	return e
}

func (e *htmlMap) Text(v interface{}) HTMLMap {
	return e.Body(Text(v))
}

func (e *htmlMap) AccessKey(v string) HTMLMap {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlMap) Aria(k string, v interface{}) HTMLMap {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMap) Attr(n string, v interface{}) HTMLMap {
	e.setAttr(n, v)
	return e
}

func (e *htmlMap) Class(v ...string) HTMLMap {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlMap) ContentEditable(v bool) HTMLMap {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlMap) DataSet(k string, v interface{}) HTMLMap {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMap) Dir(v string) HTMLMap {
	e.setAttr("dir", v)
	return e
}

func (e *htmlMap) Draggable(v bool) HTMLMap {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlMap) Hidden(v bool) HTMLMap {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlMap) ID(v string) HTMLMap {
	e.setAttr("id", v)
	return e
}

func (e *htmlMap) Lang(v string) HTMLMap {
	e.setAttr("lang", v)
	return e
}

func (e *htmlMap) Name(v string) HTMLMap {
	e.setAttr("name", v)
	return e
}

func (e *htmlMap) Role(v string) HTMLMap {
	e.setAttr("role", v)
	return e
}

func (e *htmlMap) Spellcheck(v bool) HTMLMap {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlMap) Style(k, v string) HTMLMap {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlMap) Styles(s map[string]string) HTMLMap {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlMap) TabIndex(v int) HTMLMap {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlMap) Title(v string) HTMLMap {
	e.setAttr("title", v)
	return e
}

func (e *htmlMap) OnBlur(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlMap) OnChange(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlMap) OnClick(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlMap) OnContextMenu(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlMap) OnCopy(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlMap) OnCut(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlMap) OnDblClick(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlMap) OnDrag(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlMap) OnDragEnd(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlMap) OnDragEnter(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlMap) OnDragLeave(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlMap) OnDragOver(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlMap) OnDragStart(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlMap) OnDrop(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlMap) OnFocus(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlMap) OnInput(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlMap) OnInvalid(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlMap) OnKeyDown(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlMap) OnKeyPress(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlMap) OnKeyup(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlMap) OnMouseDown(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlMap) OnMouseMove(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlMap) OnMouseOut(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlMap) OnMouseOver(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlMap) OnMouseUp(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlMap) OnPaste(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlMap) OnReset(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlMap) OnScroll(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlMap) OnSearch(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlMap) OnSelect(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlMap) OnSubmit(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlMap) OnWheel(h EventHandler, scope ...interface{}) HTMLMap {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLMark is the interface that describes a <mark> HTML element.
type HTMLMark interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLMark

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLMark

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLMark

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLMark

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLMark

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLMark

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLMark

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLMark

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLMark

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLMark

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLMark

	// ID specifies a unique id for an element.
	ID(v string) HTMLMark

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLMark

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLMark

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLMark

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLMark

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLMark

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLMark

	// Title specifies extra information about an element.
	Title(v string) HTMLMark

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLMark

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLMark

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLMark

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLMark

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLMark

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLMark

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLMark

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLMark

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLMark

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLMark

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLMark

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLMark

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLMark

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLMark

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLMark

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLMark

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLMark

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLMark

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLMark

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLMark

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLMark

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLMark

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLMark

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLMark

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLMark

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLMark

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLMark

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLMark

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLMark

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLMark

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLMark

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLMark
}

// Mark returns an HTML element that defines marked/highlighted text.
func Mark() HTMLMark {
	e := &htmlMark{
		elem: elem{
			tag:         "mark",
			selfClosing: false,
		},
	}

	return e
}

type htmlMark struct {
	elem
}

func (e *htmlMark) Body(elems ...UI) HTMLMark {
	e.setBody(elems...)
	return e
}

func (e *htmlMark) Text(v interface{}) HTMLMark {
	return e.Body(Text(v))
}

func (e *htmlMark) AccessKey(v string) HTMLMark {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlMark) Aria(k string, v interface{}) HTMLMark {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMark) Attr(n string, v interface{}) HTMLMark {
	e.setAttr(n, v)
	return e
}

func (e *htmlMark) Class(v ...string) HTMLMark {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlMark) ContentEditable(v bool) HTMLMark {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlMark) DataSet(k string, v interface{}) HTMLMark {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMark) Dir(v string) HTMLMark {
	e.setAttr("dir", v)
	return e
}

func (e *htmlMark) Draggable(v bool) HTMLMark {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlMark) Hidden(v bool) HTMLMark {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlMark) ID(v string) HTMLMark {
	e.setAttr("id", v)
	return e
}

func (e *htmlMark) Lang(v string) HTMLMark {
	e.setAttr("lang", v)
	return e
}

func (e *htmlMark) Role(v string) HTMLMark {
	e.setAttr("role", v)
	return e
}

func (e *htmlMark) Spellcheck(v bool) HTMLMark {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlMark) Style(k, v string) HTMLMark {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlMark) Styles(s map[string]string) HTMLMark {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlMark) TabIndex(v int) HTMLMark {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlMark) Title(v string) HTMLMark {
	e.setAttr("title", v)
	return e
}

func (e *htmlMark) OnBlur(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlMark) OnChange(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlMark) OnClick(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlMark) OnContextMenu(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlMark) OnCopy(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlMark) OnCut(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlMark) OnDblClick(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlMark) OnDrag(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlMark) OnDragEnd(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlMark) OnDragEnter(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlMark) OnDragLeave(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlMark) OnDragOver(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlMark) OnDragStart(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlMark) OnDrop(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlMark) OnFocus(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlMark) OnInput(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlMark) OnInvalid(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlMark) OnKeyDown(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlMark) OnKeyPress(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlMark) OnKeyup(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlMark) OnMouseDown(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlMark) OnMouseMove(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlMark) OnMouseOut(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlMark) OnMouseOver(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlMark) OnMouseUp(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlMark) OnPaste(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlMark) OnReset(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlMark) OnScroll(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlMark) OnSearch(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlMark) OnSelect(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlMark) OnSubmit(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlMark) OnWheel(h EventHandler, scope ...interface{}) HTMLMark {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLMeta is the interface that describes a <meta> HTML element.
type HTMLMeta interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLMeta

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLMeta

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLMeta

	// Charset specifies the character encoding.
	Charset(v string) HTMLMeta

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLMeta

	// Content gives the value associated with the http-equiv or name attribute.
	Content(v string) HTMLMeta

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLMeta

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLMeta

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLMeta

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLMeta

	// HTTPEquiv provides an HTTP header for the information/value of the content attribute.
	HTTPEquiv(v string) HTMLMeta

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLMeta

	// ID specifies a unique id for an element.
	ID(v string) HTMLMeta

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLMeta

	// Name specifies the name of the element.
	Name(v string) HTMLMeta

	// Property specifies the property name.
	Property(v string) HTMLMeta

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLMeta

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLMeta

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLMeta

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLMeta

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLMeta

	// Title specifies extra information about an element.
	Title(v string) HTMLMeta
}

// Meta returns an HTML element that .
func Meta() HTMLMeta {
	e := &htmlMeta{
		elem: elem{
			tag:         "meta",
			selfClosing: true,
		},
	}

	return e
}

type htmlMeta struct {
	elem
}

func (e *htmlMeta) AccessKey(v string) HTMLMeta {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlMeta) Aria(k string, v interface{}) HTMLMeta {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMeta) Attr(n string, v interface{}) HTMLMeta {
	e.setAttr(n, v)
	return e
}

func (e *htmlMeta) Charset(v string) HTMLMeta {
	e.setAttr("charset", v)
	return e
}

func (e *htmlMeta) Class(v ...string) HTMLMeta {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlMeta) Content(v string) HTMLMeta {
	e.setAttr("content", v)
	return e
}

func (e *htmlMeta) ContentEditable(v bool) HTMLMeta {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlMeta) DataSet(k string, v interface{}) HTMLMeta {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMeta) Dir(v string) HTMLMeta {
	e.setAttr("dir", v)
	return e
}

func (e *htmlMeta) Draggable(v bool) HTMLMeta {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlMeta) HTTPEquiv(v string) HTMLMeta {
	e.setAttr("httpequiv", v)
	return e
}

func (e *htmlMeta) Hidden(v bool) HTMLMeta {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlMeta) ID(v string) HTMLMeta {
	e.setAttr("id", v)
	return e
}

func (e *htmlMeta) Lang(v string) HTMLMeta {
	e.setAttr("lang", v)
	return e
}

func (e *htmlMeta) Name(v string) HTMLMeta {
	e.setAttr("name", v)
	return e
}

func (e *htmlMeta) Property(v string) HTMLMeta {
	e.setAttr("property", v)
	return e
}

func (e *htmlMeta) Role(v string) HTMLMeta {
	e.setAttr("role", v)
	return e
}

func (e *htmlMeta) Spellcheck(v bool) HTMLMeta {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlMeta) Style(k, v string) HTMLMeta {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlMeta) Styles(s map[string]string) HTMLMeta {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlMeta) TabIndex(v int) HTMLMeta {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlMeta) Title(v string) HTMLMeta {
	e.setAttr("title", v)
	return e
}

// HTMLMeter is the interface that describes a <meter> HTML element.
type HTMLMeter interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLMeter

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLMeter

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLMeter

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLMeter

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLMeter

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLMeter

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLMeter

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLMeter

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLMeter

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLMeter

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLMeter

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLMeter

	// High specifies the range that is considered to be a high value.
	High(v float64) HTMLMeter

	// ID specifies a unique id for an element.
	ID(v string) HTMLMeter

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLMeter

	// Low specifies the range that is considered to be a low value.
	Low(v float64) HTMLMeter

	// Max Specifies the maximum value.
	Max(v interface{}) HTMLMeter

	// Min specifies a minimum value.
	Min(v interface{}) HTMLMeter

	// Optimum specifies what value is the optimal value for the gauge.
	Optimum(v float64) HTMLMeter

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLMeter

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLMeter

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLMeter

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLMeter

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLMeter

	// Title specifies extra information about an element.
	Title(v string) HTMLMeter

	// Value specifies the value of the element.
	Value(v interface{}) HTMLMeter

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLMeter

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLMeter

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLMeter

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLMeter

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLMeter

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLMeter

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLMeter

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLMeter

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLMeter

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLMeter

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLMeter

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLMeter

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLMeter

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLMeter

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLMeter

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLMeter

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLMeter

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLMeter

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLMeter

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLMeter

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLMeter

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLMeter

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLMeter

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLMeter

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLMeter
}

// Meter returns an HTML element that defines a scalar measurement within a known range (a gauge).
func Meter() HTMLMeter {
	e := &htmlMeter{
		elem: elem{
			tag:         "meter",
			selfClosing: false,
		},
	}

	return e
}

type htmlMeter struct {
	elem
}

func (e *htmlMeter) Body(elems ...UI) HTMLMeter {
	e.setBody(elems...)
	return e
}

func (e *htmlMeter) Text(v interface{}) HTMLMeter {
	return e.Body(Text(v))
}

func (e *htmlMeter) AccessKey(v string) HTMLMeter {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlMeter) Aria(k string, v interface{}) HTMLMeter {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMeter) Attr(n string, v interface{}) HTMLMeter {
	e.setAttr(n, v)
	return e
}

func (e *htmlMeter) Class(v ...string) HTMLMeter {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlMeter) ContentEditable(v bool) HTMLMeter {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlMeter) DataSet(k string, v interface{}) HTMLMeter {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlMeter) Dir(v string) HTMLMeter {
	e.setAttr("dir", v)
	return e
}

func (e *htmlMeter) Draggable(v bool) HTMLMeter {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlMeter) Form(v string) HTMLMeter {
	e.setAttr("form", v)
	return e
}

func (e *htmlMeter) Hidden(v bool) HTMLMeter {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlMeter) High(v float64) HTMLMeter {
	e.setAttr("high", v)
	return e
}

func (e *htmlMeter) ID(v string) HTMLMeter {
	e.setAttr("id", v)
	return e
}

func (e *htmlMeter) Lang(v string) HTMLMeter {
	e.setAttr("lang", v)
	return e
}

func (e *htmlMeter) Low(v float64) HTMLMeter {
	e.setAttr("low", v)
	return e
}

func (e *htmlMeter) Max(v interface{}) HTMLMeter {
	e.setAttr("max", v)
	return e
}

func (e *htmlMeter) Min(v interface{}) HTMLMeter {
	e.setAttr("min", v)
	return e
}

func (e *htmlMeter) Optimum(v float64) HTMLMeter {
	e.setAttr("optimum", v)
	return e
}

func (e *htmlMeter) Role(v string) HTMLMeter {
	e.setAttr("role", v)
	return e
}

func (e *htmlMeter) Spellcheck(v bool) HTMLMeter {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlMeter) Style(k, v string) HTMLMeter {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlMeter) Styles(s map[string]string) HTMLMeter {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlMeter) TabIndex(v int) HTMLMeter {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlMeter) Title(v string) HTMLMeter {
	e.setAttr("title", v)
	return e
}

func (e *htmlMeter) Value(v interface{}) HTMLMeter {
	e.setAttr("value", v)
	return e
}

func (e *htmlMeter) OnBlur(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlMeter) OnChange(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlMeter) OnClick(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlMeter) OnContextMenu(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlMeter) OnCopy(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlMeter) OnCut(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlMeter) OnDblClick(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlMeter) OnDrag(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlMeter) OnDragEnd(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlMeter) OnDragEnter(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlMeter) OnDragLeave(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlMeter) OnDragOver(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlMeter) OnDragStart(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlMeter) OnDrop(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlMeter) OnFocus(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlMeter) OnInput(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlMeter) OnInvalid(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlMeter) OnKeyDown(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlMeter) OnKeyPress(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlMeter) OnKeyup(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlMeter) OnMouseDown(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlMeter) OnMouseMove(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlMeter) OnMouseOut(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlMeter) OnMouseOver(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlMeter) OnMouseUp(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlMeter) OnPaste(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlMeter) OnReset(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlMeter) OnScroll(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlMeter) OnSearch(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlMeter) OnSelect(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlMeter) OnSubmit(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlMeter) OnWheel(h EventHandler, scope ...interface{}) HTMLMeter {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLNav is the interface that describes a <nav> HTML element.
type HTMLNav interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLNav

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLNav

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLNav

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLNav

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLNav

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLNav

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLNav

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLNav

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLNav

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLNav

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLNav

	// ID specifies a unique id for an element.
	ID(v string) HTMLNav

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLNav

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLNav

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLNav

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLNav

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLNav

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLNav

	// Title specifies extra information about an element.
	Title(v string) HTMLNav

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLNav

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLNav

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLNav

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLNav

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLNav

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLNav

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLNav

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLNav

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLNav

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLNav

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLNav

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLNav

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLNav

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLNav

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLNav

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLNav

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLNav

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLNav

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLNav

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLNav

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLNav

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLNav

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLNav

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLNav

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLNav

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLNav

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLNav

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLNav

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLNav

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLNav

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLNav

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLNav
}

// Nav returns an HTML element that defines navigation links.
func Nav() HTMLNav {
	e := &htmlNav{
		elem: elem{
			tag:         "nav",
			selfClosing: false,
		},
	}

	return e
}

type htmlNav struct {
	elem
}

func (e *htmlNav) Body(elems ...UI) HTMLNav {
	e.setBody(elems...)
	return e
}

func (e *htmlNav) Text(v interface{}) HTMLNav {
	return e.Body(Text(v))
}

func (e *htmlNav) AccessKey(v string) HTMLNav {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlNav) Aria(k string, v interface{}) HTMLNav {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlNav) Attr(n string, v interface{}) HTMLNav {
	e.setAttr(n, v)
	return e
}

func (e *htmlNav) Class(v ...string) HTMLNav {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlNav) ContentEditable(v bool) HTMLNav {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlNav) DataSet(k string, v interface{}) HTMLNav {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlNav) Dir(v string) HTMLNav {
	e.setAttr("dir", v)
	return e
}

func (e *htmlNav) Draggable(v bool) HTMLNav {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlNav) Hidden(v bool) HTMLNav {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlNav) ID(v string) HTMLNav {
	e.setAttr("id", v)
	return e
}

func (e *htmlNav) Lang(v string) HTMLNav {
	e.setAttr("lang", v)
	return e
}

func (e *htmlNav) Role(v string) HTMLNav {
	e.setAttr("role", v)
	return e
}

func (e *htmlNav) Spellcheck(v bool) HTMLNav {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlNav) Style(k, v string) HTMLNav {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlNav) Styles(s map[string]string) HTMLNav {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlNav) TabIndex(v int) HTMLNav {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlNav) Title(v string) HTMLNav {
	e.setAttr("title", v)
	return e
}

func (e *htmlNav) OnBlur(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlNav) OnChange(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlNav) OnClick(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlNav) OnContextMenu(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlNav) OnCopy(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlNav) OnCut(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlNav) OnDblClick(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlNav) OnDrag(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlNav) OnDragEnd(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlNav) OnDragEnter(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlNav) OnDragLeave(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlNav) OnDragOver(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlNav) OnDragStart(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlNav) OnDrop(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlNav) OnFocus(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlNav) OnInput(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlNav) OnInvalid(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlNav) OnKeyDown(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlNav) OnKeyPress(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlNav) OnKeyup(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlNav) OnMouseDown(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlNav) OnMouseMove(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlNav) OnMouseOut(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlNav) OnMouseOver(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlNav) OnMouseUp(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlNav) OnPaste(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlNav) OnReset(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlNav) OnScroll(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlNav) OnSearch(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlNav) OnSelect(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlNav) OnSubmit(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlNav) OnWheel(h EventHandler, scope ...interface{}) HTMLNav {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLNoScript is the interface that describes a <noscript> HTML element.
type HTMLNoScript interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLNoScript

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLNoScript

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLNoScript

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLNoScript

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLNoScript

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLNoScript

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLNoScript

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLNoScript

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLNoScript

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLNoScript

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLNoScript

	// ID specifies a unique id for an element.
	ID(v string) HTMLNoScript

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLNoScript

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLNoScript

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLNoScript

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLNoScript

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLNoScript

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLNoScript

	// Title specifies extra information about an element.
	Title(v string) HTMLNoScript
}

// NoScript returns an HTML element that defines an alternate content for users that do not support client-side scripts.
func NoScript() HTMLNoScript {
	e := &htmlNoScript{
		elem: elem{
			tag:         "noscript",
			selfClosing: false,
		},
	}

	return e
}

type htmlNoScript struct {
	elem
}

func (e *htmlNoScript) Body(elems ...UI) HTMLNoScript {
	e.setBody(elems...)
	return e
}

func (e *htmlNoScript) Text(v interface{}) HTMLNoScript {
	return e.Body(Text(v))
}

func (e *htmlNoScript) AccessKey(v string) HTMLNoScript {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlNoScript) Aria(k string, v interface{}) HTMLNoScript {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlNoScript) Attr(n string, v interface{}) HTMLNoScript {
	e.setAttr(n, v)
	return e
}

func (e *htmlNoScript) Class(v ...string) HTMLNoScript {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlNoScript) ContentEditable(v bool) HTMLNoScript {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlNoScript) DataSet(k string, v interface{}) HTMLNoScript {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlNoScript) Dir(v string) HTMLNoScript {
	e.setAttr("dir", v)
	return e
}

func (e *htmlNoScript) Draggable(v bool) HTMLNoScript {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlNoScript) Hidden(v bool) HTMLNoScript {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlNoScript) ID(v string) HTMLNoScript {
	e.setAttr("id", v)
	return e
}

func (e *htmlNoScript) Lang(v string) HTMLNoScript {
	e.setAttr("lang", v)
	return e
}

func (e *htmlNoScript) Role(v string) HTMLNoScript {
	e.setAttr("role", v)
	return e
}

func (e *htmlNoScript) Spellcheck(v bool) HTMLNoScript {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlNoScript) Style(k, v string) HTMLNoScript {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlNoScript) Styles(s map[string]string) HTMLNoScript {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlNoScript) TabIndex(v int) HTMLNoScript {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlNoScript) Title(v string) HTMLNoScript {
	e.setAttr("title", v)
	return e
}

// HTMLObject is the interface that describes a <object> HTML element.
type HTMLObject interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLObject

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLObject

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLObject

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLObject

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLObject

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLObject

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLObject

	// Data specifies the URL of the resource to be used by the object.
	Data(v string) HTMLObject

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLObject

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLObject

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLObject

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLObject

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLObject

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLObject

	// ID specifies a unique id for an element.
	ID(v string) HTMLObject

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLObject

	// Name specifies the name of the element.
	Name(v string) HTMLObject

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLObject

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLObject

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLObject

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLObject

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLObject

	// Title specifies extra information about an element.
	Title(v string) HTMLObject

	// Type specifies the type of element.
	Type(v string) HTMLObject

	// UseMap specifies an image as a client-side image-map.
	UseMap(v string) HTMLObject

	// Width specifies the width of the element.
	Width(v int) HTMLObject

	// OnAbort calls the given handler on abort.
	OnAbort(h EventHandler, scope ...interface{}) HTMLObject

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLObject

	// OnCanPlay calls the given handler when a file is ready to start playing (when it has buffered enough to begin).
	OnCanPlay(h EventHandler, scope ...interface{}) HTMLObject

	// OnCanPlayThrough calls the given handler when a file can be played all the way to the end without pausing for buffering.
	OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLObject

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLObject

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLObject

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLObject

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLObject

	// OnCueChange calls the given handler when the cue changes in a track element.
	OnCueChange(h EventHandler, scope ...interface{}) HTMLObject

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLObject

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLObject

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLObject

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLObject

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLObject

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLObject

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLObject

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLObject

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLObject

	// OnDurationChange calls the given handler when the length of the media changes.
	OnDurationChange(h EventHandler, scope ...interface{}) HTMLObject

	// OnEmptied calls the given handler when something bad happens and the file is suddenly unavailable (like unexpectedly disconnects).
	OnEmptied(h EventHandler, scope ...interface{}) HTMLObject

	// OnEnded calls the given handler when the media has reach the end.
	OnEnded(h EventHandler, scope ...interface{}) HTMLObject

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLObject

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLObject

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLObject

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLObject

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLObject

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLObject

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLObject

	// OnLoadStart calls the given handler just as the file begins to load before anything is actually loaded.
	OnLoadStart(h EventHandler, scope ...interface{}) HTMLObject

	// OnLoadedData calls the given handler when media data is loaded.
	OnLoadedData(h EventHandler, scope ...interface{}) HTMLObject

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLObject

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLObject

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLObject

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLObject

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLObject

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLObject

	// OnPause calls the given handler when the media is paused either by the user or programmatically.
	OnPause(h EventHandler, scope ...interface{}) HTMLObject

	// OnPlay calls the given handler when the media is ready to start playing.
	OnPlay(h EventHandler, scope ...interface{}) HTMLObject

	// OnPlaying calls the given handler when the media actually has started playing.
	OnPlaying(h EventHandler, scope ...interface{}) HTMLObject

	// OnProgress calls the given handler when the browser is in the process of getting the media data.
	OnProgress(h EventHandler, scope ...interface{}) HTMLObject

	// OnRateChange calls the given handler each time the playback rate changes (like when a user switches to a slow motion or fast forward mode).
	OnRateChange(h EventHandler, scope ...interface{}) HTMLObject

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLObject

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLObject

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLObject

	// OnSeeked calls the given handler when the seeking attribute is set to false indicating that seeking has ended.
	OnSeeked(h EventHandler, scope ...interface{}) HTMLObject

	// OnSeeking calls the given handler when the seeking attribute is set to true indicating that seeking is active.
	OnSeeking(h EventHandler, scope ...interface{}) HTMLObject

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLObject

	// OnStalled calls the given handler when the browser is unable to fetch the media data for whatever reason.
	OnStalled(h EventHandler, scope ...interface{}) HTMLObject

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLObject

	// OnSuspend calls the given handler when fetching the media data is stopped before it is completely loaded for whatever reason.
	OnSuspend(h EventHandler, scope ...interface{}) HTMLObject

	// OnTimeUpdate calls the given handler when the playing position has changed (like when the user fast forwards to a different point in the media).
	OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLObject

	// OnVolumeChange calls the given handler each time the volume is changed which (includes setting the volume to "mute").
	OnVolumeChange(h EventHandler, scope ...interface{}) HTMLObject

	// OnWaiting calls the given handler when the media has paused but is expected to resume (like when the media pauses to buffer more data).
	OnWaiting(h EventHandler, scope ...interface{}) HTMLObject

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLObject

	// OnloadedMetaData calls the given handler when meta data (like dimensions and duration) are loaded.
	OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLObject
}

// Object returns an HTML element that defines an embedded object.
func Object() HTMLObject {
	e := &htmlObject{
		elem: elem{
			tag:         "object",
			selfClosing: false,
		},
	}

	return e
}

type htmlObject struct {
	elem
}

func (e *htmlObject) Body(elems ...UI) HTMLObject {
	e.setBody(elems...)
	return e
}

func (e *htmlObject) Text(v interface{}) HTMLObject {
	return e.Body(Text(v))
}

func (e *htmlObject) AccessKey(v string) HTMLObject {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlObject) Aria(k string, v interface{}) HTMLObject {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlObject) Attr(n string, v interface{}) HTMLObject {
	e.setAttr(n, v)
	return e
}

func (e *htmlObject) Class(v ...string) HTMLObject {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlObject) ContentEditable(v bool) HTMLObject {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlObject) Data(v string) HTMLObject {
	e.setAttr("data", v)
	return e
}

func (e *htmlObject) DataSet(k string, v interface{}) HTMLObject {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlObject) Dir(v string) HTMLObject {
	e.setAttr("dir", v)
	return e
}

func (e *htmlObject) Draggable(v bool) HTMLObject {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlObject) Form(v string) HTMLObject {
	e.setAttr("form", v)
	return e
}

func (e *htmlObject) Height(v int) HTMLObject {
	e.setAttr("height", v)
	return e
}

func (e *htmlObject) Hidden(v bool) HTMLObject {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlObject) ID(v string) HTMLObject {
	e.setAttr("id", v)
	return e
}

func (e *htmlObject) Lang(v string) HTMLObject {
	e.setAttr("lang", v)
	return e
}

func (e *htmlObject) Name(v string) HTMLObject {
	e.setAttr("name", v)
	return e
}

func (e *htmlObject) Role(v string) HTMLObject {
	e.setAttr("role", v)
	return e
}

func (e *htmlObject) Spellcheck(v bool) HTMLObject {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlObject) Style(k, v string) HTMLObject {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlObject) Styles(s map[string]string) HTMLObject {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlObject) TabIndex(v int) HTMLObject {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlObject) Title(v string) HTMLObject {
	e.setAttr("title", v)
	return e
}

func (e *htmlObject) Type(v string) HTMLObject {
	e.setAttr("type", v)
	return e
}

func (e *htmlObject) UseMap(v string) HTMLObject {
	e.setAttr("usemap", v)
	return e
}

func (e *htmlObject) Width(v int) HTMLObject {
	e.setAttr("width", v)
	return e
}

func (e *htmlObject) OnAbort(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("abort", h, scope...)
	return e
}

func (e *htmlObject) OnBlur(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlObject) OnCanPlay(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("canplay", h, scope...)
	return e
}

func (e *htmlObject) OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("canplaythrough", h, scope...)
	return e
}

func (e *htmlObject) OnChange(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlObject) OnClick(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlObject) OnContextMenu(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlObject) OnCopy(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlObject) OnCueChange(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("cuechange", h, scope...)
	return e
}

func (e *htmlObject) OnCut(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlObject) OnDblClick(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlObject) OnDrag(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlObject) OnDragEnd(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlObject) OnDragEnter(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlObject) OnDragLeave(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlObject) OnDragOver(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlObject) OnDragStart(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlObject) OnDrop(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlObject) OnDurationChange(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("durationchange", h, scope...)
	return e
}

func (e *htmlObject) OnEmptied(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("emptied", h, scope...)
	return e
}

func (e *htmlObject) OnEnded(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("ended", h, scope...)
	return e
}

func (e *htmlObject) OnError(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlObject) OnFocus(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlObject) OnInput(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlObject) OnInvalid(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlObject) OnKeyDown(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlObject) OnKeyPress(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlObject) OnKeyup(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlObject) OnLoadStart(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("loadstart", h, scope...)
	return e
}

func (e *htmlObject) OnLoadedData(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("loadeddata", h, scope...)
	return e
}

func (e *htmlObject) OnMouseDown(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlObject) OnMouseMove(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlObject) OnMouseOut(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlObject) OnMouseOver(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlObject) OnMouseUp(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlObject) OnPaste(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlObject) OnPause(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("pause", h, scope...)
	return e
}

func (e *htmlObject) OnPlay(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("play", h, scope...)
	return e
}

func (e *htmlObject) OnPlaying(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("playing", h, scope...)
	return e
}

func (e *htmlObject) OnProgress(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("progress", h, scope...)
	return e
}

func (e *htmlObject) OnRateChange(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("ratechange", h, scope...)
	return e
}

func (e *htmlObject) OnReset(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlObject) OnScroll(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlObject) OnSearch(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlObject) OnSeeked(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("seeked", h, scope...)
	return e
}

func (e *htmlObject) OnSeeking(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("seeking", h, scope...)
	return e
}

func (e *htmlObject) OnSelect(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlObject) OnStalled(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("stalled", h, scope...)
	return e
}

func (e *htmlObject) OnSubmit(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlObject) OnSuspend(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("suspend", h, scope...)
	return e
}

func (e *htmlObject) OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("timeupdate", h, scope...)
	return e
}

func (e *htmlObject) OnVolumeChange(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("volumechange", h, scope...)
	return e
}

func (e *htmlObject) OnWaiting(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("waiting", h, scope...)
	return e
}

func (e *htmlObject) OnWheel(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("wheel", h, scope...)
	return e
}

func (e *htmlObject) OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLObject {
	e.setEventHandler("loadedmetadata", h, scope...)
	return e
}

// HTMLOl is the interface that describes a <ol> HTML element.
type HTMLOl interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLOl

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLOl

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLOl

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLOl

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLOl

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLOl

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLOl

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLOl

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLOl

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLOl

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLOl

	// ID specifies a unique id for an element.
	ID(v string) HTMLOl

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLOl

	// Reversed specifies that the list order should be descending (9,8,7...).
	Reversed(v bool) HTMLOl

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLOl

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLOl

	// Start specifies the start value of the ordered list.
	Start(v int) HTMLOl

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLOl

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLOl

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLOl

	// Title specifies extra information about an element.
	Title(v string) HTMLOl

	// Type specifies the type of element.
	Type(v string) HTMLOl

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLOl

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLOl

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLOl

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLOl

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLOl

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLOl

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLOl

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLOl

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLOl

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLOl

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLOl

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLOl

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLOl

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLOl

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLOl

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLOl

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLOl

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLOl

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLOl

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLOl

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLOl

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLOl

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLOl

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLOl

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLOl

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLOl

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLOl

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLOl

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLOl

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLOl

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLOl

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLOl
}

// Ol returns an HTML element that defines an ordered list.
func Ol() HTMLOl {
	e := &htmlOl{
		elem: elem{
			tag:         "ol",
			selfClosing: false,
		},
	}

	return e
}

type htmlOl struct {
	elem
}

func (e *htmlOl) Body(elems ...UI) HTMLOl {
	e.setBody(elems...)
	return e
}

func (e *htmlOl) Text(v interface{}) HTMLOl {
	return e.Body(Text(v))
}

func (e *htmlOl) AccessKey(v string) HTMLOl {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlOl) Aria(k string, v interface{}) HTMLOl {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOl) Attr(n string, v interface{}) HTMLOl {
	e.setAttr(n, v)
	return e
}

func (e *htmlOl) Class(v ...string) HTMLOl {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlOl) ContentEditable(v bool) HTMLOl {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlOl) DataSet(k string, v interface{}) HTMLOl {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOl) Dir(v string) HTMLOl {
	e.setAttr("dir", v)
	return e
}

func (e *htmlOl) Draggable(v bool) HTMLOl {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlOl) Hidden(v bool) HTMLOl {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlOl) ID(v string) HTMLOl {
	e.setAttr("id", v)
	return e
}

func (e *htmlOl) Lang(v string) HTMLOl {
	e.setAttr("lang", v)
	return e
}

func (e *htmlOl) Reversed(v bool) HTMLOl {
	e.setAttr("reversed", v)
	return e
}

func (e *htmlOl) Role(v string) HTMLOl {
	e.setAttr("role", v)
	return e
}

func (e *htmlOl) Spellcheck(v bool) HTMLOl {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlOl) Start(v int) HTMLOl {
	e.setAttr("start", v)
	return e
}

func (e *htmlOl) Style(k, v string) HTMLOl {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlOl) Styles(s map[string]string) HTMLOl {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlOl) TabIndex(v int) HTMLOl {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlOl) Title(v string) HTMLOl {
	e.setAttr("title", v)
	return e
}

func (e *htmlOl) Type(v string) HTMLOl {
	e.setAttr("type", v)
	return e
}

func (e *htmlOl) OnBlur(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlOl) OnChange(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlOl) OnClick(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlOl) OnContextMenu(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlOl) OnCopy(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlOl) OnCut(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlOl) OnDblClick(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlOl) OnDrag(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlOl) OnDragEnd(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlOl) OnDragEnter(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlOl) OnDragLeave(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlOl) OnDragOver(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlOl) OnDragStart(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlOl) OnDrop(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlOl) OnFocus(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlOl) OnInput(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlOl) OnInvalid(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlOl) OnKeyDown(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlOl) OnKeyPress(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlOl) OnKeyup(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlOl) OnMouseDown(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlOl) OnMouseMove(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlOl) OnMouseOut(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlOl) OnMouseOver(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlOl) OnMouseUp(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlOl) OnPaste(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlOl) OnReset(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlOl) OnScroll(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlOl) OnSearch(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlOl) OnSelect(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlOl) OnSubmit(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlOl) OnWheel(h EventHandler, scope ...interface{}) HTMLOl {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLOptGroup is the interface that describes a <optgroup> HTML element.
type HTMLOptGroup interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLOptGroup

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLOptGroup

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLOptGroup

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLOptGroup

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLOptGroup

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLOptGroup

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLOptGroup

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLOptGroup

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLOptGroup

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLOptGroup

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLOptGroup

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLOptGroup

	// ID specifies a unique id for an element.
	ID(v string) HTMLOptGroup

	// Label specifies a shorter label for the option.
	Label(v string) HTMLOptGroup

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLOptGroup

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLOptGroup

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLOptGroup

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLOptGroup

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLOptGroup

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLOptGroup

	// Title specifies extra information about an element.
	Title(v string) HTMLOptGroup

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLOptGroup

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLOptGroup
}

// OptGroup returns an HTML element that defines a group of related options in a drop-down list.
func OptGroup() HTMLOptGroup {
	e := &htmlOptGroup{
		elem: elem{
			tag:         "optgroup",
			selfClosing: false,
		},
	}

	return e
}

type htmlOptGroup struct {
	elem
}

func (e *htmlOptGroup) Body(elems ...UI) HTMLOptGroup {
	e.setBody(elems...)
	return e
}

func (e *htmlOptGroup) Text(v interface{}) HTMLOptGroup {
	return e.Body(Text(v))
}

func (e *htmlOptGroup) AccessKey(v string) HTMLOptGroup {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlOptGroup) Aria(k string, v interface{}) HTMLOptGroup {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOptGroup) Attr(n string, v interface{}) HTMLOptGroup {
	e.setAttr(n, v)
	return e
}

func (e *htmlOptGroup) Class(v ...string) HTMLOptGroup {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlOptGroup) ContentEditable(v bool) HTMLOptGroup {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlOptGroup) DataSet(k string, v interface{}) HTMLOptGroup {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOptGroup) Dir(v string) HTMLOptGroup {
	e.setAttr("dir", v)
	return e
}

func (e *htmlOptGroup) Disabled(v bool) HTMLOptGroup {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlOptGroup) Draggable(v bool) HTMLOptGroup {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlOptGroup) Hidden(v bool) HTMLOptGroup {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlOptGroup) ID(v string) HTMLOptGroup {
	e.setAttr("id", v)
	return e
}

func (e *htmlOptGroup) Label(v string) HTMLOptGroup {
	e.setAttr("label", v)
	return e
}

func (e *htmlOptGroup) Lang(v string) HTMLOptGroup {
	e.setAttr("lang", v)
	return e
}

func (e *htmlOptGroup) Role(v string) HTMLOptGroup {
	e.setAttr("role", v)
	return e
}

func (e *htmlOptGroup) Spellcheck(v bool) HTMLOptGroup {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlOptGroup) Style(k, v string) HTMLOptGroup {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlOptGroup) Styles(s map[string]string) HTMLOptGroup {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlOptGroup) TabIndex(v int) HTMLOptGroup {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlOptGroup) Title(v string) HTMLOptGroup {
	e.setAttr("title", v)
	return e
}

func (e *htmlOptGroup) OnBlur(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlOptGroup) OnChange(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlOptGroup) OnClick(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlOptGroup) OnContextMenu(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlOptGroup) OnCopy(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlOptGroup) OnCut(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDblClick(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDrag(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDragEnd(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDragEnter(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDragLeave(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDragOver(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDragStart(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlOptGroup) OnDrop(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlOptGroup) OnFocus(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlOptGroup) OnInput(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlOptGroup) OnInvalid(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlOptGroup) OnKeyDown(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlOptGroup) OnKeyPress(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlOptGroup) OnKeyup(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlOptGroup) OnMouseDown(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlOptGroup) OnMouseMove(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlOptGroup) OnMouseOut(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlOptGroup) OnMouseOver(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlOptGroup) OnMouseUp(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlOptGroup) OnPaste(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlOptGroup) OnReset(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlOptGroup) OnScroll(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlOptGroup) OnSearch(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlOptGroup) OnSelect(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlOptGroup) OnSubmit(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlOptGroup) OnWheel(h EventHandler, scope ...interface{}) HTMLOptGroup {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLOption is the interface that describes a <option> HTML element.
type HTMLOption interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLOption

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLOption

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLOption

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLOption

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLOption

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLOption

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLOption

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLOption

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLOption

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLOption

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLOption

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLOption

	// ID specifies a unique id for an element.
	ID(v string) HTMLOption

	// Label specifies a shorter label for the option.
	Label(v string) HTMLOption

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLOption

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLOption

	// Selected specifies that an option should be pre-selected when the page loads.
	Selected(v bool) HTMLOption

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLOption

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLOption

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLOption

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLOption

	// Title specifies extra information about an element.
	Title(v string) HTMLOption

	// Value specifies the value of the element.
	Value(v interface{}) HTMLOption

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLOption

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLOption

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLOption

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLOption

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLOption

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLOption

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLOption

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLOption

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLOption

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLOption

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLOption

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLOption

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLOption

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLOption

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLOption

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLOption

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLOption

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLOption

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLOption

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLOption

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLOption

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLOption

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLOption

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLOption

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLOption

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLOption

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLOption

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLOption

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLOption

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLOption

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLOption

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLOption
}

// Option returns an HTML element that defines an option in a drop-down list.
func Option() HTMLOption {
	e := &htmlOption{
		elem: elem{
			tag:         "option",
			selfClosing: false,
		},
	}

	return e
}

type htmlOption struct {
	elem
}

func (e *htmlOption) Body(elems ...UI) HTMLOption {
	e.setBody(elems...)
	return e
}

func (e *htmlOption) Text(v interface{}) HTMLOption {
	return e.Body(Text(v))
}

func (e *htmlOption) AccessKey(v string) HTMLOption {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlOption) Aria(k string, v interface{}) HTMLOption {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOption) Attr(n string, v interface{}) HTMLOption {
	e.setAttr(n, v)
	return e
}

func (e *htmlOption) Class(v ...string) HTMLOption {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlOption) ContentEditable(v bool) HTMLOption {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlOption) DataSet(k string, v interface{}) HTMLOption {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOption) Dir(v string) HTMLOption {
	e.setAttr("dir", v)
	return e
}

func (e *htmlOption) Disabled(v bool) HTMLOption {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlOption) Draggable(v bool) HTMLOption {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlOption) Hidden(v bool) HTMLOption {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlOption) ID(v string) HTMLOption {
	e.setAttr("id", v)
	return e
}

func (e *htmlOption) Label(v string) HTMLOption {
	e.setAttr("label", v)
	return e
}

func (e *htmlOption) Lang(v string) HTMLOption {
	e.setAttr("lang", v)
	return e
}

func (e *htmlOption) Role(v string) HTMLOption {
	e.setAttr("role", v)
	return e
}

func (e *htmlOption) Selected(v bool) HTMLOption {
	e.setAttr("selected", v)
	return e
}

func (e *htmlOption) Spellcheck(v bool) HTMLOption {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlOption) Style(k, v string) HTMLOption {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlOption) Styles(s map[string]string) HTMLOption {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlOption) TabIndex(v int) HTMLOption {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlOption) Title(v string) HTMLOption {
	e.setAttr("title", v)
	return e
}

func (e *htmlOption) Value(v interface{}) HTMLOption {
	e.setAttr("value", v)
	return e
}

func (e *htmlOption) OnBlur(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlOption) OnChange(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlOption) OnClick(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlOption) OnContextMenu(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlOption) OnCopy(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlOption) OnCut(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlOption) OnDblClick(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlOption) OnDrag(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlOption) OnDragEnd(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlOption) OnDragEnter(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlOption) OnDragLeave(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlOption) OnDragOver(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlOption) OnDragStart(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlOption) OnDrop(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlOption) OnFocus(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlOption) OnInput(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlOption) OnInvalid(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlOption) OnKeyDown(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlOption) OnKeyPress(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlOption) OnKeyup(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlOption) OnMouseDown(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlOption) OnMouseMove(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlOption) OnMouseOut(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlOption) OnMouseOver(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlOption) OnMouseUp(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlOption) OnPaste(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlOption) OnReset(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlOption) OnScroll(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlOption) OnSearch(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlOption) OnSelect(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlOption) OnSubmit(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlOption) OnWheel(h EventHandler, scope ...interface{}) HTMLOption {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLOutput is the interface that describes a <output> HTML element.
type HTMLOutput interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLOutput

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLOutput

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLOutput

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLOutput

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLOutput

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLOutput

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLOutput

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLOutput

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLOutput

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLOutput

	// For specifies which form element(s) a label/calculation is bound to.
	For(v string) HTMLOutput

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLOutput

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLOutput

	// ID specifies a unique id for an element.
	ID(v string) HTMLOutput

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLOutput

	// Name specifies the name of the element.
	Name(v string) HTMLOutput

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLOutput

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLOutput

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLOutput

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLOutput

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLOutput

	// Title specifies extra information about an element.
	Title(v string) HTMLOutput

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLOutput

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLOutput

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLOutput

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLOutput

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLOutput

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLOutput

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLOutput

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLOutput

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLOutput

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLOutput

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLOutput

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLOutput

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLOutput

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLOutput

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLOutput

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLOutput

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLOutput

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLOutput

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLOutput

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLOutput

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLOutput

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLOutput

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLOutput

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLOutput

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLOutput
}

// Output returns an HTML element that .
func Output() HTMLOutput {
	e := &htmlOutput{
		elem: elem{
			tag:         "output",
			selfClosing: false,
		},
	}

	return e
}

type htmlOutput struct {
	elem
}

func (e *htmlOutput) Body(elems ...UI) HTMLOutput {
	e.setBody(elems...)
	return e
}

func (e *htmlOutput) Text(v interface{}) HTMLOutput {
	return e.Body(Text(v))
}

func (e *htmlOutput) AccessKey(v string) HTMLOutput {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlOutput) Aria(k string, v interface{}) HTMLOutput {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOutput) Attr(n string, v interface{}) HTMLOutput {
	e.setAttr(n, v)
	return e
}

func (e *htmlOutput) Class(v ...string) HTMLOutput {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlOutput) ContentEditable(v bool) HTMLOutput {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlOutput) DataSet(k string, v interface{}) HTMLOutput {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlOutput) Dir(v string) HTMLOutput {
	e.setAttr("dir", v)
	return e
}

func (e *htmlOutput) Draggable(v bool) HTMLOutput {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlOutput) For(v string) HTMLOutput {
	e.setAttr("for", v)
	return e
}

func (e *htmlOutput) Form(v string) HTMLOutput {
	e.setAttr("form", v)
	return e
}

func (e *htmlOutput) Hidden(v bool) HTMLOutput {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlOutput) ID(v string) HTMLOutput {
	e.setAttr("id", v)
	return e
}

func (e *htmlOutput) Lang(v string) HTMLOutput {
	e.setAttr("lang", v)
	return e
}

func (e *htmlOutput) Name(v string) HTMLOutput {
	e.setAttr("name", v)
	return e
}

func (e *htmlOutput) Role(v string) HTMLOutput {
	e.setAttr("role", v)
	return e
}

func (e *htmlOutput) Spellcheck(v bool) HTMLOutput {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlOutput) Style(k, v string) HTMLOutput {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlOutput) Styles(s map[string]string) HTMLOutput {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlOutput) TabIndex(v int) HTMLOutput {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlOutput) Title(v string) HTMLOutput {
	e.setAttr("title", v)
	return e
}

func (e *htmlOutput) OnBlur(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlOutput) OnChange(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlOutput) OnClick(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlOutput) OnContextMenu(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlOutput) OnCopy(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlOutput) OnCut(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlOutput) OnDblClick(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlOutput) OnDrag(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlOutput) OnDragEnd(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlOutput) OnDragEnter(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlOutput) OnDragLeave(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlOutput) OnDragOver(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlOutput) OnDragStart(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlOutput) OnDrop(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlOutput) OnFocus(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlOutput) OnInput(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlOutput) OnInvalid(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlOutput) OnKeyDown(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlOutput) OnKeyPress(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlOutput) OnKeyup(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlOutput) OnMouseDown(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlOutput) OnMouseMove(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlOutput) OnMouseOut(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlOutput) OnMouseOver(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlOutput) OnMouseUp(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlOutput) OnPaste(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlOutput) OnReset(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlOutput) OnScroll(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlOutput) OnSearch(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlOutput) OnSelect(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlOutput) OnSubmit(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlOutput) OnWheel(h EventHandler, scope ...interface{}) HTMLOutput {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLP is the interface that describes a <p> HTML element.
type HTMLP interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLP

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLP

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLP

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLP

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLP

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLP

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLP

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLP

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLP

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLP

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLP

	// ID specifies a unique id for an element.
	ID(v string) HTMLP

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLP

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLP

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLP

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLP

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLP

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLP

	// Title specifies extra information about an element.
	Title(v string) HTMLP

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLP

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLP

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLP

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLP

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLP

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLP

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLP

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLP

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLP

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLP

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLP

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLP

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLP

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLP

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLP

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLP

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLP

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLP

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLP

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLP

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLP

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLP

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLP

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLP

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLP

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLP

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLP

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLP

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLP

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLP

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLP

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLP
}

// P returns an HTML element that defines a paragraph.
func P() HTMLP {
	e := &htmlP{
		elem: elem{
			tag:         "p",
			selfClosing: false,
		},
	}

	return e
}

type htmlP struct {
	elem
}

func (e *htmlP) Body(elems ...UI) HTMLP {
	e.setBody(elems...)
	return e
}

func (e *htmlP) Text(v interface{}) HTMLP {
	return e.Body(Text(v))
}

func (e *htmlP) AccessKey(v string) HTMLP {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlP) Aria(k string, v interface{}) HTMLP {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlP) Attr(n string, v interface{}) HTMLP {
	e.setAttr(n, v)
	return e
}

func (e *htmlP) Class(v ...string) HTMLP {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlP) ContentEditable(v bool) HTMLP {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlP) DataSet(k string, v interface{}) HTMLP {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlP) Dir(v string) HTMLP {
	e.setAttr("dir", v)
	return e
}

func (e *htmlP) Draggable(v bool) HTMLP {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlP) Hidden(v bool) HTMLP {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlP) ID(v string) HTMLP {
	e.setAttr("id", v)
	return e
}

func (e *htmlP) Lang(v string) HTMLP {
	e.setAttr("lang", v)
	return e
}

func (e *htmlP) Role(v string) HTMLP {
	e.setAttr("role", v)
	return e
}

func (e *htmlP) Spellcheck(v bool) HTMLP {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlP) Style(k, v string) HTMLP {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlP) Styles(s map[string]string) HTMLP {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlP) TabIndex(v int) HTMLP {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlP) Title(v string) HTMLP {
	e.setAttr("title", v)
	return e
}

func (e *htmlP) OnBlur(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlP) OnChange(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlP) OnClick(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlP) OnContextMenu(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlP) OnCopy(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlP) OnCut(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlP) OnDblClick(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlP) OnDrag(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlP) OnDragEnd(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlP) OnDragEnter(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlP) OnDragLeave(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlP) OnDragOver(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlP) OnDragStart(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlP) OnDrop(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlP) OnFocus(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlP) OnInput(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlP) OnInvalid(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlP) OnKeyDown(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlP) OnKeyPress(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlP) OnKeyup(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlP) OnMouseDown(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlP) OnMouseMove(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlP) OnMouseOut(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlP) OnMouseOver(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlP) OnMouseUp(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlP) OnPaste(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlP) OnReset(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlP) OnScroll(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlP) OnSearch(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlP) OnSelect(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlP) OnSubmit(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlP) OnWheel(h EventHandler, scope ...interface{}) HTMLP {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLParam is the interface that describes a <param> HTML element.
type HTMLParam interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLParam

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLParam

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLParam

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLParam

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLParam

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLParam

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLParam

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLParam

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLParam

	// ID specifies a unique id for an element.
	ID(v string) HTMLParam

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLParam

	// Name specifies the name of the element.
	Name(v string) HTMLParam

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLParam

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLParam

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLParam

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLParam

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLParam

	// Title specifies extra information about an element.
	Title(v string) HTMLParam

	// Value specifies the value of the element.
	Value(v interface{}) HTMLParam

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLParam

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLParam

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLParam

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLParam

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLParam

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLParam

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLParam

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLParam

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLParam

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLParam

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLParam

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLParam

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLParam

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLParam

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLParam

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLParam

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLParam

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLParam

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLParam

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLParam

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLParam

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLParam

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLParam

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLParam

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLParam

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLParam

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLParam

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLParam

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLParam

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLParam

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLParam

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLParam
}

// Param returns an HTML element that defines a parameter for an object.
func Param() HTMLParam {
	e := &htmlParam{
		elem: elem{
			tag:         "param",
			selfClosing: true,
		},
	}

	return e
}

type htmlParam struct {
	elem
}

func (e *htmlParam) AccessKey(v string) HTMLParam {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlParam) Aria(k string, v interface{}) HTMLParam {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlParam) Attr(n string, v interface{}) HTMLParam {
	e.setAttr(n, v)
	return e
}

func (e *htmlParam) Class(v ...string) HTMLParam {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlParam) ContentEditable(v bool) HTMLParam {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlParam) DataSet(k string, v interface{}) HTMLParam {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlParam) Dir(v string) HTMLParam {
	e.setAttr("dir", v)
	return e
}

func (e *htmlParam) Draggable(v bool) HTMLParam {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlParam) Hidden(v bool) HTMLParam {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlParam) ID(v string) HTMLParam {
	e.setAttr("id", v)
	return e
}

func (e *htmlParam) Lang(v string) HTMLParam {
	e.setAttr("lang", v)
	return e
}

func (e *htmlParam) Name(v string) HTMLParam {
	e.setAttr("name", v)
	return e
}

func (e *htmlParam) Role(v string) HTMLParam {
	e.setAttr("role", v)
	return e
}

func (e *htmlParam) Spellcheck(v bool) HTMLParam {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlParam) Style(k, v string) HTMLParam {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlParam) Styles(s map[string]string) HTMLParam {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlParam) TabIndex(v int) HTMLParam {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlParam) Title(v string) HTMLParam {
	e.setAttr("title", v)
	return e
}

func (e *htmlParam) Value(v interface{}) HTMLParam {
	e.setAttr("value", v)
	return e
}

func (e *htmlParam) OnBlur(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlParam) OnChange(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlParam) OnClick(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlParam) OnContextMenu(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlParam) OnCopy(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlParam) OnCut(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlParam) OnDblClick(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlParam) OnDrag(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlParam) OnDragEnd(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlParam) OnDragEnter(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlParam) OnDragLeave(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlParam) OnDragOver(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlParam) OnDragStart(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlParam) OnDrop(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlParam) OnFocus(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlParam) OnInput(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlParam) OnInvalid(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlParam) OnKeyDown(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlParam) OnKeyPress(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlParam) OnKeyup(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlParam) OnMouseDown(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlParam) OnMouseMove(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlParam) OnMouseOut(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlParam) OnMouseOver(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlParam) OnMouseUp(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlParam) OnPaste(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlParam) OnReset(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlParam) OnScroll(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlParam) OnSearch(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlParam) OnSelect(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlParam) OnSubmit(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlParam) OnWheel(h EventHandler, scope ...interface{}) HTMLParam {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLPicture is the interface that describes a <picture> HTML element.
type HTMLPicture interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLPicture

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLPicture

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLPicture

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLPicture

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLPicture

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLPicture

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLPicture

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLPicture

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLPicture

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLPicture

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLPicture

	// ID specifies a unique id for an element.
	ID(v string) HTMLPicture

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLPicture

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLPicture

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLPicture

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLPicture

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLPicture

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLPicture

	// Title specifies extra information about an element.
	Title(v string) HTMLPicture

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLPicture

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLPicture

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLPicture

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLPicture

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLPicture

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLPicture

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLPicture

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLPicture

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLPicture

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLPicture

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLPicture

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLPicture

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLPicture

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLPicture

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLPicture

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLPicture

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLPicture

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLPicture

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLPicture

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLPicture

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLPicture

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLPicture

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLPicture

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLPicture

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLPicture
}

// Picture returns an HTML element that defines a container for multiple image resources.
func Picture() HTMLPicture {
	e := &htmlPicture{
		elem: elem{
			tag:         "picture",
			selfClosing: false,
		},
	}

	return e
}

type htmlPicture struct {
	elem
}

func (e *htmlPicture) Body(elems ...UI) HTMLPicture {
	e.setBody(elems...)
	return e
}

func (e *htmlPicture) Text(v interface{}) HTMLPicture {
	return e.Body(Text(v))
}

func (e *htmlPicture) AccessKey(v string) HTMLPicture {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlPicture) Aria(k string, v interface{}) HTMLPicture {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlPicture) Attr(n string, v interface{}) HTMLPicture {
	e.setAttr(n, v)
	return e
}

func (e *htmlPicture) Class(v ...string) HTMLPicture {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlPicture) ContentEditable(v bool) HTMLPicture {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlPicture) DataSet(k string, v interface{}) HTMLPicture {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlPicture) Dir(v string) HTMLPicture {
	e.setAttr("dir", v)
	return e
}

func (e *htmlPicture) Draggable(v bool) HTMLPicture {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlPicture) Hidden(v bool) HTMLPicture {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlPicture) ID(v string) HTMLPicture {
	e.setAttr("id", v)
	return e
}

func (e *htmlPicture) Lang(v string) HTMLPicture {
	e.setAttr("lang", v)
	return e
}

func (e *htmlPicture) Role(v string) HTMLPicture {
	e.setAttr("role", v)
	return e
}

func (e *htmlPicture) Spellcheck(v bool) HTMLPicture {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlPicture) Style(k, v string) HTMLPicture {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlPicture) Styles(s map[string]string) HTMLPicture {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlPicture) TabIndex(v int) HTMLPicture {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlPicture) Title(v string) HTMLPicture {
	e.setAttr("title", v)
	return e
}

func (e *htmlPicture) OnBlur(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlPicture) OnChange(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlPicture) OnClick(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlPicture) OnContextMenu(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlPicture) OnCopy(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlPicture) OnCut(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlPicture) OnDblClick(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlPicture) OnDrag(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlPicture) OnDragEnd(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlPicture) OnDragEnter(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlPicture) OnDragLeave(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlPicture) OnDragOver(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlPicture) OnDragStart(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlPicture) OnDrop(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlPicture) OnFocus(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlPicture) OnInput(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlPicture) OnInvalid(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlPicture) OnKeyDown(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlPicture) OnKeyPress(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlPicture) OnKeyup(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlPicture) OnMouseDown(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlPicture) OnMouseMove(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlPicture) OnMouseOut(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlPicture) OnMouseOver(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlPicture) OnMouseUp(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlPicture) OnPaste(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlPicture) OnReset(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlPicture) OnScroll(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlPicture) OnSearch(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlPicture) OnSelect(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlPicture) OnSubmit(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlPicture) OnWheel(h EventHandler, scope ...interface{}) HTMLPicture {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLPre is the interface that describes a <pre> HTML element.
type HTMLPre interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLPre

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLPre

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLPre

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLPre

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLPre

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLPre

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLPre

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLPre

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLPre

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLPre

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLPre

	// ID specifies a unique id for an element.
	ID(v string) HTMLPre

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLPre

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLPre

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLPre

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLPre

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLPre

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLPre

	// Title specifies extra information about an element.
	Title(v string) HTMLPre

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLPre

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLPre

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLPre

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLPre

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLPre

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLPre

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLPre

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLPre

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLPre

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLPre

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLPre

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLPre

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLPre

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLPre

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLPre

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLPre

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLPre

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLPre

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLPre

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLPre

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLPre

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLPre

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLPre

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLPre

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLPre

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLPre

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLPre

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLPre

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLPre

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLPre

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLPre

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLPre
}

// Pre returns an HTML element that defines preformatted text.
func Pre() HTMLPre {
	e := &htmlPre{
		elem: elem{
			tag:         "pre",
			selfClosing: false,
		},
	}

	return e
}

type htmlPre struct {
	elem
}

func (e *htmlPre) Body(elems ...UI) HTMLPre {
	e.setBody(elems...)
	return e
}

func (e *htmlPre) Text(v interface{}) HTMLPre {
	return e.Body(Text(v))
}

func (e *htmlPre) AccessKey(v string) HTMLPre {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlPre) Aria(k string, v interface{}) HTMLPre {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlPre) Attr(n string, v interface{}) HTMLPre {
	e.setAttr(n, v)
	return e
}

func (e *htmlPre) Class(v ...string) HTMLPre {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlPre) ContentEditable(v bool) HTMLPre {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlPre) DataSet(k string, v interface{}) HTMLPre {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlPre) Dir(v string) HTMLPre {
	e.setAttr("dir", v)
	return e
}

func (e *htmlPre) Draggable(v bool) HTMLPre {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlPre) Hidden(v bool) HTMLPre {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlPre) ID(v string) HTMLPre {
	e.setAttr("id", v)
	return e
}

func (e *htmlPre) Lang(v string) HTMLPre {
	e.setAttr("lang", v)
	return e
}

func (e *htmlPre) Role(v string) HTMLPre {
	e.setAttr("role", v)
	return e
}

func (e *htmlPre) Spellcheck(v bool) HTMLPre {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlPre) Style(k, v string) HTMLPre {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlPre) Styles(s map[string]string) HTMLPre {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlPre) TabIndex(v int) HTMLPre {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlPre) Title(v string) HTMLPre {
	e.setAttr("title", v)
	return e
}

func (e *htmlPre) OnBlur(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlPre) OnChange(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlPre) OnClick(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlPre) OnContextMenu(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlPre) OnCopy(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlPre) OnCut(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlPre) OnDblClick(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlPre) OnDrag(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlPre) OnDragEnd(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlPre) OnDragEnter(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlPre) OnDragLeave(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlPre) OnDragOver(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlPre) OnDragStart(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlPre) OnDrop(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlPre) OnFocus(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlPre) OnInput(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlPre) OnInvalid(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlPre) OnKeyDown(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlPre) OnKeyPress(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlPre) OnKeyup(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlPre) OnMouseDown(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlPre) OnMouseMove(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlPre) OnMouseOut(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlPre) OnMouseOver(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlPre) OnMouseUp(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlPre) OnPaste(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlPre) OnReset(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlPre) OnScroll(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlPre) OnSearch(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlPre) OnSelect(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlPre) OnSubmit(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlPre) OnWheel(h EventHandler, scope ...interface{}) HTMLPre {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLProgress is the interface that describes a <progress> HTML element.
type HTMLProgress interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLProgress

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLProgress

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLProgress

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLProgress

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLProgress

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLProgress

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLProgress

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLProgress

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLProgress

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLProgress

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLProgress

	// ID specifies a unique id for an element.
	ID(v string) HTMLProgress

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLProgress

	// Max Specifies the maximum value.
	Max(v interface{}) HTMLProgress

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLProgress

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLProgress

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLProgress

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLProgress

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLProgress

	// Title specifies extra information about an element.
	Title(v string) HTMLProgress

	// Value specifies the value of the element.
	Value(v interface{}) HTMLProgress

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLProgress

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLProgress

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLProgress

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLProgress

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLProgress

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLProgress

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLProgress

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLProgress

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLProgress

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLProgress

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLProgress

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLProgress

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLProgress

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLProgress

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLProgress

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLProgress

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLProgress

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLProgress

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLProgress

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLProgress

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLProgress

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLProgress

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLProgress

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLProgress

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLProgress
}

// Progress returns an HTML element that represents the progress of a task.
func Progress() HTMLProgress {
	e := &htmlProgress{
		elem: elem{
			tag:         "progress",
			selfClosing: false,
		},
	}

	return e
}

type htmlProgress struct {
	elem
}

func (e *htmlProgress) Body(elems ...UI) HTMLProgress {
	e.setBody(elems...)
	return e
}

func (e *htmlProgress) Text(v interface{}) HTMLProgress {
	return e.Body(Text(v))
}

func (e *htmlProgress) AccessKey(v string) HTMLProgress {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlProgress) Aria(k string, v interface{}) HTMLProgress {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlProgress) Attr(n string, v interface{}) HTMLProgress {
	e.setAttr(n, v)
	return e
}

func (e *htmlProgress) Class(v ...string) HTMLProgress {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlProgress) ContentEditable(v bool) HTMLProgress {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlProgress) DataSet(k string, v interface{}) HTMLProgress {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlProgress) Dir(v string) HTMLProgress {
	e.setAttr("dir", v)
	return e
}

func (e *htmlProgress) Draggable(v bool) HTMLProgress {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlProgress) Hidden(v bool) HTMLProgress {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlProgress) ID(v string) HTMLProgress {
	e.setAttr("id", v)
	return e
}

func (e *htmlProgress) Lang(v string) HTMLProgress {
	e.setAttr("lang", v)
	return e
}

func (e *htmlProgress) Max(v interface{}) HTMLProgress {
	e.setAttr("max", v)
	return e
}

func (e *htmlProgress) Role(v string) HTMLProgress {
	e.setAttr("role", v)
	return e
}

func (e *htmlProgress) Spellcheck(v bool) HTMLProgress {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlProgress) Style(k, v string) HTMLProgress {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlProgress) Styles(s map[string]string) HTMLProgress {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlProgress) TabIndex(v int) HTMLProgress {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlProgress) Title(v string) HTMLProgress {
	e.setAttr("title", v)
	return e
}

func (e *htmlProgress) Value(v interface{}) HTMLProgress {
	e.setAttr("value", v)
	return e
}

func (e *htmlProgress) OnBlur(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlProgress) OnChange(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlProgress) OnClick(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlProgress) OnContextMenu(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlProgress) OnCopy(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlProgress) OnCut(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlProgress) OnDblClick(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlProgress) OnDrag(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlProgress) OnDragEnd(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlProgress) OnDragEnter(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlProgress) OnDragLeave(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlProgress) OnDragOver(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlProgress) OnDragStart(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlProgress) OnDrop(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlProgress) OnFocus(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlProgress) OnInput(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlProgress) OnInvalid(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlProgress) OnKeyDown(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlProgress) OnKeyPress(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlProgress) OnKeyup(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlProgress) OnMouseDown(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlProgress) OnMouseMove(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlProgress) OnMouseOut(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlProgress) OnMouseOver(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlProgress) OnMouseUp(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlProgress) OnPaste(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlProgress) OnReset(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlProgress) OnScroll(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlProgress) OnSearch(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlProgress) OnSelect(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlProgress) OnSubmit(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlProgress) OnWheel(h EventHandler, scope ...interface{}) HTMLProgress {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLQ is the interface that describes a <q> HTML element.
type HTMLQ interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLQ

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLQ

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLQ

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLQ

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLQ

	// Cite specifies a URL which explains the quote/deleted/inserted text.
	Cite(v string) HTMLQ

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLQ

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLQ

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLQ

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLQ

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLQ

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLQ

	// ID specifies a unique id for an element.
	ID(v string) HTMLQ

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLQ

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLQ

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLQ

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLQ

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLQ

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLQ

	// Title specifies extra information about an element.
	Title(v string) HTMLQ

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLQ

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLQ

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLQ

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLQ

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLQ

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLQ

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLQ

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLQ

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLQ

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLQ

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLQ

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLQ

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLQ

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLQ

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLQ

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLQ

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLQ

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLQ

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLQ

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLQ

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLQ

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLQ

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLQ

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLQ

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLQ

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLQ

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLQ

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLQ

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLQ

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLQ

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLQ

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLQ
}

// Q returns an HTML element that defines a short quotation.
func Q() HTMLQ {
	e := &htmlQ{
		elem: elem{
			tag:         "q",
			selfClosing: false,
		},
	}

	return e
}

type htmlQ struct {
	elem
}

func (e *htmlQ) Body(elems ...UI) HTMLQ {
	e.setBody(elems...)
	return e
}

func (e *htmlQ) Text(v interface{}) HTMLQ {
	return e.Body(Text(v))
}

func (e *htmlQ) AccessKey(v string) HTMLQ {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlQ) Aria(k string, v interface{}) HTMLQ {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlQ) Attr(n string, v interface{}) HTMLQ {
	e.setAttr(n, v)
	return e
}

func (e *htmlQ) Cite(v string) HTMLQ {
	e.setAttr("cite", v)
	return e
}

func (e *htmlQ) Class(v ...string) HTMLQ {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlQ) ContentEditable(v bool) HTMLQ {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlQ) DataSet(k string, v interface{}) HTMLQ {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlQ) Dir(v string) HTMLQ {
	e.setAttr("dir", v)
	return e
}

func (e *htmlQ) Draggable(v bool) HTMLQ {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlQ) Hidden(v bool) HTMLQ {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlQ) ID(v string) HTMLQ {
	e.setAttr("id", v)
	return e
}

func (e *htmlQ) Lang(v string) HTMLQ {
	e.setAttr("lang", v)
	return e
}

func (e *htmlQ) Role(v string) HTMLQ {
	e.setAttr("role", v)
	return e
}

func (e *htmlQ) Spellcheck(v bool) HTMLQ {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlQ) Style(k, v string) HTMLQ {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlQ) Styles(s map[string]string) HTMLQ {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlQ) TabIndex(v int) HTMLQ {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlQ) Title(v string) HTMLQ {
	e.setAttr("title", v)
	return e
}

func (e *htmlQ) OnBlur(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlQ) OnChange(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlQ) OnClick(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlQ) OnContextMenu(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlQ) OnCopy(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlQ) OnCut(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlQ) OnDblClick(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlQ) OnDrag(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlQ) OnDragEnd(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlQ) OnDragEnter(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlQ) OnDragLeave(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlQ) OnDragOver(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlQ) OnDragStart(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlQ) OnDrop(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlQ) OnFocus(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlQ) OnInput(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlQ) OnInvalid(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlQ) OnKeyDown(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlQ) OnKeyPress(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlQ) OnKeyup(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlQ) OnMouseDown(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlQ) OnMouseMove(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlQ) OnMouseOut(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlQ) OnMouseOver(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlQ) OnMouseUp(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlQ) OnPaste(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlQ) OnReset(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlQ) OnScroll(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlQ) OnSearch(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlQ) OnSelect(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlQ) OnSubmit(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlQ) OnWheel(h EventHandler, scope ...interface{}) HTMLQ {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLRp is the interface that describes a <rp> HTML element.
type HTMLRp interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLRp

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLRp

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLRp

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLRp

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLRp

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLRp

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLRp

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLRp

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLRp

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLRp

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLRp

	// ID specifies a unique id for an element.
	ID(v string) HTMLRp

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLRp

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLRp

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLRp

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLRp

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLRp

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLRp

	// Title specifies extra information about an element.
	Title(v string) HTMLRp

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLRp

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLRp

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLRp

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLRp

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLRp

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLRp

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLRp

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLRp

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLRp

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLRp

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLRp

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLRp

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLRp

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLRp

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLRp

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLRp

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLRp

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLRp

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLRp

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLRp

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLRp

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLRp

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLRp

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLRp

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLRp

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLRp

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLRp

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLRp

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLRp

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLRp

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLRp

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLRp
}

// Rp returns an HTML element that defines what to show in browsers that do not support ruby annotations.
func Rp() HTMLRp {
	e := &htmlRp{
		elem: elem{
			tag:         "rp",
			selfClosing: false,
		},
	}

	return e
}

type htmlRp struct {
	elem
}

func (e *htmlRp) Body(elems ...UI) HTMLRp {
	e.setBody(elems...)
	return e
}

func (e *htmlRp) Text(v interface{}) HTMLRp {
	return e.Body(Text(v))
}

func (e *htmlRp) AccessKey(v string) HTMLRp {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlRp) Aria(k string, v interface{}) HTMLRp {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRp) Attr(n string, v interface{}) HTMLRp {
	e.setAttr(n, v)
	return e
}

func (e *htmlRp) Class(v ...string) HTMLRp {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlRp) ContentEditable(v bool) HTMLRp {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlRp) DataSet(k string, v interface{}) HTMLRp {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRp) Dir(v string) HTMLRp {
	e.setAttr("dir", v)
	return e
}

func (e *htmlRp) Draggable(v bool) HTMLRp {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlRp) Hidden(v bool) HTMLRp {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlRp) ID(v string) HTMLRp {
	e.setAttr("id", v)
	return e
}

func (e *htmlRp) Lang(v string) HTMLRp {
	e.setAttr("lang", v)
	return e
}

func (e *htmlRp) Role(v string) HTMLRp {
	e.setAttr("role", v)
	return e
}

func (e *htmlRp) Spellcheck(v bool) HTMLRp {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlRp) Style(k, v string) HTMLRp {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlRp) Styles(s map[string]string) HTMLRp {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlRp) TabIndex(v int) HTMLRp {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlRp) Title(v string) HTMLRp {
	e.setAttr("title", v)
	return e
}

func (e *htmlRp) OnBlur(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlRp) OnChange(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlRp) OnClick(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlRp) OnContextMenu(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlRp) OnCopy(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlRp) OnCut(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlRp) OnDblClick(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlRp) OnDrag(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlRp) OnDragEnd(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlRp) OnDragEnter(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlRp) OnDragLeave(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlRp) OnDragOver(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlRp) OnDragStart(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlRp) OnDrop(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlRp) OnFocus(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlRp) OnInput(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlRp) OnInvalid(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlRp) OnKeyDown(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlRp) OnKeyPress(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlRp) OnKeyup(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlRp) OnMouseDown(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlRp) OnMouseMove(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlRp) OnMouseOut(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlRp) OnMouseOver(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlRp) OnMouseUp(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlRp) OnPaste(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlRp) OnReset(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlRp) OnScroll(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlRp) OnSearch(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlRp) OnSelect(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlRp) OnSubmit(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlRp) OnWheel(h EventHandler, scope ...interface{}) HTMLRp {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLRt is the interface that describes a <rt> HTML element.
type HTMLRt interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLRt

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLRt

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLRt

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLRt

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLRt

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLRt

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLRt

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLRt

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLRt

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLRt

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLRt

	// ID specifies a unique id for an element.
	ID(v string) HTMLRt

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLRt

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLRt

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLRt

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLRt

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLRt

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLRt

	// Title specifies extra information about an element.
	Title(v string) HTMLRt

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLRt

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLRt

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLRt

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLRt

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLRt

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLRt

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLRt

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLRt

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLRt

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLRt

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLRt

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLRt

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLRt

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLRt

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLRt

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLRt

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLRt

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLRt

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLRt

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLRt

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLRt

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLRt

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLRt

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLRt

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLRt

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLRt

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLRt

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLRt

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLRt

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLRt

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLRt

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLRt
}

// Rt returns an HTML element that defines an explanation/pronunciation of characters (for East Asian typography).
func Rt() HTMLRt {
	e := &htmlRt{
		elem: elem{
			tag:         "rt",
			selfClosing: false,
		},
	}

	return e
}

type htmlRt struct {
	elem
}

func (e *htmlRt) Body(elems ...UI) HTMLRt {
	e.setBody(elems...)
	return e
}

func (e *htmlRt) Text(v interface{}) HTMLRt {
	return e.Body(Text(v))
}

func (e *htmlRt) AccessKey(v string) HTMLRt {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlRt) Aria(k string, v interface{}) HTMLRt {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRt) Attr(n string, v interface{}) HTMLRt {
	e.setAttr(n, v)
	return e
}

func (e *htmlRt) Class(v ...string) HTMLRt {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlRt) ContentEditable(v bool) HTMLRt {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlRt) DataSet(k string, v interface{}) HTMLRt {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRt) Dir(v string) HTMLRt {
	e.setAttr("dir", v)
	return e
}

func (e *htmlRt) Draggable(v bool) HTMLRt {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlRt) Hidden(v bool) HTMLRt {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlRt) ID(v string) HTMLRt {
	e.setAttr("id", v)
	return e
}

func (e *htmlRt) Lang(v string) HTMLRt {
	e.setAttr("lang", v)
	return e
}

func (e *htmlRt) Role(v string) HTMLRt {
	e.setAttr("role", v)
	return e
}

func (e *htmlRt) Spellcheck(v bool) HTMLRt {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlRt) Style(k, v string) HTMLRt {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlRt) Styles(s map[string]string) HTMLRt {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlRt) TabIndex(v int) HTMLRt {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlRt) Title(v string) HTMLRt {
	e.setAttr("title", v)
	return e
}

func (e *htmlRt) OnBlur(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlRt) OnChange(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlRt) OnClick(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlRt) OnContextMenu(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlRt) OnCopy(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlRt) OnCut(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlRt) OnDblClick(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlRt) OnDrag(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlRt) OnDragEnd(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlRt) OnDragEnter(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlRt) OnDragLeave(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlRt) OnDragOver(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlRt) OnDragStart(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlRt) OnDrop(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlRt) OnFocus(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlRt) OnInput(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlRt) OnInvalid(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlRt) OnKeyDown(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlRt) OnKeyPress(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlRt) OnKeyup(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlRt) OnMouseDown(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlRt) OnMouseMove(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlRt) OnMouseOut(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlRt) OnMouseOver(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlRt) OnMouseUp(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlRt) OnPaste(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlRt) OnReset(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlRt) OnScroll(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlRt) OnSearch(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlRt) OnSelect(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlRt) OnSubmit(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlRt) OnWheel(h EventHandler, scope ...interface{}) HTMLRt {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLRuby is the interface that describes a <ruby> HTML element.
type HTMLRuby interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLRuby

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLRuby

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLRuby

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLRuby

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLRuby

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLRuby

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLRuby

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLRuby

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLRuby

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLRuby

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLRuby

	// ID specifies a unique id for an element.
	ID(v string) HTMLRuby

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLRuby

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLRuby

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLRuby

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLRuby

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLRuby

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLRuby

	// Title specifies extra information about an element.
	Title(v string) HTMLRuby

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLRuby

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLRuby

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLRuby

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLRuby

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLRuby

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLRuby

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLRuby

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLRuby

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLRuby

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLRuby

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLRuby

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLRuby

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLRuby

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLRuby

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLRuby

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLRuby

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLRuby

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLRuby

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLRuby

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLRuby

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLRuby

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLRuby

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLRuby

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLRuby

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLRuby
}

// Ruby returns an HTML element that defines a ruby annotation (for East Asian typography).
func Ruby() HTMLRuby {
	e := &htmlRuby{
		elem: elem{
			tag:         "ruby",
			selfClosing: false,
		},
	}

	return e
}

type htmlRuby struct {
	elem
}

func (e *htmlRuby) Body(elems ...UI) HTMLRuby {
	e.setBody(elems...)
	return e
}

func (e *htmlRuby) Text(v interface{}) HTMLRuby {
	return e.Body(Text(v))
}

func (e *htmlRuby) AccessKey(v string) HTMLRuby {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlRuby) Aria(k string, v interface{}) HTMLRuby {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRuby) Attr(n string, v interface{}) HTMLRuby {
	e.setAttr(n, v)
	return e
}

func (e *htmlRuby) Class(v ...string) HTMLRuby {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlRuby) ContentEditable(v bool) HTMLRuby {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlRuby) DataSet(k string, v interface{}) HTMLRuby {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlRuby) Dir(v string) HTMLRuby {
	e.setAttr("dir", v)
	return e
}

func (e *htmlRuby) Draggable(v bool) HTMLRuby {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlRuby) Hidden(v bool) HTMLRuby {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlRuby) ID(v string) HTMLRuby {
	e.setAttr("id", v)
	return e
}

func (e *htmlRuby) Lang(v string) HTMLRuby {
	e.setAttr("lang", v)
	return e
}

func (e *htmlRuby) Role(v string) HTMLRuby {
	e.setAttr("role", v)
	return e
}

func (e *htmlRuby) Spellcheck(v bool) HTMLRuby {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlRuby) Style(k, v string) HTMLRuby {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlRuby) Styles(s map[string]string) HTMLRuby {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlRuby) TabIndex(v int) HTMLRuby {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlRuby) Title(v string) HTMLRuby {
	e.setAttr("title", v)
	return e
}

func (e *htmlRuby) OnBlur(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlRuby) OnChange(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlRuby) OnClick(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlRuby) OnContextMenu(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlRuby) OnCopy(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlRuby) OnCut(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlRuby) OnDblClick(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlRuby) OnDrag(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlRuby) OnDragEnd(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlRuby) OnDragEnter(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlRuby) OnDragLeave(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlRuby) OnDragOver(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlRuby) OnDragStart(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlRuby) OnDrop(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlRuby) OnFocus(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlRuby) OnInput(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlRuby) OnInvalid(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlRuby) OnKeyDown(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlRuby) OnKeyPress(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlRuby) OnKeyup(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlRuby) OnMouseDown(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlRuby) OnMouseMove(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlRuby) OnMouseOut(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlRuby) OnMouseOver(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlRuby) OnMouseUp(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlRuby) OnPaste(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlRuby) OnReset(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlRuby) OnScroll(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlRuby) OnSearch(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlRuby) OnSelect(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlRuby) OnSubmit(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlRuby) OnWheel(h EventHandler, scope ...interface{}) HTMLRuby {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLS is the interface that describes a <s> HTML element.
type HTMLS interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLS

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLS

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLS

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLS

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLS

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLS

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLS

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLS

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLS

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLS

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLS

	// ID specifies a unique id for an element.
	ID(v string) HTMLS

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLS

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLS

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLS

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLS

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLS

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLS

	// Title specifies extra information about an element.
	Title(v string) HTMLS

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLS

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLS

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLS

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLS

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLS

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLS

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLS

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLS

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLS

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLS

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLS

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLS

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLS

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLS

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLS

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLS

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLS

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLS

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLS

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLS

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLS

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLS

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLS

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLS

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLS

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLS

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLS

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLS

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLS

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLS

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLS

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLS
}

// S returns an HTML element that Defines text that is no longer correct.
func S() HTMLS {
	e := &htmlS{
		elem: elem{
			tag:         "s",
			selfClosing: false,
		},
	}

	return e
}

type htmlS struct {
	elem
}

func (e *htmlS) Body(elems ...UI) HTMLS {
	e.setBody(elems...)
	return e
}

func (e *htmlS) Text(v interface{}) HTMLS {
	return e.Body(Text(v))
}

func (e *htmlS) AccessKey(v string) HTMLS {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlS) Aria(k string, v interface{}) HTMLS {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlS) Attr(n string, v interface{}) HTMLS {
	e.setAttr(n, v)
	return e
}

func (e *htmlS) Class(v ...string) HTMLS {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlS) ContentEditable(v bool) HTMLS {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlS) DataSet(k string, v interface{}) HTMLS {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlS) Dir(v string) HTMLS {
	e.setAttr("dir", v)
	return e
}

func (e *htmlS) Draggable(v bool) HTMLS {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlS) Hidden(v bool) HTMLS {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlS) ID(v string) HTMLS {
	e.setAttr("id", v)
	return e
}

func (e *htmlS) Lang(v string) HTMLS {
	e.setAttr("lang", v)
	return e
}

func (e *htmlS) Role(v string) HTMLS {
	e.setAttr("role", v)
	return e
}

func (e *htmlS) Spellcheck(v bool) HTMLS {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlS) Style(k, v string) HTMLS {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlS) Styles(s map[string]string) HTMLS {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlS) TabIndex(v int) HTMLS {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlS) Title(v string) HTMLS {
	e.setAttr("title", v)
	return e
}

func (e *htmlS) OnBlur(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlS) OnChange(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlS) OnClick(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlS) OnContextMenu(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlS) OnCopy(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlS) OnCut(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlS) OnDblClick(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlS) OnDrag(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlS) OnDragEnd(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlS) OnDragEnter(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlS) OnDragLeave(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlS) OnDragOver(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlS) OnDragStart(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlS) OnDrop(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlS) OnFocus(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlS) OnInput(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlS) OnInvalid(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlS) OnKeyDown(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlS) OnKeyPress(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlS) OnKeyup(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlS) OnMouseDown(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlS) OnMouseMove(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlS) OnMouseOut(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlS) OnMouseOver(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlS) OnMouseUp(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlS) OnPaste(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlS) OnReset(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlS) OnScroll(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlS) OnSearch(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlS) OnSelect(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlS) OnSubmit(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlS) OnWheel(h EventHandler, scope ...interface{}) HTMLS {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSamp is the interface that describes a <samp> HTML element.
type HTMLSamp interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSamp

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSamp

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSamp

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSamp

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSamp

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSamp

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSamp

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSamp

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSamp

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSamp

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSamp

	// ID specifies a unique id for an element.
	ID(v string) HTMLSamp

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSamp

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSamp

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSamp

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSamp

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSamp

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSamp

	// Title specifies extra information about an element.
	Title(v string) HTMLSamp

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSamp

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSamp

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSamp

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSamp

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSamp

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSamp

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSamp

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSamp

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSamp

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSamp

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSamp

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSamp

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSamp

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSamp

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSamp

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSamp

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSamp

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSamp

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSamp

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSamp

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSamp

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSamp

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSamp

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSamp

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSamp
}

// Samp returns an HTML element that defines sample output from a computer program.
func Samp() HTMLSamp {
	e := &htmlSamp{
		elem: elem{
			tag:         "samp",
			selfClosing: false,
		},
	}

	return e
}

type htmlSamp struct {
	elem
}

func (e *htmlSamp) Body(elems ...UI) HTMLSamp {
	e.setBody(elems...)
	return e
}

func (e *htmlSamp) Text(v interface{}) HTMLSamp {
	return e.Body(Text(v))
}

func (e *htmlSamp) AccessKey(v string) HTMLSamp {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSamp) Aria(k string, v interface{}) HTMLSamp {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSamp) Attr(n string, v interface{}) HTMLSamp {
	e.setAttr(n, v)
	return e
}

func (e *htmlSamp) Class(v ...string) HTMLSamp {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSamp) ContentEditable(v bool) HTMLSamp {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSamp) DataSet(k string, v interface{}) HTMLSamp {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSamp) Dir(v string) HTMLSamp {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSamp) Draggable(v bool) HTMLSamp {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSamp) Hidden(v bool) HTMLSamp {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSamp) ID(v string) HTMLSamp {
	e.setAttr("id", v)
	return e
}

func (e *htmlSamp) Lang(v string) HTMLSamp {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSamp) Role(v string) HTMLSamp {
	e.setAttr("role", v)
	return e
}

func (e *htmlSamp) Spellcheck(v bool) HTMLSamp {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSamp) Style(k, v string) HTMLSamp {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSamp) Styles(s map[string]string) HTMLSamp {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSamp) TabIndex(v int) HTMLSamp {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSamp) Title(v string) HTMLSamp {
	e.setAttr("title", v)
	return e
}

func (e *htmlSamp) OnBlur(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSamp) OnChange(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSamp) OnClick(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSamp) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSamp) OnCopy(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSamp) OnCut(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSamp) OnDblClick(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSamp) OnDrag(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSamp) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSamp) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSamp) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSamp) OnDragOver(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSamp) OnDragStart(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSamp) OnDrop(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSamp) OnFocus(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSamp) OnInput(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSamp) OnInvalid(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSamp) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSamp) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSamp) OnKeyup(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSamp) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSamp) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSamp) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSamp) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSamp) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSamp) OnPaste(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSamp) OnReset(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSamp) OnScroll(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSamp) OnSearch(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSamp) OnSelect(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSamp) OnSubmit(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSamp) OnWheel(h EventHandler, scope ...interface{}) HTMLSamp {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLScript is the interface that describes a <script> HTML element.
type HTMLScript interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLScript

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLScript

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLScript

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLScript

	// Async specifies that the script is executed asynchronously (only for external scripts).
	Async(v bool) HTMLScript

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLScript

	// Charset specifies the character encoding.
	Charset(v string) HTMLScript

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLScript

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLScript

	// CrossOrigin sets the mode of the request to an HTTP CORS Request.
	CrossOrigin(v string) HTMLScript

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLScript

	// Defer specifies that the script is executed when the page has finished parsing (only for external scripts).
	Defer(v bool) HTMLScript

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLScript

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLScript

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLScript

	// ID specifies a unique id for an element.
	ID(v string) HTMLScript

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLScript

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLScript

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLScript

	// Src specifies the URL of the media file.
	Src(v string) HTMLScript

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLScript

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLScript

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLScript

	// Title specifies extra information about an element.
	Title(v string) HTMLScript

	// Type specifies the type of element.
	Type(v string) HTMLScript

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLScript
}

// Script returns an HTML element that defines a client-side script.
func Script() HTMLScript {
	e := &htmlScript{
		elem: elem{
			tag:         "script",
			selfClosing: false,
		},
	}

	return e
}

type htmlScript struct {
	elem
}

func (e *htmlScript) Body(elems ...UI) HTMLScript {
	e.setBody(elems...)
	return e
}

func (e *htmlScript) Text(v interface{}) HTMLScript {
	return e.Body(Text(v))
}

func (e *htmlScript) AccessKey(v string) HTMLScript {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlScript) Aria(k string, v interface{}) HTMLScript {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlScript) Async(v bool) HTMLScript {
	e.setAttr("async", v)
	return e
}

func (e *htmlScript) Attr(n string, v interface{}) HTMLScript {
	e.setAttr(n, v)
	return e
}

func (e *htmlScript) Charset(v string) HTMLScript {
	e.setAttr("charset", v)
	return e
}

func (e *htmlScript) Class(v ...string) HTMLScript {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlScript) ContentEditable(v bool) HTMLScript {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlScript) CrossOrigin(v string) HTMLScript {
	e.setAttr("crossorigin", v)
	return e
}

func (e *htmlScript) DataSet(k string, v interface{}) HTMLScript {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlScript) Defer(v bool) HTMLScript {
	e.setAttr("defer", v)
	return e
}

func (e *htmlScript) Dir(v string) HTMLScript {
	e.setAttr("dir", v)
	return e
}

func (e *htmlScript) Draggable(v bool) HTMLScript {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlScript) Hidden(v bool) HTMLScript {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlScript) ID(v string) HTMLScript {
	e.setAttr("id", v)
	return e
}

func (e *htmlScript) Lang(v string) HTMLScript {
	e.setAttr("lang", v)
	return e
}

func (e *htmlScript) Role(v string) HTMLScript {
	e.setAttr("role", v)
	return e
}

func (e *htmlScript) Spellcheck(v bool) HTMLScript {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlScript) Src(v string) HTMLScript {
	e.setAttr("src", v)
	return e
}

func (e *htmlScript) Style(k, v string) HTMLScript {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlScript) Styles(s map[string]string) HTMLScript {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlScript) TabIndex(v int) HTMLScript {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlScript) Title(v string) HTMLScript {
	e.setAttr("title", v)
	return e
}

func (e *htmlScript) Type(v string) HTMLScript {
	e.setAttr("type", v)
	return e
}

func (e *htmlScript) OnLoad(h EventHandler, scope ...interface{}) HTMLScript {
	e.setEventHandler("load", h, scope...)
	return e
}

// HTMLSection is the interface that describes a <section> HTML element.
type HTMLSection interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSection

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSection

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSection

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSection

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSection

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSection

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSection

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSection

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSection

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSection

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSection

	// ID specifies a unique id for an element.
	ID(v string) HTMLSection

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSection

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSection

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSection

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSection

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSection

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSection

	// Title specifies extra information about an element.
	Title(v string) HTMLSection

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSection

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSection

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSection

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSection

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSection

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSection

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSection

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSection

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSection

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSection

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSection

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSection

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSection

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSection

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSection

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSection

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSection

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSection

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSection

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSection

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSection

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSection

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSection

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSection

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSection

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSection

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSection

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSection

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSection

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSection

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSection

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSection
}

// Section returns an HTML element that defines a section in a document.
func Section() HTMLSection {
	e := &htmlSection{
		elem: elem{
			tag:         "section",
			selfClosing: false,
		},
	}

	return e
}

type htmlSection struct {
	elem
}

func (e *htmlSection) Body(elems ...UI) HTMLSection {
	e.setBody(elems...)
	return e
}

func (e *htmlSection) Text(v interface{}) HTMLSection {
	return e.Body(Text(v))
}

func (e *htmlSection) AccessKey(v string) HTMLSection {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSection) Aria(k string, v interface{}) HTMLSection {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSection) Attr(n string, v interface{}) HTMLSection {
	e.setAttr(n, v)
	return e
}

func (e *htmlSection) Class(v ...string) HTMLSection {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSection) ContentEditable(v bool) HTMLSection {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSection) DataSet(k string, v interface{}) HTMLSection {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSection) Dir(v string) HTMLSection {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSection) Draggable(v bool) HTMLSection {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSection) Hidden(v bool) HTMLSection {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSection) ID(v string) HTMLSection {
	e.setAttr("id", v)
	return e
}

func (e *htmlSection) Lang(v string) HTMLSection {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSection) Role(v string) HTMLSection {
	e.setAttr("role", v)
	return e
}

func (e *htmlSection) Spellcheck(v bool) HTMLSection {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSection) Style(k, v string) HTMLSection {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSection) Styles(s map[string]string) HTMLSection {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSection) TabIndex(v int) HTMLSection {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSection) Title(v string) HTMLSection {
	e.setAttr("title", v)
	return e
}

func (e *htmlSection) OnBlur(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSection) OnChange(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSection) OnClick(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSection) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSection) OnCopy(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSection) OnCut(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSection) OnDblClick(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSection) OnDrag(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSection) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSection) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSection) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSection) OnDragOver(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSection) OnDragStart(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSection) OnDrop(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSection) OnFocus(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSection) OnInput(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSection) OnInvalid(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSection) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSection) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSection) OnKeyup(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSection) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSection) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSection) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSection) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSection) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSection) OnPaste(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSection) OnReset(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSection) OnScroll(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSection) OnSearch(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSection) OnSelect(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSection) OnSubmit(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSection) OnWheel(h EventHandler, scope ...interface{}) HTMLSection {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSelect is the interface that describes a <select> HTML element.
type HTMLSelect interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSelect

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSelect

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSelect

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSelect

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSelect

	// AutoFocus specifies that the element should automatically get focus when the page loads.
	AutoFocus(v bool) HTMLSelect

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSelect

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSelect

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSelect

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSelect

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLSelect

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSelect

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLSelect

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSelect

	// ID specifies a unique id for an element.
	ID(v string) HTMLSelect

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSelect

	// Multiple specifies that a user can enter more than one value.
	Multiple(v bool) HTMLSelect

	// Name specifies the name of the element.
	Name(v string) HTMLSelect

	// Required specifies that the element must be filled out before submitting the form.
	Required(v bool) HTMLSelect

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSelect

	// Size specifies the width.
	Size(v int) HTMLSelect

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSelect

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSelect

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSelect

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSelect

	// Title specifies extra information about an element.
	Title(v string) HTMLSelect

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSelect

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSelect

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSelect

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSelect

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSelect

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSelect

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSelect

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSelect

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSelect

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSelect

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSelect

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSelect

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSelect

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSelect

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSelect

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSelect

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSelect

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSelect

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSelect

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSelect

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSelect

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSelect

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSelect

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSelect

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSelect
}

// Select returns an HTML element that defines a drop-down list.
func Select() HTMLSelect {
	e := &htmlSelect{
		elem: elem{
			tag:         "select",
			selfClosing: false,
		},
	}

	return e
}

type htmlSelect struct {
	elem
}

func (e *htmlSelect) Body(elems ...UI) HTMLSelect {
	e.setBody(elems...)
	return e
}

func (e *htmlSelect) Text(v interface{}) HTMLSelect {
	return e.Body(Text(v))
}

func (e *htmlSelect) AccessKey(v string) HTMLSelect {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSelect) Aria(k string, v interface{}) HTMLSelect {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSelect) Attr(n string, v interface{}) HTMLSelect {
	e.setAttr(n, v)
	return e
}

func (e *htmlSelect) AutoFocus(v bool) HTMLSelect {
	e.setAttr("autofocus", v)
	return e
}

func (e *htmlSelect) Class(v ...string) HTMLSelect {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSelect) ContentEditable(v bool) HTMLSelect {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSelect) DataSet(k string, v interface{}) HTMLSelect {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSelect) Dir(v string) HTMLSelect {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSelect) Disabled(v bool) HTMLSelect {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlSelect) Draggable(v bool) HTMLSelect {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSelect) Form(v string) HTMLSelect {
	e.setAttr("form", v)
	return e
}

func (e *htmlSelect) Hidden(v bool) HTMLSelect {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSelect) ID(v string) HTMLSelect {
	e.setAttr("id", v)
	return e
}

func (e *htmlSelect) Lang(v string) HTMLSelect {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSelect) Multiple(v bool) HTMLSelect {
	e.setAttr("multiple", v)
	return e
}

func (e *htmlSelect) Name(v string) HTMLSelect {
	e.setAttr("name", v)
	return e
}

func (e *htmlSelect) Required(v bool) HTMLSelect {
	e.setAttr("required", v)
	return e
}

func (e *htmlSelect) Role(v string) HTMLSelect {
	e.setAttr("role", v)
	return e
}

func (e *htmlSelect) Size(v int) HTMLSelect {
	e.setAttr("size", v)
	return e
}

func (e *htmlSelect) Spellcheck(v bool) HTMLSelect {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSelect) Style(k, v string) HTMLSelect {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSelect) Styles(s map[string]string) HTMLSelect {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSelect) TabIndex(v int) HTMLSelect {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSelect) Title(v string) HTMLSelect {
	e.setAttr("title", v)
	return e
}

func (e *htmlSelect) OnBlur(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSelect) OnChange(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSelect) OnClick(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSelect) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSelect) OnCopy(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSelect) OnCut(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSelect) OnDblClick(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSelect) OnDrag(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSelect) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSelect) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSelect) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSelect) OnDragOver(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSelect) OnDragStart(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSelect) OnDrop(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSelect) OnFocus(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSelect) OnInput(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSelect) OnInvalid(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSelect) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSelect) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSelect) OnKeyup(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSelect) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSelect) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSelect) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSelect) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSelect) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSelect) OnPaste(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSelect) OnReset(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSelect) OnScroll(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSelect) OnSearch(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSelect) OnSelect(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSelect) OnSubmit(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSelect) OnWheel(h EventHandler, scope ...interface{}) HTMLSelect {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSmall is the interface that describes a <small> HTML element.
type HTMLSmall interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSmall

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSmall

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSmall

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSmall

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSmall

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSmall

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSmall

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSmall

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSmall

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSmall

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSmall

	// ID specifies a unique id for an element.
	ID(v string) HTMLSmall

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSmall

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSmall

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSmall

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSmall

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSmall

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSmall

	// Title specifies extra information about an element.
	Title(v string) HTMLSmall

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSmall

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSmall

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSmall

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSmall

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSmall

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSmall

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSmall

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSmall

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSmall

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSmall

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSmall

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSmall

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSmall

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSmall

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSmall

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSmall

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSmall

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSmall

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSmall

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSmall

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSmall

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSmall

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSmall

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSmall

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSmall
}

// Small returns an HTML element that defines smaller text.
func Small() HTMLSmall {
	e := &htmlSmall{
		elem: elem{
			tag:         "small",
			selfClosing: false,
		},
	}

	return e
}

type htmlSmall struct {
	elem
}

func (e *htmlSmall) Body(elems ...UI) HTMLSmall {
	e.setBody(elems...)
	return e
}

func (e *htmlSmall) Text(v interface{}) HTMLSmall {
	return e.Body(Text(v))
}

func (e *htmlSmall) AccessKey(v string) HTMLSmall {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSmall) Aria(k string, v interface{}) HTMLSmall {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSmall) Attr(n string, v interface{}) HTMLSmall {
	e.setAttr(n, v)
	return e
}

func (e *htmlSmall) Class(v ...string) HTMLSmall {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSmall) ContentEditable(v bool) HTMLSmall {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSmall) DataSet(k string, v interface{}) HTMLSmall {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSmall) Dir(v string) HTMLSmall {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSmall) Draggable(v bool) HTMLSmall {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSmall) Hidden(v bool) HTMLSmall {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSmall) ID(v string) HTMLSmall {
	e.setAttr("id", v)
	return e
}

func (e *htmlSmall) Lang(v string) HTMLSmall {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSmall) Role(v string) HTMLSmall {
	e.setAttr("role", v)
	return e
}

func (e *htmlSmall) Spellcheck(v bool) HTMLSmall {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSmall) Style(k, v string) HTMLSmall {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSmall) Styles(s map[string]string) HTMLSmall {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSmall) TabIndex(v int) HTMLSmall {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSmall) Title(v string) HTMLSmall {
	e.setAttr("title", v)
	return e
}

func (e *htmlSmall) OnBlur(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSmall) OnChange(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSmall) OnClick(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSmall) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSmall) OnCopy(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSmall) OnCut(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSmall) OnDblClick(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSmall) OnDrag(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSmall) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSmall) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSmall) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSmall) OnDragOver(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSmall) OnDragStart(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSmall) OnDrop(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSmall) OnFocus(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSmall) OnInput(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSmall) OnInvalid(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSmall) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSmall) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSmall) OnKeyup(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSmall) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSmall) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSmall) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSmall) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSmall) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSmall) OnPaste(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSmall) OnReset(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSmall) OnScroll(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSmall) OnSearch(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSmall) OnSelect(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSmall) OnSubmit(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSmall) OnWheel(h EventHandler, scope ...interface{}) HTMLSmall {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSource is the interface that describes a <source> HTML element.
type HTMLSource interface {
	UI

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSource

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSource

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSource

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSource

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSource

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSource

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSource

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSource

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSource

	// ID specifies a unique id for an element.
	ID(v string) HTMLSource

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSource

	// Media specifies what media/device the linked document is optimized for.
	Media(v string) HTMLSource

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSource

	// Sizes specifies the size of the linked resource.
	Sizes(v string) HTMLSource

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSource

	// Src specifies the URL of the media file.
	Src(v string) HTMLSource

	// SrcSet specifies the URL of the image to use in different situations.
	SrcSet(v string) HTMLSource

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSource

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSource

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSource

	// Title specifies extra information about an element.
	Title(v string) HTMLSource

	// Type specifies the type of element.
	Type(v string) HTMLSource

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSource

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSource

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSource

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSource

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSource

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSource

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSource

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSource

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSource

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSource

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSource

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSource

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSource

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSource

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSource

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSource

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSource

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSource

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSource

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSource

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSource

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSource

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSource

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSource

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSource

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSource

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSource

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSource

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSource

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSource

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSource

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSource
}

// Source returns an HTML element that .
func Source() HTMLSource {
	e := &htmlSource{
		elem: elem{
			tag:         "source",
			selfClosing: true,
		},
	}

	return e
}

type htmlSource struct {
	elem
}

func (e *htmlSource) AccessKey(v string) HTMLSource {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSource) Aria(k string, v interface{}) HTMLSource {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSource) Attr(n string, v interface{}) HTMLSource {
	e.setAttr(n, v)
	return e
}

func (e *htmlSource) Class(v ...string) HTMLSource {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSource) ContentEditable(v bool) HTMLSource {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSource) DataSet(k string, v interface{}) HTMLSource {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSource) Dir(v string) HTMLSource {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSource) Draggable(v bool) HTMLSource {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSource) Hidden(v bool) HTMLSource {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSource) ID(v string) HTMLSource {
	e.setAttr("id", v)
	return e
}

func (e *htmlSource) Lang(v string) HTMLSource {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSource) Media(v string) HTMLSource {
	e.setAttr("media", v)
	return e
}

func (e *htmlSource) Role(v string) HTMLSource {
	e.setAttr("role", v)
	return e
}

func (e *htmlSource) Sizes(v string) HTMLSource {
	e.setAttr("sizes", v)
	return e
}

func (e *htmlSource) Spellcheck(v bool) HTMLSource {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSource) Src(v string) HTMLSource {
	e.setAttr("src", v)
	return e
}

func (e *htmlSource) SrcSet(v string) HTMLSource {
	e.setAttr("srcset", v)
	return e
}

func (e *htmlSource) Style(k, v string) HTMLSource {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSource) Styles(s map[string]string) HTMLSource {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSource) TabIndex(v int) HTMLSource {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSource) Title(v string) HTMLSource {
	e.setAttr("title", v)
	return e
}

func (e *htmlSource) Type(v string) HTMLSource {
	e.setAttr("type", v)
	return e
}

func (e *htmlSource) OnBlur(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSource) OnChange(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSource) OnClick(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSource) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSource) OnCopy(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSource) OnCut(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSource) OnDblClick(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSource) OnDrag(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSource) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSource) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSource) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSource) OnDragOver(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSource) OnDragStart(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSource) OnDrop(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSource) OnFocus(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSource) OnInput(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSource) OnInvalid(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSource) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSource) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSource) OnKeyup(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSource) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSource) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSource) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSource) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSource) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSource) OnPaste(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSource) OnReset(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSource) OnScroll(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSource) OnSearch(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSource) OnSelect(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSource) OnSubmit(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSource) OnWheel(h EventHandler, scope ...interface{}) HTMLSource {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSpan is the interface that describes a <span> HTML element.
type HTMLSpan interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSpan

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSpan

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSpan

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSpan

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSpan

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSpan

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSpan

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSpan

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSpan

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSpan

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSpan

	// ID specifies a unique id for an element.
	ID(v string) HTMLSpan

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSpan

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSpan

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSpan

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSpan

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSpan

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSpan

	// Title specifies extra information about an element.
	Title(v string) HTMLSpan

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSpan

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSpan

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSpan

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSpan

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSpan

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSpan

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSpan

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSpan

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSpan

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSpan

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSpan

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSpan

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSpan

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSpan

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSpan

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSpan

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSpan

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSpan

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSpan

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSpan

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSpan

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSpan

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSpan

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSpan

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSpan
}

// Span returns an HTML element that defines a section in a document.
func Span() HTMLSpan {
	e := &htmlSpan{
		elem: elem{
			tag:         "span",
			selfClosing: false,
		},
	}

	return e
}

type htmlSpan struct {
	elem
}

func (e *htmlSpan) Body(elems ...UI) HTMLSpan {
	e.setBody(elems...)
	return e
}

func (e *htmlSpan) Text(v interface{}) HTMLSpan {
	return e.Body(Text(v))
}

func (e *htmlSpan) AccessKey(v string) HTMLSpan {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSpan) Aria(k string, v interface{}) HTMLSpan {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSpan) Attr(n string, v interface{}) HTMLSpan {
	e.setAttr(n, v)
	return e
}

func (e *htmlSpan) Class(v ...string) HTMLSpan {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSpan) ContentEditable(v bool) HTMLSpan {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSpan) DataSet(k string, v interface{}) HTMLSpan {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSpan) Dir(v string) HTMLSpan {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSpan) Draggable(v bool) HTMLSpan {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSpan) Hidden(v bool) HTMLSpan {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSpan) ID(v string) HTMLSpan {
	e.setAttr("id", v)
	return e
}

func (e *htmlSpan) Lang(v string) HTMLSpan {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSpan) Role(v string) HTMLSpan {
	e.setAttr("role", v)
	return e
}

func (e *htmlSpan) Spellcheck(v bool) HTMLSpan {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSpan) Style(k, v string) HTMLSpan {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSpan) Styles(s map[string]string) HTMLSpan {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSpan) TabIndex(v int) HTMLSpan {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSpan) Title(v string) HTMLSpan {
	e.setAttr("title", v)
	return e
}

func (e *htmlSpan) OnBlur(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSpan) OnChange(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSpan) OnClick(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSpan) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSpan) OnCopy(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSpan) OnCut(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSpan) OnDblClick(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSpan) OnDrag(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSpan) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSpan) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSpan) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSpan) OnDragOver(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSpan) OnDragStart(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSpan) OnDrop(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSpan) OnFocus(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSpan) OnInput(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSpan) OnInvalid(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSpan) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSpan) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSpan) OnKeyup(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSpan) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSpan) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSpan) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSpan) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSpan) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSpan) OnPaste(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSpan) OnReset(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSpan) OnScroll(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSpan) OnSearch(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSpan) OnSelect(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSpan) OnSubmit(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSpan) OnWheel(h EventHandler, scope ...interface{}) HTMLSpan {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLStrong is the interface that describes a <strong> HTML element.
type HTMLStrong interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLStrong

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLStrong

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLStrong

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLStrong

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLStrong

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLStrong

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLStrong

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLStrong

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLStrong

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLStrong

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLStrong

	// ID specifies a unique id for an element.
	ID(v string) HTMLStrong

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLStrong

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLStrong

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLStrong

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLStrong

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLStrong

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLStrong

	// Title specifies extra information about an element.
	Title(v string) HTMLStrong

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLStrong

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLStrong

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLStrong

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLStrong

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLStrong

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLStrong

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLStrong

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLStrong

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLStrong

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLStrong

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLStrong

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLStrong

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLStrong

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLStrong

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLStrong

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLStrong

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLStrong

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLStrong

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLStrong

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLStrong

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLStrong

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLStrong

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLStrong

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLStrong

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLStrong
}

// Strong returns an HTML element that defines important text.
func Strong() HTMLStrong {
	e := &htmlStrong{
		elem: elem{
			tag:         "strong",
			selfClosing: false,
		},
	}

	return e
}

type htmlStrong struct {
	elem
}

func (e *htmlStrong) Body(elems ...UI) HTMLStrong {
	e.setBody(elems...)
	return e
}

func (e *htmlStrong) Text(v interface{}) HTMLStrong {
	return e.Body(Text(v))
}

func (e *htmlStrong) AccessKey(v string) HTMLStrong {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlStrong) Aria(k string, v interface{}) HTMLStrong {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlStrong) Attr(n string, v interface{}) HTMLStrong {
	e.setAttr(n, v)
	return e
}

func (e *htmlStrong) Class(v ...string) HTMLStrong {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlStrong) ContentEditable(v bool) HTMLStrong {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlStrong) DataSet(k string, v interface{}) HTMLStrong {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlStrong) Dir(v string) HTMLStrong {
	e.setAttr("dir", v)
	return e
}

func (e *htmlStrong) Draggable(v bool) HTMLStrong {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlStrong) Hidden(v bool) HTMLStrong {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlStrong) ID(v string) HTMLStrong {
	e.setAttr("id", v)
	return e
}

func (e *htmlStrong) Lang(v string) HTMLStrong {
	e.setAttr("lang", v)
	return e
}

func (e *htmlStrong) Role(v string) HTMLStrong {
	e.setAttr("role", v)
	return e
}

func (e *htmlStrong) Spellcheck(v bool) HTMLStrong {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlStrong) Style(k, v string) HTMLStrong {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlStrong) Styles(s map[string]string) HTMLStrong {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlStrong) TabIndex(v int) HTMLStrong {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlStrong) Title(v string) HTMLStrong {
	e.setAttr("title", v)
	return e
}

func (e *htmlStrong) OnBlur(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlStrong) OnChange(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlStrong) OnClick(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlStrong) OnContextMenu(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlStrong) OnCopy(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlStrong) OnCut(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlStrong) OnDblClick(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlStrong) OnDrag(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlStrong) OnDragEnd(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlStrong) OnDragEnter(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlStrong) OnDragLeave(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlStrong) OnDragOver(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlStrong) OnDragStart(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlStrong) OnDrop(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlStrong) OnFocus(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlStrong) OnInput(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlStrong) OnInvalid(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlStrong) OnKeyDown(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlStrong) OnKeyPress(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlStrong) OnKeyup(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlStrong) OnMouseDown(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlStrong) OnMouseMove(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlStrong) OnMouseOut(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlStrong) OnMouseOver(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlStrong) OnMouseUp(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlStrong) OnPaste(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlStrong) OnReset(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlStrong) OnScroll(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlStrong) OnSearch(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlStrong) OnSelect(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlStrong) OnSubmit(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlStrong) OnWheel(h EventHandler, scope ...interface{}) HTMLStrong {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLStyle is the interface that describes a <style> HTML element.
type HTMLStyle interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLStyle

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLStyle

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLStyle

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLStyle

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLStyle

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLStyle

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLStyle

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLStyle

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLStyle

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLStyle

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLStyle

	// ID specifies a unique id for an element.
	ID(v string) HTMLStyle

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLStyle

	// Media specifies what media/device the linked document is optimized for.
	Media(v string) HTMLStyle

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLStyle

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLStyle

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLStyle

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLStyle

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLStyle

	// Title specifies extra information about an element.
	Title(v string) HTMLStyle

	// Type specifies the type of element.
	Type(v string) HTMLStyle

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLStyle

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLStyle

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLStyle

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLStyle

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLStyle

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLStyle

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLStyle

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLStyle

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLStyle

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLStyle

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLStyle

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLStyle

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLStyle

	// OnLoad calls the given handler after the element is finished loading.
	OnLoad(h EventHandler, scope ...interface{}) HTMLStyle

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLStyle

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLStyle

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLStyle

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLStyle

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLStyle

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLStyle

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLStyle

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLStyle

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLStyle

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLStyle

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLStyle

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLStyle
}

// Style returns an HTML element that defines style information for a document.
func Style() HTMLStyle {
	e := &htmlStyle{
		elem: elem{
			tag:         "style",
			selfClosing: false,
		},
	}

	return e
}

type htmlStyle struct {
	elem
}

func (e *htmlStyle) Body(elems ...UI) HTMLStyle {
	e.setBody(elems...)
	return e
}

func (e *htmlStyle) Text(v interface{}) HTMLStyle {
	return e.Body(Text(v))
}

func (e *htmlStyle) AccessKey(v string) HTMLStyle {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlStyle) Aria(k string, v interface{}) HTMLStyle {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlStyle) Attr(n string, v interface{}) HTMLStyle {
	e.setAttr(n, v)
	return e
}

func (e *htmlStyle) Class(v ...string) HTMLStyle {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlStyle) ContentEditable(v bool) HTMLStyle {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlStyle) DataSet(k string, v interface{}) HTMLStyle {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlStyle) Dir(v string) HTMLStyle {
	e.setAttr("dir", v)
	return e
}

func (e *htmlStyle) Draggable(v bool) HTMLStyle {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlStyle) Hidden(v bool) HTMLStyle {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlStyle) ID(v string) HTMLStyle {
	e.setAttr("id", v)
	return e
}

func (e *htmlStyle) Lang(v string) HTMLStyle {
	e.setAttr("lang", v)
	return e
}

func (e *htmlStyle) Media(v string) HTMLStyle {
	e.setAttr("media", v)
	return e
}

func (e *htmlStyle) Role(v string) HTMLStyle {
	e.setAttr("role", v)
	return e
}

func (e *htmlStyle) Spellcheck(v bool) HTMLStyle {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlStyle) Style(k, v string) HTMLStyle {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlStyle) Styles(s map[string]string) HTMLStyle {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlStyle) TabIndex(v int) HTMLStyle {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlStyle) Title(v string) HTMLStyle {
	e.setAttr("title", v)
	return e
}

func (e *htmlStyle) Type(v string) HTMLStyle {
	e.setAttr("type", v)
	return e
}

func (e *htmlStyle) OnBlur(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlStyle) OnChange(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlStyle) OnClick(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlStyle) OnContextMenu(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlStyle) OnCopy(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlStyle) OnCut(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlStyle) OnDblClick(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlStyle) OnDrag(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlStyle) OnDragEnd(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlStyle) OnDragEnter(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlStyle) OnDragLeave(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlStyle) OnDragOver(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlStyle) OnDragStart(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlStyle) OnDrop(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlStyle) OnFocus(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlStyle) OnInput(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlStyle) OnInvalid(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlStyle) OnKeyDown(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlStyle) OnKeyPress(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlStyle) OnKeyup(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlStyle) OnLoad(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("load", h, scope...)
	return e
}

func (e *htmlStyle) OnMouseDown(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlStyle) OnMouseMove(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlStyle) OnMouseOut(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlStyle) OnMouseOver(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlStyle) OnMouseUp(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlStyle) OnPaste(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlStyle) OnReset(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlStyle) OnScroll(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlStyle) OnSearch(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlStyle) OnSelect(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlStyle) OnSubmit(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlStyle) OnWheel(h EventHandler, scope ...interface{}) HTMLStyle {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSub is the interface that describes a <sub> HTML element.
type HTMLSub interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSub

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSub

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSub

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSub

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSub

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSub

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSub

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSub

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSub

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSub

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSub

	// ID specifies a unique id for an element.
	ID(v string) HTMLSub

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSub

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSub

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSub

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSub

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSub

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSub

	// Title specifies extra information about an element.
	Title(v string) HTMLSub

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSub

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSub

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSub

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSub

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSub

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSub

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSub

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSub

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSub

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSub

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSub

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSub

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSub

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSub

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSub

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSub

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSub

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSub

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSub

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSub

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSub

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSub

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSub

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSub

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSub

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSub

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSub

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSub

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSub

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSub

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSub

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSub
}

// Sub returns an HTML element that defines subscripted text.
func Sub() HTMLSub {
	e := &htmlSub{
		elem: elem{
			tag:         "sub",
			selfClosing: false,
		},
	}

	return e
}

type htmlSub struct {
	elem
}

func (e *htmlSub) Body(elems ...UI) HTMLSub {
	e.setBody(elems...)
	return e
}

func (e *htmlSub) Text(v interface{}) HTMLSub {
	return e.Body(Text(v))
}

func (e *htmlSub) AccessKey(v string) HTMLSub {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSub) Aria(k string, v interface{}) HTMLSub {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSub) Attr(n string, v interface{}) HTMLSub {
	e.setAttr(n, v)
	return e
}

func (e *htmlSub) Class(v ...string) HTMLSub {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSub) ContentEditable(v bool) HTMLSub {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSub) DataSet(k string, v interface{}) HTMLSub {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSub) Dir(v string) HTMLSub {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSub) Draggable(v bool) HTMLSub {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSub) Hidden(v bool) HTMLSub {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSub) ID(v string) HTMLSub {
	e.setAttr("id", v)
	return e
}

func (e *htmlSub) Lang(v string) HTMLSub {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSub) Role(v string) HTMLSub {
	e.setAttr("role", v)
	return e
}

func (e *htmlSub) Spellcheck(v bool) HTMLSub {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSub) Style(k, v string) HTMLSub {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSub) Styles(s map[string]string) HTMLSub {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSub) TabIndex(v int) HTMLSub {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSub) Title(v string) HTMLSub {
	e.setAttr("title", v)
	return e
}

func (e *htmlSub) OnBlur(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSub) OnChange(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSub) OnClick(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSub) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSub) OnCopy(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSub) OnCut(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSub) OnDblClick(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSub) OnDrag(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSub) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSub) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSub) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSub) OnDragOver(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSub) OnDragStart(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSub) OnDrop(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSub) OnFocus(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSub) OnInput(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSub) OnInvalid(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSub) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSub) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSub) OnKeyup(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSub) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSub) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSub) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSub) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSub) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSub) OnPaste(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSub) OnReset(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSub) OnScroll(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSub) OnSearch(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSub) OnSelect(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSub) OnSubmit(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSub) OnWheel(h EventHandler, scope ...interface{}) HTMLSub {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSummary is the interface that describes a <summary> HTML element.
type HTMLSummary interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSummary

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSummary

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSummary

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSummary

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSummary

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSummary

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSummary

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSummary

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSummary

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSummary

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSummary

	// ID specifies a unique id for an element.
	ID(v string) HTMLSummary

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSummary

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSummary

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSummary

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSummary

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSummary

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSummary

	// Title specifies extra information about an element.
	Title(v string) HTMLSummary

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSummary

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSummary

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSummary

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSummary

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSummary

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSummary

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSummary

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSummary

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSummary

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSummary

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSummary

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSummary

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSummary

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSummary

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSummary

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSummary

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSummary

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSummary

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSummary

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSummary

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSummary

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSummary

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSummary

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSummary

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSummary
}

// Summary returns an HTML element that defines a visible heading for a details element.
func Summary() HTMLSummary {
	e := &htmlSummary{
		elem: elem{
			tag:         "summary",
			selfClosing: false,
		},
	}

	return e
}

type htmlSummary struct {
	elem
}

func (e *htmlSummary) Body(elems ...UI) HTMLSummary {
	e.setBody(elems...)
	return e
}

func (e *htmlSummary) Text(v interface{}) HTMLSummary {
	return e.Body(Text(v))
}

func (e *htmlSummary) AccessKey(v string) HTMLSummary {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSummary) Aria(k string, v interface{}) HTMLSummary {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSummary) Attr(n string, v interface{}) HTMLSummary {
	e.setAttr(n, v)
	return e
}

func (e *htmlSummary) Class(v ...string) HTMLSummary {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSummary) ContentEditable(v bool) HTMLSummary {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSummary) DataSet(k string, v interface{}) HTMLSummary {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSummary) Dir(v string) HTMLSummary {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSummary) Draggable(v bool) HTMLSummary {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSummary) Hidden(v bool) HTMLSummary {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSummary) ID(v string) HTMLSummary {
	e.setAttr("id", v)
	return e
}

func (e *htmlSummary) Lang(v string) HTMLSummary {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSummary) Role(v string) HTMLSummary {
	e.setAttr("role", v)
	return e
}

func (e *htmlSummary) Spellcheck(v bool) HTMLSummary {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSummary) Style(k, v string) HTMLSummary {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSummary) Styles(s map[string]string) HTMLSummary {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSummary) TabIndex(v int) HTMLSummary {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSummary) Title(v string) HTMLSummary {
	e.setAttr("title", v)
	return e
}

func (e *htmlSummary) OnBlur(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSummary) OnChange(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSummary) OnClick(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSummary) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSummary) OnCopy(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSummary) OnCut(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSummary) OnDblClick(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSummary) OnDrag(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSummary) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSummary) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSummary) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSummary) OnDragOver(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSummary) OnDragStart(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSummary) OnDrop(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSummary) OnFocus(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSummary) OnInput(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSummary) OnInvalid(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSummary) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSummary) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSummary) OnKeyup(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSummary) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSummary) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSummary) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSummary) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSummary) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSummary) OnPaste(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSummary) OnReset(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSummary) OnScroll(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSummary) OnSearch(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSummary) OnSelect(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSummary) OnSubmit(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSummary) OnWheel(h EventHandler, scope ...interface{}) HTMLSummary {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLSup is the interface that describes a <sup> HTML element.
type HTMLSup interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLSup

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLSup

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLSup

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLSup

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLSup

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLSup

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLSup

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLSup

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLSup

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLSup

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLSup

	// ID specifies a unique id for an element.
	ID(v string) HTMLSup

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLSup

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLSup

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLSup

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLSup

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLSup

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLSup

	// Title specifies extra information about an element.
	Title(v string) HTMLSup

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLSup

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLSup

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLSup

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLSup

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLSup

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLSup

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLSup

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLSup

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLSup

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLSup

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLSup

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLSup

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLSup

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLSup

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLSup

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLSup

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLSup

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLSup

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLSup

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLSup

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLSup

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLSup

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLSup

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLSup

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLSup

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLSup

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLSup

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLSup

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLSup

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLSup

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLSup

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLSup
}

// Sup returns an HTML element that defines superscripted text.
func Sup() HTMLSup {
	e := &htmlSup{
		elem: elem{
			tag:         "sup",
			selfClosing: false,
		},
	}

	return e
}

type htmlSup struct {
	elem
}

func (e *htmlSup) Body(elems ...UI) HTMLSup {
	e.setBody(elems...)
	return e
}

func (e *htmlSup) Text(v interface{}) HTMLSup {
	return e.Body(Text(v))
}

func (e *htmlSup) AccessKey(v string) HTMLSup {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlSup) Aria(k string, v interface{}) HTMLSup {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSup) Attr(n string, v interface{}) HTMLSup {
	e.setAttr(n, v)
	return e
}

func (e *htmlSup) Class(v ...string) HTMLSup {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlSup) ContentEditable(v bool) HTMLSup {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlSup) DataSet(k string, v interface{}) HTMLSup {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlSup) Dir(v string) HTMLSup {
	e.setAttr("dir", v)
	return e
}

func (e *htmlSup) Draggable(v bool) HTMLSup {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlSup) Hidden(v bool) HTMLSup {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlSup) ID(v string) HTMLSup {
	e.setAttr("id", v)
	return e
}

func (e *htmlSup) Lang(v string) HTMLSup {
	e.setAttr("lang", v)
	return e
}

func (e *htmlSup) Role(v string) HTMLSup {
	e.setAttr("role", v)
	return e
}

func (e *htmlSup) Spellcheck(v bool) HTMLSup {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlSup) Style(k, v string) HTMLSup {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlSup) Styles(s map[string]string) HTMLSup {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlSup) TabIndex(v int) HTMLSup {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlSup) Title(v string) HTMLSup {
	e.setAttr("title", v)
	return e
}

func (e *htmlSup) OnBlur(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlSup) OnChange(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlSup) OnClick(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlSup) OnContextMenu(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlSup) OnCopy(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlSup) OnCut(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlSup) OnDblClick(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlSup) OnDrag(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlSup) OnDragEnd(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlSup) OnDragEnter(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlSup) OnDragLeave(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlSup) OnDragOver(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlSup) OnDragStart(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlSup) OnDrop(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlSup) OnFocus(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlSup) OnInput(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlSup) OnInvalid(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlSup) OnKeyDown(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlSup) OnKeyPress(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlSup) OnKeyup(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlSup) OnMouseDown(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlSup) OnMouseMove(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlSup) OnMouseOut(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlSup) OnMouseOver(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlSup) OnMouseUp(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlSup) OnPaste(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlSup) OnReset(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlSup) OnScroll(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlSup) OnSearch(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlSup) OnSelect(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlSup) OnSubmit(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlSup) OnWheel(h EventHandler, scope ...interface{}) HTMLSup {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTable is the interface that describes a <table> HTML element.
type HTMLTable interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTable

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTable

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTable

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTable

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTable

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTable

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTable

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTable

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTable

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTable

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTable

	// ID specifies a unique id for an element.
	ID(v string) HTMLTable

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTable

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTable

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTable

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTable

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTable

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTable

	// Title specifies extra information about an element.
	Title(v string) HTMLTable

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTable

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTable

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTable

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTable

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTable

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTable

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTable

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTable

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTable

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTable

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTable

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTable

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTable

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTable

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTable

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTable

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTable

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTable

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTable

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTable

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTable

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTable

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTable

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTable

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTable

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTable

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTable

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTable

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTable

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTable

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTable

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTable
}

// Table returns an HTML element that defines a table.
func Table() HTMLTable {
	e := &htmlTable{
		elem: elem{
			tag:         "table",
			selfClosing: false,
		},
	}

	return e
}

type htmlTable struct {
	elem
}

func (e *htmlTable) Body(elems ...UI) HTMLTable {
	e.setBody(elems...)
	return e
}

func (e *htmlTable) Text(v interface{}) HTMLTable {
	return e.Body(Text(v))
}

func (e *htmlTable) AccessKey(v string) HTMLTable {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTable) Aria(k string, v interface{}) HTMLTable {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTable) Attr(n string, v interface{}) HTMLTable {
	e.setAttr(n, v)
	return e
}

func (e *htmlTable) Class(v ...string) HTMLTable {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTable) ContentEditable(v bool) HTMLTable {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTable) DataSet(k string, v interface{}) HTMLTable {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTable) Dir(v string) HTMLTable {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTable) Draggable(v bool) HTMLTable {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTable) Hidden(v bool) HTMLTable {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTable) ID(v string) HTMLTable {
	e.setAttr("id", v)
	return e
}

func (e *htmlTable) Lang(v string) HTMLTable {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTable) Role(v string) HTMLTable {
	e.setAttr("role", v)
	return e
}

func (e *htmlTable) Spellcheck(v bool) HTMLTable {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTable) Style(k, v string) HTMLTable {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTable) Styles(s map[string]string) HTMLTable {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTable) TabIndex(v int) HTMLTable {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTable) Title(v string) HTMLTable {
	e.setAttr("title", v)
	return e
}

func (e *htmlTable) OnBlur(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTable) OnChange(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTable) OnClick(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTable) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTable) OnCopy(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTable) OnCut(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTable) OnDblClick(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTable) OnDrag(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTable) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTable) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTable) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTable) OnDragOver(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTable) OnDragStart(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTable) OnDrop(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTable) OnFocus(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTable) OnInput(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTable) OnInvalid(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTable) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTable) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTable) OnKeyup(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTable) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTable) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTable) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTable) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTable) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTable) OnPaste(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTable) OnReset(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTable) OnScroll(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTable) OnSearch(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTable) OnSelect(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTable) OnSubmit(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTable) OnWheel(h EventHandler, scope ...interface{}) HTMLTable {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTBody is the interface that describes a <tbody> HTML element.
type HTMLTBody interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTBody

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTBody

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTBody

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTBody

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTBody

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTBody

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTBody

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTBody

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTBody

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTBody

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTBody

	// ID specifies a unique id for an element.
	ID(v string) HTMLTBody

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTBody

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTBody

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTBody

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTBody

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTBody

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTBody

	// Title specifies extra information about an element.
	Title(v string) HTMLTBody

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTBody

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTBody

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTBody

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTBody

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTBody

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTBody

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTBody

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTBody

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTBody

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTBody

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTBody

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTBody

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTBody

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTBody

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTBody

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTBody

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTBody

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTBody

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTBody

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTBody

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTBody

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTBody

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTBody

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTBody

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTBody
}

// TBody returns an HTML element that groups the body content in a table.
func TBody() HTMLTBody {
	e := &htmlTBody{
		elem: elem{
			tag:         "tbody",
			selfClosing: false,
		},
	}

	return e
}

type htmlTBody struct {
	elem
}

func (e *htmlTBody) Body(elems ...UI) HTMLTBody {
	e.setBody(elems...)
	return e
}

func (e *htmlTBody) Text(v interface{}) HTMLTBody {
	return e.Body(Text(v))
}

func (e *htmlTBody) AccessKey(v string) HTMLTBody {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTBody) Aria(k string, v interface{}) HTMLTBody {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTBody) Attr(n string, v interface{}) HTMLTBody {
	e.setAttr(n, v)
	return e
}

func (e *htmlTBody) Class(v ...string) HTMLTBody {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTBody) ContentEditable(v bool) HTMLTBody {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTBody) DataSet(k string, v interface{}) HTMLTBody {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTBody) Dir(v string) HTMLTBody {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTBody) Draggable(v bool) HTMLTBody {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTBody) Hidden(v bool) HTMLTBody {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTBody) ID(v string) HTMLTBody {
	e.setAttr("id", v)
	return e
}

func (e *htmlTBody) Lang(v string) HTMLTBody {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTBody) Role(v string) HTMLTBody {
	e.setAttr("role", v)
	return e
}

func (e *htmlTBody) Spellcheck(v bool) HTMLTBody {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTBody) Style(k, v string) HTMLTBody {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTBody) Styles(s map[string]string) HTMLTBody {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTBody) TabIndex(v int) HTMLTBody {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTBody) Title(v string) HTMLTBody {
	e.setAttr("title", v)
	return e
}

func (e *htmlTBody) OnBlur(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTBody) OnChange(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTBody) OnClick(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTBody) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTBody) OnCopy(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTBody) OnCut(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTBody) OnDblClick(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTBody) OnDrag(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTBody) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTBody) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTBody) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTBody) OnDragOver(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTBody) OnDragStart(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTBody) OnDrop(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTBody) OnFocus(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTBody) OnInput(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTBody) OnInvalid(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTBody) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTBody) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTBody) OnKeyup(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTBody) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTBody) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTBody) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTBody) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTBody) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTBody) OnPaste(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTBody) OnReset(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTBody) OnScroll(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTBody) OnSearch(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTBody) OnSelect(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTBody) OnSubmit(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTBody) OnWheel(h EventHandler, scope ...interface{}) HTMLTBody {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTd is the interface that describes a <td> HTML element.
type HTMLTd interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTd

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTd

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTd

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTd

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTd

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTd

	// ColSpan specifies the number of columns a table cell should span.
	ColSpan(v int) HTMLTd

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTd

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTd

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTd

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTd

	// Headers specifies one or more headers cells a cell is related to.
	Headers(v string) HTMLTd

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTd

	// ID specifies a unique id for an element.
	ID(v string) HTMLTd

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTd

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTd

	// Rowspan specifies the number of rows a table cell should span.
	Rowspan(v int) HTMLTd

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTd

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTd

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTd

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTd

	// Title specifies extra information about an element.
	Title(v string) HTMLTd

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTd

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTd

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTd

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTd

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTd

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTd

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTd

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTd

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTd

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTd

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTd

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTd

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTd

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTd

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTd

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTd

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTd

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTd

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTd

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTd

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTd

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTd

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTd

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTd

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTd

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTd

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTd

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTd

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTd

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTd

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTd

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTd
}

// Td returns an HTML element that defines a cell in a table.
func Td() HTMLTd {
	e := &htmlTd{
		elem: elem{
			tag:         "td",
			selfClosing: false,
		},
	}

	return e
}

type htmlTd struct {
	elem
}

func (e *htmlTd) Body(elems ...UI) HTMLTd {
	e.setBody(elems...)
	return e
}

func (e *htmlTd) Text(v interface{}) HTMLTd {
	return e.Body(Text(v))
}

func (e *htmlTd) AccessKey(v string) HTMLTd {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTd) Aria(k string, v interface{}) HTMLTd {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTd) Attr(n string, v interface{}) HTMLTd {
	e.setAttr(n, v)
	return e
}

func (e *htmlTd) Class(v ...string) HTMLTd {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTd) ColSpan(v int) HTMLTd {
	e.setAttr("colspan", v)
	return e
}

func (e *htmlTd) ContentEditable(v bool) HTMLTd {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTd) DataSet(k string, v interface{}) HTMLTd {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTd) Dir(v string) HTMLTd {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTd) Draggable(v bool) HTMLTd {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTd) Headers(v string) HTMLTd {
	e.setAttr("headers", v)
	return e
}

func (e *htmlTd) Hidden(v bool) HTMLTd {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTd) ID(v string) HTMLTd {
	e.setAttr("id", v)
	return e
}

func (e *htmlTd) Lang(v string) HTMLTd {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTd) Role(v string) HTMLTd {
	e.setAttr("role", v)
	return e
}

func (e *htmlTd) Rowspan(v int) HTMLTd {
	e.setAttr("rowspan", v)
	return e
}

func (e *htmlTd) Spellcheck(v bool) HTMLTd {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTd) Style(k, v string) HTMLTd {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTd) Styles(s map[string]string) HTMLTd {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTd) TabIndex(v int) HTMLTd {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTd) Title(v string) HTMLTd {
	e.setAttr("title", v)
	return e
}

func (e *htmlTd) OnBlur(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTd) OnChange(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTd) OnClick(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTd) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTd) OnCopy(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTd) OnCut(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTd) OnDblClick(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTd) OnDrag(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTd) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTd) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTd) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTd) OnDragOver(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTd) OnDragStart(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTd) OnDrop(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTd) OnFocus(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTd) OnInput(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTd) OnInvalid(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTd) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTd) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTd) OnKeyup(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTd) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTd) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTd) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTd) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTd) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTd) OnPaste(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTd) OnReset(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTd) OnScroll(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTd) OnSearch(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTd) OnSelect(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTd) OnSubmit(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTd) OnWheel(h EventHandler, scope ...interface{}) HTMLTd {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTemplate is the interface that describes a <template> HTML element.
type HTMLTemplate interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTemplate

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTemplate

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTemplate

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTemplate

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTemplate

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTemplate

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTemplate

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTemplate

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTemplate

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTemplate

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTemplate

	// ID specifies a unique id for an element.
	ID(v string) HTMLTemplate

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTemplate

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTemplate

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTemplate

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTemplate

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTemplate

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTemplate

	// Title specifies extra information about an element.
	Title(v string) HTMLTemplate
}

// Template returns an HTML element that defines a template.
func Template() HTMLTemplate {
	e := &htmlTemplate{
		elem: elem{
			tag:         "template",
			selfClosing: false,
		},
	}

	return e
}

type htmlTemplate struct {
	elem
}

func (e *htmlTemplate) Body(elems ...UI) HTMLTemplate {
	e.setBody(elems...)
	return e
}

func (e *htmlTemplate) Text(v interface{}) HTMLTemplate {
	return e.Body(Text(v))
}

func (e *htmlTemplate) AccessKey(v string) HTMLTemplate {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTemplate) Aria(k string, v interface{}) HTMLTemplate {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTemplate) Attr(n string, v interface{}) HTMLTemplate {
	e.setAttr(n, v)
	return e
}

func (e *htmlTemplate) Class(v ...string) HTMLTemplate {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTemplate) ContentEditable(v bool) HTMLTemplate {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTemplate) DataSet(k string, v interface{}) HTMLTemplate {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTemplate) Dir(v string) HTMLTemplate {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTemplate) Draggable(v bool) HTMLTemplate {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTemplate) Hidden(v bool) HTMLTemplate {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTemplate) ID(v string) HTMLTemplate {
	e.setAttr("id", v)
	return e
}

func (e *htmlTemplate) Lang(v string) HTMLTemplate {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTemplate) Role(v string) HTMLTemplate {
	e.setAttr("role", v)
	return e
}

func (e *htmlTemplate) Spellcheck(v bool) HTMLTemplate {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTemplate) Style(k, v string) HTMLTemplate {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTemplate) Styles(s map[string]string) HTMLTemplate {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTemplate) TabIndex(v int) HTMLTemplate {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTemplate) Title(v string) HTMLTemplate {
	e.setAttr("title", v)
	return e
}

// HTMLTextarea is the interface that describes a <textarea> HTML element.
type HTMLTextarea interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTextarea

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTextarea

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTextarea

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTextarea

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTextarea

	// AutoFocus specifies that the element should automatically get focus when the page loads.
	AutoFocus(v bool) HTMLTextarea

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTextarea

	// Cols specifies the visible width of a text area.
	Cols(v int) HTMLTextarea

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTextarea

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTextarea

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTextarea

	// DirName specifies that the text direction will be submitted.
	DirName(v string) HTMLTextarea

	// Disabled specifies that the specified element/group of elements should be disabled.
	Disabled(v bool) HTMLTextarea

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTextarea

	// Form specifies the name of the form the element belongs to.
	Form(v string) HTMLTextarea

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTextarea

	// ID specifies a unique id for an element.
	ID(v string) HTMLTextarea

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTextarea

	// MaxLength specifies the maximum number of characters allowed in an element.
	MaxLength(v int) HTMLTextarea

	// Name specifies the name of the element.
	Name(v string) HTMLTextarea

	// Placeholder specifies a short hint that describes the expected value of the element.
	Placeholder(v string) HTMLTextarea

	// ReadOnly specifies that the element is read-only.
	ReadOnly(v bool) HTMLTextarea

	// Required specifies that the element must be filled out before submitting the form.
	Required(v bool) HTMLTextarea

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTextarea

	// Rows specifies the visible number of lines in a text area.
	Rows(v int) HTMLTextarea

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTextarea

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTextarea

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTextarea

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTextarea

	// Title specifies extra information about an element.
	Title(v string) HTMLTextarea

	// Wrap specifies how the text in a text area is to be wrapped when submitted in a form.
	Wrap(v string) HTMLTextarea

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTextarea

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTextarea
}

// Textarea returns an HTML element that defines a multiline input control (text area).
func Textarea() HTMLTextarea {
	e := &htmlTextarea{
		elem: elem{
			tag:         "textarea",
			selfClosing: false,
		},
	}

	return e
}

type htmlTextarea struct {
	elem
}

func (e *htmlTextarea) Body(elems ...UI) HTMLTextarea {
	e.setBody(elems...)
	return e
}

func (e *htmlTextarea) Text(v interface{}) HTMLTextarea {
	e.setAttr("value", v)
	return e
}

func (e *htmlTextarea) AccessKey(v string) HTMLTextarea {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTextarea) Aria(k string, v interface{}) HTMLTextarea {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTextarea) Attr(n string, v interface{}) HTMLTextarea {
	e.setAttr(n, v)
	return e
}

func (e *htmlTextarea) AutoFocus(v bool) HTMLTextarea {
	e.setAttr("autofocus", v)
	return e
}

func (e *htmlTextarea) Class(v ...string) HTMLTextarea {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTextarea) Cols(v int) HTMLTextarea {
	e.setAttr("cols", v)
	return e
}

func (e *htmlTextarea) ContentEditable(v bool) HTMLTextarea {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTextarea) DataSet(k string, v interface{}) HTMLTextarea {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTextarea) Dir(v string) HTMLTextarea {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTextarea) DirName(v string) HTMLTextarea {
	e.setAttr("dirname", v)
	return e
}

func (e *htmlTextarea) Disabled(v bool) HTMLTextarea {
	e.setAttr("disabled", v)
	return e
}

func (e *htmlTextarea) Draggable(v bool) HTMLTextarea {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTextarea) Form(v string) HTMLTextarea {
	e.setAttr("form", v)
	return e
}

func (e *htmlTextarea) Hidden(v bool) HTMLTextarea {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTextarea) ID(v string) HTMLTextarea {
	e.setAttr("id", v)
	return e
}

func (e *htmlTextarea) Lang(v string) HTMLTextarea {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTextarea) MaxLength(v int) HTMLTextarea {
	e.setAttr("maxlength", v)
	return e
}

func (e *htmlTextarea) Name(v string) HTMLTextarea {
	e.setAttr("name", v)
	return e
}

func (e *htmlTextarea) Placeholder(v string) HTMLTextarea {
	e.setAttr("placeholder", v)
	return e
}

func (e *htmlTextarea) ReadOnly(v bool) HTMLTextarea {
	e.setAttr("readonly", v)
	return e
}

func (e *htmlTextarea) Required(v bool) HTMLTextarea {
	e.setAttr("required", v)
	return e
}

func (e *htmlTextarea) Role(v string) HTMLTextarea {
	e.setAttr("role", v)
	return e
}

func (e *htmlTextarea) Rows(v int) HTMLTextarea {
	e.setAttr("rows", v)
	return e
}

func (e *htmlTextarea) Spellcheck(v bool) HTMLTextarea {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTextarea) Style(k, v string) HTMLTextarea {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTextarea) Styles(s map[string]string) HTMLTextarea {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTextarea) TabIndex(v int) HTMLTextarea {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTextarea) Title(v string) HTMLTextarea {
	e.setAttr("title", v)
	return e
}

func (e *htmlTextarea) Wrap(v string) HTMLTextarea {
	e.setAttr("wrap", v)
	return e
}

func (e *htmlTextarea) OnBlur(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTextarea) OnChange(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTextarea) OnClick(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTextarea) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTextarea) OnCopy(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTextarea) OnCut(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTextarea) OnDblClick(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTextarea) OnDrag(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTextarea) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTextarea) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTextarea) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTextarea) OnDragOver(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTextarea) OnDragStart(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTextarea) OnDrop(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTextarea) OnFocus(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTextarea) OnInput(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTextarea) OnInvalid(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTextarea) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTextarea) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTextarea) OnKeyup(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTextarea) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTextarea) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTextarea) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTextarea) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTextarea) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTextarea) OnPaste(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTextarea) OnReset(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTextarea) OnScroll(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTextarea) OnSearch(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTextarea) OnSelect(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTextarea) OnSubmit(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTextarea) OnWheel(h EventHandler, scope ...interface{}) HTMLTextarea {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTFoot is the interface that describes a <tfoot> HTML element.
type HTMLTFoot interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTFoot

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTFoot

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTFoot

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTFoot

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTFoot

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTFoot

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTFoot

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTFoot

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTFoot

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTFoot

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTFoot

	// ID specifies a unique id for an element.
	ID(v string) HTMLTFoot

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTFoot

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTFoot

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTFoot

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTFoot

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTFoot

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTFoot

	// Title specifies extra information about an element.
	Title(v string) HTMLTFoot

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTFoot

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTFoot
}

// TFoot returns an HTML element that groups the footer content in a table.
func TFoot() HTMLTFoot {
	e := &htmlTFoot{
		elem: elem{
			tag:         "tfoot",
			selfClosing: false,
		},
	}

	return e
}

type htmlTFoot struct {
	elem
}

func (e *htmlTFoot) Body(elems ...UI) HTMLTFoot {
	e.setBody(elems...)
	return e
}

func (e *htmlTFoot) Text(v interface{}) HTMLTFoot {
	return e.Body(Text(v))
}

func (e *htmlTFoot) AccessKey(v string) HTMLTFoot {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTFoot) Aria(k string, v interface{}) HTMLTFoot {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTFoot) Attr(n string, v interface{}) HTMLTFoot {
	e.setAttr(n, v)
	return e
}

func (e *htmlTFoot) Class(v ...string) HTMLTFoot {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTFoot) ContentEditable(v bool) HTMLTFoot {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTFoot) DataSet(k string, v interface{}) HTMLTFoot {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTFoot) Dir(v string) HTMLTFoot {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTFoot) Draggable(v bool) HTMLTFoot {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTFoot) Hidden(v bool) HTMLTFoot {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTFoot) ID(v string) HTMLTFoot {
	e.setAttr("id", v)
	return e
}

func (e *htmlTFoot) Lang(v string) HTMLTFoot {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTFoot) Role(v string) HTMLTFoot {
	e.setAttr("role", v)
	return e
}

func (e *htmlTFoot) Spellcheck(v bool) HTMLTFoot {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTFoot) Style(k, v string) HTMLTFoot {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTFoot) Styles(s map[string]string) HTMLTFoot {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTFoot) TabIndex(v int) HTMLTFoot {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTFoot) Title(v string) HTMLTFoot {
	e.setAttr("title", v)
	return e
}

func (e *htmlTFoot) OnBlur(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTFoot) OnChange(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTFoot) OnClick(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTFoot) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTFoot) OnCopy(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTFoot) OnCut(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTFoot) OnDblClick(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTFoot) OnDrag(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTFoot) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTFoot) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTFoot) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTFoot) OnDragOver(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTFoot) OnDragStart(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTFoot) OnDrop(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTFoot) OnFocus(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTFoot) OnInput(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTFoot) OnInvalid(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTFoot) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTFoot) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTFoot) OnKeyup(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTFoot) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTFoot) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTFoot) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTFoot) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTFoot) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTFoot) OnPaste(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTFoot) OnReset(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTFoot) OnScroll(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTFoot) OnSearch(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTFoot) OnSelect(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTFoot) OnSubmit(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTFoot) OnWheel(h EventHandler, scope ...interface{}) HTMLTFoot {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTh is the interface that describes a <th> HTML element.
type HTMLTh interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTh

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTh

	// Accept specifies an abbreviated version of the content in a header cell.
	Accept(v string) HTMLTh

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTh

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTh

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTh

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTh

	// ColSpan specifies the number of columns a table cell should span.
	ColSpan(v int) HTMLTh

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTh

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTh

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTh

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTh

	// Headers specifies one or more headers cells a cell is related to.
	Headers(v string) HTMLTh

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTh

	// ID specifies a unique id for an element.
	ID(v string) HTMLTh

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTh

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTh

	// Rowspan specifies the number of rows a table cell should span.
	Rowspan(v int) HTMLTh

	// Scope specifies whether a header cell is a header for a column, row, or group of columns or rows.
	Scope(v string) HTMLTh

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTh

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTh

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTh

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTh

	// Title specifies extra information about an element.
	Title(v string) HTMLTh

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTh

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTh

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTh

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTh

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTh

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTh

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTh

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTh

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTh

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTh

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTh

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTh

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTh

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTh

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTh

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTh

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTh

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTh

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTh

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTh

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTh

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTh

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTh

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTh

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTh

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTh

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTh

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTh

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTh

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTh

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTh

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTh
}

// Th returns an HTML element that defines a header cell in a table.
func Th() HTMLTh {
	e := &htmlTh{
		elem: elem{
			tag:         "th",
			selfClosing: false,
		},
	}

	return e
}

type htmlTh struct {
	elem
}

func (e *htmlTh) Body(elems ...UI) HTMLTh {
	e.setBody(elems...)
	return e
}

func (e *htmlTh) Text(v interface{}) HTMLTh {
	return e.Body(Text(v))
}

func (e *htmlTh) Accept(v string) HTMLTh {
	e.setAttr("accept", v)
	return e
}

func (e *htmlTh) AccessKey(v string) HTMLTh {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTh) Aria(k string, v interface{}) HTMLTh {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTh) Attr(n string, v interface{}) HTMLTh {
	e.setAttr(n, v)
	return e
}

func (e *htmlTh) Class(v ...string) HTMLTh {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTh) ColSpan(v int) HTMLTh {
	e.setAttr("colspan", v)
	return e
}

func (e *htmlTh) ContentEditable(v bool) HTMLTh {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTh) DataSet(k string, v interface{}) HTMLTh {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTh) Dir(v string) HTMLTh {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTh) Draggable(v bool) HTMLTh {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTh) Headers(v string) HTMLTh {
	e.setAttr("headers", v)
	return e
}

func (e *htmlTh) Hidden(v bool) HTMLTh {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTh) ID(v string) HTMLTh {
	e.setAttr("id", v)
	return e
}

func (e *htmlTh) Lang(v string) HTMLTh {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTh) Role(v string) HTMLTh {
	e.setAttr("role", v)
	return e
}

func (e *htmlTh) Rowspan(v int) HTMLTh {
	e.setAttr("rowspan", v)
	return e
}

func (e *htmlTh) Scope(v string) HTMLTh {
	e.setAttr("scope", v)
	return e
}

func (e *htmlTh) Spellcheck(v bool) HTMLTh {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTh) Style(k, v string) HTMLTh {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTh) Styles(s map[string]string) HTMLTh {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTh) TabIndex(v int) HTMLTh {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTh) Title(v string) HTMLTh {
	e.setAttr("title", v)
	return e
}

func (e *htmlTh) OnBlur(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTh) OnChange(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTh) OnClick(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTh) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTh) OnCopy(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTh) OnCut(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTh) OnDblClick(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTh) OnDrag(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTh) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTh) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTh) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTh) OnDragOver(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTh) OnDragStart(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTh) OnDrop(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTh) OnFocus(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTh) OnInput(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTh) OnInvalid(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTh) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTh) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTh) OnKeyup(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTh) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTh) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTh) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTh) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTh) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTh) OnPaste(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTh) OnReset(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTh) OnScroll(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTh) OnSearch(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTh) OnSelect(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTh) OnSubmit(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTh) OnWheel(h EventHandler, scope ...interface{}) HTMLTh {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTHead is the interface that describes a <thead> HTML element.
type HTMLTHead interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTHead

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTHead

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTHead

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTHead

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTHead

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTHead

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTHead

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTHead

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTHead

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTHead

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTHead

	// ID specifies a unique id for an element.
	ID(v string) HTMLTHead

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTHead

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTHead

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTHead

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTHead

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTHead

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTHead

	// Title specifies extra information about an element.
	Title(v string) HTMLTHead

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTHead

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTHead

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTHead

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTHead

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTHead

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTHead

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTHead

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTHead

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTHead

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTHead

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTHead

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTHead

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTHead

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTHead

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTHead

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTHead

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTHead

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTHead

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTHead

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTHead

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTHead

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTHead

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTHead

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTHead

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTHead
}

// THead returns an HTML element that groups the header content in a table
func THead() HTMLTHead {
	e := &htmlTHead{
		elem: elem{
			tag:         "thead",
			selfClosing: false,
		},
	}

	return e
}

type htmlTHead struct {
	elem
}

func (e *htmlTHead) Body(elems ...UI) HTMLTHead {
	e.setBody(elems...)
	return e
}

func (e *htmlTHead) Text(v interface{}) HTMLTHead {
	return e.Body(Text(v))
}

func (e *htmlTHead) AccessKey(v string) HTMLTHead {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTHead) Aria(k string, v interface{}) HTMLTHead {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTHead) Attr(n string, v interface{}) HTMLTHead {
	e.setAttr(n, v)
	return e
}

func (e *htmlTHead) Class(v ...string) HTMLTHead {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTHead) ContentEditable(v bool) HTMLTHead {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTHead) DataSet(k string, v interface{}) HTMLTHead {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTHead) Dir(v string) HTMLTHead {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTHead) Draggable(v bool) HTMLTHead {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTHead) Hidden(v bool) HTMLTHead {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTHead) ID(v string) HTMLTHead {
	e.setAttr("id", v)
	return e
}

func (e *htmlTHead) Lang(v string) HTMLTHead {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTHead) Role(v string) HTMLTHead {
	e.setAttr("role", v)
	return e
}

func (e *htmlTHead) Spellcheck(v bool) HTMLTHead {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTHead) Style(k, v string) HTMLTHead {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTHead) Styles(s map[string]string) HTMLTHead {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTHead) TabIndex(v int) HTMLTHead {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTHead) Title(v string) HTMLTHead {
	e.setAttr("title", v)
	return e
}

func (e *htmlTHead) OnBlur(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTHead) OnChange(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTHead) OnClick(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTHead) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTHead) OnCopy(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTHead) OnCut(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTHead) OnDblClick(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTHead) OnDrag(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTHead) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTHead) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTHead) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTHead) OnDragOver(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTHead) OnDragStart(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTHead) OnDrop(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTHead) OnFocus(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTHead) OnInput(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTHead) OnInvalid(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTHead) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTHead) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTHead) OnKeyup(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTHead) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTHead) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTHead) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTHead) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTHead) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTHead) OnPaste(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTHead) OnReset(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTHead) OnScroll(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTHead) OnSearch(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTHead) OnSelect(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTHead) OnSubmit(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTHead) OnWheel(h EventHandler, scope ...interface{}) HTMLTHead {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTime is the interface that describes a <time> HTML element.
type HTMLTime interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTime

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTime

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTime

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTime

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTime

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTime

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTime

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTime

	// DateTime specifies the date and time.
	DateTime(v string) HTMLTime

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTime

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTime

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTime

	// ID specifies a unique id for an element.
	ID(v string) HTMLTime

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTime

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTime

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTime

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTime

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTime

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTime

	// Title specifies extra information about an element.
	Title(v string) HTMLTime

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTime

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTime

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTime

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTime

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTime

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTime

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTime

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTime

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTime

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTime

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTime

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTime

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTime

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTime

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTime

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTime

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTime

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTime

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTime

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTime

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTime

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTime

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTime

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTime

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTime

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTime

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTime

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTime

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTime

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTime

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTime

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTime
}

// Time returns an HTML element that defines a date/time.
func Time() HTMLTime {
	e := &htmlTime{
		elem: elem{
			tag:         "time",
			selfClosing: false,
		},
	}

	return e
}

type htmlTime struct {
	elem
}

func (e *htmlTime) Body(elems ...UI) HTMLTime {
	e.setBody(elems...)
	return e
}

func (e *htmlTime) Text(v interface{}) HTMLTime {
	return e.Body(Text(v))
}

func (e *htmlTime) AccessKey(v string) HTMLTime {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTime) Aria(k string, v interface{}) HTMLTime {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTime) Attr(n string, v interface{}) HTMLTime {
	e.setAttr(n, v)
	return e
}

func (e *htmlTime) Class(v ...string) HTMLTime {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTime) ContentEditable(v bool) HTMLTime {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTime) DataSet(k string, v interface{}) HTMLTime {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTime) DateTime(v string) HTMLTime {
	e.setAttr("datetime", v)
	return e
}

func (e *htmlTime) Dir(v string) HTMLTime {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTime) Draggable(v bool) HTMLTime {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTime) Hidden(v bool) HTMLTime {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTime) ID(v string) HTMLTime {
	e.setAttr("id", v)
	return e
}

func (e *htmlTime) Lang(v string) HTMLTime {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTime) Role(v string) HTMLTime {
	e.setAttr("role", v)
	return e
}

func (e *htmlTime) Spellcheck(v bool) HTMLTime {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTime) Style(k, v string) HTMLTime {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTime) Styles(s map[string]string) HTMLTime {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTime) TabIndex(v int) HTMLTime {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTime) Title(v string) HTMLTime {
	e.setAttr("title", v)
	return e
}

func (e *htmlTime) OnBlur(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTime) OnChange(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTime) OnClick(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTime) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTime) OnCopy(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTime) OnCut(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTime) OnDblClick(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTime) OnDrag(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTime) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTime) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTime) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTime) OnDragOver(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTime) OnDragStart(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTime) OnDrop(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTime) OnFocus(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTime) OnInput(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTime) OnInvalid(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTime) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTime) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTime) OnKeyup(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTime) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTime) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTime) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTime) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTime) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTime) OnPaste(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTime) OnReset(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTime) OnScroll(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTime) OnSearch(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTime) OnSelect(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTime) OnSubmit(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTime) OnWheel(h EventHandler, scope ...interface{}) HTMLTime {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLTitle is the interface that describes a <title> HTML element.
type HTMLTitle interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTitle

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTitle

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTitle

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTitle

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTitle

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTitle

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTitle

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTitle

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTitle

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTitle

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTitle

	// ID specifies a unique id for an element.
	ID(v string) HTMLTitle

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTitle

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTitle

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTitle

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTitle

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTitle

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTitle

	// Title specifies extra information about an element.
	Title(v string) HTMLTitle
}

// Title returns an HTML element that defines a title for the document.
func Title() HTMLTitle {
	e := &htmlTitle{
		elem: elem{
			tag:         "title",
			selfClosing: false,
		},
	}

	return e
}

type htmlTitle struct {
	elem
}

func (e *htmlTitle) Body(elems ...UI) HTMLTitle {
	e.setBody(elems...)
	return e
}

func (e *htmlTitle) Text(v interface{}) HTMLTitle {
	return e.Body(Text(v))
}

func (e *htmlTitle) AccessKey(v string) HTMLTitle {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTitle) Aria(k string, v interface{}) HTMLTitle {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTitle) Attr(n string, v interface{}) HTMLTitle {
	e.setAttr(n, v)
	return e
}

func (e *htmlTitle) Class(v ...string) HTMLTitle {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTitle) ContentEditable(v bool) HTMLTitle {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTitle) DataSet(k string, v interface{}) HTMLTitle {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTitle) Dir(v string) HTMLTitle {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTitle) Draggable(v bool) HTMLTitle {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTitle) Hidden(v bool) HTMLTitle {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTitle) ID(v string) HTMLTitle {
	e.setAttr("id", v)
	return e
}

func (e *htmlTitle) Lang(v string) HTMLTitle {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTitle) Role(v string) HTMLTitle {
	e.setAttr("role", v)
	return e
}

func (e *htmlTitle) Spellcheck(v bool) HTMLTitle {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTitle) Style(k, v string) HTMLTitle {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTitle) Styles(s map[string]string) HTMLTitle {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTitle) TabIndex(v int) HTMLTitle {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTitle) Title(v string) HTMLTitle {
	e.setAttr("title", v)
	return e
}

// HTMLTr is the interface that describes a <tr> HTML element.
type HTMLTr interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLTr

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLTr

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLTr

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLTr

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLTr

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLTr

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLTr

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLTr

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLTr

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLTr

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLTr

	// ID specifies a unique id for an element.
	ID(v string) HTMLTr

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLTr

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLTr

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLTr

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLTr

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLTr

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLTr

	// Title specifies extra information about an element.
	Title(v string) HTMLTr

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLTr

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLTr

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLTr

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLTr

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLTr

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLTr

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLTr

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLTr

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLTr

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLTr

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLTr

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLTr

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLTr

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLTr

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLTr

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLTr

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLTr

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLTr

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLTr

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLTr

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLTr

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLTr

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLTr

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLTr

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLTr

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLTr

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLTr

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLTr

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLTr

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLTr

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLTr

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLTr
}

// Tr returns an HTML element that defines a row in a table.
func Tr() HTMLTr {
	e := &htmlTr{
		elem: elem{
			tag:         "tr",
			selfClosing: false,
		},
	}

	return e
}

type htmlTr struct {
	elem
}

func (e *htmlTr) Body(elems ...UI) HTMLTr {
	e.setBody(elems...)
	return e
}

func (e *htmlTr) Text(v interface{}) HTMLTr {
	return e.Body(Text(v))
}

func (e *htmlTr) AccessKey(v string) HTMLTr {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlTr) Aria(k string, v interface{}) HTMLTr {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTr) Attr(n string, v interface{}) HTMLTr {
	e.setAttr(n, v)
	return e
}

func (e *htmlTr) Class(v ...string) HTMLTr {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlTr) ContentEditable(v bool) HTMLTr {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlTr) DataSet(k string, v interface{}) HTMLTr {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlTr) Dir(v string) HTMLTr {
	e.setAttr("dir", v)
	return e
}

func (e *htmlTr) Draggable(v bool) HTMLTr {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlTr) Hidden(v bool) HTMLTr {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlTr) ID(v string) HTMLTr {
	e.setAttr("id", v)
	return e
}

func (e *htmlTr) Lang(v string) HTMLTr {
	e.setAttr("lang", v)
	return e
}

func (e *htmlTr) Role(v string) HTMLTr {
	e.setAttr("role", v)
	return e
}

func (e *htmlTr) Spellcheck(v bool) HTMLTr {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlTr) Style(k, v string) HTMLTr {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlTr) Styles(s map[string]string) HTMLTr {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlTr) TabIndex(v int) HTMLTr {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlTr) Title(v string) HTMLTr {
	e.setAttr("title", v)
	return e
}

func (e *htmlTr) OnBlur(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlTr) OnChange(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlTr) OnClick(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlTr) OnContextMenu(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlTr) OnCopy(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlTr) OnCut(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlTr) OnDblClick(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlTr) OnDrag(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlTr) OnDragEnd(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlTr) OnDragEnter(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlTr) OnDragLeave(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlTr) OnDragOver(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlTr) OnDragStart(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlTr) OnDrop(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlTr) OnFocus(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlTr) OnInput(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlTr) OnInvalid(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlTr) OnKeyDown(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlTr) OnKeyPress(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlTr) OnKeyup(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlTr) OnMouseDown(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlTr) OnMouseMove(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlTr) OnMouseOut(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlTr) OnMouseOver(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlTr) OnMouseUp(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlTr) OnPaste(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlTr) OnReset(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlTr) OnScroll(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlTr) OnSearch(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlTr) OnSelect(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlTr) OnSubmit(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlTr) OnWheel(h EventHandler, scope ...interface{}) HTMLTr {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLU is the interface that describes a <u> HTML element.
type HTMLU interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLU

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLU

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLU

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLU

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLU

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLU

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLU

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLU

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLU

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLU

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLU

	// ID specifies a unique id for an element.
	ID(v string) HTMLU

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLU

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLU

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLU

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLU

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLU

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLU

	// Title specifies extra information about an element.
	Title(v string) HTMLU

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLU

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLU

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLU

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLU

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLU

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLU

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLU

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLU

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLU

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLU

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLU

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLU

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLU

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLU

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLU

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLU

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLU

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLU

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLU

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLU

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLU

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLU

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLU

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLU

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLU

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLU

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLU

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLU

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLU

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLU

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLU

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLU
}

// U returns an HTML element that defines text that should be stylistically different from normal text.
func U() HTMLU {
	e := &htmlU{
		elem: elem{
			tag:         "u",
			selfClosing: false,
		},
	}

	return e
}

type htmlU struct {
	elem
}

func (e *htmlU) Body(elems ...UI) HTMLU {
	e.setBody(elems...)
	return e
}

func (e *htmlU) Text(v interface{}) HTMLU {
	return e.Body(Text(v))
}

func (e *htmlU) AccessKey(v string) HTMLU {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlU) Aria(k string, v interface{}) HTMLU {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlU) Attr(n string, v interface{}) HTMLU {
	e.setAttr(n, v)
	return e
}

func (e *htmlU) Class(v ...string) HTMLU {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlU) ContentEditable(v bool) HTMLU {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlU) DataSet(k string, v interface{}) HTMLU {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlU) Dir(v string) HTMLU {
	e.setAttr("dir", v)
	return e
}

func (e *htmlU) Draggable(v bool) HTMLU {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlU) Hidden(v bool) HTMLU {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlU) ID(v string) HTMLU {
	e.setAttr("id", v)
	return e
}

func (e *htmlU) Lang(v string) HTMLU {
	e.setAttr("lang", v)
	return e
}

func (e *htmlU) Role(v string) HTMLU {
	e.setAttr("role", v)
	return e
}

func (e *htmlU) Spellcheck(v bool) HTMLU {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlU) Style(k, v string) HTMLU {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlU) Styles(s map[string]string) HTMLU {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlU) TabIndex(v int) HTMLU {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlU) Title(v string) HTMLU {
	e.setAttr("title", v)
	return e
}

func (e *htmlU) OnBlur(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlU) OnChange(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlU) OnClick(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlU) OnContextMenu(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlU) OnCopy(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlU) OnCut(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlU) OnDblClick(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlU) OnDrag(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlU) OnDragEnd(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlU) OnDragEnter(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlU) OnDragLeave(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlU) OnDragOver(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlU) OnDragStart(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlU) OnDrop(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlU) OnFocus(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlU) OnInput(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlU) OnInvalid(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlU) OnKeyDown(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlU) OnKeyPress(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlU) OnKeyup(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlU) OnMouseDown(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlU) OnMouseMove(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlU) OnMouseOut(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlU) OnMouseOver(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlU) OnMouseUp(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlU) OnPaste(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlU) OnReset(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlU) OnScroll(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlU) OnSearch(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlU) OnSelect(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlU) OnSubmit(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlU) OnWheel(h EventHandler, scope ...interface{}) HTMLU {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLUl is the interface that describes a <ul> HTML element.
type HTMLUl interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLUl

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLUl

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLUl

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLUl

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLUl

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLUl

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLUl

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLUl

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLUl

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLUl

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLUl

	// ID specifies a unique id for an element.
	ID(v string) HTMLUl

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLUl

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLUl

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLUl

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLUl

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLUl

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLUl

	// Title specifies extra information about an element.
	Title(v string) HTMLUl

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLUl

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLUl

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLUl

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLUl

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLUl

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLUl

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLUl

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLUl

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLUl

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLUl

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLUl

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLUl

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLUl

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLUl

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLUl

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLUl

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLUl

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLUl

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLUl

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLUl

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLUl

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLUl

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLUl

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLUl

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLUl

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLUl

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLUl

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLUl

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLUl

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLUl

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLUl

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLUl
}

// Ul returns an HTML element that defines an unordered list.
func Ul() HTMLUl {
	e := &htmlUl{
		elem: elem{
			tag:         "ul",
			selfClosing: false,
		},
	}

	return e
}

type htmlUl struct {
	elem
}

func (e *htmlUl) Body(elems ...UI) HTMLUl {
	e.setBody(elems...)
	return e
}

func (e *htmlUl) Text(v interface{}) HTMLUl {
	return e.Body(Text(v))
}

func (e *htmlUl) AccessKey(v string) HTMLUl {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlUl) Aria(k string, v interface{}) HTMLUl {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlUl) Attr(n string, v interface{}) HTMLUl {
	e.setAttr(n, v)
	return e
}

func (e *htmlUl) Class(v ...string) HTMLUl {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlUl) ContentEditable(v bool) HTMLUl {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlUl) DataSet(k string, v interface{}) HTMLUl {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlUl) Dir(v string) HTMLUl {
	e.setAttr("dir", v)
	return e
}

func (e *htmlUl) Draggable(v bool) HTMLUl {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlUl) Hidden(v bool) HTMLUl {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlUl) ID(v string) HTMLUl {
	e.setAttr("id", v)
	return e
}

func (e *htmlUl) Lang(v string) HTMLUl {
	e.setAttr("lang", v)
	return e
}

func (e *htmlUl) Role(v string) HTMLUl {
	e.setAttr("role", v)
	return e
}

func (e *htmlUl) Spellcheck(v bool) HTMLUl {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlUl) Style(k, v string) HTMLUl {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlUl) Styles(s map[string]string) HTMLUl {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlUl) TabIndex(v int) HTMLUl {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlUl) Title(v string) HTMLUl {
	e.setAttr("title", v)
	return e
}

func (e *htmlUl) OnBlur(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlUl) OnChange(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlUl) OnClick(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlUl) OnContextMenu(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlUl) OnCopy(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlUl) OnCut(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlUl) OnDblClick(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlUl) OnDrag(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlUl) OnDragEnd(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlUl) OnDragEnter(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlUl) OnDragLeave(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlUl) OnDragOver(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlUl) OnDragStart(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlUl) OnDrop(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlUl) OnFocus(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlUl) OnInput(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlUl) OnInvalid(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlUl) OnKeyDown(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlUl) OnKeyPress(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlUl) OnKeyup(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlUl) OnMouseDown(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlUl) OnMouseMove(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlUl) OnMouseOut(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlUl) OnMouseOver(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlUl) OnMouseUp(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlUl) OnPaste(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlUl) OnReset(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlUl) OnScroll(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlUl) OnSearch(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlUl) OnSelect(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlUl) OnSubmit(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlUl) OnWheel(h EventHandler, scope ...interface{}) HTMLUl {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLVar is the interface that describes a <var> HTML element.
type HTMLVar interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLVar

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLVar

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLVar

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLVar

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLVar

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLVar

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLVar

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLVar

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLVar

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLVar

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLVar

	// ID specifies a unique id for an element.
	ID(v string) HTMLVar

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLVar

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLVar

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLVar

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLVar

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLVar

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLVar

	// Title specifies extra information about an element.
	Title(v string) HTMLVar

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLVar

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLVar

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLVar

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLVar

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLVar

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLVar

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLVar

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLVar

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLVar

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLVar

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLVar

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLVar

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLVar

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLVar

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLVar

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLVar

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLVar

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLVar

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLVar

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLVar

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLVar

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLVar

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLVar

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLVar

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLVar

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLVar

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLVar

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLVar

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLVar

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLVar

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLVar

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLVar
}

// Var returns an HTML element that defines a variable.
func Var() HTMLVar {
	e := &htmlVar{
		elem: elem{
			tag:         "var",
			selfClosing: false,
		},
	}

	return e
}

type htmlVar struct {
	elem
}

func (e *htmlVar) Body(elems ...UI) HTMLVar {
	e.setBody(elems...)
	return e
}

func (e *htmlVar) Text(v interface{}) HTMLVar {
	return e.Body(Text(v))
}

func (e *htmlVar) AccessKey(v string) HTMLVar {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlVar) Aria(k string, v interface{}) HTMLVar {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlVar) Attr(n string, v interface{}) HTMLVar {
	e.setAttr(n, v)
	return e
}

func (e *htmlVar) Class(v ...string) HTMLVar {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlVar) ContentEditable(v bool) HTMLVar {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlVar) DataSet(k string, v interface{}) HTMLVar {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlVar) Dir(v string) HTMLVar {
	e.setAttr("dir", v)
	return e
}

func (e *htmlVar) Draggable(v bool) HTMLVar {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlVar) Hidden(v bool) HTMLVar {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlVar) ID(v string) HTMLVar {
	e.setAttr("id", v)
	return e
}

func (e *htmlVar) Lang(v string) HTMLVar {
	e.setAttr("lang", v)
	return e
}

func (e *htmlVar) Role(v string) HTMLVar {
	e.setAttr("role", v)
	return e
}

func (e *htmlVar) Spellcheck(v bool) HTMLVar {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlVar) Style(k, v string) HTMLVar {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlVar) Styles(s map[string]string) HTMLVar {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlVar) TabIndex(v int) HTMLVar {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlVar) Title(v string) HTMLVar {
	e.setAttr("title", v)
	return e
}

func (e *htmlVar) OnBlur(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlVar) OnChange(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlVar) OnClick(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlVar) OnContextMenu(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlVar) OnCopy(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlVar) OnCut(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlVar) OnDblClick(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlVar) OnDrag(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlVar) OnDragEnd(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlVar) OnDragEnter(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlVar) OnDragLeave(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlVar) OnDragOver(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlVar) OnDragStart(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlVar) OnDrop(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlVar) OnFocus(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlVar) OnInput(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlVar) OnInvalid(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlVar) OnKeyDown(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlVar) OnKeyPress(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlVar) OnKeyup(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlVar) OnMouseDown(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlVar) OnMouseMove(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlVar) OnMouseOut(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlVar) OnMouseOver(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlVar) OnMouseUp(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlVar) OnPaste(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlVar) OnReset(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlVar) OnScroll(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlVar) OnSearch(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlVar) OnSelect(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlVar) OnSubmit(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlVar) OnWheel(h EventHandler, scope ...interface{}) HTMLVar {
	e.setEventHandler("wheel", h, scope...)
	return e
}

// HTMLVideo is the interface that describes a <video> HTML element.
type HTMLVideo interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLVideo

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLVideo

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLVideo

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLVideo

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLVideo

	// AutoPlay specifies that the audio/video will start playing as soon as it is ready.
	AutoPlay(v bool) HTMLVideo

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLVideo

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLVideo

	// Controls specifies that audio/video controls should be displayed (such as a play/pause button etc).
	Controls(v bool) HTMLVideo

	// CrossOrigin sets the mode of the request to an HTTP CORS Request.
	CrossOrigin(v string) HTMLVideo

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLVideo

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLVideo

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLVideo

	// Height specifies the height of the element (in pixels).
	Height(v int) HTMLVideo

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLVideo

	// ID specifies a unique id for an element.
	ID(v string) HTMLVideo

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLVideo

	// Loop specifies that the audio/video will start over again, every time it is finished.
	Loop(v bool) HTMLVideo

	// Muted specifies that the audio output of the video should be muted.
	Muted(v bool) HTMLVideo

	// Poster specifies an image to be shown while the video is downloading, or until the user hits the play button.
	Poster(v string) HTMLVideo

	// Preload specifies if and how the author thinks the audio/video should be loaded when the page loads.
	Preload(v string) HTMLVideo

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLVideo

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLVideo

	// Src specifies the URL of the media file.
	Src(v string) HTMLVideo

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLVideo

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLVideo

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLVideo

	// Title specifies extra information about an element.
	Title(v string) HTMLVideo

	// Width specifies the width of the element.
	Width(v int) HTMLVideo

	// OnAbort calls the given handler on abort.
	OnAbort(h EventHandler, scope ...interface{}) HTMLVideo

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLVideo

	// OnCanPlay calls the given handler when a file is ready to start playing (when it has buffered enough to begin).
	OnCanPlay(h EventHandler, scope ...interface{}) HTMLVideo

	// OnCanPlayThrough calls the given handler when a file can be played all the way to the end without pausing for buffering.
	OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLVideo

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLVideo

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLVideo

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLVideo

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLVideo

	// OnCueChange calls the given handler when the cue changes in a track element.
	OnCueChange(h EventHandler, scope ...interface{}) HTMLVideo

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLVideo

	// OnDurationChange calls the given handler when the length of the media changes.
	OnDurationChange(h EventHandler, scope ...interface{}) HTMLVideo

	// OnEmptied calls the given handler when something bad happens and the file is suddenly unavailable (like unexpectedly disconnects).
	OnEmptied(h EventHandler, scope ...interface{}) HTMLVideo

	// OnEnded calls the given handler when the media has reach the end.
	OnEnded(h EventHandler, scope ...interface{}) HTMLVideo

	// OnError calls the given handler when an error occurs.
	OnError(h EventHandler, scope ...interface{}) HTMLVideo

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLVideo

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLVideo

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLVideo

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLVideo

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLVideo

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLVideo

	// OnLoadStart calls the given handler just as the file begins to load before anything is actually loaded.
	OnLoadStart(h EventHandler, scope ...interface{}) HTMLVideo

	// OnLoadedData calls the given handler when media data is loaded.
	OnLoadedData(h EventHandler, scope ...interface{}) HTMLVideo

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLVideo

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLVideo

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLVideo

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLVideo

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLVideo

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLVideo

	// OnPause calls the given handler when the media is paused either by the user or programmatically.
	OnPause(h EventHandler, scope ...interface{}) HTMLVideo

	// OnPlay calls the given handler when the media is ready to start playing.
	OnPlay(h EventHandler, scope ...interface{}) HTMLVideo

	// OnPlaying calls the given handler when the media actually has started playing.
	OnPlaying(h EventHandler, scope ...interface{}) HTMLVideo

	// OnProgress calls the given handler when the browser is in the process of getting the media data.
	OnProgress(h EventHandler, scope ...interface{}) HTMLVideo

	// OnRateChange calls the given handler each time the playback rate changes (like when a user switches to a slow motion or fast forward mode).
	OnRateChange(h EventHandler, scope ...interface{}) HTMLVideo

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLVideo

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSeeked calls the given handler when the seeking attribute is set to false indicating that seeking has ended.
	OnSeeked(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSeeking calls the given handler when the seeking attribute is set to true indicating that seeking is active.
	OnSeeking(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLVideo

	// OnStalled calls the given handler when the browser is unable to fetch the media data for whatever reason.
	OnStalled(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLVideo

	// OnSuspend calls the given handler when fetching the media data is stopped before it is completely loaded for whatever reason.
	OnSuspend(h EventHandler, scope ...interface{}) HTMLVideo

	// OnTimeUpdate calls the given handler when the playing position has changed (like when the user fast forwards to a different point in the media).
	OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLVideo

	// OnVolumeChange calls the given handler each time the volume is changed which (includes setting the volume to "mute").
	OnVolumeChange(h EventHandler, scope ...interface{}) HTMLVideo

	// OnWaiting calls the given handler when the media has paused but is expected to resume (like when the media pauses to buffer more data).
	OnWaiting(h EventHandler, scope ...interface{}) HTMLVideo

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLVideo

	// OnloadedMetaData calls the given handler when meta data (like dimensions and duration) are loaded.
	OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLVideo
}

// Video returns an HTML element that defines a video or movie.
func Video() HTMLVideo {
	e := &htmlVideo{
		elem: elem{
			tag:         "video",
			selfClosing: false,
		},
	}

	return e
}

type htmlVideo struct {
	elem
}

func (e *htmlVideo) Body(elems ...UI) HTMLVideo {
	e.setBody(elems...)
	return e
}

func (e *htmlVideo) Text(v interface{}) HTMLVideo {
	return e.Body(Text(v))
}

func (e *htmlVideo) AccessKey(v string) HTMLVideo {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlVideo) Aria(k string, v interface{}) HTMLVideo {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlVideo) Attr(n string, v interface{}) HTMLVideo {
	e.setAttr(n, v)
	return e
}

func (e *htmlVideo) AutoPlay(v bool) HTMLVideo {
	e.setAttr("autoplay", v)
	return e
}

func (e *htmlVideo) Class(v ...string) HTMLVideo {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlVideo) ContentEditable(v bool) HTMLVideo {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlVideo) Controls(v bool) HTMLVideo {
	e.setAttr("controls", v)
	return e
}

func (e *htmlVideo) CrossOrigin(v string) HTMLVideo {
	e.setAttr("crossorigin", v)
	return e
}

func (e *htmlVideo) DataSet(k string, v interface{}) HTMLVideo {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlVideo) Dir(v string) HTMLVideo {
	e.setAttr("dir", v)
	return e
}

func (e *htmlVideo) Draggable(v bool) HTMLVideo {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlVideo) Height(v int) HTMLVideo {
	e.setAttr("height", v)
	return e
}

func (e *htmlVideo) Hidden(v bool) HTMLVideo {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlVideo) ID(v string) HTMLVideo {
	e.setAttr("id", v)
	return e
}

func (e *htmlVideo) Lang(v string) HTMLVideo {
	e.setAttr("lang", v)
	return e
}

func (e *htmlVideo) Loop(v bool) HTMLVideo {
	e.setAttr("loop", v)
	return e
}

func (e *htmlVideo) Muted(v bool) HTMLVideo {
	e.setAttr("muted", v)
	return e
}

func (e *htmlVideo) Poster(v string) HTMLVideo {
	e.setAttr("poster", v)
	return e
}

func (e *htmlVideo) Preload(v string) HTMLVideo {
	e.setAttr("preload", v)
	return e
}

func (e *htmlVideo) Role(v string) HTMLVideo {
	e.setAttr("role", v)
	return e
}

func (e *htmlVideo) Spellcheck(v bool) HTMLVideo {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlVideo) Src(v string) HTMLVideo {
	e.setAttr("src", v)
	return e
}

func (e *htmlVideo) Style(k, v string) HTMLVideo {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlVideo) Styles(s map[string]string) HTMLVideo {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlVideo) TabIndex(v int) HTMLVideo {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlVideo) Title(v string) HTMLVideo {
	e.setAttr("title", v)
	return e
}

func (e *htmlVideo) Width(v int) HTMLVideo {
	e.setAttr("width", v)
	return e
}

func (e *htmlVideo) OnAbort(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("abort", h, scope...)
	return e
}

func (e *htmlVideo) OnBlur(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlVideo) OnCanPlay(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("canplay", h, scope...)
	return e
}

func (e *htmlVideo) OnCanPlayThrough(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("canplaythrough", h, scope...)
	return e
}

func (e *htmlVideo) OnChange(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlVideo) OnClick(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlVideo) OnContextMenu(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlVideo) OnCopy(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlVideo) OnCueChange(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("cuechange", h, scope...)
	return e
}

func (e *htmlVideo) OnCut(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlVideo) OnDblClick(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlVideo) OnDrag(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlVideo) OnDragEnd(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlVideo) OnDragEnter(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlVideo) OnDragLeave(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlVideo) OnDragOver(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlVideo) OnDragStart(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlVideo) OnDrop(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlVideo) OnDurationChange(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("durationchange", h, scope...)
	return e
}

func (e *htmlVideo) OnEmptied(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("emptied", h, scope...)
	return e
}

func (e *htmlVideo) OnEnded(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("ended", h, scope...)
	return e
}

func (e *htmlVideo) OnError(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("error", h, scope...)
	return e
}

func (e *htmlVideo) OnFocus(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlVideo) OnInput(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlVideo) OnInvalid(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlVideo) OnKeyDown(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlVideo) OnKeyPress(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlVideo) OnKeyup(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlVideo) OnLoadStart(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("loadstart", h, scope...)
	return e
}

func (e *htmlVideo) OnLoadedData(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("loadeddata", h, scope...)
	return e
}

func (e *htmlVideo) OnMouseDown(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlVideo) OnMouseMove(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlVideo) OnMouseOut(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlVideo) OnMouseOver(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlVideo) OnMouseUp(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlVideo) OnPaste(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlVideo) OnPause(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("pause", h, scope...)
	return e
}

func (e *htmlVideo) OnPlay(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("play", h, scope...)
	return e
}

func (e *htmlVideo) OnPlaying(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("playing", h, scope...)
	return e
}

func (e *htmlVideo) OnProgress(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("progress", h, scope...)
	return e
}

func (e *htmlVideo) OnRateChange(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("ratechange", h, scope...)
	return e
}

func (e *htmlVideo) OnReset(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlVideo) OnScroll(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlVideo) OnSearch(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlVideo) OnSeeked(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("seeked", h, scope...)
	return e
}

func (e *htmlVideo) OnSeeking(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("seeking", h, scope...)
	return e
}

func (e *htmlVideo) OnSelect(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlVideo) OnStalled(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("stalled", h, scope...)
	return e
}

func (e *htmlVideo) OnSubmit(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlVideo) OnSuspend(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("suspend", h, scope...)
	return e
}

func (e *htmlVideo) OnTimeUpdate(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("timeupdate", h, scope...)
	return e
}

func (e *htmlVideo) OnVolumeChange(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("volumechange", h, scope...)
	return e
}

func (e *htmlVideo) OnWaiting(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("waiting", h, scope...)
	return e
}

func (e *htmlVideo) OnWheel(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("wheel", h, scope...)
	return e
}

func (e *htmlVideo) OnloadedMetaData(h EventHandler, scope ...interface{}) HTMLVideo {
	e.setEventHandler("loadedmetadata", h, scope...)
	return e
}

// HTMLWbr is the interface that describes a <wbr> HTML element.
type HTMLWbr interface {
	UI

	// Body set the content of the element.
	Body(elems ...UI) HTMLWbr

	// Text sets the content of the element with a text node containing the stringified given value.
	Text(v interface{}) HTMLWbr

	// AccessKey specifies a shortcut key to activate/focus an element.
	AccessKey(v string) HTMLWbr

	// Aria stores accessible rich internet applications (ARIA) data.
	Aria(k string, v interface{}) HTMLWbr

	// Attr sets the named attribute with the given value.
	Attr(n string, v interface{}) HTMLWbr

	// Class specifies one or more classnames for an element (refers to a class in a style sheet).
	Class(v ...string) HTMLWbr

	// ContentEditable specifies whether the content of an element is editable or not.
	ContentEditable(v bool) HTMLWbr

	// DataSet stores custom data private to the page or application.
	DataSet(k string, v interface{}) HTMLWbr

	// Dir specifies the text direction for the content in an element.
	Dir(v string) HTMLWbr

	// Draggable specifies whether an element is draggable or not.
	Draggable(v bool) HTMLWbr

	// Hidden specifies that an element is not yet, or is no longer relevant.
	Hidden(v bool) HTMLWbr

	// ID specifies a unique id for an element.
	ID(v string) HTMLWbr

	// Lang specifies the language of the element's content.
	Lang(v string) HTMLWbr

	// Role specifies to parsing software the exact function of an element (and its children).
	Role(v string) HTMLWbr

	// Spellcheck specifies whether the element is to have its spelling and grammar checked or not.
	Spellcheck(v bool) HTMLWbr

	// Style specifies a CSS style for an element. Can be called multiple times to set multiple css styles.
	Style(k, v string) HTMLWbr

	// Styles specifies CSS styles for an element. Can be called multiple times to set multiple css styles.
	Styles(s map[string]string) HTMLWbr

	// TabIndex specifies the tabbing order of an element.
	TabIndex(v int) HTMLWbr

	// Title specifies extra information about an element.
	Title(v string) HTMLWbr

	// OnBlur calls the given handler when the element loses focus.
	OnBlur(h EventHandler, scope ...interface{}) HTMLWbr

	// OnChange calls the given handler when the value of the element is changed.
	OnChange(h EventHandler, scope ...interface{}) HTMLWbr

	// OnClick calls the given handler when there is a mouse click on the element.
	OnClick(h EventHandler, scope ...interface{}) HTMLWbr

	// OnContextMenu calls the given handler when a context menu is triggered.
	OnContextMenu(h EventHandler, scope ...interface{}) HTMLWbr

	// OnCopy calls the given handler when the user copies the content of an element.
	OnCopy(h EventHandler, scope ...interface{}) HTMLWbr

	// OnCut calls the given handler when the user cuts the content of an element.
	OnCut(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDblClick calls the given handler when there is a mouse double-click on the element.
	OnDblClick(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDrag calls the given handler when an element is dragged.
	OnDrag(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDragEnd calls the given handler at the end of a drag operation.
	OnDragEnd(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDragEnter calls the given handler when an element has been dragged to a valid drop target.
	OnDragEnter(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDragLeave calls the given handler when an element leaves a valid drop target.
	OnDragLeave(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDragOver calls the given handler when an element is being dragged over a valid drop target.
	OnDragOver(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDragStart calls the given handler at the start of a drag operation.
	OnDragStart(h EventHandler, scope ...interface{}) HTMLWbr

	// OnDrop calls the given handler when dragged element is being dropped.
	OnDrop(h EventHandler, scope ...interface{}) HTMLWbr

	// OnFocus calls the given handler when the element gets focus.
	OnFocus(h EventHandler, scope ...interface{}) HTMLWbr

	// OnInput calls the given handler when an element gets user input.
	OnInput(h EventHandler, scope ...interface{}) HTMLWbr

	// OnInvalid calls the given handler when an element is invalid.
	OnInvalid(h EventHandler, scope ...interface{}) HTMLWbr

	// OnKeyDown calls the given handler when a user is pressing a key.
	OnKeyDown(h EventHandler, scope ...interface{}) HTMLWbr

	// OnKeyPress calls the given handler when a user presses a key.
	OnKeyPress(h EventHandler, scope ...interface{}) HTMLWbr

	// OnKeyup calls the given handler when a user releases a key.
	OnKeyup(h EventHandler, scope ...interface{}) HTMLWbr

	// OnMouseDown calls the given handler when a mouse button is pressed down on an element.
	OnMouseDown(h EventHandler, scope ...interface{}) HTMLWbr

	// OnMouseMove calls the given handler when the mouse pointer is moving while it is over an element.
	OnMouseMove(h EventHandler, scope ...interface{}) HTMLWbr

	// OnMouseOut calls the given handler when the mouse pointer moves out of an element.
	OnMouseOut(h EventHandler, scope ...interface{}) HTMLWbr

	// OnMouseOver calls the given handler when the mouse pointer moves over an element.
	OnMouseOver(h EventHandler, scope ...interface{}) HTMLWbr

	// OnMouseUp calls the given handler when a mouse button is released over an element.
	OnMouseUp(h EventHandler, scope ...interface{}) HTMLWbr

	// OnPaste calls the given handler when the user pastes some content in an element.
	OnPaste(h EventHandler, scope ...interface{}) HTMLWbr

	// OnReset calls the given handler when the Reset button in a form is clicked.
	OnReset(h EventHandler, scope ...interface{}) HTMLWbr

	// OnScroll calls the given handler when an element's scrollbar is being scrolled.
	OnScroll(h EventHandler, scope ...interface{}) HTMLWbr

	// OnSearch calls the given handler when the user writes something in a search field.
	OnSearch(h EventHandler, scope ...interface{}) HTMLWbr

	// OnSelect calls the given handler after some text has been selected in an element.
	OnSelect(h EventHandler, scope ...interface{}) HTMLWbr

	// OnSubmit calls the given handler when a form is submitted.
	OnSubmit(h EventHandler, scope ...interface{}) HTMLWbr

	// OnWheel calls the given handler when the mouse wheel rolls up or down over an element.
	OnWheel(h EventHandler, scope ...interface{}) HTMLWbr
}

// Wbr returns an HTML element that defines a possible line-break.
func Wbr() HTMLWbr {
	e := &htmlWbr{
		elem: elem{
			tag:         "wbr",
			selfClosing: false,
		},
	}

	return e
}

type htmlWbr struct {
	elem
}

func (e *htmlWbr) Body(elems ...UI) HTMLWbr {
	e.setBody(elems...)
	return e
}

func (e *htmlWbr) Text(v interface{}) HTMLWbr {
	return e.Body(Text(v))
}

func (e *htmlWbr) AccessKey(v string) HTMLWbr {
	e.setAttr("accesskey", v)
	return e
}

func (e *htmlWbr) Aria(k string, v interface{}) HTMLWbr {
	e.setAttr("aria-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlWbr) Attr(n string, v interface{}) HTMLWbr {
	e.setAttr(n, v)
	return e
}

func (e *htmlWbr) Class(v ...string) HTMLWbr {
	e.setAttr("class", strings.Join(v, " "))
	return e
}

func (e *htmlWbr) ContentEditable(v bool) HTMLWbr {
	e.setAttr("contenteditable", v)
	return e
}

func (e *htmlWbr) DataSet(k string, v interface{}) HTMLWbr {
	e.setAttr("data-"+k, fmt.Sprintf("%v", v))
	return e
}

func (e *htmlWbr) Dir(v string) HTMLWbr {
	e.setAttr("dir", v)
	return e
}

func (e *htmlWbr) Draggable(v bool) HTMLWbr {
	e.setAttr("draggable", v)
	return e
}

func (e *htmlWbr) Hidden(v bool) HTMLWbr {
	e.setAttr("hidden", v)
	return e
}

func (e *htmlWbr) ID(v string) HTMLWbr {
	e.setAttr("id", v)
	return e
}

func (e *htmlWbr) Lang(v string) HTMLWbr {
	e.setAttr("lang", v)
	return e
}

func (e *htmlWbr) Role(v string) HTMLWbr {
	e.setAttr("role", v)
	return e
}

func (e *htmlWbr) Spellcheck(v bool) HTMLWbr {
	s := "false"
	if v {
		s = "true"
	}

	e.setAttr("spellcheck", s)
	return e
}

func (e *htmlWbr) Style(k, v string) HTMLWbr {
	e.setAttr("style", k+":"+v)
	return e
}

func (e *htmlWbr) Styles(s map[string]string) HTMLWbr {
	for k, v := range s {
		e.Style(k, v)
	}
	return e
}

func (e *htmlWbr) TabIndex(v int) HTMLWbr {
	e.setAttr("tabindex", v)
	return e
}

func (e *htmlWbr) Title(v string) HTMLWbr {
	e.setAttr("title", v)
	return e
}

func (e *htmlWbr) OnBlur(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("blur", h, scope...)
	return e
}

func (e *htmlWbr) OnChange(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("change", h, scope...)
	return e
}

func (e *htmlWbr) OnClick(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("click", h, scope...)
	return e
}

func (e *htmlWbr) OnContextMenu(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("contextmenu", h, scope...)
	return e
}

func (e *htmlWbr) OnCopy(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("copy", h, scope...)
	return e
}

func (e *htmlWbr) OnCut(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("cut", h, scope...)
	return e
}

func (e *htmlWbr) OnDblClick(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dblclick", h, scope...)
	return e
}

func (e *htmlWbr) OnDrag(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("drag", h, scope...)
	return e
}

func (e *htmlWbr) OnDragEnd(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dragend", h, scope...)
	return e
}

func (e *htmlWbr) OnDragEnter(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dragenter", h, scope...)
	return e
}

func (e *htmlWbr) OnDragLeave(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dragleave", h, scope...)
	return e
}

func (e *htmlWbr) OnDragOver(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dragover", h, scope...)
	return e
}

func (e *htmlWbr) OnDragStart(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("dragstart", h, scope...)
	return e
}

func (e *htmlWbr) OnDrop(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("drop", h, scope...)
	return e
}

func (e *htmlWbr) OnFocus(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("focus", h, scope...)
	return e
}

func (e *htmlWbr) OnInput(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("input", h, scope...)
	return e
}

func (e *htmlWbr) OnInvalid(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("invalid", h, scope...)
	return e
}

func (e *htmlWbr) OnKeyDown(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("keydown", h, scope...)
	return e
}

func (e *htmlWbr) OnKeyPress(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("keypress", h, scope...)
	return e
}

func (e *htmlWbr) OnKeyup(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("keyup", h, scope...)
	return e
}

func (e *htmlWbr) OnMouseDown(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("mousedown", h, scope...)
	return e
}

func (e *htmlWbr) OnMouseMove(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("mousemove", h, scope...)
	return e
}

func (e *htmlWbr) OnMouseOut(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("mouseout", h, scope...)
	return e
}

func (e *htmlWbr) OnMouseOver(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("mouseover", h, scope...)
	return e
}

func (e *htmlWbr) OnMouseUp(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("mouseup", h, scope...)
	return e
}

func (e *htmlWbr) OnPaste(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("paste", h, scope...)
	return e
}

func (e *htmlWbr) OnReset(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("reset", h, scope...)
	return e
}

func (e *htmlWbr) OnScroll(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("scroll", h, scope...)
	return e
}

func (e *htmlWbr) OnSearch(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("search", h, scope...)
	return e
}

func (e *htmlWbr) OnSelect(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("select", h, scope...)
	return e
}

func (e *htmlWbr) OnSubmit(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("submit", h, scope...)
	return e
}

func (e *htmlWbr) OnWheel(h EventHandler, scope ...interface{}) HTMLWbr {
	e.setEventHandler("wheel", h, scope...)
	return e
}
